#include "qemu/osdep.h"
#include "exec/gdbstub.h"

const GDBFeature gdb_static_features[] = {
    {
        "hexagon-core.xml",
        "<?xml version=\"1.0\"?>\n"
        "<!--\n"
        "  Copyright(c) 2023 Qualcomm Innovation Center, Inc. All Rights Reserved.\n"
        "\n"
        "  This work is licensed under the terms of the GNU GPL, version 2 or\n"
        "  (at your option) any later version. See the COPYING file in the\n"
        "  top-level directory.\n"
        "\n"
        "  Note: this file is intended to be use with LLDB, so it contains fields\n"
        "  that may be unknown to GDB. For more information on such fields, please\n"
        "  see:\n"
        "  https://github.com/llvm/llvm-project/blob/287aa6c4536408413b860e61fca0318a27214cf3/lldb/docs/lldb-gdb-remote.txt#L738-L860\n"
        "  https://github.com/llvm/llvm-project/blob/287aa6c4536408413b860e61fca0318a27214cf3/lldb/source/Plugins/Process/gdb-remote/ProcessGDBRemote.cpp#L4275-L4335\n"
        "-->\n"
        "\n"
        "<!DOCTYPE feature SYSTEM \"gdb-target.dtd\">\n"
        "<feature name=\"org.gnu.gdb.hexagon.core\">\n"
        "\n"
        "  <reg name=\"r00\" altname=\"r0\" bitsize=\"32\" offset=\"0\"   encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"0\" generic=\"r00\"/>\n"
        "  <reg name=\"r01\" altname=\"r1\" bitsize=\"32\" offset=\"4\"   encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"1\" generic=\"r01\"/>\n"
        "  <reg name=\"r02\" altname=\"r2\" bitsize=\"32\" offset=\"8\"   encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"2\" generic=\"r02\"/>\n"
        "  <reg name=\"r03\" altname=\"r3\" bitsize=\"32\" offset=\"12\"  encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"3\" generic=\"r03\"/>\n"
        "  <reg name=\"r04\" altname=\"r4\" bitsize=\"32\" offset=\"16\"  encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"4\" generic=\"r04\"/>\n"
        "  <reg name=\"r05\" altname=\"r5\" bitsize=\"32\" offset=\"20\"  encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"5\" generic=\"r05\"/>\n"
        "  <reg name=\"r06\" altname=\"r6\" bitsize=\"32\" offset=\"24\"  encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"6\" generic=\"r06\"/>\n"
        "  <reg name=\"r07\" altname=\"r7\" bitsize=\"32\" offset=\"28\"  encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"7\" generic=\"r07\"/>\n"
        "  <reg name=\"r08\" altname=\"r8\" bitsize=\"32\" offset=\"32\"  encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"8\" generic=\"r08\"/>\n"
        "  <reg name=\"r09\" altname=\"r9\" bitsize=\"32\" offset=\"36\"  encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"9\" generic=\"r09\"/>\n"
        "  <reg name=\"r10\"              bitsize=\"32\" offset=\"40\"  encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"10\"/>\n"
        "  <reg name=\"r11\"              bitsize=\"32\" offset=\"44\"  encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"11\"/>\n"
        "  <reg name=\"r12\"              bitsize=\"32\" offset=\"48\"  encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"12\"/>\n"
        "  <reg name=\"r13\"              bitsize=\"32\" offset=\"52\"  encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"13\"/>\n"
        "  <reg name=\"r14\"              bitsize=\"32\" offset=\"56\"  encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"14\"/>\n"
        "  <reg name=\"r15\"              bitsize=\"32\" offset=\"60\"  encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"15\"/>\n"
        "  <reg name=\"r16\"              bitsize=\"32\" offset=\"64\"  encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"16\"/>\n"
        "  <reg name=\"r17\"              bitsize=\"32\" offset=\"68\"  encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"17\"/>\n"
        "  <reg name=\"r18\"              bitsize=\"32\" offset=\"72\"  encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"18\"/>\n"
        "  <reg name=\"r19\"              bitsize=\"32\" offset=\"76\"  encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"19\"/>\n"
        "  <reg name=\"r20\"              bitsize=\"32\" offset=\"80\"  encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"20\"/>\n"
        "  <reg name=\"r21\"              bitsize=\"32\" offset=\"84\"  encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"21\"/>\n"
        "  <reg name=\"r22\"              bitsize=\"32\" offset=\"88\"  encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"22\"/>\n"
        "  <reg name=\"r23\"              bitsize=\"32\" offset=\"92\"  encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"23\"/>\n"
        "  <reg name=\"r24\"              bitsize=\"32\" offset=\"96\"  encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"24\"/>\n"
        "  <reg name=\"r25\"              bitsize=\"32\" offset=\"100\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"25\"/>\n"
        "  <reg name=\"r26\"              bitsize=\"32\" offset=\"104\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"26\"/>\n"
        "  <reg name=\"r27\"              bitsize=\"32\" offset=\"108\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"27\"/>\n"
        "  <reg name=\"r28\"              bitsize=\"32\" offset=\"112\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"28\"/>\n"
        "  <reg name=\"r29\" altname=\"sp\" bitsize=\"32\" offset=\"116\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"29\" generic=\"sp\"/>\n"
        "  <reg name=\"r30\" altname=\"fp\" bitsize=\"32\" offset=\"120\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"30\" generic=\"fp\"/>\n"
        "  <reg name=\"r31\" altname=\"ra\" bitsize=\"32\" offset=\"124\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"31\" generic=\"ra\"/>\n"
        "  <reg name=\"sa0\"              bitsize=\"32\" offset=\"128\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"32\"/>\n"
        "  <reg name=\"lc0\"              bitsize=\"32\" offset=\"132\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"33\"/>\n"
        "  <reg name=\"sa1\"              bitsize=\"32\" offset=\"136\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"34\"/>\n"
        "  <reg name=\"lc1\"              bitsize=\"32\" offset=\"140\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"35\"/>\n"
        "  <reg name=\"p3_0\"             bitsize=\"32\" offset=\"144\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"36\"/>\n"
        "  <reg name=\"c5\"               bitsize=\"32\" offset=\"148\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"37\"/>\n"
        "  <reg name=\"m0\"               bitsize=\"32\" offset=\"152\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"38\"/>\n"
        "  <reg name=\"m1\"               bitsize=\"32\" offset=\"156\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"39\"/>\n"
        "  <reg name=\"usr\"              bitsize=\"32\" offset=\"160\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"40\"/>\n"
        "  <reg name=\"pc\"               bitsize=\"32\" offset=\"164\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"41\" generic=\"pc\"/>\n"
        "  <reg name=\"ugp\"              bitsize=\"32\" offset=\"168\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"42\"/>\n"
        "  <reg name=\"gp\"               bitsize=\"32\" offset=\"172\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"43\"/>\n"
        "  <reg name=\"cs0\"              bitsize=\"32\" offset=\"176\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"44\"/>\n"
        "  <reg name=\"cs1\"              bitsize=\"32\" offset=\"180\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"45\"/>\n"
        "  <reg name=\"upcyclelo\"        bitsize=\"32\" offset=\"184\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"46\"/>\n"
        "  <reg name=\"upcyclehi\"        bitsize=\"32\" offset=\"188\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"47\"/>\n"
        "  <reg name=\"framelimit\"       bitsize=\"32\" offset=\"192\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"48\"/>\n"
        "  <reg name=\"framekey\"         bitsize=\"32\" offset=\"196\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"49\"/>\n"
        "  <reg name=\"pktcountlo\"       bitsize=\"32\" offset=\"200\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"50\"/>\n"
        "  <reg name=\"pktcounthi\"       bitsize=\"32\" offset=\"204\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"51\"/>\n"
        "  <reg name=\"pkt_cnt\"          bitsize=\"32\" offset=\"208\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"52\"/>\n"
        "  <reg name=\"insn_cnt\"         bitsize=\"32\" offset=\"212\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"53\"/>\n"
        "  <reg name=\"hvx_cnt\"          bitsize=\"32\" offset=\"216\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"54\"/>\n"
        "  <reg name=\"c23\"              bitsize=\"32\" offset=\"220\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"55\"/>\n"
        "  <reg name=\"c24\"              bitsize=\"32\" offset=\"224\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"56\"/>\n"
        "  <reg name=\"c25\"              bitsize=\"32\" offset=\"228\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"57\"/>\n"
        "  <reg name=\"c26\"              bitsize=\"32\" offset=\"232\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"58\"/>\n"
        "  <reg name=\"c27\"              bitsize=\"32\" offset=\"236\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"59\"/>\n"
        "  <reg name=\"c28\"              bitsize=\"32\" offset=\"240\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"60\"/>\n"
        "  <reg name=\"c29\"              bitsize=\"32\" offset=\"244\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"61\"/>\n"
        "  <reg name=\"utimerlo\"         bitsize=\"32\" offset=\"248\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"62\"/>\n"
        "  <reg name=\"utimerhi\"         bitsize=\"32\" offset=\"252\" encoding=\"uint\" format=\"hex\" group=\"Thread Registers\" dwarf_regnum=\"63\"/>\n"
        "\n"
        "</feature>\n",
        64,
    },
    {
        "hexagon-hvx.xml",
        "<?xml version=\"1.0\"?>\n"
        "<!--\n"
        "  Copyright(c) 2023 Qualcomm Innovation Center, Inc. All Rights Reserved.\n"
        "\n"
        "  This work is licensed under the terms of the GNU GPL, version 2 or\n"
        "  (at your option) any later version. See the COPYING file in the\n"
        "  top-level directory.\n"
        "\n"
        "  Note: this file is intended to be use with LLDB, so it contains fields\n"
        "  that may be unknown to GDB. For more information on such fields, please\n"
        "  see:\n"
        "  https://github.com/llvm/llvm-project/blob/287aa6c4536408413b860e61fca0318a27214cf3/lldb/docs/lldb-gdb-remote.txt#L738-L860\n"
        "  https://github.com/llvm/llvm-project/blob/287aa6c4536408413b860e61fca0318a27214cf3/lldb/source/Plugins/Process/gdb-remote/ProcessGDBRemote.cpp#L4275-L4335\n"
        "-->\n"
        "\n"
        "<!DOCTYPE feature SYSTEM \"gdb-target.dtd\">\n"
        "<feature name=\"org.gnu.gdb.hexagon.hvx\">\n"
        "\n"
        "  <vector id=\"vud\" type=\"uint64\" count=\"16\"/>\n"
        "  <vector id=\"vd\" type=\"int64\" count=\"16\"/>\n"
        "  <vector id=\"vuw\" type=\"uint32\" count=\"32\"/>\n"
        "  <vector id=\"vw\" type=\"int32\" count=\"32\"/>\n"
        "  <vector id=\"vuh\" type=\"uint16\" count=\"64\"/>\n"
        "  <vector id=\"vh\" type=\"int16\" count=\"64\"/>\n"
        "  <vector id=\"vub\" type=\"uint8\" count=\"128\"/>\n"
        "  <vector id=\"vb\" type=\"int8\" count=\"128\"/>\n"
        "  <union id=\"hex_vec\">\n"
        "    <field name=\"ud\" type=\"vud\"/>\n"
        "    <field name=\"d\" type=\"vd\"/>\n"
        "    <field name=\"uw\" type=\"vuw\"/>\n"
        "    <field name=\"w\" type=\"vw\"/>\n"
        "    <field name=\"uh\" type=\"vuh\"/>\n"
        "    <field name=\"h\" type=\"vh\"/>\n"
        "    <field name=\"ub\" type=\"vub\"/>\n"
        "    <field name=\"b\" type=\"vb\"/>\n"
        "  </union>\n"
        "\n"
        "  <flags id=\"ui2\" size=\"1\">\n"
        "    <field name=\"0\" start=\"0\" end=\"0\"/>\n"
        "    <field name=\"1\" start=\"1\" end=\"1\"/>\n"
        "  </flags>\n"
        "  <flags id=\"ui4\" size=\"1\">\n"
        "    <field name=\"0\" start=\"0\" end=\"0\"/>\n"
        "    <field name=\"1\" start=\"1\" end=\"1\"/>\n"
        "    <field name=\"2\" start=\"2\" end=\"2\"/>\n"
        "    <field name=\"3\" start=\"3\" end=\"3\"/>\n"
        "  </flags>\n"
        "  <vector id=\"vpd\" type=\"uint8\" count=\"16\"/>\n"
        "  <vector id=\"vpw\" type=\"ui4\" count=\"32\"/>\n"
        "  <vector id=\"vph\" type=\"ui2\" count=\"64\"/>\n"
        "  <vector id=\"vpb\" type=\"bool\" count=\"128\"/>\n"
        "  <union id=\"hex_vec_pred\">\n"
        "    <field name=\"d\" type=\"vpd\"/>\n"
        "    <field name=\"w\" type=\"vpw\"/>\n"
        "    <field name=\"h\" type=\"vph\"/>\n"
        "    <field name=\"b\" type=\"vpb\"/>\n"
        "  </union>\n"
        "\n"
        "  <reg name=\"v0\"  bitsize=\"1024\" offset=\"256\"  encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"88\"/>\n"
        "  <reg name=\"v1\"  bitsize=\"1024\" offset=\"384\"  encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"89\"/>\n"
        "  <reg name=\"v2\"  bitsize=\"1024\" offset=\"512\"  encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"90\"/>\n"
        "  <reg name=\"v3\"  bitsize=\"1024\" offset=\"640\"  encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"91\"/>\n"
        "  <reg name=\"v4\"  bitsize=\"1024\" offset=\"768\"  encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"92\"/>\n"
        "  <reg name=\"v5\"  bitsize=\"1024\" offset=\"896\"  encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"93\"/>\n"
        "  <reg name=\"v6\"  bitsize=\"1024\" offset=\"1024\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"94\"/>\n"
        "  <reg name=\"v7\"  bitsize=\"1024\" offset=\"1152\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"95\"/>\n"
        "  <reg name=\"v8\"  bitsize=\"1024\" offset=\"1280\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"96\"/>\n"
        "  <reg name=\"v9\"  bitsize=\"1024\" offset=\"1408\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"97\"/>\n"
        "  <reg name=\"v10\" bitsize=\"1024\" offset=\"1536\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"98\"/>\n"
        "  <reg name=\"v11\" bitsize=\"1024\" offset=\"1664\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"99\"/>\n"
        "  <reg name=\"v12\" bitsize=\"1024\" offset=\"1792\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"100\"/>\n"
        "  <reg name=\"v13\" bitsize=\"1024\" offset=\"1920\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"101\"/>\n"
        "  <reg name=\"v14\" bitsize=\"1024\" offset=\"2048\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"102\"/>\n"
        "  <reg name=\"v15\" bitsize=\"1024\" offset=\"2176\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"103\"/>\n"
        "  <reg name=\"v16\" bitsize=\"1024\" offset=\"2304\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"104\"/>\n"
        "  <reg name=\"v17\" bitsize=\"1024\" offset=\"2432\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"105\"/>\n"
        "  <reg name=\"v18\" bitsize=\"1024\" offset=\"2560\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"106\"/>\n"
        "  <reg name=\"v19\" bitsize=\"1024\" offset=\"2688\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"107\"/>\n"
        "  <reg name=\"v20\" bitsize=\"1024\" offset=\"2816\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"108\"/>\n"
        "  <reg name=\"v21\" bitsize=\"1024\" offset=\"2944\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"109\"/>\n"
        "  <reg name=\"v22\" bitsize=\"1024\" offset=\"3072\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"110\"/>\n"
        "  <reg name=\"v23\" bitsize=\"1024\" offset=\"3200\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"111\"/>\n"
        "  <reg name=\"v24\" bitsize=\"1024\" offset=\"3328\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"112\"/>\n"
        "  <reg name=\"v25\" bitsize=\"1024\" offset=\"3456\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"113\"/>\n"
        "  <reg name=\"v26\" bitsize=\"1024\" offset=\"3584\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"114\"/>\n"
        "  <reg name=\"v27\" bitsize=\"1024\" offset=\"3712\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"115\"/>\n"
        "  <reg name=\"v28\" bitsize=\"1024\" offset=\"3840\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"116\"/>\n"
        "  <reg name=\"v29\" bitsize=\"1024\" offset=\"3968\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"117\"/>\n"
        "  <reg name=\"v30\" bitsize=\"1024\" offset=\"4096\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"118\"/>\n"
        "  <reg name=\"v31\" bitsize=\"1024\" offset=\"4224\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"119\"/>\n"
        "  <reg name=\"q0\"  bitsize=\"128\"  offset=\"4352\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"120\"/>\n"
        "  <reg name=\"q1\"  bitsize=\"128\"  offset=\"4368\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"121\"/>\n"
        "  <reg name=\"q2\"  bitsize=\"128\"  offset=\"4384\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"122\"/>\n"
        "  <reg name=\"q3\"  bitsize=\"128\"  offset=\"4400\" encoding=\"vector\" format=\"hex\" group=\"HVX Vector Registers\" dwarf_regnum=\"123\"/>\n"
        "\n"
        "</feature>\n",
        36,
    },
    { NULL }
};
