#include "qemu/osdep.h"
#include "exec/gdbstub.h"

const GDBFeature gdb_static_features[] = {
    {
        "power64-core.xml",
        "<?xml version=\"1.0\"?>\n"
        "<!-- Copyright (C) 2007, 2008 Free Software Foundation, Inc.\n"
        "\n"
        "     Copying and distribution of this file, with or without modification,\n"
        "     are permitted in any medium without royalty provided the copyright\n"
        "     notice and this notice are preserved.  -->\n"
        "\n"
        "<!DOCTYPE feature SYSTEM \"gdb-target.dtd\">\n"
        "<feature name=\"org.gnu.gdb.power.core\">\n"
        "  <reg name=\"r0\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r1\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r2\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r3\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r4\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r5\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r6\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r7\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r8\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r9\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r10\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r11\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r12\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r13\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r14\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r15\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r16\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r17\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r18\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r19\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r20\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r21\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r22\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r23\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r24\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r25\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r26\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r27\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r28\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r29\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r30\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"r31\" bitsize=\"64\" type=\"uint64\"/>\n"
        "\n"
        "  <reg name=\"pc\" bitsize=\"64\" type=\"code_ptr\" regnum=\"64\"/>\n"
        "  <reg name=\"msr\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"cr\" bitsize=\"32\" type=\"uint32\"/>\n"
        "  <reg name=\"lr\" bitsize=\"64\" type=\"code_ptr\"/>\n"
        "  <reg name=\"ctr\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"xer\" bitsize=\"32\" type=\"uint32\"/>\n"
        "</feature>\n",
        70,
    },
    {
        "power-fpu.xml",
        "<?xml version=\"1.0\"?>\n"
        "<!-- Copyright (C) 2007, 2008 Free Software Foundation, Inc.\n"
        "\n"
        "     Copying and distribution of this file, with or without modification,\n"
        "     are permitted in any medium without royalty provided the copyright\n"
        "     notice and this notice are preserved.  -->\n"
        "\n"
        "<!DOCTYPE feature SYSTEM \"gdb-target.dtd\">\n"
        "<feature name=\"org.gnu.gdb.power.fpu\">\n"
        "  <reg name=\"f0\" bitsize=\"64\" type=\"ieee_double\" regnum=\"71\"/>\n"
        "  <reg name=\"f1\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f2\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f3\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f4\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f5\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f6\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f7\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f8\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f9\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f10\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f11\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f12\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f13\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f14\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f15\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f16\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f17\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f18\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f19\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f20\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f21\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f22\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f23\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f24\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f25\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f26\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f27\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f28\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f29\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f30\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "  <reg name=\"f31\" bitsize=\"64\" type=\"ieee_double\"/>\n"
        "\n"
        "  <reg name=\"fpscr\" bitsize=\"32\" group=\"float\"/>\n"
        "</feature>\n",
        33,
    },
    {
        "power-altivec.xml",
        "<?xml version=\"1.0\"?>\n"
        "<!-- Copyright (C) 2007, 2008 Free Software Foundation, Inc.\n"
        "\n"
        "     Copying and distribution of this file, with or without modification,\n"
        "     are permitted in any medium without royalty provided the copyright\n"
        "     notice and this notice are preserved.  -->\n"
        "\n"
        "<!DOCTYPE feature SYSTEM \"gdb-target.dtd\">\n"
        "<feature name=\"org.gnu.gdb.power.altivec\">\n"
        "  <vector id=\"v4f\" type=\"ieee_single\" count=\"4\"/>\n"
        "  <vector id=\"v4i32\" type=\"int32\" count=\"4\"/>\n"
        "  <vector id=\"v8i16\" type=\"int16\" count=\"8\"/>\n"
        "  <vector id=\"v16i8\" type=\"int8\" count=\"16\"/>\n"
        "  <union id=\"vec128\">\n"
        "    <field name=\"uint128\" type=\"uint128\"/>\n"
        "    <field name=\"v4_float\" type=\"v4f\"/>\n"
        "    <field name=\"v4_int32\" type=\"v4i32\"/>\n"
        "    <field name=\"v8_int16\" type=\"v8i16\"/>\n"
        "    <field name=\"v16_int8\" type=\"v16i8\"/>\n"
        "  </union>\n"
        "\n"
        "  <reg name=\"vr0\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr1\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr2\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr3\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr4\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr5\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr6\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr7\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr8\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr9\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr10\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr11\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr12\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr13\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr14\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr15\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr16\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr17\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr18\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr19\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr20\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr21\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr22\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr23\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr24\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr25\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr26\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr27\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr28\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr29\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr30\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"vr31\" bitsize=\"128\" type=\"vec128\"/>\n"
        "\n"
        "  <reg name=\"vscr\" bitsize=\"32\" group=\"vector\"/>\n"
        "  <reg name=\"vrsave\" bitsize=\"32\" group=\"vector\"/>\n"
        "</feature>\n",
        34,
    },
    {
        "power-spe.xml",
        "<?xml version=\"1.0\"?>\n"
        "<!-- Copyright (C) 2007, 2008 Free Software Foundation, Inc.\n"
        "\n"
        "     Copying and distribution of this file, with or without modification,\n"
        "     are permitted in any medium without royalty provided the copyright\n"
        "     notice and this notice are preserved.  -->\n"
        "\n"
        "<!DOCTYPE feature SYSTEM \"gdb-target.dtd\">\n"
        "<feature name=\"org.gnu.gdb.power.spe\">\n"
        "  <reg name=\"ev0h\" bitsize=\"32\" regnum=\"71\"/>\n"
        "  <reg name=\"ev1h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev2h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev3h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev4h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev5h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev6h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev7h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev8h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev9h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev10h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev11h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev12h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev13h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev14h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev15h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev16h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev17h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev18h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev19h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev20h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev21h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev22h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev23h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev24h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev25h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev26h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev27h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev28h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev29h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev30h\" bitsize=\"32\"/>\n"
        "  <reg name=\"ev31h\" bitsize=\"32\"/>\n"
        "\n"
        "  <reg name=\"acc\" bitsize=\"64\"/>\n"
        "  <reg name=\"spefscr\" bitsize=\"32\"/>\n"
        "</feature>\n",
        34,
    },
    {
        "power-vsx.xml",
        "<?xml version=\"1.0\"?>\n"
        "<!-- Copyright (C) 2008-2015 Free Software Foundation, Inc.\n"
        "\n"
        "     Copying and distribution of this file, with or without modification,\n"
        "     are permitted in any medium without royalty provided the copyright\n"
        "     notice and this notice are preserved.  -->\n"
        "\n"
        "<!-- POWER7 VSX registers that do not overlap existing FP and VMX\n"
        "     registers.  -->\n"
        "<!DOCTYPE feature SYSTEM \"gdb-target.dtd\">\n"
        "<feature name=\"org.gnu.gdb.power.vsx\">\n"
        "  <reg name=\"vs0h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs1h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs2h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs3h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs4h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs5h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs6h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs7h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs8h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs9h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs10h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs11h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs12h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs13h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs14h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs15h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs16h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs17h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs18h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs19h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs20h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs21h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs22h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs23h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs24h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs25h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs26h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs27h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs28h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs29h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs30h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"vs31h\" bitsize=\"64\" type=\"uint64\"/>\n"
        "</feature>\n",
        32,
    },
    { NULL }
};
