#include "qemu/osdep.h"
#include "exec/gdbstub.h"

const GDBFeature gdb_static_features[] = {
    {
        "s390x-core64.xml",
        "<?xml version=\"1.0\"?>\n"
        "<!-- Copyright (C) 2010-2014 Free Software Foundation, Inc.\n"
        "\n"
        "     Copying and distribution of this file, with or without modification,\n"
        "     are permitted in any medium without royalty provided the copyright\n"
        "     notice and this notice are preserved.  -->\n"
        "\n"
        "<!DOCTYPE feature SYSTEM \"gdb-target.dtd\">\n"
        "<feature name=\"org.gnu.gdb.s390.core\">\n"
        "  <reg name=\"pswm\" bitsize=\"64\" type=\"uint64\" group=\"psw\"/>\n"
        "  <reg name=\"pswa\" bitsize=\"64\" type=\"uint64\" group=\"psw\"/>\n"
        "  <reg name=\"r0\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r1\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r2\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r3\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r4\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r5\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r6\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r7\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r8\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r9\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r10\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r11\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r12\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r13\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r14\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "  <reg name=\"r15\" bitsize=\"64\" type=\"uint64\" group=\"general\"/>\n"
        "</feature>\n",
        18,
    },
    {
        "s390-acr.xml",
        "<?xml version=\"1.0\"?>\n"
        "<!-- Copyright (C) 2010-2014 Free Software Foundation, Inc.\n"
        "\n"
        "     Copying and distribution of this file, with or without modification,\n"
        "     are permitted in any medium without royalty provided the copyright\n"
        "     notice and this notice are preserved.  -->\n"
        "\n"
        "<!DOCTYPE feature SYSTEM \"gdb-target.dtd\">\n"
        "<feature name=\"org.gnu.gdb.s390.acr\">\n"
        "  <reg name=\"acr0\" bitsize=\"32\" type=\"uint32\" group=\"access\"/>\n"
        "  <reg name=\"acr1\" bitsize=\"32\" type=\"uint32\" group=\"access\"/>\n"
        "  <reg name=\"acr2\" bitsize=\"32\" type=\"uint32\" group=\"access\"/>\n"
        "  <reg name=\"acr3\" bitsize=\"32\" type=\"uint32\" group=\"access\"/>\n"
        "  <reg name=\"acr4\" bitsize=\"32\" type=\"uint32\" group=\"access\"/>\n"
        "  <reg name=\"acr5\" bitsize=\"32\" type=\"uint32\" group=\"access\"/>\n"
        "  <reg name=\"acr6\" bitsize=\"32\" type=\"uint32\" group=\"access\"/>\n"
        "  <reg name=\"acr7\" bitsize=\"32\" type=\"uint32\" group=\"access\"/>\n"
        "  <reg name=\"acr8\" bitsize=\"32\" type=\"uint32\" group=\"access\"/>\n"
        "  <reg name=\"acr9\" bitsize=\"32\" type=\"uint32\" group=\"access\"/>\n"
        "  <reg name=\"acr10\" bitsize=\"32\" type=\"uint32\" group=\"access\"/>\n"
        "  <reg name=\"acr11\" bitsize=\"32\" type=\"uint32\" group=\"access\"/>\n"
        "  <reg name=\"acr12\" bitsize=\"32\" type=\"uint32\" group=\"access\"/>\n"
        "  <reg name=\"acr13\" bitsize=\"32\" type=\"uint32\" group=\"access\"/>\n"
        "  <reg name=\"acr14\" bitsize=\"32\" type=\"uint32\" group=\"access\"/>\n"
        "  <reg name=\"acr15\" bitsize=\"32\" type=\"uint32\" group=\"access\"/>\n"
        "</feature>\n",
        16,
    },
    {
        "s390-fpr.xml",
        "<?xml version=\"1.0\"?>\n"
        "<!-- Copyright (C) 2010-2014 Free Software Foundation, Inc.\n"
        "\n"
        "     Copying and distribution of this file, with or without modification,\n"
        "     are permitted in any medium without royalty provided the copyright\n"
        "     notice and this notice are preserved.  -->\n"
        "\n"
        "<!DOCTYPE feature SYSTEM \"gdb-target.dtd\">\n"
        "<feature name=\"org.gnu.gdb.s390.fpr\">\n"
        "  <reg name=\"fpc\" bitsize=\"32\" type=\"uint32\" group=\"float\"/>\n"
        "  <reg name=\"f0\" bitsize=\"64\" type=\"ieee_double\" group=\"float\"/>\n"
        "  <reg name=\"f1\" bitsize=\"64\" type=\"ieee_double\" group=\"float\"/>\n"
        "  <reg name=\"f2\" bitsize=\"64\" type=\"ieee_double\" group=\"float\"/>\n"
        "  <reg name=\"f3\" bitsize=\"64\" type=\"ieee_double\" group=\"float\"/>\n"
        "  <reg name=\"f4\" bitsize=\"64\" type=\"ieee_double\" group=\"float\"/>\n"
        "  <reg name=\"f5\" bitsize=\"64\" type=\"ieee_double\" group=\"float\"/>\n"
        "  <reg name=\"f6\" bitsize=\"64\" type=\"ieee_double\" group=\"float\"/>\n"
        "  <reg name=\"f7\" bitsize=\"64\" type=\"ieee_double\" group=\"float\"/>\n"
        "  <reg name=\"f8\" bitsize=\"64\" type=\"ieee_double\" group=\"float\"/>\n"
        "  <reg name=\"f9\" bitsize=\"64\" type=\"ieee_double\" group=\"float\"/>\n"
        "  <reg name=\"f10\" bitsize=\"64\" type=\"ieee_double\" group=\"float\"/>\n"
        "  <reg name=\"f11\" bitsize=\"64\" type=\"ieee_double\" group=\"float\"/>\n"
        "  <reg name=\"f12\" bitsize=\"64\" type=\"ieee_double\" group=\"float\"/>\n"
        "  <reg name=\"f13\" bitsize=\"64\" type=\"ieee_double\" group=\"float\"/>\n"
        "  <reg name=\"f14\" bitsize=\"64\" type=\"ieee_double\" group=\"float\"/>\n"
        "  <reg name=\"f15\" bitsize=\"64\" type=\"ieee_double\" group=\"float\"/>\n"
        "</feature>\n",
        17,
    },
    {
        "s390-vx.xml",
        "<?xml version=\"1.0\"?>\n"
        "<!-- Copyright (C) 2010-2014 Free Software Foundation, Inc.\n"
        "\n"
        "     Copying and distribution of this file, with or without modification,\n"
        "     are permitted in any medium without royalty provided the copyright\n"
        "     notice and this notice are preserved.  -->\n"
        "\n"
        "<!DOCTYPE feature SYSTEM \"gdb-target.dtd\">\n"
        "<feature name=\"org.gnu.gdb.s390.vx\">\n"
        "  <vector id=\"v4f\" type=\"ieee_single\" count=\"4\"/>\n"
        "  <vector id=\"v2d\" type=\"ieee_double\" count=\"2\"/>\n"
        "  <vector id=\"v16i8\" type=\"int8\" count=\"16\"/>\n"
        "  <vector id=\"v8i16\" type=\"int16\" count=\"8\"/>\n"
        "  <vector id=\"v4i32\" type=\"int32\" count=\"4\"/>\n"
        "  <vector id=\"v2i64\" type=\"int64\" count=\"2\"/>\n"
        "  <union id=\"vec128\">\n"
        "    <field name=\"v4_float\" type=\"v4f\"/>\n"
        "    <field name=\"v2_double\" type=\"v2d\"/>\n"
        "    <field name=\"v16_int8\" type=\"v16i8\"/>\n"
        "    <field name=\"v8_int16\" type=\"v8i16\"/>\n"
        "    <field name=\"v4_int32\" type=\"v4i32\"/>\n"
        "    <field name=\"v2_int64\" type=\"v2i64\"/>\n"
        "    <field name=\"uint128\" type=\"uint128\"/>\n"
        "  </union>\n"
        "\n"
        "  <reg name=\"v0l\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"v1l\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"v2l\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"v3l\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"v4l\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"v5l\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"v6l\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"v7l\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"v8l\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"v9l\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"v10l\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"v11l\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"v12l\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"v13l\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"v14l\" bitsize=\"64\" type=\"uint64\"/>\n"
        "  <reg name=\"v15l\" bitsize=\"64\" type=\"uint64\"/>\n"
        "\n"
        "  <reg name=\"v16\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"v17\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"v18\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"v19\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"v20\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"v21\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"v22\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"v23\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"v24\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"v25\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"v26\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"v27\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"v28\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"v29\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"v30\" bitsize=\"128\" type=\"vec128\"/>\n"
        "  <reg name=\"v31\" bitsize=\"128\" type=\"vec128\"/>\n"
        "</feature>\n",
        32,
    },
    {
        "s390-cr.xml",
        "<?xml version=\"1.0\"?>\n"
        "<!-- Copyright 2015 IBM Corp.\n"
        "\n"
        "     This work is licensed under the terms of the GNU GPL, version 2 or\n"
        "     (at your option) any later version. See the COPYING file in the\n"
        "     top-level directory. -->\n"
        "\n"
        "<!DOCTYPE feature SYSTEM \"gdb-target.dtd\">\n"
        "<feature name=\"org.gnu.gdb.s390.cr\">\n"
        "  <reg name=\"cr0\" bitsize=\"64\" type=\"uint64\" group=\"control\"/>\n"
        "  <reg name=\"cr1\" bitsize=\"64\" type=\"uint64\" group=\"control\"/>\n"
        "  <reg name=\"cr2\" bitsize=\"64\" type=\"uint64\" group=\"control\"/>\n"
        "  <reg name=\"cr3\" bitsize=\"64\" type=\"uint64\" group=\"control\"/>\n"
        "  <reg name=\"cr4\" bitsize=\"64\" type=\"uint64\" group=\"control\"/>\n"
        "  <reg name=\"cr5\" bitsize=\"64\" type=\"uint64\" group=\"control\"/>\n"
        "  <reg name=\"cr6\" bitsize=\"64\" type=\"uint64\" group=\"control\"/>\n"
        "  <reg name=\"cr7\" bitsize=\"64\" type=\"uint64\" group=\"control\"/>\n"
        "  <reg name=\"cr8\" bitsize=\"64\" type=\"uint64\" group=\"control\"/>\n"
        "  <reg name=\"cr9\" bitsize=\"64\" type=\"uint64\" group=\"control\"/>\n"
        "  <reg name=\"cr10\" bitsize=\"64\" type=\"uint64\" group=\"control\"/>\n"
        "  <reg name=\"cr11\" bitsize=\"64\" type=\"uint64\" group=\"control\"/>\n"
        "  <reg name=\"cr12\" bitsize=\"64\" type=\"uint64\" group=\"control\"/>\n"
        "  <reg name=\"cr13\" bitsize=\"64\" type=\"uint64\" group=\"control\"/>\n"
        "  <reg name=\"cr14\" bitsize=\"64\" type=\"uint64\" group=\"control\"/>\n"
        "  <reg name=\"cr15\" bitsize=\"64\" type=\"uint64\" group=\"control\"/>\n"
        "</feature>\n",
        16,
    },
    {
        "s390-virt.xml",
        "<?xml version=\"1.0\"?>\n"
        "<!-- Copyright 2015 IBM Corp.\n"
        "\n"
        "     This work is licensed under the terms of the GNU GPL, version 2 or\n"
        "     (at your option) any later version. See the COPYING file in the\n"
        "     top-level directory. -->\n"
        "\n"
        "<!DOCTYPE feature SYSTEM \"gdb-target.dtd\">\n"
        "<feature name=\"org.gnu.gdb.s390.virt\">\n"
        "  <reg name=\"ckc\" bitsize=\"64\" type=\"uint64\" group=\"system\"/>\n"
        "  <reg name=\"cputm\" bitsize=\"64\" type=\"uint64\" group=\"system\"/>\n"
        "  <reg name=\"last_break\" bitsize=\"64\" type=\"code_ptr\" group=\"system\"/>\n"
        "  <reg name=\"prefix\" bitsize=\"64\" type=\"data_ptr\" group=\"system\"/>\n"
        "</feature>\n",
        4,
    },
    {
        "s390-virt-kvm.xml",
        "<?xml version=\"1.0\"?>\n"
        "<!-- Copyright 2023 IBM Corp.\n"
        "\n"
        "     This work is licensed under the terms of the GNU GPL, version 2 or\n"
        "     (at your option) any later version. See the COPYING file in the\n"
        "     top-level directory. -->\n"
        "\n"
        "<!DOCTYPE feature SYSTEM \"gdb-target.dtd\">\n"
        "<feature name=\"org.gnu.gdb.s390.virt.kvm\">\n"
        "  <reg name=\"pp\" bitsize=\"64\" type=\"uint64\" group=\"system\"/>\n"
        "  <reg name=\"pfault_token\" bitsize=\"64\" type=\"uint64\" group=\"system\"/>\n"
        "  <reg name=\"pfault_select\" bitsize=\"64\" type=\"uint64\" group=\"system\"/>\n"
        "  <reg name=\"pfault_compare\" bitsize=\"64\" type=\"uint64\" group=\"system\"/>\n"
        "</feature>\n",
        4,
    },
    {
        "s390-gs.xml",
        "<?xml version=\"1.0\"?>\n"
        "<!-- Copyright 2017 IBM Corp.\n"
        "\n"
        "     This work is licensed under the terms of the GNU GPL, version 2 or\n"
        "     (at your option) any later version. See the COPYING file in the\n"
        "     top-level directory. -->\n"
        "\n"
        "<!DOCTYPE feature SYSTEM \"gdb-target.dtd\">\n"
        "<feature name=\"org.gnu.gdb.s390.gs\">\n"
        "  <reg name=\"gs_reserved\" bitsize=\"64\" type=\"uint64\" group=\"system\"/>\n"
        "  <reg name=\"gsd\" bitsize=\"64\" type=\"uint64\" group=\"system\"/>\n"
        "  <reg name=\"gssm\" bitsize=\"64\" type=\"uint64\" group=\"system\"/>\n"
        "  <reg name=\"gsepla\" bitsize=\"64\" type=\"data_ptr\" group=\"system\"/>\n"
        "</feature>\n",
        4,
    },
    { NULL }
};
