#include "qemu/osdep.h"
#include "qemu/log.h"
#include "cpu.h"
#include "internal.h"
#include "tcg/tcg.h"
#include "tcg/tcg-op.h"
#include "exec/helper-gen.h"
#include "insn.h"
#include "opcodes.h"
#include "translate.h"
#define QEMU_GENERATE
#include "genptr.h"
#include "macros.h"
#include "target/hexagon/idef-generated-emitter.h.inc"
void emit_J4_hintjumpr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV)
/* {fHINTJR(RsV);} */
{
}

void emit_J2_loop0r(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int riV)
/* { fIMMEXT(riV); (riV = riV & ~3); SA0 = fREAD_PC()+riV; (LC0 = RsV); (USR.LPCFG = 0); } */
{
int32_t qemu_tmp_0 = ~(((int32_t) 0x3));
int32_t qemu_tmp_1 = riV & qemu_tmp_0;
riV = qemu_tmp_1;
int32_t qemu_tmp_2 = ctx->base.pc_next + riV;
TCGv_i32 tmp_0 = tcg_constant_i32((int32_t) (qemu_tmp_2));
gen_log_reg_write(ctx, 32, tmp_0);
gen_log_reg_write(ctx, 33, RsV);
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
gen_set_usr_field(ctx, USR_LPCFG, tmp_1);
}

void emit_J2_loop1r(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int riV)
/* { fIMMEXT(riV); (riV = riV & ~3); SA1 = fREAD_PC()+riV; (LC1 = RsV); } */
{
int32_t qemu_tmp_0 = ~(((int32_t) 0x3));
int32_t qemu_tmp_1 = riV & qemu_tmp_0;
riV = qemu_tmp_1;
int32_t qemu_tmp_2 = ctx->base.pc_next + riV;
TCGv_i32 tmp_0 = tcg_constant_i32((int32_t) (qemu_tmp_2));
gen_log_reg_write(ctx, 34, tmp_0);
gen_log_reg_write(ctx, 35, RsV);
}

void emit_J2_loop0i(DisasContext *ctx, Insn *insn, Packet *pkt, int riV, int UiV)
/* { fIMMEXT(riV); (riV = riV & ~3); SA0 = fREAD_PC()+riV; (LC0 = UiV); (USR.LPCFG = 0); } */
{
int32_t qemu_tmp_0 = ~(((int32_t) 0x3));
int32_t qemu_tmp_1 = riV & qemu_tmp_0;
riV = qemu_tmp_1;
int32_t qemu_tmp_2 = ctx->base.pc_next + riV;
TCGv_i32 tmp_0 = tcg_constant_i32((int32_t) (qemu_tmp_2));
gen_log_reg_write(ctx, 32, tmp_0);
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (UiV));
gen_log_reg_write(ctx, 33, tmp_1);
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
gen_set_usr_field(ctx, USR_LPCFG, tmp_2);
}

void emit_J2_loop1i(DisasContext *ctx, Insn *insn, Packet *pkt, int riV, int UiV)
/* { fIMMEXT(riV); (riV = riV & ~3); SA1 = fREAD_PC()+riV; (LC1 = UiV); } */
{
int32_t qemu_tmp_0 = ~(((int32_t) 0x3));
int32_t qemu_tmp_1 = riV & qemu_tmp_0;
riV = qemu_tmp_1;
int32_t qemu_tmp_2 = ctx->base.pc_next + riV;
TCGv_i32 tmp_0 = tcg_constant_i32((int32_t) (qemu_tmp_2));
gen_log_reg_write(ctx, 34, tmp_0);
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (UiV));
gen_log_reg_write(ctx, 35, tmp_1);
}

void emit_J2_ploop1sr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int riV)
/* { fIMMEXT(riV); (riV = riV & ~3); SA0 = fREAD_PC()+riV; (LC0 = RsV); (USR.LPCFG = 1); P3 = 0;; } */
{
int32_t qemu_tmp_0 = ~(((int32_t) 0x3));
int32_t qemu_tmp_1 = riV & qemu_tmp_0;
riV = qemu_tmp_1;
int32_t qemu_tmp_2 = ctx->base.pc_next + riV;
TCGv_i32 tmp_0 = tcg_constant_i32((int32_t) (qemu_tmp_2));
gen_log_reg_write(ctx, 32, tmp_0);
gen_log_reg_write(ctx, 33, RsV);
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (((int32_t) 0x1)));
gen_set_usr_field(ctx, USR_LPCFG, tmp_1);
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_3, tmp_2, 0xff);
gen_log_pred_write(ctx, 3, tmp_3);
}

void emit_J2_ploop1si(DisasContext *ctx, Insn *insn, Packet *pkt, int riV, int UiV)
/* { fIMMEXT(riV); (riV = riV & ~3); SA0 = fREAD_PC()+riV; (LC0 = UiV); (USR.LPCFG = 1); P3 = 0;; } */
{
int32_t qemu_tmp_0 = ~(((int32_t) 0x3));
int32_t qemu_tmp_1 = riV & qemu_tmp_0;
riV = qemu_tmp_1;
int32_t qemu_tmp_2 = ctx->base.pc_next + riV;
TCGv_i32 tmp_0 = tcg_constant_i32((int32_t) (qemu_tmp_2));
gen_log_reg_write(ctx, 32, tmp_0);
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (UiV));
gen_log_reg_write(ctx, 33, tmp_1);
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (((int32_t) 0x1)));
gen_set_usr_field(ctx, USR_LPCFG, tmp_2);
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_4, tmp_3, 0xff);
gen_log_pred_write(ctx, 3, tmp_4);
}

void emit_J2_ploop2sr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int riV)
/* { fIMMEXT(riV); (riV = riV & ~3); SA0 = fREAD_PC()+riV; (LC0 = RsV); (USR.LPCFG = 2); P3 = 0;; } */
{
int32_t qemu_tmp_0 = ~(((int32_t) 0x3));
int32_t qemu_tmp_1 = riV & qemu_tmp_0;
riV = qemu_tmp_1;
int32_t qemu_tmp_2 = ctx->base.pc_next + riV;
TCGv_i32 tmp_0 = tcg_constant_i32((int32_t) (qemu_tmp_2));
gen_log_reg_write(ctx, 32, tmp_0);
gen_log_reg_write(ctx, 33, RsV);
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (((int32_t) 0x2)));
gen_set_usr_field(ctx, USR_LPCFG, tmp_1);
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_3, tmp_2, 0xff);
gen_log_pred_write(ctx, 3, tmp_3);
}

void emit_J2_ploop2si(DisasContext *ctx, Insn *insn, Packet *pkt, int riV, int UiV)
/* { fIMMEXT(riV); (riV = riV & ~3); SA0 = fREAD_PC()+riV; (LC0 = UiV); (USR.LPCFG = 2); P3 = 0;; } */
{
int32_t qemu_tmp_0 = ~(((int32_t) 0x3));
int32_t qemu_tmp_1 = riV & qemu_tmp_0;
riV = qemu_tmp_1;
int32_t qemu_tmp_2 = ctx->base.pc_next + riV;
TCGv_i32 tmp_0 = tcg_constant_i32((int32_t) (qemu_tmp_2));
gen_log_reg_write(ctx, 32, tmp_0);
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (UiV));
gen_log_reg_write(ctx, 33, tmp_1);
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (((int32_t) 0x2)));
gen_set_usr_field(ctx, USR_LPCFG, tmp_2);
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_4, tmp_3, 0xff);
gen_log_pred_write(ctx, 3, tmp_4);
}

void emit_J2_ploop3sr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int riV)
/* { fIMMEXT(riV); (riV = riV & ~3); SA0 = fREAD_PC()+riV; (LC0 = RsV); (USR.LPCFG = 3); P3 = 0;; } */
{
int32_t qemu_tmp_0 = ~(((int32_t) 0x3));
int32_t qemu_tmp_1 = riV & qemu_tmp_0;
riV = qemu_tmp_1;
int32_t qemu_tmp_2 = ctx->base.pc_next + riV;
TCGv_i32 tmp_0 = tcg_constant_i32((int32_t) (qemu_tmp_2));
gen_log_reg_write(ctx, 32, tmp_0);
gen_log_reg_write(ctx, 33, RsV);
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (((int32_t) 0x3)));
gen_set_usr_field(ctx, USR_LPCFG, tmp_1);
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_3, tmp_2, 0xff);
gen_log_pred_write(ctx, 3, tmp_3);
}

void emit_J2_ploop3si(DisasContext *ctx, Insn *insn, Packet *pkt, int riV, int UiV)
/* { fIMMEXT(riV); (riV = riV & ~3); SA0 = fREAD_PC()+riV; (LC0 = UiV); (USR.LPCFG = 3); P3 = 0;; } */
{
int32_t qemu_tmp_0 = ~(((int32_t) 0x3));
int32_t qemu_tmp_1 = riV & qemu_tmp_0;
riV = qemu_tmp_1;
int32_t qemu_tmp_2 = ctx->base.pc_next + riV;
TCGv_i32 tmp_0 = tcg_constant_i32((int32_t) (qemu_tmp_2));
gen_log_reg_write(ctx, 32, tmp_0);
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (UiV));
gen_log_reg_write(ctx, 33, tmp_1);
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (((int32_t) 0x3)));
gen_set_usr_field(ctx, USR_LPCFG, tmp_2);
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_4, tmp_3, 0xff);
gen_log_pred_write(ctx, 3, tmp_4);
}

void emit_L2_loadrub_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int siV)
/* size4u_t EA; {fIMMEXT(siV); (EA = RsV + siV); fLOAD(1,1,u,EA,RdV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
}

void emit_L4_loadrub_ur(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, int uiV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV + (RtV << uiV)); fLOAD(1,1,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, UiV);
tcg_gen_mov_i32(EA, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
}

void emit_L4_loadrub_ap(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 ReV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV); fLOAD(1,1,u,EA,RdV); ReV=UiV; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, UiV);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
tcg_gen_movi_i32(ReV, UiV);
}

void emit_L2_loadrub_pr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + MuV); fLOAD(1,1,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
}

void emit_L2_loadrub_pbr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = fbrev(RxV)); (RxV = RxV + MuV); fLOAD(1,1,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_helper_fbrev(tmp_0, RxV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
}

void emit_L2_loadrub_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + siV); fLOAD(1,1,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
}

void emit_L2_loadrub_pci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, int siV)
/* size4u_t EA; {(EA = RxV); fPM_CIRI(RxV,siV,MuV); fLOAD(1,1,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (siV));
gen_read_reg(tmp_0, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_1, MuV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
}

void emit_L2_loadrub_pcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); fPM_CIRR(RxV,fREAD_IREG(MuV)<<0,MuV); fLOAD(1,1,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_read_ireg(tmp_0, MuV, ((int32_t) 0x0));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_read_reg(tmp_1, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_0, MuV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
}

void emit_L2_loadrb_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int siV)
/* size4u_t EA; {fIMMEXT(siV); (EA = RsV + siV); fLOAD(1,1,s,EA,RdV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
}

void emit_L4_loadrb_ur(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, int uiV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV + (RtV << uiV)); fLOAD(1,1,s,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, UiV);
tcg_gen_mov_i32(EA, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
}

void emit_L4_loadrb_ap(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 ReV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV); fLOAD(1,1,s,EA,RdV); ReV=UiV; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, UiV);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
tcg_gen_movi_i32(ReV, UiV);
}

void emit_L2_loadrb_pr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + MuV); fLOAD(1,1,s,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
}

void emit_L2_loadrb_pbr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = fbrev(RxV)); (RxV = RxV + MuV); fLOAD(1,1,s,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_helper_fbrev(tmp_0, RxV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
}

void emit_L2_loadrb_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + siV); fLOAD(1,1,s,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
}

void emit_L2_loadrb_pci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, int siV)
/* size4u_t EA; {(EA = RxV); fPM_CIRI(RxV,siV,MuV); fLOAD(1,1,s,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (siV));
gen_read_reg(tmp_0, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_1, MuV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
}

void emit_L2_loadrb_pcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); fPM_CIRR(RxV,fREAD_IREG(MuV)<<0,MuV); fLOAD(1,1,s,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_read_ireg(tmp_0, MuV, ((int32_t) 0x0));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_read_reg(tmp_1, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_0, MuV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
}

void emit_L2_loadruh_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int siV)
/* size4u_t EA; {fIMMEXT(siV); (EA = RsV + siV); fLOAD(1,2,u,EA,RdV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
}

void emit_L4_loadruh_ur(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, int uiV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV + (RtV << uiV)); fLOAD(1,2,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, UiV);
tcg_gen_mov_i32(EA, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
}

void emit_L4_loadruh_ap(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 ReV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV); fLOAD(1,2,u,EA,RdV); ReV=UiV; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, UiV);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
tcg_gen_movi_i32(ReV, UiV);
}

void emit_L2_loadruh_pr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + MuV); fLOAD(1,2,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
}

void emit_L2_loadruh_pbr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = fbrev(RxV)); (RxV = RxV + MuV); fLOAD(1,2,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_helper_fbrev(tmp_0, RxV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
}

void emit_L2_loadruh_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + siV); fLOAD(1,2,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
}

void emit_L2_loadruh_pci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, int siV)
/* size4u_t EA; {(EA = RxV); fPM_CIRI(RxV,siV,MuV); fLOAD(1,2,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (siV));
gen_read_reg(tmp_0, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_1, MuV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
}

void emit_L2_loadruh_pcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); fPM_CIRR(RxV,fREAD_IREG(MuV)<<1,MuV); fLOAD(1,2,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_read_ireg(tmp_0, MuV, ((int32_t) 0x1));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_read_reg(tmp_1, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_0, MuV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
}

void emit_L2_loadrh_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int siV)
/* size4u_t EA; {fIMMEXT(siV); (EA = RsV + siV); fLOAD(1,2,s,EA,RdV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
}

void emit_L4_loadrh_ur(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, int uiV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV + (RtV << uiV)); fLOAD(1,2,s,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, UiV);
tcg_gen_mov_i32(EA, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
}

void emit_L4_loadrh_ap(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 ReV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV); fLOAD(1,2,s,EA,RdV); ReV=UiV; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, UiV);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
tcg_gen_movi_i32(ReV, UiV);
}

void emit_L2_loadrh_pr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + MuV); fLOAD(1,2,s,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
}

void emit_L2_loadrh_pbr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = fbrev(RxV)); (RxV = RxV + MuV); fLOAD(1,2,s,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_helper_fbrev(tmp_0, RxV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
}

void emit_L2_loadrh_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + siV); fLOAD(1,2,s,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
}

void emit_L2_loadrh_pci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, int siV)
/* size4u_t EA; {(EA = RxV); fPM_CIRI(RxV,siV,MuV); fLOAD(1,2,s,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (siV));
gen_read_reg(tmp_0, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_1, MuV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
}

void emit_L2_loadrh_pcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); fPM_CIRR(RxV,fREAD_IREG(MuV)<<1,MuV); fLOAD(1,2,s,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_read_ireg(tmp_0, MuV, ((int32_t) 0x1));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_read_reg(tmp_1, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_0, MuV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
}

void emit_L2_loadri_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int siV)
/* size4u_t EA; {fIMMEXT(siV); (EA = RsV + siV); fLOAD(1,4,u,EA,RdV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
}

void emit_L4_loadri_ur(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, int uiV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV + (RtV << uiV)); fLOAD(1,4,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, UiV);
tcg_gen_mov_i32(EA, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
}

void emit_L4_loadri_ap(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 ReV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV); fLOAD(1,4,u,EA,RdV); ReV=UiV; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, UiV);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
tcg_gen_movi_i32(ReV, UiV);
}

void emit_L2_loadri_pr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + MuV); fLOAD(1,4,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
}

void emit_L2_loadri_pbr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = fbrev(RxV)); (RxV = RxV + MuV); fLOAD(1,4,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_helper_fbrev(tmp_0, RxV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
}

void emit_L2_loadri_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + siV); fLOAD(1,4,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
}

void emit_L2_loadri_pci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, int siV)
/* size4u_t EA; {(EA = RxV); fPM_CIRI(RxV,siV,MuV); fLOAD(1,4,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (siV));
gen_read_reg(tmp_0, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_1, MuV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
}

void emit_L2_loadri_pcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); fPM_CIRR(RxV,fREAD_IREG(MuV)<<2,MuV); fLOAD(1,4,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_read_ireg(tmp_0, MuV, ((int32_t) 0x2));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_read_reg(tmp_1, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_0, MuV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
}

void emit_L2_loadrd_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, int siV)
/* size4u_t EA; {fIMMEXT(siV); (EA = RsV + siV); fLOAD(1,8,u,EA,RddV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
}

void emit_L4_loadrd_ur(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RtV, int uiV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV + (RtV << uiV)); fLOAD(1,8,u,EA,RddV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, UiV);
tcg_gen_mov_i32(EA, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
}

void emit_L4_loadrd_ap(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 ReV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV); fLOAD(1,8,u,EA,RddV); ReV=UiV; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, UiV);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
tcg_gen_movi_i32(ReV, UiV);
}

void emit_L2_loadrd_pr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + MuV); fLOAD(1,8,u,EA,RddV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
}

void emit_L2_loadrd_pbr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = fbrev(RxV)); (RxV = RxV + MuV); fLOAD(1,8,u,EA,RddV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_helper_fbrev(tmp_0, RxV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
}

void emit_L2_loadrd_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + siV); fLOAD(1,8,u,EA,RddV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
}

void emit_L2_loadrd_pci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, int siV)
/* size4u_t EA; {(EA = RxV); fPM_CIRI(RxV,siV,MuV); fLOAD(1,8,u,EA,RddV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (siV));
gen_read_reg(tmp_0, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_1, MuV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
}

void emit_L2_loadrd_pcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); fPM_CIRR(RxV,fREAD_IREG(MuV)<<3,MuV); fLOAD(1,8,u,EA,RddV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_read_ireg(tmp_0, MuV, ((int32_t) 0x3));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_read_reg(tmp_1, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_0, MuV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
}

void emit_L2_loadbzw2_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int siV)
/* size4u_t EA; {fIMMEXT(siV); (EA = RsV + siV); {size2u_t tmpV; int i; fLOAD(1,2,u,EA,tmpV); for (i=0;i<2;i++) { fSETHALF(i,RdV,fGETUBYTE(i,tmpV)); } }; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmpV, i * 8, 8);
tcg_gen_deposit_i32(RdV, RdV, tmp_1, i * 16, 16);
}
}

void emit_L4_loadbzw2_ur(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, int uiV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV + (RtV << uiV)); {size2u_t tmpV; int i; fLOAD(1,2,u,EA,tmpV); for (i=0;i<2;i++) { fSETHALF(i,RdV,fGETUBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, UiV);
tcg_gen_mov_i32(EA, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmpV, i * 8, 8);
tcg_gen_deposit_i32(RdV, RdV, tmp_2, i * 16, 16);
}
}

void emit_L4_loadbzw2_ap(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 ReV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV); {size2u_t tmpV; int i; fLOAD(1,2,u,EA,tmpV); for (i=0;i<2;i++) { fSETHALF(i,RdV,fGETUBYTE(i,tmpV)); } }; ReV=UiV; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, UiV);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, tmpV, i * 8, 8);
tcg_gen_deposit_i32(RdV, RdV, tmp_0, i * 16, 16);
}
tcg_gen_movi_i32(ReV, UiV);
}

void emit_L2_loadbzw2_pr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + MuV); {size2u_t tmpV; int i; fLOAD(1,2,u,EA,tmpV); for (i=0;i<2;i++) { fSETHALF(i,RdV,fGETUBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmpV, i * 8, 8);
tcg_gen_deposit_i32(RdV, RdV, tmp_1, i * 16, 16);
}
}

void emit_L2_loadbzw2_pbr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = fbrev(RxV)); (RxV = RxV + MuV); {size2u_t tmpV; int i; fLOAD(1,2,u,EA,tmpV); for (i=0;i<2;i++) { fSETHALF(i,RdV,fGETUBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_helper_fbrev(tmp_0, RxV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmpV, i * 8, 8);
tcg_gen_deposit_i32(RdV, RdV, tmp_2, i * 16, 16);
}
}

void emit_L2_loadbzw2_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + siV); {size2u_t tmpV; int i; fLOAD(1,2,u,EA,tmpV); for (i=0;i<2;i++) { fSETHALF(i,RdV,fGETUBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmpV, i * 8, 8);
tcg_gen_deposit_i32(RdV, RdV, tmp_1, i * 16, 16);
}
}

void emit_L2_loadbzw2_pci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, int siV)
/* size4u_t EA; {(EA = RxV); fPM_CIRI(RxV,siV,MuV); {size2u_t tmpV; int i; fLOAD(1,2,u,EA,tmpV); for (i=0;i<2;i++) { fSETHALF(i,RdV,fGETUBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (siV));
gen_read_reg(tmp_0, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_1, MuV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmpV, i * 8, 8);
tcg_gen_deposit_i32(RdV, RdV, tmp_2, i * 16, 16);
}
}

void emit_L2_loadbzw2_pcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); fPM_CIRR(RxV,fREAD_IREG(MuV)<<1,MuV); {size2u_t tmpV; int i; fLOAD(1,2,u,EA,tmpV); for (i=0;i<2;i++) { fSETHALF(i,RdV,fGETUBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_read_ireg(tmp_0, MuV, ((int32_t) 0x1));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_read_reg(tmp_1, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_0, MuV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmpV, i * 8, 8);
tcg_gen_deposit_i32(RdV, RdV, tmp_2, i * 16, 16);
}
}

void emit_L2_loadbzw4_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, int siV)
/* size4u_t EA; {fIMMEXT(siV); (EA = RsV + siV); {size4u_t tmpV; int i; fLOAD(1,4,u,EA,tmpV); for (i=0;i<4;i++) { fSETHALF(i,RddV,fGETUBYTE(i,tmpV)); } }; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_32 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmpV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_2, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 16, 16);
}
}

void emit_L4_loadbzw4_ur(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RtV, int uiV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV + (RtV << uiV)); {size4u_t tmpV; int i; fLOAD(1,4,u,EA,tmpV); for (i=0;i<4;i++) { fSETHALF(i,RddV,fGETUBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, UiV);
tcg_gen_mov_i32(EA, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_32 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmpV, i * 8, 8);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 16, 16);
}
}

void emit_L4_loadbzw4_ap(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 ReV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV); {size4u_t tmpV; int i; fLOAD(1,4,u,EA,tmpV); for (i=0;i<4;i++) { fSETHALF(i,RddV,fGETUBYTE(i,tmpV)); } }; ReV=UiV; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, UiV);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_32 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, tmpV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_1, tmp_0);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, i * 16, 16);
}
tcg_gen_movi_i32(ReV, UiV);
}

void emit_L2_loadbzw4_pr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + MuV); {size4u_t tmpV; int i; fLOAD(1,4,u,EA,tmpV); for (i=0;i<4;i++) { fSETHALF(i,RddV,fGETUBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_32 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmpV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_2, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 16, 16);
}
}

void emit_L2_loadbzw4_pbr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = fbrev(RxV)); (RxV = RxV + MuV); {size4u_t tmpV; int i; fLOAD(1,4,u,EA,tmpV); for (i=0;i<4;i++) { fSETHALF(i,RddV,fGETUBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_helper_fbrev(tmp_0, RxV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_32 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmpV, i * 8, 8);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 16, 16);
}
}

void emit_L2_loadbzw4_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + siV); {size4u_t tmpV; int i; fLOAD(1,4,u,EA,tmpV); for (i=0;i<4;i++) { fSETHALF(i,RddV,fGETUBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_32 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmpV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_2, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 16, 16);
}
}

void emit_L2_loadbzw4_pci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, int siV)
/* size4u_t EA; {(EA = RxV); fPM_CIRI(RxV,siV,MuV); {size4u_t tmpV; int i; fLOAD(1,4,u,EA,tmpV); for (i=0;i<4;i++) { fSETHALF(i,RddV,fGETUBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (siV));
gen_read_reg(tmp_0, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_1, MuV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_32 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmpV, i * 8, 8);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 16, 16);
}
}

void emit_L2_loadbzw4_pcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); fPM_CIRR(RxV,fREAD_IREG(MuV)<<2,MuV); {size4u_t tmpV; int i; fLOAD(1,4,u,EA,tmpV); for (i=0;i<4;i++) { fSETHALF(i,RddV,fGETUBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_read_ireg(tmp_0, MuV, ((int32_t) 0x2));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_read_reg(tmp_1, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_0, MuV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_32 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmpV, i * 8, 8);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 16, 16);
}
}

void emit_L2_loadbsw2_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int siV)
/* size4u_t EA; {fIMMEXT(siV); (EA = RsV + siV); {size2u_t tmpV; int i; fLOAD(1,2,u,EA,tmpV); for (i=0;i<2;i++) { fSETHALF(i,RdV,fGETBYTE(i,tmpV)); } }; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, tmpV, i * 8, 8);
tcg_gen_deposit_i32(RdV, RdV, tmp_1, i * 16, 16);
}
}

void emit_L4_loadbsw2_ur(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, int uiV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV + (RtV << uiV)); {size2u_t tmpV; int i; fLOAD(1,2,u,EA,tmpV); for (i=0;i<2;i++) { fSETHALF(i,RdV,fGETBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, UiV);
tcg_gen_mov_i32(EA, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, tmpV, i * 8, 8);
tcg_gen_deposit_i32(RdV, RdV, tmp_2, i * 16, 16);
}
}

void emit_L4_loadbsw2_ap(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 ReV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV); {size2u_t tmpV; int i; fLOAD(1,2,u,EA,tmpV); for (i=0;i<2;i++) { fSETHALF(i,RdV,fGETBYTE(i,tmpV)); } }; ReV=UiV; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, UiV);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, tmpV, i * 8, 8);
tcg_gen_deposit_i32(RdV, RdV, tmp_0, i * 16, 16);
}
tcg_gen_movi_i32(ReV, UiV);
}

void emit_L2_loadbsw2_pr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + MuV); {size2u_t tmpV; int i; fLOAD(1,2,u,EA,tmpV); for (i=0;i<2;i++) { fSETHALF(i,RdV,fGETBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, tmpV, i * 8, 8);
tcg_gen_deposit_i32(RdV, RdV, tmp_1, i * 16, 16);
}
}

void emit_L2_loadbsw2_pbr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = fbrev(RxV)); (RxV = RxV + MuV); {size2u_t tmpV; int i; fLOAD(1,2,u,EA,tmpV); for (i=0;i<2;i++) { fSETHALF(i,RdV,fGETBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_helper_fbrev(tmp_0, RxV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, tmpV, i * 8, 8);
tcg_gen_deposit_i32(RdV, RdV, tmp_2, i * 16, 16);
}
}

void emit_L2_loadbsw2_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + siV); {size2u_t tmpV; int i; fLOAD(1,2,u,EA,tmpV); for (i=0;i<2;i++) { fSETHALF(i,RdV,fGETBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, tmpV, i * 8, 8);
tcg_gen_deposit_i32(RdV, RdV, tmp_1, i * 16, 16);
}
}

void emit_L2_loadbsw2_pci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, int siV)
/* size4u_t EA; {(EA = RxV); fPM_CIRI(RxV,siV,MuV); {size2u_t tmpV; int i; fLOAD(1,2,u,EA,tmpV); for (i=0;i<2;i++) { fSETHALF(i,RdV,fGETBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (siV));
gen_read_reg(tmp_0, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_1, MuV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, tmpV, i * 8, 8);
tcg_gen_deposit_i32(RdV, RdV, tmp_2, i * 16, 16);
}
}

void emit_L2_loadbsw2_pcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); fPM_CIRR(RxV,fREAD_IREG(MuV)<<1,MuV); {size2u_t tmpV; int i; fLOAD(1,2,u,EA,tmpV); for (i=0;i<2;i++) { fSETHALF(i,RdV,fGETBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_read_ireg(tmp_0, MuV, ((int32_t) 0x1));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_read_reg(tmp_1, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_0, MuV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, tmpV, i * 8, 8);
tcg_gen_deposit_i32(RdV, RdV, tmp_2, i * 16, 16);
}
}

void emit_L2_loadbsw4_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, int siV)
/* size4u_t EA; {fIMMEXT(siV); (EA = RsV + siV); {size4u_t tmpV; int i; fLOAD(1,4,u,EA,tmpV); for (i=0;i<4;i++) { fSETHALF(i,RddV,fGETBYTE(i,tmpV)); } }; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_32 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, tmpV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 16, 16);
}
}

void emit_L4_loadbsw4_ur(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RtV, int uiV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV + (RtV << uiV)); {size4u_t tmpV; int i; fLOAD(1,4,u,EA,tmpV); for (i=0;i<4;i++) { fSETHALF(i,RddV,fGETBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, UiV);
tcg_gen_mov_i32(EA, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_32 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, tmpV, i * 8, 8);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 16, 16);
}
}

void emit_L4_loadbsw4_ap(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 ReV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV); {size4u_t tmpV; int i; fLOAD(1,4,u,EA,tmpV); for (i=0;i<4;i++) { fSETHALF(i,RddV,fGETBYTE(i,tmpV)); } }; ReV=UiV; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, UiV);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_32 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, tmpV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, tmp_0);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, i * 16, 16);
}
tcg_gen_movi_i32(ReV, UiV);
}

void emit_L2_loadbsw4_pr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + MuV); {size4u_t tmpV; int i; fLOAD(1,4,u,EA,tmpV); for (i=0;i<4;i++) { fSETHALF(i,RddV,fGETBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_32 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, tmpV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 16, 16);
}
}

void emit_L2_loadbsw4_pbr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = fbrev(RxV)); (RxV = RxV + MuV); {size4u_t tmpV; int i; fLOAD(1,4,u,EA,tmpV); for (i=0;i<4;i++) { fSETHALF(i,RddV,fGETBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_helper_fbrev(tmp_0, RxV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_32 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, tmpV, i * 8, 8);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 16, 16);
}
}

void emit_L2_loadbsw4_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + siV); {size4u_t tmpV; int i; fLOAD(1,4,u,EA,tmpV); for (i=0;i<4;i++) { fSETHALF(i,RddV,fGETBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_32 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, tmpV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 16, 16);
}
}

void emit_L2_loadbsw4_pci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, int siV)
/* size4u_t EA; {(EA = RxV); fPM_CIRI(RxV,siV,MuV); {size4u_t tmpV; int i; fLOAD(1,4,u,EA,tmpV); for (i=0;i<4;i++) { fSETHALF(i,RddV,fGETBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (siV));
gen_read_reg(tmp_0, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_1, MuV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_32 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, tmpV, i * 8, 8);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 16, 16);
}
}

void emit_L2_loadbsw4_pcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); fPM_CIRR(RxV,fREAD_IREG(MuV)<<2,MuV); {size4u_t tmpV; int i; fLOAD(1,4,u,EA,tmpV); for (i=0;i<4;i++) { fSETHALF(i,RddV,fGETBYTE(i,tmpV)); } };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmpV = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_read_ireg(tmp_0, MuV, ((int32_t) 0x2));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_read_reg(tmp_1, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_0, MuV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmpV, EA, ctx->mem_idx, MO_32 | MO_TE);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, tmpV, i * 8, 8);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 16, 16);
}
}

void emit_L2_loadalignh_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RyyV, TCGv_i32 RsV, int siV)
/* size4u_t EA; {fIMMEXT(siV); (EA = RsV + siV); { size8u_t tmpV; fLOAD(1,2,u,EA,tmpV); RyyV = (((size8u_t)RyyV)>>16)|(tmpV<<48); }; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i64 tmpV = tcg_temp_new_i64();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_1, 0);
} else {
tcg_gen_shri_i64(tmp_1, RyyV, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x30);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_2, 0);
} else {
tcg_gen_shli_i64(tmp_2, tmpV, qemu_tmp_1);
}
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_3, tmp_1, tmp_2);
tcg_gen_mov_i64(RyyV, tmp_3);
}

void emit_L4_loadalignh_ur(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RyyV, TCGv_i32 RtV, int uiV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV + (RtV << uiV)); { size8u_t tmpV; fLOAD(1,2,u,EA,tmpV); RyyV = (((size8u_t)RyyV)>>16)|(tmpV<<48); };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i64 tmpV = tcg_temp_new_i64();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, UiV);
tcg_gen_mov_i32(EA, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_2, 0);
} else {
tcg_gen_shri_i64(tmp_2, RyyV, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x30);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmpV, qemu_tmp_1);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_4, tmp_2, tmp_3);
tcg_gen_mov_i64(RyyV, tmp_4);
}

void emit_L4_loadalignh_ap(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RyyV, TCGv_i32 ReV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV); { size8u_t tmpV; fLOAD(1,2,u,EA,tmpV); RyyV = (((size8u_t)RyyV)>>16)|(tmpV<<48); }; ReV=UiV; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i64 tmpV = tcg_temp_new_i64();
tcg_gen_movi_i32(EA, UiV);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_0, 0);
} else {
tcg_gen_shri_i64(tmp_0, RyyV, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x30);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_1, 0);
} else {
tcg_gen_shli_i64(tmp_1, tmpV, qemu_tmp_1);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_mov_i64(RyyV, tmp_2);
tcg_gen_movi_i32(ReV, UiV);
}

void emit_L2_loadalignh_pr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RyyV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + MuV); { size8u_t tmpV; fLOAD(1,2,u,EA,tmpV); RyyV = (((size8u_t)RyyV)>>16)|(tmpV<<48); };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i64 tmpV = tcg_temp_new_i64();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_1, 0);
} else {
tcg_gen_shri_i64(tmp_1, RyyV, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x30);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_2, 0);
} else {
tcg_gen_shli_i64(tmp_2, tmpV, qemu_tmp_1);
}
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_3, tmp_1, tmp_2);
tcg_gen_mov_i64(RyyV, tmp_3);
}

void emit_L2_loadalignh_pbr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RyyV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = fbrev(RxV)); (RxV = RxV + MuV); { size8u_t tmpV; fLOAD(1,2,u,EA,tmpV); RyyV = (((size8u_t)RyyV)>>16)|(tmpV<<48); };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i64 tmpV = tcg_temp_new_i64();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_helper_fbrev(tmp_0, RxV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_2, 0);
} else {
tcg_gen_shri_i64(tmp_2, RyyV, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x30);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmpV, qemu_tmp_1);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_4, tmp_2, tmp_3);
tcg_gen_mov_i64(RyyV, tmp_4);
}

void emit_L2_loadalignh_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RyyV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + siV); { size8u_t tmpV; fLOAD(1,2,u,EA,tmpV); RyyV = (((size8u_t)RyyV)>>16)|(tmpV<<48); };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i64 tmpV = tcg_temp_new_i64();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_1, 0);
} else {
tcg_gen_shri_i64(tmp_1, RyyV, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x30);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_2, 0);
} else {
tcg_gen_shli_i64(tmp_2, tmpV, qemu_tmp_1);
}
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_3, tmp_1, tmp_2);
tcg_gen_mov_i64(RyyV, tmp_3);
}

void emit_L2_loadalignh_pci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RyyV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, int siV)
/* size4u_t EA; {(EA = RxV); fPM_CIRI(RxV,siV,MuV); { size8u_t tmpV; fLOAD(1,2,u,EA,tmpV); RyyV = (((size8u_t)RyyV)>>16)|(tmpV<<48); };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i64 tmpV = tcg_temp_new_i64();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (siV));
gen_read_reg(tmp_0, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_1, MuV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_2, 0);
} else {
tcg_gen_shri_i64(tmp_2, RyyV, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x30);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmpV, qemu_tmp_1);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_4, tmp_2, tmp_3);
tcg_gen_mov_i64(RyyV, tmp_4);
}

void emit_L2_loadalignh_pcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RyyV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); fPM_CIRR(RxV,fREAD_IREG(MuV)<<1,MuV); { size8u_t tmpV; fLOAD(1,2,u,EA,tmpV); RyyV = (((size8u_t)RyyV)>>16)|(tmpV<<48); };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i64 tmpV = tcg_temp_new_i64();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_read_ireg(tmp_0, MuV, ((int32_t) 0x1));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_read_reg(tmp_1, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_0, MuV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(tmpV, EA, ctx->mem_idx, MO_16 | MO_TE);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_2, 0);
} else {
tcg_gen_shri_i64(tmp_2, RyyV, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x30);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmpV, qemu_tmp_1);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_4, tmp_2, tmp_3);
tcg_gen_mov_i64(RyyV, tmp_4);
}

void emit_L2_loadalignb_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RyyV, TCGv_i32 RsV, int siV)
/* size4u_t EA; {fIMMEXT(siV); (EA = RsV + siV); { size8u_t tmpV; fLOAD(1,1,u,EA,tmpV); RyyV = (((size8u_t)RyyV)>>8)|(tmpV<<56); }; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i64 tmpV = tcg_temp_new_i64();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(tmpV, EA, ctx->mem_idx, MO_8 | MO_TE);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_1, 0);
} else {
tcg_gen_shri_i64(tmp_1, RyyV, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x38);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_2, 0);
} else {
tcg_gen_shli_i64(tmp_2, tmpV, qemu_tmp_1);
}
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_3, tmp_1, tmp_2);
tcg_gen_mov_i64(RyyV, tmp_3);
}

void emit_L4_loadalignb_ur(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RyyV, TCGv_i32 RtV, int uiV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV + (RtV << uiV)); { size8u_t tmpV; fLOAD(1,1,u,EA,tmpV); RyyV = (((size8u_t)RyyV)>>8)|(tmpV<<56); };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i64 tmpV = tcg_temp_new_i64();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, UiV);
tcg_gen_mov_i32(EA, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(tmpV, EA, ctx->mem_idx, MO_8 | MO_TE);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_2, 0);
} else {
tcg_gen_shri_i64(tmp_2, RyyV, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x38);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmpV, qemu_tmp_1);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_4, tmp_2, tmp_3);
tcg_gen_mov_i64(RyyV, tmp_4);
}

void emit_L4_loadalignb_ap(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RyyV, TCGv_i32 ReV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV); { size8u_t tmpV; fLOAD(1,1,u,EA,tmpV); RyyV = (((size8u_t)RyyV)>>8)|(tmpV<<56); }; ReV=UiV; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i64 tmpV = tcg_temp_new_i64();
tcg_gen_movi_i32(EA, UiV);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(tmpV, EA, ctx->mem_idx, MO_8 | MO_TE);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x8);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_0, 0);
} else {
tcg_gen_shri_i64(tmp_0, RyyV, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x38);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_1, 0);
} else {
tcg_gen_shli_i64(tmp_1, tmpV, qemu_tmp_1);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_mov_i64(RyyV, tmp_2);
tcg_gen_movi_i32(ReV, UiV);
}

void emit_L2_loadalignb_pr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RyyV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + MuV); { size8u_t tmpV; fLOAD(1,1,u,EA,tmpV); RyyV = (((size8u_t)RyyV)>>8)|(tmpV<<56); };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i64 tmpV = tcg_temp_new_i64();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(tmpV, EA, ctx->mem_idx, MO_8 | MO_TE);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_1, 0);
} else {
tcg_gen_shri_i64(tmp_1, RyyV, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x38);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_2, 0);
} else {
tcg_gen_shli_i64(tmp_2, tmpV, qemu_tmp_1);
}
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_3, tmp_1, tmp_2);
tcg_gen_mov_i64(RyyV, tmp_3);
}

void emit_L2_loadalignb_pbr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RyyV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = fbrev(RxV)); (RxV = RxV + MuV); { size8u_t tmpV; fLOAD(1,1,u,EA,tmpV); RyyV = (((size8u_t)RyyV)>>8)|(tmpV<<56); };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i64 tmpV = tcg_temp_new_i64();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_helper_fbrev(tmp_0, RxV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(tmpV, EA, ctx->mem_idx, MO_8 | MO_TE);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_2, 0);
} else {
tcg_gen_shri_i64(tmp_2, RyyV, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x38);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmpV, qemu_tmp_1);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_4, tmp_2, tmp_3);
tcg_gen_mov_i64(RyyV, tmp_4);
}

void emit_L2_loadalignb_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RyyV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + siV); { size8u_t tmpV; fLOAD(1,1,u,EA,tmpV); RyyV = (((size8u_t)RyyV)>>8)|(tmpV<<56); };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i64 tmpV = tcg_temp_new_i64();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(tmpV, EA, ctx->mem_idx, MO_8 | MO_TE);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_1, 0);
} else {
tcg_gen_shri_i64(tmp_1, RyyV, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x38);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_2, 0);
} else {
tcg_gen_shli_i64(tmp_2, tmpV, qemu_tmp_1);
}
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_3, tmp_1, tmp_2);
tcg_gen_mov_i64(RyyV, tmp_3);
}

void emit_L2_loadalignb_pci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RyyV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, int siV)
/* size4u_t EA; {(EA = RxV); fPM_CIRI(RxV,siV,MuV); { size8u_t tmpV; fLOAD(1,1,u,EA,tmpV); RyyV = (((size8u_t)RyyV)>>8)|(tmpV<<56); };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i64 tmpV = tcg_temp_new_i64();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (siV));
gen_read_reg(tmp_0, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_1, MuV, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(tmpV, EA, ctx->mem_idx, MO_8 | MO_TE);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_2, 0);
} else {
tcg_gen_shri_i64(tmp_2, RyyV, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x38);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmpV, qemu_tmp_1);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_4, tmp_2, tmp_3);
tcg_gen_mov_i64(RyyV, tmp_4);
}

void emit_L2_loadalignb_pcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RyyV, TCGv_i32 RxV, TCGv_i32 MuV, int MuN)
/* size4u_t EA; {(EA = RxV); fPM_CIRR(RxV,fREAD_IREG(MuV)<<0,MuV); { size8u_t tmpV; fLOAD(1,1,u,EA,tmpV); RyyV = (((size8u_t)RyyV)>>8)|(tmpV<<56); };} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i64 tmpV = tcg_temp_new_i64();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_read_ireg(tmp_0, MuV, ((int32_t) 0x0));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_read_reg(tmp_1, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_0, MuV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(tmpV, EA, ctx->mem_idx, MO_8 | MO_TE);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_2, 0);
} else {
tcg_gen_shri_i64(tmp_2, RyyV, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x38);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmpV, qemu_tmp_1);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_4, tmp_2, tmp_3);
tcg_gen_mov_i64(RyyV, tmp_4);
}

void emit_S2_storerb_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {fIMMEXT(siV); (EA = RsV + siV); fSTORE(1,1,EA,fGETBYTE(0,RtV)); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_1, insn->slot);
}

void emit_S2_storerb_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + siV); fSTORE(1,1,EA,fGETBYTE(0,RtV)); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_1, insn->slot);
}

void emit_S4_storerb_ap(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 ReV, TCGv_i32 RtV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV); fSTORE(1,1,EA,fGETBYTE(0,RtV)); ReV=UiV; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, UiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_0, insn->slot);
tcg_gen_movi_i32(ReV, UiV);
}

void emit_S2_storerb_pr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv_i32 RtV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + MuV); fSTORE(1,1,EA,fGETBYTE(0,RtV)); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_1, insn->slot);
}

void emit_S4_storerb_ur(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RuV, TCGv_i32 RtV, int uiV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV + (RuV << uiV)); fSTORE(1,1,EA,fGETBYTE(0,RtV));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, UiV);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_storerb_pbr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv_i32 RtV)
/* size4u_t EA; {(EA = fbrev(RxV)); (RxV = RxV + MuV); fSTORE(1,1,EA,fGETBYTE(0,RtV)); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_helper_fbrev(tmp_0, RxV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_storerb_pci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); fPM_CIRI(RxV,siV,MuV); fSTORE(1,1,EA,fGETBYTE(0,RtV));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (siV));
gen_read_reg(tmp_0, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_1, MuV, tmp_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_storerb_pcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv_i32 RtV)
/* size4u_t EA; {(EA = RxV); fPM_CIRR(RxV,fREAD_IREG(MuV)<<0,MuV); fSTORE(1,1,EA,fGETBYTE(0,RtV));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_read_ireg(tmp_0, MuV, ((int32_t) 0x0));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_read_reg(tmp_1, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_0, MuV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_storerh_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {fIMMEXT(siV); (EA = RsV + siV); fSTORE(1,2,EA,fGETHALF(0,RtV)); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_1, insn->slot);
}

void emit_S2_storerh_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + siV); fSTORE(1,2,EA,fGETHALF(0,RtV)); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_1, insn->slot);
}

void emit_S4_storerh_ap(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 ReV, TCGv_i32 RtV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV); fSTORE(1,2,EA,fGETHALF(0,RtV)); ReV=UiV; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, UiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_0, insn->slot);
tcg_gen_movi_i32(ReV, UiV);
}

void emit_S2_storerh_pr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv_i32 RtV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + MuV); fSTORE(1,2,EA,fGETHALF(0,RtV)); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_1, insn->slot);
}

void emit_S4_storerh_ur(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RuV, TCGv_i32 RtV, int uiV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV + (RuV << uiV)); fSTORE(1,2,EA,fGETHALF(0,RtV));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, UiV);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_storerh_pbr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv_i32 RtV)
/* size4u_t EA; {(EA = fbrev(RxV)); (RxV = RxV + MuV); fSTORE(1,2,EA,fGETHALF(0,RtV)); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_helper_fbrev(tmp_0, RxV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_storerh_pci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); fPM_CIRI(RxV,siV,MuV); fSTORE(1,2,EA,fGETHALF(0,RtV));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (siV));
gen_read_reg(tmp_0, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_1, MuV, tmp_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_storerh_pcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv_i32 RtV)
/* size4u_t EA; {(EA = RxV); fPM_CIRR(RxV,fREAD_IREG(MuV)<<1,MuV); fSTORE(1,2,EA,fGETHALF(0,RtV));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_read_ireg(tmp_0, MuV, ((int32_t) 0x1));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_read_reg(tmp_1, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_0, MuV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_storerf_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {fIMMEXT(siV); (EA = RsV + siV); fSTORE(1,2,EA,fGETHALF(1,RtV)); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_1, insn->slot);
}

void emit_S2_storerf_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + siV); fSTORE(1,2,EA,fGETHALF(1,RtV)); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_1, insn->slot);
}

void emit_S4_storerf_ap(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 ReV, TCGv_i32 RtV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV); fSTORE(1,2,EA,fGETHALF(1,RtV)); ReV=UiV; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, UiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_0, insn->slot);
tcg_gen_movi_i32(ReV, UiV);
}

void emit_S2_storerf_pr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv_i32 RtV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + MuV); fSTORE(1,2,EA,fGETHALF(1,RtV)); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_1, insn->slot);
}

void emit_S4_storerf_ur(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RuV, TCGv_i32 RtV, int uiV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV + (RuV << uiV)); fSTORE(1,2,EA,fGETHALF(1,RtV));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, UiV);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_storerf_pbr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv_i32 RtV)
/* size4u_t EA; {(EA = fbrev(RxV)); (RxV = RxV + MuV); fSTORE(1,2,EA,fGETHALF(1,RtV)); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_helper_fbrev(tmp_0, RxV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_storerf_pci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); fPM_CIRI(RxV,siV,MuV); fSTORE(1,2,EA,fGETHALF(1,RtV));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (siV));
gen_read_reg(tmp_0, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_1, MuV, tmp_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_storerf_pcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv_i32 RtV)
/* size4u_t EA; {(EA = RxV); fPM_CIRR(RxV,fREAD_IREG(MuV)<<1,MuV); fSTORE(1,2,EA,fGETHALF(1,RtV));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_read_ireg(tmp_0, MuV, ((int32_t) 0x1));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_read_reg(tmp_1, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_0, MuV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_storeri_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {fIMMEXT(siV); (EA = RsV + siV); fSTORE(1,4,EA,RtV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(EA, tmp_0);
gen_store4(tcg_env, EA, RtV, insn->slot);
}

void emit_S2_storeri_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + siV); fSTORE(1,4,EA,RtV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_0);
gen_store4(tcg_env, EA, RtV, insn->slot);
}

void emit_S4_storeri_ap(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 ReV, TCGv_i32 RtV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV); fSTORE(1,4,EA,RtV); ReV=UiV; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, UiV);
gen_store4(tcg_env, EA, RtV, insn->slot);
tcg_gen_movi_i32(ReV, UiV);
}

void emit_S2_storeri_pr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv_i32 RtV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + MuV); fSTORE(1,4,EA,RtV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_0);
gen_store4(tcg_env, EA, RtV, insn->slot);
}

void emit_S4_storeri_ur(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RuV, TCGv_i32 RtV, int uiV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV + (RuV << uiV)); fSTORE(1,4,EA,RtV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, UiV);
tcg_gen_mov_i32(EA, tmp_1);
gen_store4(tcg_env, EA, RtV, insn->slot);
}

void emit_S2_storeri_pbr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv_i32 RtV)
/* size4u_t EA; {(EA = fbrev(RxV)); (RxV = RxV + MuV); fSTORE(1,4,EA,RtV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_helper_fbrev(tmp_0, RxV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_1);
gen_store4(tcg_env, EA, RtV, insn->slot);
}

void emit_S2_storeri_pci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); fPM_CIRI(RxV,siV,MuV); fSTORE(1,4,EA,RtV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (siV));
gen_read_reg(tmp_0, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_1, MuV, tmp_0);
gen_store4(tcg_env, EA, RtV, insn->slot);
}

void emit_S2_storeri_pcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv_i32 RtV)
/* size4u_t EA; {(EA = RxV); fPM_CIRR(RxV,fREAD_IREG(MuV)<<2,MuV); fSTORE(1,4,EA,RtV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_read_ireg(tmp_0, MuV, ((int32_t) 0x2));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_read_reg(tmp_1, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_0, MuV, tmp_1);
gen_store4(tcg_env, EA, RtV, insn->slot);
}

void emit_S2_storerd_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i64 RttV, int siV)
/* size4u_t EA; {fIMMEXT(siV); (EA = RsV + siV); fSTORE(1,8,EA,RttV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(EA, tmp_0);
gen_store8(tcg_env, EA, RttV, insn->slot);
}

void emit_S2_storerd_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i64 RttV, int siV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + siV); fSTORE(1,8,EA,RttV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_0);
gen_store8(tcg_env, EA, RttV, insn->slot);
}

void emit_S4_storerd_ap(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 ReV, TCGv_i64 RttV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV); fSTORE(1,8,EA,RttV); ReV=UiV; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, UiV);
gen_store8(tcg_env, EA, RttV, insn->slot);
tcg_gen_movi_i32(ReV, UiV);
}

void emit_S2_storerd_pr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv_i64 RttV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + MuV); fSTORE(1,8,EA,RttV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_0);
gen_store8(tcg_env, EA, RttV, insn->slot);
}

void emit_S4_storerd_ur(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RuV, TCGv_i64 RttV, int uiV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV + (RuV << uiV)); fSTORE(1,8,EA,RttV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, UiV);
tcg_gen_mov_i32(EA, tmp_1);
gen_store8(tcg_env, EA, RttV, insn->slot);
}

void emit_S2_storerd_pbr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv_i64 RttV)
/* size4u_t EA; {(EA = fbrev(RxV)); (RxV = RxV + MuV); fSTORE(1,8,EA,RttV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_helper_fbrev(tmp_0, RxV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_1);
gen_store8(tcg_env, EA, RttV, insn->slot);
}

void emit_S2_storerd_pci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv_i64 RttV, int siV)
/* size4u_t EA; {(EA = RxV); fPM_CIRI(RxV,siV,MuV); fSTORE(1,8,EA,RttV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (siV));
gen_read_reg(tmp_0, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_1, MuV, tmp_0);
gen_store8(tcg_env, EA, RttV, insn->slot);
}

void emit_S2_storerd_pcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv_i64 RttV)
/* size4u_t EA; {(EA = RxV); fPM_CIRR(RxV,fREAD_IREG(MuV)<<3,MuV); fSTORE(1,8,EA,RttV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_read_ireg(tmp_0, MuV, ((int32_t) 0x3));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_read_reg(tmp_1, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_0, MuV, tmp_1);
gen_store8(tcg_env, EA, RttV, insn->slot);
}

void emit_S2_storerinew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv NtN, int siV)
/* size4u_t EA; {fIMMEXT(siV); (EA = RsV + siV); fSTORE(1,4,EA,fNEWREG_ST(NtN)); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(EA, tmp_0);
gen_store4(tcg_env, EA, NtN, insn->slot);
}

void emit_S2_storerinew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv NtN, int siV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + siV); fSTORE(1,4,EA,fNEWREG_ST(NtN)); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_0);
gen_store4(tcg_env, EA, NtN, insn->slot);
}

void emit_S4_storerinew_ap(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 ReV, TCGv NtN, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV); fSTORE(1,4,EA,fNEWREG_ST(NtN)); ReV=UiV; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, UiV);
gen_store4(tcg_env, EA, NtN, insn->slot);
tcg_gen_movi_i32(ReV, UiV);
}

void emit_S2_storerinew_pr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv NtN)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + MuV); fSTORE(1,4,EA,fNEWREG_ST(NtN)); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_0);
gen_store4(tcg_env, EA, NtN, insn->slot);
}

void emit_S4_storerinew_ur(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RuV, TCGv NtN, int uiV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV + (RuV << uiV)); fSTORE(1,4,EA,fNEWREG_ST(NtN));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, UiV);
tcg_gen_mov_i32(EA, tmp_1);
gen_store4(tcg_env, EA, NtN, insn->slot);
}

void emit_S2_storerinew_pbr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv NtN)
/* size4u_t EA; {(EA = fbrev(RxV)); (RxV = RxV + MuV); fSTORE(1,4,EA,fNEWREG_ST(NtN)); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_helper_fbrev(tmp_0, RxV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_1);
gen_store4(tcg_env, EA, NtN, insn->slot);
}

void emit_S2_storerinew_pci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv NtN, int siV)
/* size4u_t EA; {(EA = RxV); fPM_CIRI(RxV,siV,MuV); fSTORE(1,4,EA,fNEWREG_ST(NtN));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (siV));
gen_read_reg(tmp_0, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_1, MuV, tmp_0);
gen_store4(tcg_env, EA, NtN, insn->slot);
}

void emit_S2_storerinew_pcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv NtN)
/* size4u_t EA; {(EA = RxV); fPM_CIRR(RxV,fREAD_IREG(MuV)<<2,MuV); fSTORE(1,4,EA,fNEWREG_ST(NtN));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_read_ireg(tmp_0, MuV, ((int32_t) 0x2));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_read_reg(tmp_1, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_0, MuV, tmp_1);
gen_store4(tcg_env, EA, NtN, insn->slot);
}

void emit_S2_storerbnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv NtN, int siV)
/* size4u_t EA; {fIMMEXT(siV); (EA = RsV + siV); fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN))); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_1, insn->slot);
}

void emit_S2_storerbnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv NtN, int siV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + siV); fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN))); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_1, insn->slot);
}

void emit_S4_storerbnew_ap(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 ReV, TCGv NtN, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV); fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN))); ReV=UiV; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, UiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_0, insn->slot);
tcg_gen_movi_i32(ReV, UiV);
}

void emit_S2_storerbnew_pr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv NtN)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + MuV); fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN))); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_1, insn->slot);
}

void emit_S4_storerbnew_ur(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RuV, TCGv NtN, int uiV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV + (RuV << uiV)); fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN)));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, UiV);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_storerbnew_pbr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv NtN)
/* size4u_t EA; {(EA = fbrev(RxV)); (RxV = RxV + MuV); fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN))); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_helper_fbrev(tmp_0, RxV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_storerbnew_pci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv NtN, int siV)
/* size4u_t EA; {(EA = RxV); fPM_CIRI(RxV,siV,MuV); fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN)));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (siV));
gen_read_reg(tmp_0, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_1, MuV, tmp_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_storerbnew_pcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv NtN)
/* size4u_t EA; {(EA = RxV); fPM_CIRR(RxV,fREAD_IREG(MuV)<<0,MuV); fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN)));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_read_ireg(tmp_0, MuV, ((int32_t) 0x0));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_read_reg(tmp_1, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_0, MuV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_storerhnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv NtN, int siV)
/* size4u_t EA; {fIMMEXT(siV); (EA = RsV + siV); fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN))); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_1, insn->slot);
}

void emit_S2_storerhnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv NtN, int siV)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + siV); fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN))); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_1, insn->slot);
}

void emit_S4_storerhnew_ap(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 ReV, TCGv NtN, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV); fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN))); ReV=UiV; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, UiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_0, insn->slot);
tcg_gen_movi_i32(ReV, UiV);
}

void emit_S2_storerhnew_pr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv NtN)
/* size4u_t EA; {(EA = RxV); (RxV = RxV + MuV); fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN))); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_1, insn->slot);
}

void emit_S4_storerhnew_ur(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RuV, TCGv NtN, int uiV, int UiV)
/* size4u_t EA; {fMUST_IMMEXT(UiV); (EA = UiV + (RuV << uiV)); fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN)));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, UiV);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_storerhnew_pbr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv NtN)
/* size4u_t EA; {(EA = fbrev(RxV)); (RxV = RxV + MuV); fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN))); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_helper_fbrev(tmp_0, RxV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, MuV);
tcg_gen_mov_i32(RxV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_storerhnew_pci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv NtN, int siV)
/* size4u_t EA; {(EA = RxV); fPM_CIRI(RxV,siV,MuV); fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN)));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (siV));
gen_read_reg(tmp_0, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_1, MuV, tmp_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_storerhnew_pcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 MuV, int MuN, TCGv NtN)
/* size4u_t EA; {(EA = RxV); fPM_CIRR(RxV,fREAD_IREG(MuV)<<1,MuV); fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN)));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_read_ireg(tmp_0, MuV, ((int32_t) 0x1));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_read_reg(tmp_1, HEX_REG_CS0 + MuN);
gen_helper_fcircadd(RxV, RxV, tmp_0, MuV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_allocframe(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, int uiV)
/* size4u_t EA; { (EA = RxV + -8); fSTORE(1,8,EA,fFRAME_SCRAMBLE((fCAST8_8u(fREAD_LR()) << 32) | fCAST4_4u(fREAD_FP()))); (FP = EA); fFRAMECHECK(EA-uiV,EA); RxV = EA-uiV; } */
{
TCGv_i32 EA = tcg_temp_new_i32();
int32_t qemu_tmp_0 = -(((int32_t) 0x8));
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RxV, qemu_tmp_0);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_1, hex_gpr[31]);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_2, 0);
} else {
tcg_gen_shli_i64(tmp_2, tmp_1, qemu_tmp_1);
}
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, hex_gpr[30]);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_read_reg(tmp_7, HEX_REG_FRAMEKEY);
tcg_gen_concat_i32_i64(tmp_5, tmp_7, tmp_7);
tcg_gen_xor_i64(tmp_6, tmp_4, tmp_5);
gen_store8(tcg_env, EA, tmp_6, insn->slot);
gen_log_reg_write(ctx, 30, EA);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_8, EA, uiV);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_9, EA, uiV);
tcg_gen_mov_i32(RxV, tmp_9);
}

void emit_L2_loadw_aq(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* size4u_t EA; { (EA = RsV); fLOAD(1,4,u,EA,RdV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RsV);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
}

void emit_L4_loadd_aq(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV)
/* size4u_t EA; { (EA = RsV); fLOAD(1,8,u,EA,RddV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RsV);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
}

void emit_S2_storew_rl_at_vi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RtV)
/* size4u_t EA; { (EA = RsV); fSTORE(1,4,EA,RtV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RsV);
gen_store4(tcg_env, EA, RtV, insn->slot);
}

void emit_S4_stored_rl_at_vi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i64 RttV)
/* size4u_t EA; { (EA = RsV); fSTORE(1,8,EA,RttV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RsV);
gen_store8(tcg_env, EA, RttV, insn->slot);
}

void emit_S2_storew_rl_st_vi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RtV)
/* size4u_t EA; { (EA = RsV); fSTORE(1,4,EA,RtV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RsV);
gen_store4(tcg_env, EA, RtV, insn->slot);
}

void emit_S4_stored_rl_st_vi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i64 RttV)
/* size4u_t EA; { (EA = RsV); fSTORE(1,8,EA,RttV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RsV);
gen_store8(tcg_env, EA, RttV, insn->slot);
}

void emit_L2_deallocframe(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV)
/* size4u_t EA; { size8u_t tmp; (EA = RsV); fLOAD(1,8,u,EA,tmp); RddV = fFRAME_UNSCRAMBLE(tmp); (SP = EA+8); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i64 tmp = tcg_temp_new_i64();
tcg_gen_mov_i32(EA, RsV);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(tmp, EA, ctx->mem_idx, MO_64 | MO_TE);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
TCGv_i64 tmp_1 = tcg_temp_new_i64();
TCGv_i32 tmp_2 = tcg_temp_new_i32();
gen_read_reg(tmp_2, HEX_REG_FRAMEKEY);
tcg_gen_concat_i32_i64(tmp_0, tmp_2, tmp_2);
tcg_gen_xor_i64(tmp_1, tmp, tmp_0);
tcg_gen_mov_i64(RddV, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_3, EA, ((int32_t) 0x8));
gen_log_reg_write(ctx, 29, tmp_3);
}

void emit_L4_loadrub_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); fLOAD(1,1,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
}

void emit_L2_ploadrubt_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if((fGETBIT(0, PtV))){fLOAD(1,1,u,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, PtV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrubt_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if((fGETBIT(0, PtV))){ (RxV = RxV + siV); fLOAD(1,1,u,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PtV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrubf_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if(fGETBIT(0, ~PtV)){ fLOAD(1,1,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PtV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmp_1, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrubf_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if(fGETBIT(0, ~PtV)){ (RxV = RxV + siV); fLOAD(1,1,u,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrubtnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if (fLSBNEW(PtN)) { fLOAD(1,1,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, PtN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrubfnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ((fLSBNEW(~PtN))) { fLOAD(1,1,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PtN);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, tmp_1, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrubt_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if((fGETBIT(0, PvV))){ fLOAD(1,1,u,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrubf_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if(fGETBIT(0, ~PvV)){ fLOAD(1,1,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvV);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_3, tmp_2, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrubtnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if (fLSBNEW(PvN)) { fLOAD(1,1,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrubfnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if ((fLSBNEW(~PvN))) { fLOAD(1,1,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvN);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_3, tmp_2, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrubtnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if(fLSBNEW(PtN)){ (RxV = RxV + siV); fLOAD(1,1,u,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PtN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrubfnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if((fLSBNEW(~PtN))){ (RxV = RxV + siV); fLOAD(1,1,u,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrubt_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV); if((fGETBIT(0, PtV))){ fLOAD(1,1,u,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PtV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrubf_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV); if(fGETBIT(0, ~PtV)){ fLOAD(1,1,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrubtnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV);if (fLSBNEW(PtN)) { fLOAD(1,1,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PtN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrubfnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV);if ((fLSBNEW(~PtN))) { fLOAD(1,1,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_loadrb_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); fLOAD(1,1,s,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
}

void emit_L2_ploadrbt_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if((fGETBIT(0, PtV))){fLOAD(1,1,s,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, PtV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrbt_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if((fGETBIT(0, PtV))){ (RxV = RxV + siV); fLOAD(1,1,s,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PtV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrbf_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if(fGETBIT(0, ~PtV)){ fLOAD(1,1,s,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PtV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmp_1, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrbf_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if(fGETBIT(0, ~PtV)){ (RxV = RxV + siV); fLOAD(1,1,s,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrbtnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if (fLSBNEW(PtN)) { fLOAD(1,1,s,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, PtN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrbfnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ((fLSBNEW(~PtN))) { fLOAD(1,1,s,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PtN);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, tmp_1, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrbt_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if((fGETBIT(0, PvV))){ fLOAD(1,1,s,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrbf_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if(fGETBIT(0, ~PvV)){ fLOAD(1,1,s,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvV);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_3, tmp_2, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrbtnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if (fLSBNEW(PvN)) { fLOAD(1,1,s,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrbfnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if ((fLSBNEW(~PvN))) { fLOAD(1,1,s,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvN);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_3, tmp_2, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrbtnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if(fLSBNEW(PtN)){ (RxV = RxV + siV); fLOAD(1,1,s,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PtN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrbfnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if((fLSBNEW(~PtN))){ (RxV = RxV + siV); fLOAD(1,1,s,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrbt_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV); if((fGETBIT(0, PtV))){ fLOAD(1,1,s,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PtV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrbf_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV); if(fGETBIT(0, ~PtV)){ fLOAD(1,1,s,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrbtnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV);if (fLSBNEW(PtN)) { fLOAD(1,1,s,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PtN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrbfnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV);if ((fLSBNEW(~PtN))) { fLOAD(1,1,s,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_loadruh_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); fLOAD(1,2,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
}

void emit_L2_ploadruht_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if((fGETBIT(0, PtV))){fLOAD(1,2,u,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, PtV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadruht_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if((fGETBIT(0, PtV))){ (RxV = RxV + siV); fLOAD(1,2,u,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PtV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadruhf_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if(fGETBIT(0, ~PtV)){ fLOAD(1,2,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PtV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmp_1, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadruhf_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if(fGETBIT(0, ~PtV)){ (RxV = RxV + siV); fLOAD(1,2,u,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadruhtnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if (fLSBNEW(PtN)) { fLOAD(1,2,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, PtN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadruhfnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ((fLSBNEW(~PtN))) { fLOAD(1,2,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PtN);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, tmp_1, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadruht_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if((fGETBIT(0, PvV))){ fLOAD(1,2,u,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadruhf_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if(fGETBIT(0, ~PvV)){ fLOAD(1,2,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvV);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_3, tmp_2, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadruhtnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if (fLSBNEW(PvN)) { fLOAD(1,2,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadruhfnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if ((fLSBNEW(~PvN))) { fLOAD(1,2,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvN);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_3, tmp_2, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadruhtnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if(fLSBNEW(PtN)){ (RxV = RxV + siV); fLOAD(1,2,u,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PtN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadruhfnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if((fLSBNEW(~PtN))){ (RxV = RxV + siV); fLOAD(1,2,u,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadruht_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV); if((fGETBIT(0, PtV))){ fLOAD(1,2,u,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PtV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadruhf_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV); if(fGETBIT(0, ~PtV)){ fLOAD(1,2,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadruhtnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV);if (fLSBNEW(PtN)) { fLOAD(1,2,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PtN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadruhfnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV);if ((fLSBNEW(~PtN))) { fLOAD(1,2,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_loadrh_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); fLOAD(1,2,s,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
}

void emit_L2_ploadrht_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if((fGETBIT(0, PtV))){fLOAD(1,2,s,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, PtV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrht_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if((fGETBIT(0, PtV))){ (RxV = RxV + siV); fLOAD(1,2,s,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PtV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrhf_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if(fGETBIT(0, ~PtV)){ fLOAD(1,2,s,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PtV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmp_1, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrhf_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if(fGETBIT(0, ~PtV)){ (RxV = RxV + siV); fLOAD(1,2,s,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrhtnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if (fLSBNEW(PtN)) { fLOAD(1,2,s,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, PtN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrhfnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ((fLSBNEW(~PtN))) { fLOAD(1,2,s,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PtN);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, tmp_1, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrht_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if((fGETBIT(0, PvV))){ fLOAD(1,2,s,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrhf_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if(fGETBIT(0, ~PvV)){ fLOAD(1,2,s,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvV);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_3, tmp_2, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrhtnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if (fLSBNEW(PvN)) { fLOAD(1,2,s,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrhfnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if ((fLSBNEW(~PvN))) { fLOAD(1,2,s,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvN);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_3, tmp_2, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrhtnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if(fLSBNEW(PtN)){ (RxV = RxV + siV); fLOAD(1,2,s,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PtN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrhfnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if((fLSBNEW(~PtN))){ (RxV = RxV + siV); fLOAD(1,2,s,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrht_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV); if((fGETBIT(0, PtV))){ fLOAD(1,2,s,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PtV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrhf_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV); if(fGETBIT(0, ~PtV)){ fLOAD(1,2,s,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrhtnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV);if (fLSBNEW(PtN)) { fLOAD(1,2,s,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PtN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrhfnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV);if ((fLSBNEW(~PtN))) { fLOAD(1,2,s,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_loadri_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); fLOAD(1,4,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
}

void emit_L2_ploadrit_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if((fGETBIT(0, PtV))){fLOAD(1,4,u,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, PtV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrit_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if((fGETBIT(0, PtV))){ (RxV = RxV + siV); fLOAD(1,4,u,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PtV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrif_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if(fGETBIT(0, ~PtV)){ fLOAD(1,4,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PtV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmp_1, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrif_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if(fGETBIT(0, ~PtV)){ (RxV = RxV + siV); fLOAD(1,4,u,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadritnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if (fLSBNEW(PtN)) { fLOAD(1,4,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, PtN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrifnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ((fLSBNEW(~PtN))) { fLOAD(1,4,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PtN);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, tmp_1, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrit_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if((fGETBIT(0, PvV))){ fLOAD(1,4,u,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrif_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if(fGETBIT(0, ~PvV)){ fLOAD(1,4,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvV);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_3, tmp_2, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadritnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if (fLSBNEW(PvN)) { fLOAD(1,4,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrifnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if ((fLSBNEW(~PvN))) { fLOAD(1,4,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvN);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_3, tmp_2, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadritnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if(fLSBNEW(PtN)){ (RxV = RxV + siV); fLOAD(1,4,u,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PtN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrifnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if((fLSBNEW(~PtN))){ (RxV = RxV + siV); fLOAD(1,4,u,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrit_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV); if((fGETBIT(0, PtV))){ fLOAD(1,4,u,EA,RdV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PtV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrif_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV); if(fGETBIT(0, ~PtV)){ fLOAD(1,4,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadritnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV);if (fLSBNEW(PtN)) { fLOAD(1,4,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PtN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrifnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV);if ((fLSBNEW(~PtN))) { fLOAD(1,4,u,EA,RdV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_loadrd_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); fLOAD(1,8,u,EA,RddV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
}

void emit_L2_ploadrdt_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i64 RddV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if((fGETBIT(0, PtV))){fLOAD(1,8,u,EA,RddV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, PtV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrdt_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i64 RddV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if((fGETBIT(0, PtV))){ (RxV = RxV + siV); fLOAD(1,8,u,EA,RddV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PtV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrdf_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i64 RddV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if(fGETBIT(0, ~PtV)){ fLOAD(1,8,u,EA,RddV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PtV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmp_1, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrdf_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i64 RddV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if(fGETBIT(0, ~PtV)){ (RxV = RxV + siV); fLOAD(1,8,u,EA,RddV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrdtnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i64 RddV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if (fLSBNEW(PtN)) { fLOAD(1,8,u,EA,RddV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, PtN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrdfnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i64 RddV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ((fLSBNEW(~PtN))) { fLOAD(1,8,u,EA,RddV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PtN);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, tmp_1, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrdt_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if((fGETBIT(0, PvV))){ fLOAD(1,8,u,EA,RddV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrdf_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if(fGETBIT(0, ~PvV)){ fLOAD(1,8,u,EA,RddV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvV);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_3, tmp_2, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrdtnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if (fLSBNEW(PvN)) { fLOAD(1,8,u,EA,RddV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrdfnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RtV << uiV)); if ((fLSBNEW(~PvN))) { fLOAD(1,8,u,EA,RddV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RtV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvN);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_3, tmp_2, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrdtnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i64 RddV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if(fLSBNEW(PtN)){ (RxV = RxV + siV); fLOAD(1,8,u,EA,RddV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PtN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L2_ploadrdfnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i64 RddV, TCGv_i32 RxV, int siV)
/* size4u_t EA; {(EA = RxV); if((fLSBNEW(~PtN))){ (RxV = RxV + siV); fLOAD(1,8,u,EA,RddV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrdt_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i64 RddV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV); if((fGETBIT(0, PtV))){ fLOAD(1,8,u,EA,RddV);} else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PtV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrdf_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtV, TCGv_i64 RddV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV); if(fGETBIT(0, ~PtV)){ fLOAD(1,8,u,EA,RddV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrdtnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i64 RddV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV);if (fLSBNEW(PtN)) { fLOAD(1,8,u,EA,RddV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PtN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_L4_ploadrdfnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PtN, TCGv_i64 RddV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV);if ((fLSBNEW(~PtN))) { fLOAD(1,8,u,EA,RddV); } else {LOAD_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PtN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
ctx->s1_store_processed = false;
process_store(ctx, 1);
}
gen_set_label(if_label_1);
}

void emit_S4_storerb_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); fSTORE(1,1,EA,fGETBYTE(0,RtV));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_pstorerbt_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ((fGETBIT(0, PvV))){ fSTORE(1,1,EA,fGETBYTE(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerbt_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RxV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); if ((fGETBIT(0, PvV))){ (RxV = RxV + siV); fSTORE(1,1,EA,fGETBYTE(0,RtV));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerbf_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if (fGETBIT(0, ~PvV)){ fSTORE(1,1,EA,fGETBYTE(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PvV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmp_1, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerbf_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RxV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); if (fGETBIT(0, ~PvV)){ (RxV = RxV + siV); fSTORE(1,1,EA,fGETBYTE(0,RtV));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerbt_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ((fGETBIT(0, PvV))){ fSTORE(1,1,EA,fGETBYTE(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerbf_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if (fGETBIT(0, ~PvV)){ fSTORE(1,1,EA,fGETBYTE(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvV);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_3, tmp_2, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_4, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_4, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerbtnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ( fLSBNEW(PvN)) { fSTORE(1,1,EA,fGETBYTE(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerbfnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ((fLSBNEW(~PvN))) { fSTORE(1,1,EA,fGETBYTE(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PvN);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, tmp_1, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerbtnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ( fLSBNEW(PvN)) { fSTORE(1,1,EA,fGETBYTE(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerbfnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ((fLSBNEW(~PvN))) { fSTORE(1,1,EA,fGETBYTE(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvN);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_3, tmp_2, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_4, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_4, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerbtnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RxV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); if (fLSBNEW(PvN)){ (RxV = RxV + siV); fSTORE(1,1,EA,fGETBYTE(0,RtV));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerbfnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RxV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); if ((fLSBNEW(~PvN))){ (RxV = RxV + siV); fSTORE(1,1,EA,fGETBYTE(0,RtV));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerbt_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV); if ((fGETBIT(0, PvV))){ fSTORE(1,1,EA,fGETBYTE(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_1, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerbf_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if (fGETBIT(0, ~PvV)){ fSTORE(1,1,EA,fGETBYTE(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerbtnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if ( fLSBNEW(PvN)) { fSTORE(1,1,EA,fGETBYTE(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_1, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerbfnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if ((fLSBNEW(~PvN))) { fSTORE(1,1,EA,fGETBYTE(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_storerh_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); fSTORE(1,2,EA,fGETHALF(0,RtV));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_pstorerht_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ((fGETBIT(0, PvV))){ fSTORE(1,2,EA,fGETHALF(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerht_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RxV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); if ((fGETBIT(0, PvV))){ (RxV = RxV + siV); fSTORE(1,2,EA,fGETHALF(0,RtV));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerhf_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if (fGETBIT(0, ~PvV)){ fSTORE(1,2,EA,fGETHALF(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PvV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmp_1, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerhf_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RxV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); if (fGETBIT(0, ~PvV)){ (RxV = RxV + siV); fSTORE(1,2,EA,fGETHALF(0,RtV));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerht_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ((fGETBIT(0, PvV))){ fSTORE(1,2,EA,fGETHALF(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerhf_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if (fGETBIT(0, ~PvV)){ fSTORE(1,2,EA,fGETHALF(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvV);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_3, tmp_2, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_4, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_4, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerhtnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ( fLSBNEW(PvN)) { fSTORE(1,2,EA,fGETHALF(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerhfnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ((fLSBNEW(~PvN))) { fSTORE(1,2,EA,fGETHALF(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PvN);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, tmp_1, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerhtnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ( fLSBNEW(PvN)) { fSTORE(1,2,EA,fGETHALF(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerhfnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ((fLSBNEW(~PvN))) { fSTORE(1,2,EA,fGETHALF(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvN);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_3, tmp_2, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_4, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_4, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerhtnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RxV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); if (fLSBNEW(PvN)){ (RxV = RxV + siV); fSTORE(1,2,EA,fGETHALF(0,RtV));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerhfnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RxV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); if ((fLSBNEW(~PvN))){ (RxV = RxV + siV); fSTORE(1,2,EA,fGETHALF(0,RtV));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerht_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV); if ((fGETBIT(0, PvV))){ fSTORE(1,2,EA,fGETHALF(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_1, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerhf_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if (fGETBIT(0, ~PvV)){ fSTORE(1,2,EA,fGETHALF(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerhtnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if ( fLSBNEW(PvN)) { fSTORE(1,2,EA,fGETHALF(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_1, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerhfnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if ((fLSBNEW(~PvN))) { fSTORE(1,2,EA,fGETHALF(0,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_storerf_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); fSTORE(1,2,EA,fGETHALF(1,RtV));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_pstorerft_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ((fGETBIT(0, PvV))){ fSTORE(1,2,EA,fGETHALF(1,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerft_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RxV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); if ((fGETBIT(0, PvV))){ (RxV = RxV + siV); fSTORE(1,2,EA,fGETHALF(1,RtV));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerff_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if (fGETBIT(0, ~PvV)){ fSTORE(1,2,EA,fGETHALF(1,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PvV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmp_1, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerff_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RxV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); if (fGETBIT(0, ~PvV)){ (RxV = RxV + siV); fSTORE(1,2,EA,fGETHALF(1,RtV));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerft_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ((fGETBIT(0, PvV))){ fSTORE(1,2,EA,fGETHALF(1,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerff_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if (fGETBIT(0, ~PvV)){ fSTORE(1,2,EA,fGETHALF(1,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvV);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_3, tmp_2, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_4, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_4, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerftnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ( fLSBNEW(PvN)) { fSTORE(1,2,EA,fGETHALF(1,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerffnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ((fLSBNEW(~PvN))) { fSTORE(1,2,EA,fGETHALF(1,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PvN);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, tmp_1, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerftnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ( fLSBNEW(PvN)) { fSTORE(1,2,EA,fGETHALF(1,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerffnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ((fLSBNEW(~PvN))) { fSTORE(1,2,EA,fGETHALF(1,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvN);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_3, tmp_2, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_4, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_4, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerftnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RxV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); if (fLSBNEW(PvN)){ (RxV = RxV + siV); fSTORE(1,2,EA,fGETHALF(1,RtV));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerffnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RxV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); if ((fLSBNEW(~PvN))){ (RxV = RxV + siV); fSTORE(1,2,EA,fGETHALF(1,RtV));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerft_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV); if ((fGETBIT(0, PvV))){ fSTORE(1,2,EA,fGETHALF(1,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_1, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerff_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if (fGETBIT(0, ~PvV)){ fSTORE(1,2,EA,fGETHALF(1,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerftnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if ( fLSBNEW(PvN)) { fSTORE(1,2,EA,fGETHALF(1,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_1, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerffnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if ((fLSBNEW(~PvN))) { fSTORE(1,2,EA,fGETHALF(1,RtV)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_storeri_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); fSTORE(1,4,EA,RtV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
gen_store4(tcg_env, EA, RtV, insn->slot);
}

void emit_S2_pstorerit_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ((fGETBIT(0, PvV))){ fSTORE(1,4,EA,RtV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
gen_store4(tcg_env, EA, RtV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerit_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RxV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); if ((fGETBIT(0, PvV))){ (RxV = RxV + siV); fSTORE(1,4,EA,RtV);} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
gen_store4(tcg_env, EA, RtV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerif_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if (fGETBIT(0, ~PvV)){ fSTORE(1,4,EA,RtV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PvV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmp_1, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
gen_store4(tcg_env, EA, RtV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerif_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RxV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); if (fGETBIT(0, ~PvV)){ (RxV = RxV + siV); fSTORE(1,4,EA,RtV);} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
gen_store4(tcg_env, EA, RtV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerit_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ((fGETBIT(0, PvV))){ fSTORE(1,4,EA,RtV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
gen_store4(tcg_env, EA, RtV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerif_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if (fGETBIT(0, ~PvV)){ fSTORE(1,4,EA,RtV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvV);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_3, tmp_2, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
gen_store4(tcg_env, EA, RtV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstoreritnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ( fLSBNEW(PvN)) { fSTORE(1,4,EA,RtV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
gen_store4(tcg_env, EA, RtV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerifnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ((fLSBNEW(~PvN))) { fSTORE(1,4,EA,RtV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PvN);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, tmp_1, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
gen_store4(tcg_env, EA, RtV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstoreritnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ( fLSBNEW(PvN)) { fSTORE(1,4,EA,RtV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
gen_store4(tcg_env, EA, RtV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerifnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ((fLSBNEW(~PvN))) { fSTORE(1,4,EA,RtV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvN);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_3, tmp_2, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
gen_store4(tcg_env, EA, RtV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstoreritnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RxV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); if (fLSBNEW(PvN)){ (RxV = RxV + siV); fSTORE(1,4,EA,RtV);} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
gen_store4(tcg_env, EA, RtV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerifnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RxV, TCGv_i32 RtV, int siV)
/* size4u_t EA; {(EA = RxV); if ((fLSBNEW(~PvN))){ (RxV = RxV + siV); fSTORE(1,4,EA,RtV);} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
gen_store4(tcg_env, EA, RtV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerit_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV); if ((fGETBIT(0, PvV))){ fSTORE(1,4,EA,RtV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
gen_store4(tcg_env, EA, RtV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerif_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if (fGETBIT(0, ~PvV)){ fSTORE(1,4,EA,RtV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
gen_store4(tcg_env, EA, RtV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstoreritnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if ( fLSBNEW(PvN)) { fSTORE(1,4,EA,RtV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
gen_store4(tcg_env, EA, RtV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerifnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if ((fLSBNEW(~PvN))) { fSTORE(1,4,EA,RtV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
gen_store4(tcg_env, EA, RtV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_storerd_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i64 RttV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); fSTORE(1,8,EA,RttV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
gen_store8(tcg_env, EA, RttV, insn->slot);
}

void emit_S2_pstorerdt_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i64 RttV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ((fGETBIT(0, PvV))){ fSTORE(1,8,EA,RttV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
gen_store8(tcg_env, EA, RttV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerdt_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RxV, TCGv_i64 RttV, int siV)
/* size4u_t EA; {(EA = RxV); if ((fGETBIT(0, PvV))){ (RxV = RxV + siV); fSTORE(1,8,EA,RttV);} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
gen_store8(tcg_env, EA, RttV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerdf_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i64 RttV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if (fGETBIT(0, ~PvV)){ fSTORE(1,8,EA,RttV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PvV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmp_1, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
gen_store8(tcg_env, EA, RttV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerdf_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RxV, TCGv_i64 RttV, int siV)
/* size4u_t EA; {(EA = RxV); if (fGETBIT(0, ~PvV)){ (RxV = RxV + siV); fSTORE(1,8,EA,RttV);} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
gen_store8(tcg_env, EA, RttV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerdt_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i64 RttV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ((fGETBIT(0, PvV))){ fSTORE(1,8,EA,RttV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
gen_store8(tcg_env, EA, RttV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerdf_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i64 RttV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if (fGETBIT(0, ~PvV)){ fSTORE(1,8,EA,RttV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvV);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_3, tmp_2, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
gen_store8(tcg_env, EA, RttV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerdtnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i64 RttV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ( fLSBNEW(PvN)) { fSTORE(1,8,EA,RttV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
gen_store8(tcg_env, EA, RttV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerdfnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i64 RttV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ((fLSBNEW(~PvN))) { fSTORE(1,8,EA,RttV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PvN);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, tmp_1, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
gen_store8(tcg_env, EA, RttV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerdtnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i64 RttV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ( fLSBNEW(PvN)) { fSTORE(1,8,EA,RttV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
gen_store8(tcg_env, EA, RttV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerdfnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RuV, TCGv_i64 RttV, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ((fLSBNEW(~PvN))) { fSTORE(1,8,EA,RttV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvN);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_3, tmp_2, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
gen_store8(tcg_env, EA, RttV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerdtnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RxV, TCGv_i64 RttV, int siV)
/* size4u_t EA; {(EA = RxV); if (fLSBNEW(PvN)){ (RxV = RxV + siV); fSTORE(1,8,EA,RttV);} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
gen_store8(tcg_env, EA, RttV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerdfnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RxV, TCGv_i64 RttV, int siV)
/* size4u_t EA; {(EA = RxV); if ((fLSBNEW(~PvN))){ (RxV = RxV + siV); fSTORE(1,8,EA,RttV);} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
gen_store8(tcg_env, EA, RttV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerdt_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i64 RttV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV); if ((fGETBIT(0, PvV))){ fSTORE(1,8,EA,RttV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
gen_store8(tcg_env, EA, RttV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerdf_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i64 RttV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if (fGETBIT(0, ~PvV)){ fSTORE(1,8,EA,RttV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
gen_store8(tcg_env, EA, RttV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerdtnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i64 RttV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if ( fLSBNEW(PvN)) { fSTORE(1,8,EA,RttV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
gen_store8(tcg_env, EA, RttV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerdfnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i64 RttV, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if ((fLSBNEW(~PvN))) { fSTORE(1,8,EA,RttV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
gen_store8(tcg_env, EA, RttV, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_storerinew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RuV, TCGv NtN, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); fSTORE(1,4,EA,fNEWREG_ST(NtN));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
gen_store4(tcg_env, EA, NtN, insn->slot);
}

void emit_S2_pstorerinewt_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv NtN, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ((fGETBIT(0, PvV))){ fSTORE(1,4,EA,fNEWREG_ST(NtN)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
gen_store4(tcg_env, EA, NtN, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerinewt_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RxV, TCGv NtN, int siV)
/* size4u_t EA; {(EA = RxV); if ((fGETBIT(0, PvV))){ (RxV = RxV + siV); fSTORE(1,4,EA,fNEWREG_ST(NtN));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
gen_store4(tcg_env, EA, NtN, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerinewf_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv NtN, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if (fGETBIT(0, ~PvV)){ fSTORE(1,4,EA,fNEWREG_ST(NtN)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PvV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmp_1, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
gen_store4(tcg_env, EA, NtN, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerinewf_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RxV, TCGv NtN, int siV)
/* size4u_t EA; {(EA = RxV); if (fGETBIT(0, ~PvV)){ (RxV = RxV + siV); fSTORE(1,4,EA,fNEWREG_ST(NtN));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
gen_store4(tcg_env, EA, NtN, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerinewt_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RuV, TCGv NtN, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ((fGETBIT(0, PvV))){ fSTORE(1,4,EA,fNEWREG_ST(NtN)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
gen_store4(tcg_env, EA, NtN, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerinewf_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RuV, TCGv NtN, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if (fGETBIT(0, ~PvV)){ fSTORE(1,4,EA,fNEWREG_ST(NtN)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvV);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_3, tmp_2, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
gen_store4(tcg_env, EA, NtN, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerinewtnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv NtN, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ( fLSBNEW(PvN)) { fSTORE(1,4,EA,fNEWREG_ST(NtN)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
gen_store4(tcg_env, EA, NtN, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerinewfnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv NtN, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ((fLSBNEW(~PvN))) { fSTORE(1,4,EA,fNEWREG_ST(NtN)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PvN);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, tmp_1, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
gen_store4(tcg_env, EA, NtN, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerinewtnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RuV, TCGv NtN, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ( fLSBNEW(PvN)) { fSTORE(1,4,EA,fNEWREG_ST(NtN)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
gen_store4(tcg_env, EA, NtN, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerinewfnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RuV, TCGv NtN, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ((fLSBNEW(~PvN))) { fSTORE(1,4,EA,fNEWREG_ST(NtN)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvN);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_3, tmp_2, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
gen_store4(tcg_env, EA, NtN, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerinewtnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RxV, TCGv NtN, int siV)
/* size4u_t EA; {(EA = RxV); if (fLSBNEW(PvN)){ (RxV = RxV + siV); fSTORE(1,4,EA,fNEWREG_ST(NtN));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
gen_store4(tcg_env, EA, NtN, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerinewfnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RxV, TCGv NtN, int siV)
/* size4u_t EA; {(EA = RxV); if ((fLSBNEW(~PvN))){ (RxV = RxV + siV); fSTORE(1,4,EA,fNEWREG_ST(NtN));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
gen_store4(tcg_env, EA, NtN, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerinewt_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv NtN, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV); if ((fGETBIT(0, PvV))){ fSTORE(1,4,EA,fNEWREG_ST(NtN)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
gen_store4(tcg_env, EA, NtN, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerinewf_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv NtN, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if (fGETBIT(0, ~PvV)){ fSTORE(1,4,EA,fNEWREG_ST(NtN)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
gen_store4(tcg_env, EA, NtN, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerinewtnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv NtN, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if ( fLSBNEW(PvN)) { fSTORE(1,4,EA,fNEWREG_ST(NtN)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
gen_store4(tcg_env, EA, NtN, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerinewfnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv NtN, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if ((fLSBNEW(~PvN))) { fSTORE(1,4,EA,fNEWREG_ST(NtN)); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
gen_store4(tcg_env, EA, NtN, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_storerbnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RuV, TCGv NtN, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN)));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_pstorerbnewt_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv NtN, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ((fGETBIT(0, PvV))){ fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerbnewt_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RxV, TCGv NtN, int siV)
/* size4u_t EA; {(EA = RxV); if ((fGETBIT(0, PvV))){ (RxV = RxV + siV); fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN)));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerbnewf_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv NtN, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if (fGETBIT(0, ~PvV)){ fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PvV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmp_1, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerbnewf_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RxV, TCGv NtN, int siV)
/* size4u_t EA; {(EA = RxV); if (fGETBIT(0, ~PvV)){ (RxV = RxV + siV); fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN)));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerbnewt_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RuV, TCGv NtN, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ((fGETBIT(0, PvV))){ fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerbnewf_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RuV, TCGv NtN, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if (fGETBIT(0, ~PvV)){ fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvV);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_3, tmp_2, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_4, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_4, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerbnewtnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv NtN, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ( fLSBNEW(PvN)) { fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerbnewfnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv NtN, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ((fLSBNEW(~PvN))) { fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PvN);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, tmp_1, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerbnewtnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RuV, TCGv NtN, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ( fLSBNEW(PvN)) { fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerbnewfnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RuV, TCGv NtN, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ((fLSBNEW(~PvN))) { fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvN);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_3, tmp_2, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_4, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_4, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerbnewtnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RxV, TCGv NtN, int siV)
/* size4u_t EA; {(EA = RxV); if (fLSBNEW(PvN)){ (RxV = RxV + siV); fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN)));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerbnewfnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RxV, TCGv NtN, int siV)
/* size4u_t EA; {(EA = RxV); if ((fLSBNEW(~PvN))){ (RxV = RxV + siV); fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN)));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerbnewt_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv NtN, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV); if ((fGETBIT(0, PvV))){ fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_1, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerbnewf_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv NtN, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if (fGETBIT(0, ~PvV)){ fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerbnewtnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv NtN, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if ( fLSBNEW(PvN)) { fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_1, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerbnewfnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv NtN, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if ((fLSBNEW(~PvN))) { fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_storerhnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RuV, TCGv NtN, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN)));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
}

void emit_S2_pstorerhnewt_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv NtN, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ((fGETBIT(0, PvV))){ fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerhnewt_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RxV, TCGv NtN, int siV)
/* size4u_t EA; {(EA = RxV); if ((fGETBIT(0, PvV))){ (RxV = RxV + siV); fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN)));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerhnewf_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv NtN, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if (fGETBIT(0, ~PvV)){ fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PvV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmp_1, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerhnewf_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RxV, TCGv NtN, int siV)
/* size4u_t EA; {(EA = RxV); if (fGETBIT(0, ~PvV)){ (RxV = RxV + siV); fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN)));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerhnewt_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RuV, TCGv NtN, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ((fGETBIT(0, PvV))){ fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerhnewf_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, TCGv_i32 RuV, TCGv NtN, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if (fGETBIT(0, ~PvV)){ fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvV);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_3, tmp_2, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_4, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_4, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerhnewtnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv NtN, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ( fLSBNEW(PvN)) { fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerhnewfnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv NtN, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); if ((fLSBNEW(~PvN))) { fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PvN);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, tmp_1, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerhnewtnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RuV, TCGv NtN, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ( fLSBNEW(PvN)) { fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerhnewfnew_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, TCGv_i32 RuV, TCGv NtN, int uiV)
/* size4u_t EA; {(EA = RsV + (RuV << uiV)); if ((fLSBNEW(~PvN))) { fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RuV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, tmp_0);
tcg_gen_mov_i32(EA, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, PvN);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_3, tmp_2, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_3, 0, if_label_0);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_4, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_4, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerhnewtnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RxV, TCGv NtN, int siV)
/* size4u_t EA; {(EA = RxV); if (fLSBNEW(PvN)){ (RxV = RxV + siV); fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN)));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S2_pstorerhnewfnew_pi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RxV, TCGv NtN, int siV)
/* size4u_t EA; {(EA = RxV); if ((fLSBNEW(~PvN))){ (RxV = RxV + siV); fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN)));} else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_mov_i32(EA, RxV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerhnewt_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv NtN, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV); (EA = uiV); if ((fGETBIT(0, PvV))){ fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_1, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerhnewf_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv NtN, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if (fGETBIT(0, ~PvV)){ fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerhnewtnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv NtN, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if ( fLSBNEW(PvN)) { fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_1, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_pstorerhnewfnew_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv NtN, int uiV)
/* size4u_t EA; {fMUST_IMMEXT(uiV);(EA = uiV); if ((fLSBNEW(~PvN))) { fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN))); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
tcg_gen_movi_i32(EA, uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PvN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_L4_add_memopw_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,4,s,EA,tmp); tmp += RtV; fSTORE(1,4,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_32 | MO_SIGN | MO_TE);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, tmp, RtV);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store4(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_add_memopb_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,1,s,EA,tmp); tmp += RtV; fSTORE(1,1,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, tmp, RtV);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store1(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_add_memoph_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,2,s,EA,tmp); tmp += RtV; fSTORE(1,2,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, tmp, RtV);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store2(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_sub_memopw_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,4,s,EA,tmp); tmp -= RtV; fSTORE(1,4,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_32 | MO_SIGN | MO_TE);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_1, tmp, RtV);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store4(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_sub_memopb_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,1,s,EA,tmp); tmp -= RtV; fSTORE(1,1,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_1, tmp, RtV);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store1(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_sub_memoph_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,2,s,EA,tmp); tmp -= RtV; fSTORE(1,2,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_1, tmp, RtV);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store2(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_and_memopw_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,4,s,EA,tmp); tmp &= RtV; fSTORE(1,4,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_32 | MO_SIGN | MO_TE);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_1, tmp, RtV);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store4(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_and_memopb_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,1,s,EA,tmp); tmp &= RtV; fSTORE(1,1,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_1, tmp, RtV);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store1(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_and_memoph_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,2,s,EA,tmp); tmp &= RtV; fSTORE(1,2,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_1, tmp, RtV);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store2(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_or_memopw_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,4,s,EA,tmp); tmp |= RtV; fSTORE(1,4,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_32 | MO_SIGN | MO_TE);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_1, tmp, RtV);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store4(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_or_memopb_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,1,s,EA,tmp); tmp |= RtV; fSTORE(1,1,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_1, tmp, RtV);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store1(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_or_memoph_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,2,s,EA,tmp); tmp |= RtV; fSTORE(1,2,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_1, tmp, RtV);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store2(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_iadd_memopw_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int uiV, int UiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,4,s,EA,tmp); tmp += UiV; fSTORE(1,4,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_32 | MO_SIGN | MO_TE);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp, UiV);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store4(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_iadd_memopb_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int uiV, int UiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,1,s,EA,tmp); tmp += UiV; fSTORE(1,1,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp, UiV);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store1(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_iadd_memoph_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int uiV, int UiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,2,s,EA,tmp); tmp += UiV; fSTORE(1,2,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp, UiV);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store2(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_isub_memopw_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int uiV, int UiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,4,s,EA,tmp); tmp -= UiV; fSTORE(1,4,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_32 | MO_SIGN | MO_TE);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_1, tmp, UiV);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store4(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_isub_memopb_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int uiV, int UiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,1,s,EA,tmp); tmp -= UiV; fSTORE(1,1,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_1, tmp, UiV);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store1(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_isub_memoph_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int uiV, int UiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,2,s,EA,tmp); tmp -= UiV; fSTORE(1,2,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_1, tmp, UiV);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store2(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_iand_memopw_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int uiV, int UiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,4,s,EA,tmp); tmp &= (~(1<<UiV)); fSTORE(1,4,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_32 | MO_SIGN | MO_TE);
int32_t qemu_tmp_0 = ((int32_t) 0x1) << UiV;
int32_t qemu_tmp_1 = ~(qemu_tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp, qemu_tmp_1);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store4(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_iand_memopb_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int uiV, int UiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,1,s,EA,tmp); tmp &= (~(1<<UiV)); fSTORE(1,1,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
int32_t qemu_tmp_0 = ((int32_t) 0x1) << UiV;
int32_t qemu_tmp_1 = ~(qemu_tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp, qemu_tmp_1);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store1(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_iand_memoph_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int uiV, int UiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,2,s,EA,tmp); tmp &= (~(1<<UiV)); fSTORE(1,2,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
int32_t qemu_tmp_0 = ((int32_t) 0x1) << UiV;
int32_t qemu_tmp_1 = ~(qemu_tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp, qemu_tmp_1);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store2(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_ior_memopw_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int uiV, int UiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,4,s,EA,tmp); tmp |= (1<<UiV); fSTORE(1,4,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_32 | MO_SIGN | MO_TE);
int32_t qemu_tmp_0 = ((int32_t) 0x1) << UiV;
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_ori_i32(tmp_1, tmp, qemu_tmp_0);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store4(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_ior_memopb_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int uiV, int UiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,1,s,EA,tmp); tmp |= (1<<UiV); fSTORE(1,1,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
int32_t qemu_tmp_0 = ((int32_t) 0x1) << UiV;
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_ori_i32(tmp_1, tmp, qemu_tmp_0);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store1(tcg_env, EA, tmp, insn->slot);
}

void emit_L4_ior_memoph_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int uiV, int UiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = RsV + uiV); size4s_t tmp; fLOAD(1,2,s,EA,tmp); tmp |= (1<<UiV); fSTORE(1,2,EA,tmp); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(tmp, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
int32_t qemu_tmp_0 = ((int32_t) 0x1) << UiV;
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_ori_i32(tmp_1, tmp, qemu_tmp_0);
tcg_gen_mov_i32(tmp, tmp_1);
gen_store2(tcg_env, EA, tmp, insn->slot);
}

void emit_S4_storeirbt_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, int uiV, int SiV)
/* size4u_t EA; {(EA = RsV + uiV); if ((fGETBIT(0, PvV))){ fIMMEXT(SiV); fSTORE(1,1,EA,SiV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (SiV));
gen_store1(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_storeirbf_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, int uiV, int SiV)
/* size4u_t EA; {(EA = RsV + uiV); if (fGETBIT(0, ~PvV)){ fIMMEXT(SiV); fSTORE(1,1,EA,SiV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PvV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmp_1, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (SiV));
gen_store1(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_storeirbtnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, int uiV, int SiV)
/* size4u_t EA; {(EA = RsV + uiV); if (fLSBNEW(PvN)){ fIMMEXT(SiV); fSTORE(1,1,EA,SiV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (SiV));
gen_store1(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_storeirbfnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, int uiV, int SiV)
/* size4u_t EA; {(EA = RsV + uiV); if ((fLSBNEW(~PvN))){ fIMMEXT(SiV); fSTORE(1,1,EA,SiV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PvN);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, tmp_1, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (SiV));
gen_store1(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_storeirht_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, int uiV, int SiV)
/* size4u_t EA; {(EA = RsV + uiV); if ((fGETBIT(0, PvV))){ fIMMEXT(SiV); fSTORE(1,2,EA,SiV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (SiV));
gen_store2(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_storeirhf_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, int uiV, int SiV)
/* size4u_t EA; {(EA = RsV + uiV); if (fGETBIT(0, ~PvV)){ fIMMEXT(SiV); fSTORE(1,2,EA,SiV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PvV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmp_1, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (SiV));
gen_store2(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_storeirhtnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, int uiV, int SiV)
/* size4u_t EA; {(EA = RsV + uiV); if (fLSBNEW(PvN)){ fIMMEXT(SiV); fSTORE(1,2,EA,SiV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (SiV));
gen_store2(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_storeirhfnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, int uiV, int SiV)
/* size4u_t EA; {(EA = RsV + uiV); if ((fLSBNEW(~PvN))){ fIMMEXT(SiV); fSTORE(1,2,EA,SiV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PvN);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, tmp_1, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (SiV));
gen_store2(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_storeirit_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, int uiV, int SiV)
/* size4u_t EA; {(EA = RsV + uiV); if ((fGETBIT(0, PvV))){ fIMMEXT(SiV); fSTORE(1,4,EA,SiV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, PvV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (SiV));
gen_store4(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_storeirif_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvV, TCGv_i32 RsV, int uiV, int SiV)
/* size4u_t EA; {(EA = RsV + uiV); if (fGETBIT(0, ~PvV)){ fIMMEXT(SiV); fSTORE(1,4,EA,SiV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PvV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmp_1, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (SiV));
gen_store4(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_storeiritnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, int uiV, int SiV)
/* size4u_t EA; {(EA = RsV + uiV); if (fLSBNEW(PvN)){ fIMMEXT(SiV); fSTORE(1,4,EA,SiV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, PvN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (SiV));
gen_store4(tcg_env, EA, tmp_2, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_storeirifnew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PvN, TCGv_i32 RsV, int uiV, int SiV)
/* size4u_t EA; {(EA = RsV + uiV); if ((fLSBNEW(~PvN))){ fIMMEXT(SiV); fSTORE(1,4,EA,SiV); } else {STORE_CANCEL(EA);}} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PvN);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, tmp_1, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (SiV));
gen_store4(tcg_env, EA, tmp_3, insn->slot);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_cancel(insn->slot);
gen_set_label(if_label_1);
}

void emit_S4_storeirb_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int uiV, int SiV)
/* size4u_t EA; {(EA = RsV + uiV); fIMMEXT(SiV); fSTORE(1,1,EA,SiV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (SiV));
gen_store1(tcg_env, EA, tmp_1, insn->slot);
}

void emit_S4_storeirh_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int uiV, int SiV)
/* size4u_t EA; {(EA = RsV + uiV); fIMMEXT(SiV); fSTORE(1,2,EA,SiV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (SiV));
gen_store2(tcg_env, EA, tmp_1, insn->slot);
}

void emit_S4_storeiri_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int uiV, int SiV)
/* size4u_t EA; {(EA = RsV + uiV); fIMMEXT(SiV); fSTORE(1,4,EA,SiV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (SiV));
gen_store4(tcg_env, EA, tmp_1, insn->slot);
}

void emit_L2_loadrubgp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = (Constant_extended ? (0) : GP) + uiV); fLOAD(1,1,u,EA,RdV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_constant_i32(0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (insn->extension_valid));
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_1, tmp_2, tmp_0, tmp_3, hex_gpr[43]);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_4, tmp_1, uiV);
tcg_gen_mov_i32(EA, tmp_4);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
}

void emit_L2_loadrbgp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = (Constant_extended ? (0) : GP) + uiV); fLOAD(1,1,s,EA,RdV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_constant_i32(0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (insn->extension_valid));
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_1, tmp_2, tmp_0, tmp_3, hex_gpr[43]);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_4, tmp_1, uiV);
tcg_gen_mov_i32(EA, tmp_4);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
}

void emit_L2_loadruhgp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = (Constant_extended ? (0) : GP) + uiV); fLOAD(1,2,u,EA,RdV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_constant_i32(0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (insn->extension_valid));
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_1, tmp_2, tmp_0, tmp_3, hex_gpr[43]);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_4, tmp_1, uiV);
tcg_gen_mov_i32(EA, tmp_4);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
}

void emit_L2_loadrhgp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = (Constant_extended ? (0) : GP) + uiV); fLOAD(1,2,s,EA,RdV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_constant_i32(0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (insn->extension_valid));
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_1, tmp_2, tmp_0, tmp_3, hex_gpr[43]);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_4, tmp_1, uiV);
tcg_gen_mov_i32(EA, tmp_4);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
}

void emit_L2_loadrigp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = (Constant_extended ? (0) : GP) + uiV); fLOAD(1,4,u,EA,RdV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_constant_i32(0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (insn->extension_valid));
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_1, tmp_2, tmp_0, tmp_3, hex_gpr[43]);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_4, tmp_1, uiV);
tcg_gen_mov_i32(EA, tmp_4);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
}

void emit_L2_loadrdgp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = (Constant_extended ? (0) : GP) + uiV); fLOAD(1,8,u,EA,RddV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_constant_i32(0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (insn->extension_valid));
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_1, tmp_2, tmp_0, tmp_3, hex_gpr[43]);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_4, tmp_1, uiV);
tcg_gen_mov_i32(EA, tmp_4);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
}

void emit_S2_storerbgp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = (Constant_extended ? (0) : GP) + uiV); fSTORE(1,1,EA,fGETBYTE(0,RtV)); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_constant_i32(0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (insn->extension_valid));
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_1, tmp_2, tmp_0, tmp_3, hex_gpr[43]);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_4, tmp_1, uiV);
tcg_gen_mov_i32(EA, tmp_4);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_5, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_5, insn->slot);
}

void emit_S2_storerhgp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = (Constant_extended ? (0) : GP) + uiV); fSTORE(1,2,EA,fGETHALF(0,RtV)); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_constant_i32(0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (insn->extension_valid));
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_1, tmp_2, tmp_0, tmp_3, hex_gpr[43]);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_4, tmp_1, uiV);
tcg_gen_mov_i32(EA, tmp_4);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_5, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_5, insn->slot);
}

void emit_S2_storerfgp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = (Constant_extended ? (0) : GP) + uiV); fSTORE(1,2,EA,fGETHALF(1,RtV)); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_constant_i32(0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (insn->extension_valid));
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_1, tmp_2, tmp_0, tmp_3, hex_gpr[43]);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_4, tmp_1, uiV);
tcg_gen_mov_i32(EA, tmp_4);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_5, RtV, ((int32_t) 0x1) * 16, 16);
gen_store2(tcg_env, EA, tmp_5, insn->slot);
}

void emit_S2_storerigp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = (Constant_extended ? (0) : GP) + uiV); fSTORE(1,4,EA,RtV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_constant_i32(0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (insn->extension_valid));
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_1, tmp_2, tmp_0, tmp_3, hex_gpr[43]);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_4, tmp_1, uiV);
tcg_gen_mov_i32(EA, tmp_4);
gen_store4(tcg_env, EA, RtV, insn->slot);
}

void emit_S2_storerdgp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RttV, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = (Constant_extended ? (0) : GP) + uiV); fSTORE(1,8,EA,RttV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_constant_i32(0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (insn->extension_valid));
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_1, tmp_2, tmp_0, tmp_3, hex_gpr[43]);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_4, tmp_1, uiV);
tcg_gen_mov_i32(EA, tmp_4);
gen_store8(tcg_env, EA, RttV, insn->slot);
}

void emit_S2_storerinewgp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv NtN, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = (Constant_extended ? (0) : GP) + uiV); fSTORE(1,4,EA,fNEWREG_ST(NtN)); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_constant_i32(0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (insn->extension_valid));
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_1, tmp_2, tmp_0, tmp_3, hex_gpr[43]);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_4, tmp_1, uiV);
tcg_gen_mov_i32(EA, tmp_4);
gen_store4(tcg_env, EA, NtN, insn->slot);
}

void emit_S2_storerbnewgp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv NtN, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = (Constant_extended ? (0) : GP) + uiV); fSTORE(1,1,EA,fGETBYTE(0,fNEWREG_ST(NtN))); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_constant_i32(0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (insn->extension_valid));
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_1, tmp_2, tmp_0, tmp_3, hex_gpr[43]);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_4, tmp_1, uiV);
tcg_gen_mov_i32(EA, tmp_4);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_5, NtN, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_5, insn->slot);
}

void emit_S2_storerhnewgp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv NtN, int uiV)
/* size4u_t EA; {fIMMEXT(uiV); (EA = (Constant_extended ? (0) : GP) + uiV); fSTORE(1,2,EA,fGETHALF(0,fNEWREG_ST(NtN))); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_constant_i32(0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (insn->extension_valid));
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_1, tmp_2, tmp_0, tmp_3, hex_gpr[43]);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_4, tmp_1, uiV);
tcg_gen_mov_i32(EA, tmp_4);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_5, NtN, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_5, insn->slot);
}

void emit_C2_cmpeq(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {PdV=((RsV==RtV) ? 0xff : 0x00);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcond_i32(TCG_COND_EQ, tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_2, tmp_0, tmp_1, tmp_3, tmp_4);
tcg_gen_andi_i32(PdV, tmp_2, 0xff);
}

void emit_C2_cmpgt(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {PdV=((RsV>RtV) ? 0xff : 0x00);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcond_i32(TCG_COND_GT, tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_2, tmp_0, tmp_1, tmp_3, tmp_4);
tcg_gen_andi_i32(PdV, tmp_2, 0xff);
}

void emit_C2_cmpgtu(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {PdV=((fCAST4u(RsV)>fCAST4u(RtV)) ? 0xff : 0x00);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcond_i32(TCG_COND_GTU, tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_2, tmp_0, tmp_1, tmp_3, tmp_4);
tcg_gen_andi_i32(PdV, tmp_2, 0xff);
}

void emit_C2_cmpeqp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* {PdV=((RssV==RttV) ? 0xff : 0x00);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_EQ, tmp_0, RssV, RttV);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_0);
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_2, tmp_3, tmp_1, tmp_4, tmp_5);
tcg_gen_andi_i32(PdV, tmp_2, 0xff);
}

void emit_C2_cmpgtp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* {PdV=((RssV>RttV) ? 0xff : 0x00);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_GT, tmp_0, RssV, RttV);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_0);
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_2, tmp_3, tmp_1, tmp_4, tmp_5);
tcg_gen_andi_i32(PdV, tmp_2, 0xff);
}

void emit_C2_cmpgtup(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* {PdV=((fCAST8u(RssV)>fCAST8u(RttV)) ? 0xff : 0x00);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_GTU, tmp_0, RssV, RttV);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_0);
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_2, tmp_3, tmp_1, tmp_4, tmp_5);
tcg_gen_andi_i32(PdV, tmp_2, 0xff);
}

void emit_A4_rcmpeqi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int siV)
/* {fIMMEXT(siV); RdV=(RsV==siV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_EQ, tmp_0, RsV, siV);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_A4_rcmpneqi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int siV)
/* {fIMMEXT(siV); RdV=(RsV!=siV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_NE, tmp_0, RsV, siV);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_A4_rcmpeq(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=(RsV==RtV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcond_i32(TCG_COND_EQ, tmp_0, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_A4_rcmpneq(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=(RsV!=RtV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcond_i32(TCG_COND_NE, tmp_0, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_C2_bitsset(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {PdV=(((RsV&RtV)==RtV) ? 0xff : 0x00);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_setcond_i32(TCG_COND_EQ, tmp_1, tmp_0, RtV);
TCGv_i32 tmp_2 = tcg_constant_i32(0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_3, tmp_1, tmp_2, tmp_4, tmp_5);
tcg_gen_andi_i32(PdV, tmp_3, 0xff);
}

void emit_C2_bitsclr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {PdV=(((RsV&RtV)==0) ? 0xff : 0x00);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_EQ, tmp_1, tmp_0, ((int32_t) 0x0));
TCGv_i32 tmp_2 = tcg_constant_i32(0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_3, tmp_1, tmp_2, tmp_4, tmp_5);
tcg_gen_andi_i32(PdV, tmp_3, 0xff);
}

void emit_C4_nbitsset(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {PdV=(((RsV&RtV)!=RtV) ? 0xff : 0x00);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_setcond_i32(TCG_COND_NE, tmp_1, tmp_0, RtV);
TCGv_i32 tmp_2 = tcg_constant_i32(0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_3, tmp_1, tmp_2, tmp_4, tmp_5);
tcg_gen_andi_i32(PdV, tmp_3, 0xff);
}

void emit_C4_nbitsclr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {PdV=(((RsV&RtV)!=0) ? 0xff : 0x00);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_NE, tmp_1, tmp_0, ((int32_t) 0x0));
TCGv_i32 tmp_2 = tcg_constant_i32(0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_3, tmp_1, tmp_2, tmp_4, tmp_5);
tcg_gen_andi_i32(PdV, tmp_3, 0xff);
}

void emit_C2_cmpeqi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, int siV)
/* {fIMMEXT(siV); PdV=((RsV==siV) ? 0xff : 0x00);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_EQ, tmp_0, RsV, siV);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_2, tmp_0, tmp_1, tmp_3, tmp_4);
tcg_gen_andi_i32(PdV, tmp_2, 0xff);
}

void emit_C2_cmpgti(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, int siV)
/* {fIMMEXT(siV); PdV=((RsV>siV) ? 0xff : 0x00);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_0, RsV, siV);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_2, tmp_0, tmp_1, tmp_3, tmp_4);
tcg_gen_andi_i32(PdV, tmp_2, 0xff);
}

void emit_C2_cmpgtui(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, int uiV)
/* {fIMMEXT(uiV); PdV=((fCAST4u(RsV)>fCAST4u(uiV)) ? 0xff : 0x00);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GTU, tmp_0, RsV, uiV);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_2, tmp_0, tmp_1, tmp_3, tmp_4);
tcg_gen_andi_i32(PdV, tmp_2, 0xff);
}

void emit_C2_bitsclri(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, int uiV)
/* {PdV=(((RsV&uiV)==0) ? 0xff : 0x00);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, RsV, uiV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_EQ, tmp_1, tmp_0, ((int32_t) 0x0));
TCGv_i32 tmp_2 = tcg_constant_i32(0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_3, tmp_1, tmp_2, tmp_4, tmp_5);
tcg_gen_andi_i32(PdV, tmp_3, 0xff);
}

void emit_C4_nbitsclri(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, int uiV)
/* {PdV=(((RsV&uiV)!=0) ? 0xff : 0x00);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, RsV, uiV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_NE, tmp_1, tmp_0, ((int32_t) 0x0));
TCGv_i32 tmp_2 = tcg_constant_i32(0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_3, tmp_1, tmp_2, tmp_4, tmp_5);
tcg_gen_andi_i32(PdV, tmp_3, 0xff);
}

void emit_C4_cmpneqi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, int siV)
/* {fIMMEXT(siV); PdV=((RsV!=siV) ? 0xff : 0x00);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_NE, tmp_0, RsV, siV);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_2, tmp_0, tmp_1, tmp_3, tmp_4);
tcg_gen_andi_i32(PdV, tmp_2, 0xff);
}

void emit_C4_cmpltei(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, int siV)
/* {fIMMEXT(siV); PdV=((RsV<=siV) ? 0xff : 0x00);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LE, tmp_0, RsV, siV);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_2, tmp_0, tmp_1, tmp_3, tmp_4);
tcg_gen_andi_i32(PdV, tmp_2, 0xff);
}

void emit_C4_cmplteui(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, int uiV)
/* {fIMMEXT(uiV); PdV=((fCAST4u(RsV)<=fCAST4u(uiV)) ? 0xff : 0x00);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LEU, tmp_0, RsV, uiV);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_2, tmp_0, tmp_1, tmp_3, tmp_4);
tcg_gen_andi_i32(PdV, tmp_2, 0xff);
}

void emit_C4_cmpneq(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {PdV=((RsV!=RtV) ? 0xff : 0x00);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcond_i32(TCG_COND_NE, tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_2, tmp_0, tmp_1, tmp_3, tmp_4);
tcg_gen_andi_i32(PdV, tmp_2, 0xff);
}

void emit_C4_cmplte(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {PdV=((RsV<=RtV) ? 0xff : 0x00);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcond_i32(TCG_COND_LE, tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_2, tmp_0, tmp_1, tmp_3, tmp_4);
tcg_gen_andi_i32(PdV, tmp_2, 0xff);
}

void emit_C4_cmplteu(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {PdV=((fCAST4u(RsV)<=fCAST4u(RtV)) ? 0xff : 0x00);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcond_i32(TCG_COND_LEU, tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_2, tmp_0, tmp_1, tmp_3, tmp_4);
tcg_gen_andi_i32(PdV, tmp_2, 0xff);
}

void emit_C2_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv PtV, TCGv PsV)
/* {PdV=PsV & PtV;} */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_0, PsV, PtV);
tcg_gen_andi_i32(PdV, tmp_0, 0xff);
}

void emit_C2_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv PtV, TCGv PsV)
/* {PdV=PsV | PtV;} */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_0, PsV, PtV);
tcg_gen_andi_i32(PdV, tmp_0, 0xff);
}

void emit_C2_xor(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv PsV, TCGv PtV)
/* {PdV=PsV ^ PtV;} */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_xor_i32(tmp_0, PsV, PtV);
tcg_gen_andi_i32(PdV, tmp_0, 0xff);
}

void emit_C2_andn(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv PtV, TCGv PsV)
/* {PdV=PtV & (~PsV);} */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PsV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_1, PtV, tmp_0);
tcg_gen_andi_i32(PdV, tmp_1, 0xff);
}

void emit_C2_not(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv PsV)
/* {PdV=~PsV;} */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PsV);
tcg_gen_andi_i32(PdV, tmp_0, 0xff);
}

void emit_C2_orn(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv PtV, TCGv PsV)
/* {PdV=PtV | (~PsV);} */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PsV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_1, PtV, tmp_0);
tcg_gen_andi_i32(PdV, tmp_1, 0xff);
}

void emit_C4_and_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv PsV, TCGv PtV, TCGv PuV)
/* { PdV = PsV & PtV & PuV; } */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_0, PsV, PtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_1, tmp_0, PuV);
tcg_gen_andi_i32(PdV, tmp_1, 0xff);
}

void emit_C4_and_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv PsV, TCGv PtV, TCGv PuV)
/* { PdV = PsV & (PtV | PuV); } */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_0, PtV, PuV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_1, PsV, tmp_0);
tcg_gen_andi_i32(PdV, tmp_1, 0xff);
}

void emit_C4_or_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv PsV, TCGv PtV, TCGv PuV)
/* { PdV = PsV | (PtV & PuV); } */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_0, PtV, PuV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_1, PsV, tmp_0);
tcg_gen_andi_i32(PdV, tmp_1, 0xff);
}

void emit_C4_or_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv PsV, TCGv PtV, TCGv PuV)
/* { PdV = PsV | PtV | PuV; } */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_0, PsV, PtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_1, tmp_0, PuV);
tcg_gen_andi_i32(PdV, tmp_1, 0xff);
}

void emit_C4_and_andn(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv PsV, TCGv PtV, TCGv PuV)
/* { PdV = PsV & PtV & (~PuV); } */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_0, PsV, PtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PuV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_2, tmp_0, tmp_1);
tcg_gen_andi_i32(PdV, tmp_2, 0xff);
}

void emit_C4_and_orn(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv PsV, TCGv PtV, TCGv PuV)
/* { PdV = PsV & (PtV | (~PuV)); } */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_1, PtV, tmp_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_2, PsV, tmp_1);
tcg_gen_andi_i32(PdV, tmp_2, 0xff);
}

void emit_C4_or_andn(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv PsV, TCGv PtV, TCGv PuV)
/* { PdV = PsV | (PtV & (~PuV)); } */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_1, PtV, tmp_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_2, PsV, tmp_1);
tcg_gen_andi_i32(PdV, tmp_2, 0xff);
}

void emit_C4_or_orn(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv PsV, TCGv PtV, TCGv PuV)
/* { PdV = PsV | PtV | (~PuV); } */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_0, PsV, PtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, PuV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_2, tmp_0, tmp_1);
tcg_gen_andi_i32(PdV, tmp_2, 0xff);
}

void emit_C2_any8(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv PsV)
/* { PdV = (PsV ? 0xff : 0x00); } */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i32 tmp_0 = tcg_constant_i32(0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_1, PsV, tmp_0, tmp_2, tmp_3);
tcg_gen_andi_i32(PdV, tmp_1, 0xff);
}

void emit_C2_all8(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv PsV)
/* { PdV = (PsV == 0xff ? 0xff : 0x00); } */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_EQ, tmp_0, PsV, ((int32_t) 0xff));
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_2, tmp_0, tmp_1, tmp_3, tmp_4);
tcg_gen_andi_i32(PdV, tmp_2, 0xff);
}

void emit_C2_vitpack(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv PsV, TCGv PtV)
/* { RdV = (PsV&0x55) | (PtV&0xAA); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PsV, ((int32_t) 0x55));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, PtV, ((int32_t) 0xaa));
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_2, tmp_0, tmp_1);
tcg_gen_mov_i32(RdV, tmp_2);
}

void emit_C2_mux(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv PuV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RdV = ((fGETBIT(0, PuV)) ? RsV : RtV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PuV, ((int32_t) 0x0) * 1, 1);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_movcond_i32(TCG_COND_NE, tmp_2, tmp_0, tmp_1, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_2);
}

void emit_C2_cmovenewit(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, int siV)
/* { fIMMEXT(siV); if (fLSBNEW(PuN)) RdV=siV; else CANCEL;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PuN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
tcg_gen_movi_i32(RdV, siV);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_C2_cmovenewif(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, int siV)
/* { fIMMEXT(siV); if ((fLSBNEW(~PuN))) RdV=siV; else CANCEL;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
tcg_gen_movi_i32(RdV, siV);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_C2_cmoveit(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, int siV)
/* { fIMMEXT(siV); if ((fGETBIT(0, PuV))) RdV=siV; else CANCEL;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PuV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
tcg_gen_movi_i32(RdV, siV);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_C2_cmoveif(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, int siV)
/* { fIMMEXT(siV); if (fGETBIT(0, ~PuV)) RdV=siV; else CANCEL;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
tcg_gen_movi_i32(RdV, siV);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_C2_ccombinewnewt(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { if (fLSBNEW(PuN)) { fSETWORD(0,RddV,RtV); fSETWORD(1,RddV,RsV); } else {CANCEL;} } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PuN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RtV);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, RsV);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, ((int32_t) 0x1) * 32, 32);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_C2_ccombinewnewf(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { if ((fLSBNEW(~PuN))) { fSETWORD(0,RddV,RtV); fSETWORD(1,RddV,RsV); } else {CANCEL;} } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, RtV);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, RsV);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, ((int32_t) 0x1) * 32, 32);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_C2_ccombinewt(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { if ((fGETBIT(0, PuV))) { fSETWORD(0,RddV,RtV); fSETWORD(1,RddV,RsV); } else {CANCEL;} } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PuV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RtV);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, RsV);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, ((int32_t) 0x1) * 32, 32);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_C2_ccombinewf(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { if (fGETBIT(0, ~PuV)) { fSETWORD(0,RddV,RtV); fSETWORD(1,RddV,RsV); } else {CANCEL;} } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, RtV);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, RsV);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, ((int32_t) 0x1) * 32, 32);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_C2_muxii(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv PuV, int siV, int SiV)
/* { fIMMEXT(siV); RdV = ((fGETBIT(0, PuV)) ? siV : SiV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PuV, ((int32_t) 0x0) * 1, 1);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (siV));
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (SiV));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_2, tmp_0, tmp_1, tmp_3, tmp_4);
tcg_gen_mov_i32(RdV, tmp_2);
}

void emit_C2_muxir(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv PuV, TCGv_i32 RsV, int siV)
/* { fIMMEXT(siV); RdV = ((fGETBIT(0, PuV)) ? RsV : siV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PuV, ((int32_t) 0x0) * 1, 1);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (siV));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_2, tmp_0, tmp_1, RsV, tmp_3);
tcg_gen_mov_i32(RdV, tmp_2);
}

void emit_C2_muxri(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv PuV, TCGv_i32 RsV, int siV)
/* { fIMMEXT(siV); RdV = ((fGETBIT(0, PuV)) ? siV : RsV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PuV, ((int32_t) 0x0) * 1, 1);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (siV));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_2, tmp_0, tmp_1, tmp_3, RsV);
tcg_gen_mov_i32(RdV, tmp_2);
}

void emit_C2_vmux(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv PuV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i = 0; i < 8; i++) { fSETBYTE(i,RddV,(fGETBIT(i,PuV)?(fGETBYTE(i,RssV)):(fGETBYTE(i,RttV)))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PuV, i * 1, 1);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, i * 8, 8);
TCGv_i64 tmp_3 = tcg_constant_i64(0);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_5, tmp_0);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_4, tmp_5, tmp_3, tmp_1, tmp_2);
tcg_gen_deposit_i64(RddV, RddV, tmp_4, i * 8, 8);
}
}

void emit_C2_mask(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv PtV)
/* { int i; for (i = 0; i < 8; i++) { fSETBYTE(i,RddV,(fGETBIT(i,PtV)?(0xff):(0x00))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PtV, i * 1, 1);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_2, tmp_0, tmp_1, tmp_3, tmp_4);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_5, tmp_2);
tcg_gen_deposit_i64(RddV, RddV, tmp_5, i * 8, 8);
}
}

void emit_A2_vcmpbeq(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i = 0; i < 8; i++) { fSETBIT(i,PdV,(fGETBYTE(i,RssV) == fGETBYTE(i,RttV))); } } */
{
tcg_gen_movi_i32(PdV, 0);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_EQ, tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_2);
tcg_gen_deposit_i32(PdV, PdV, tmp_3, i * 1, 1);
}
}

void emit_A4_vcmpbeqi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, int uiV)
/* { int i; for (i = 0; i < 8; i++) { fSETBIT(i,PdV,(fGETUBYTE(i,RssV) == uiV)); } } */
{
tcg_gen_movi_i32(PdV, 0);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
int64_t qemu_tmp_0 = (int64_t)uiV;
tcg_gen_setcondi_i64(TCG_COND_EQ, tmp_1, tmp_0, qemu_tmp_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_deposit_i32(PdV, PdV, tmp_2, i * 1, 1);
}
}

void emit_A4_vcmpbeq_any(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; PdV = 0; for (i = 0; i < 8; i++) { if (fGETBYTE(i,RssV) == fGETBYTE(i,RttV)) PdV = 0xff; } } */
{
TCGv_i32 tmp_0 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_andi_i32(PdV, tmp_0, 0xff);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, i * 8, 8);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_EQ, tmp_3, tmp_1, tmp_2);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i64(TCG_COND_EQ, tmp_3, 0, if_label_0);
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
tcg_gen_andi_i32(PdV, tmp_4, 0xff);
gen_set_label(if_label_0);
}
}

void emit_A6_vcmpbeq_notany(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; PdV = 0; for (i = 0; i < 8; i++) { if (fGETBYTE(i,RssV) == fGETBYTE(i,RttV)) PdV = 0xff; } PdV = ~PdV; } */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i32 tmp_0 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_andi_i32(PdV, tmp_0, 0xff);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, i * 8, 8);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_EQ, tmp_3, tmp_1, tmp_2);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i64(TCG_COND_EQ, tmp_3, 0, if_label_0);
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
tcg_gen_andi_i32(PdV, tmp_4, 0xff);
gen_set_label(if_label_0);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_5, PdV);
tcg_gen_andi_i32(PdV, tmp_5, 0xff);
}

void emit_A2_vcmpbgtu(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i = 0; i < 8; i++) { fSETBIT(i,PdV,(fGETUBYTE(i,RssV) > fGETUBYTE(i,RttV))); } } */
{
tcg_gen_movi_i32(PdV, 0);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_GTU, tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_2);
tcg_gen_deposit_i32(PdV, PdV, tmp_3, i * 1, 1);
}
}

void emit_A4_vcmpbgtui(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, int uiV)
/* { int i; for (i = 0; i < 8; i++) { fSETBIT(i,PdV,(fGETUBYTE(i,RssV) > uiV)); } } */
{
tcg_gen_movi_i32(PdV, 0);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
int64_t qemu_tmp_0 = (int64_t)uiV;
tcg_gen_setcondi_i64(TCG_COND_GTU, tmp_1, tmp_0, qemu_tmp_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_deposit_i32(PdV, PdV, tmp_2, i * 1, 1);
}
}

void emit_A4_vcmpbgt(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i = 0; i < 8; i++) { fSETBIT(i,PdV,(fGETBYTE(i,RssV) > fGETBYTE(i,RttV))); } } */
{
tcg_gen_movi_i32(PdV, 0);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_GT, tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_2);
tcg_gen_deposit_i32(PdV, PdV, tmp_3, i * 1, 1);
}
}

void emit_A4_vcmpbgti(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, int siV)
/* { int i; for (i = 0; i < 8; i++) { fSETBIT(i,PdV,(fGETBYTE(i,RssV) > siV)); } } */
{
tcg_gen_movi_i32(PdV, 0);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
int64_t qemu_tmp_0 = (int64_t)siV;
tcg_gen_setcondi_i64(TCG_COND_GT, tmp_1, tmp_0, qemu_tmp_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_deposit_i32(PdV, PdV, tmp_2, i * 1, 1);
}
}

void emit_A4_cmpbeq(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { PdV=((fGETBYTE(0,RsV) == fGETBYTE(0,RtV)) ? 0xff : 0x00); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_setcond_i32(TCG_COND_EQ, tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_constant_i32(0);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_6 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_4, tmp_2, tmp_3, tmp_5, tmp_6);
tcg_gen_andi_i32(PdV, tmp_4, 0xff);
}

void emit_A4_cmpbeqi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, int uiV)
/* { PdV=((fGETUBYTE(0,RsV) == uiV) ? 0xff : 0x00); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_EQ, tmp_1, tmp_0, uiV);
TCGv_i32 tmp_2 = tcg_constant_i32(0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_3, tmp_1, tmp_2, tmp_4, tmp_5);
tcg_gen_andi_i32(PdV, tmp_3, 0xff);
}

void emit_A4_cmpbgtu(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { PdV=((fGETUBYTE(0,RsV) > fGETUBYTE(0,RtV)) ? 0xff : 0x00); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_setcond_i32(TCG_COND_GTU, tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_constant_i32(0);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_6 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_4, tmp_2, tmp_3, tmp_5, tmp_6);
tcg_gen_andi_i32(PdV, tmp_4, 0xff);
}

void emit_A4_cmpbgtui(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, int uiV)
/* { fIMMEXT(uiV); PdV=((fGETUBYTE(0,RsV) > fCAST4u(uiV)) ? 0xff : 0x00); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GTU, tmp_1, tmp_0, uiV);
TCGv_i32 tmp_2 = tcg_constant_i32(0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_3, tmp_1, tmp_2, tmp_4, tmp_5);
tcg_gen_andi_i32(PdV, tmp_3, 0xff);
}

void emit_A4_cmpbgt(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { PdV=((fGETBYTE(0,RsV) > fGETBYTE(0,RtV)) ? 0xff : 0x00); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_setcond_i32(TCG_COND_GT, tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_constant_i32(0);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_6 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_4, tmp_2, tmp_3, tmp_5, tmp_6);
tcg_gen_andi_i32(PdV, tmp_4, 0xff);
}

void emit_A4_cmpbgti(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, int siV)
/* { PdV=((fGETBYTE(0,RsV) > siV) ? 0xff : 0x00); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_1, tmp_0, siV);
TCGv_i32 tmp_2 = tcg_constant_i32(0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_3, tmp_1, tmp_2, tmp_4, tmp_5);
tcg_gen_andi_i32(PdV, tmp_3, 0xff);
}

void emit_A2_vcmpheq(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i = 0; i < 4; i++) { fSETBIT(i*2,PdV, (fGETHALF(i,RssV) == fGETHALF(i,RttV))); fSETBIT(i*2+1,PdV,(fGETHALF(i,RssV) == fGETHALF(i,RttV))); } } */
{
tcg_gen_movi_i32(PdV, 0);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
int32_t qemu_tmp_0 = i * ((int32_t) 0x2);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_EQ, tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_2);
tcg_gen_deposit_i32(PdV, PdV, tmp_3, qemu_tmp_0 * 1, 1);
int32_t qemu_tmp_1 = i * ((int32_t) 0x2);
int32_t qemu_tmp_2 = qemu_tmp_1 + ((int32_t) 0x1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RssV, i * 16, 16);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RttV, i * 16, 16);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_EQ, tmp_6, tmp_4, tmp_5);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_deposit_i32(PdV, PdV, tmp_7, qemu_tmp_2 * 1, 1);
}
}

void emit_A2_vcmphgt(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i = 0; i < 4; i++) { fSETBIT(i*2, PdV, (fGETHALF(i,RssV) > fGETHALF(i,RttV))); fSETBIT(i*2+1,PdV, (fGETHALF(i,RssV) > fGETHALF(i,RttV))); } } */
{
tcg_gen_movi_i32(PdV, 0);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
int32_t qemu_tmp_0 = i * ((int32_t) 0x2);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_GT, tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_2);
tcg_gen_deposit_i32(PdV, PdV, tmp_3, qemu_tmp_0 * 1, 1);
int32_t qemu_tmp_1 = i * ((int32_t) 0x2);
int32_t qemu_tmp_2 = qemu_tmp_1 + ((int32_t) 0x1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RssV, i * 16, 16);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RttV, i * 16, 16);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_GT, tmp_6, tmp_4, tmp_5);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_deposit_i32(PdV, PdV, tmp_7, qemu_tmp_2 * 1, 1);
}
}

void emit_A2_vcmphgtu(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i = 0; i < 4; i++) { fSETBIT(i*2, PdV, (fGETUHALF(i,RssV) > fGETUHALF(i,RttV))); fSETBIT(i*2+1,PdV, (fGETUHALF(i,RssV) > fGETUHALF(i,RttV))); } } */
{
tcg_gen_movi_i32(PdV, 0);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
int32_t qemu_tmp_0 = i * ((int32_t) 0x2);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_GTU, tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_2);
tcg_gen_deposit_i32(PdV, PdV, tmp_3, qemu_tmp_0 * 1, 1);
int32_t qemu_tmp_1 = i * ((int32_t) 0x2);
int32_t qemu_tmp_2 = qemu_tmp_1 + ((int32_t) 0x1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_4, RssV, i * 16, 16);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_5, RttV, i * 16, 16);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_GTU, tmp_6, tmp_4, tmp_5);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_deposit_i32(PdV, PdV, tmp_7, qemu_tmp_2 * 1, 1);
}
}

void emit_A4_vcmpheqi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, int siV)
/* { int i; for (i = 0; i < 4; i++) { fSETBIT(i*2,PdV, (fGETHALF(i,RssV) == siV)); fSETBIT(i*2+1,PdV,(fGETHALF(i,RssV) == siV)); } } */
{
tcg_gen_movi_i32(PdV, 0);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
int32_t qemu_tmp_0 = i * ((int32_t) 0x2);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
int64_t qemu_tmp_1 = (int64_t)siV;
tcg_gen_setcondi_i64(TCG_COND_EQ, tmp_1, tmp_0, qemu_tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_deposit_i32(PdV, PdV, tmp_2, qemu_tmp_0 * 1, 1);
int32_t qemu_tmp_2 = i * ((int32_t) 0x2);
int32_t qemu_tmp_3 = qemu_tmp_2 + ((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RssV, i * 16, 16);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
int64_t qemu_tmp_4 = (int64_t)siV;
tcg_gen_setcondi_i64(TCG_COND_EQ, tmp_4, tmp_3, qemu_tmp_4);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_deposit_i32(PdV, PdV, tmp_5, qemu_tmp_3 * 1, 1);
}
}

void emit_A4_vcmphgti(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, int siV)
/* { int i; for (i = 0; i < 4; i++) { fSETBIT(i*2, PdV, (fGETHALF(i,RssV) > siV)); fSETBIT(i*2+1,PdV, (fGETHALF(i,RssV) > siV)); } } */
{
tcg_gen_movi_i32(PdV, 0);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
int32_t qemu_tmp_0 = i * ((int32_t) 0x2);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
int64_t qemu_tmp_1 = (int64_t)siV;
tcg_gen_setcondi_i64(TCG_COND_GT, tmp_1, tmp_0, qemu_tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_deposit_i32(PdV, PdV, tmp_2, qemu_tmp_0 * 1, 1);
int32_t qemu_tmp_2 = i * ((int32_t) 0x2);
int32_t qemu_tmp_3 = qemu_tmp_2 + ((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RssV, i * 16, 16);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
int64_t qemu_tmp_4 = (int64_t)siV;
tcg_gen_setcondi_i64(TCG_COND_GT, tmp_4, tmp_3, qemu_tmp_4);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_deposit_i32(PdV, PdV, tmp_5, qemu_tmp_3 * 1, 1);
}
}

void emit_A4_vcmphgtui(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, int uiV)
/* { int i; for (i = 0; i < 4; i++) { fSETBIT(i*2, PdV, (fGETUHALF(i,RssV) > uiV)); fSETBIT(i*2+1,PdV, (fGETUHALF(i,RssV) > uiV)); } } */
{
tcg_gen_movi_i32(PdV, 0);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
int32_t qemu_tmp_0 = i * ((int32_t) 0x2);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
int64_t qemu_tmp_1 = (int64_t)uiV;
tcg_gen_setcondi_i64(TCG_COND_GTU, tmp_1, tmp_0, qemu_tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_deposit_i32(PdV, PdV, tmp_2, qemu_tmp_0 * 1, 1);
int32_t qemu_tmp_2 = i * ((int32_t) 0x2);
int32_t qemu_tmp_3 = qemu_tmp_2 + ((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_3, RssV, i * 16, 16);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
int64_t qemu_tmp_4 = (int64_t)uiV;
tcg_gen_setcondi_i64(TCG_COND_GTU, tmp_4, tmp_3, qemu_tmp_4);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_deposit_i32(PdV, PdV, tmp_5, qemu_tmp_3 * 1, 1);
}
}

void emit_A4_cmpheq(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { PdV=((fGETHALF(0,RsV) == fGETHALF(0,RtV)) ? 0xff : 0x00); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_setcond_i32(TCG_COND_EQ, tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_constant_i32(0);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_6 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_4, tmp_2, tmp_3, tmp_5, tmp_6);
tcg_gen_andi_i32(PdV, tmp_4, 0xff);
}

void emit_A4_cmphgt(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { PdV=((fGETHALF(0,RsV) > fGETHALF(0,RtV)) ? 0xff : 0x00); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_setcond_i32(TCG_COND_GT, tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_constant_i32(0);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_6 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_4, tmp_2, tmp_3, tmp_5, tmp_6);
tcg_gen_andi_i32(PdV, tmp_4, 0xff);
}

void emit_A4_cmphgtu(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { PdV=((fGETUHALF(0,RsV) > fGETUHALF(0,RtV)) ? 0xff : 0x00); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_setcond_i32(TCG_COND_GTU, tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_constant_i32(0);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_6 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_4, tmp_2, tmp_3, tmp_5, tmp_6);
tcg_gen_andi_i32(PdV, tmp_4, 0xff);
}

void emit_A4_cmpheqi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, int siV)
/* { fIMMEXT(siV); PdV=((fGETHALF(0,RsV) == siV) ? 0xff : 0x00); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_EQ, tmp_1, tmp_0, siV);
TCGv_i32 tmp_2 = tcg_constant_i32(0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_3, tmp_1, tmp_2, tmp_4, tmp_5);
tcg_gen_andi_i32(PdV, tmp_3, 0xff);
}

void emit_A4_cmphgti(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, int siV)
/* { fIMMEXT(siV); PdV=((fGETHALF(0,RsV) > siV) ? 0xff : 0x00); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_1, tmp_0, siV);
TCGv_i32 tmp_2 = tcg_constant_i32(0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_3, tmp_1, tmp_2, tmp_4, tmp_5);
tcg_gen_andi_i32(PdV, tmp_3, 0xff);
}

void emit_A4_cmphgtui(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, int uiV)
/* { fIMMEXT(uiV); PdV=((fGETUHALF(0,RsV) > fCAST4u(uiV)) ? 0xff : 0x00); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GTU, tmp_1, tmp_0, uiV);
TCGv_i32 tmp_2 = tcg_constant_i32(0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_3, tmp_1, tmp_2, tmp_4, tmp_5);
tcg_gen_andi_i32(PdV, tmp_3, 0xff);
}

void emit_A2_vcmpweq(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETBITS(3,0,PdV,(fGETWORD(0,RssV)==fGETWORD(0,RttV))); fSETBITS(7,4,PdV,(fGETWORD(1,RssV)==fGETWORD(1,RttV))); } */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_EQ, tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_2);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_4, tmp_3, 1);
tcg_gen_neg_i32(tmp_4, tmp_4);
tcg_gen_deposit_i32(PdV, PdV, tmp_4, ((int32_t) 0x0), 4);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_6, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_EQ, tmp_7, tmp_5, tmp_6);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_7);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_9, tmp_8, 1);
tcg_gen_neg_i32(tmp_9, tmp_9);
tcg_gen_deposit_i32(PdV, PdV, tmp_9, ((int32_t) 0x4), 4);
}

void emit_A2_vcmpwgt(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETBITS(3,0,PdV,(fGETWORD(0,RssV)>fGETWORD(0,RttV))); fSETBITS(7,4,PdV,(fGETWORD(1,RssV)>fGETWORD(1,RttV))); } */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_GT, tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_2);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_4, tmp_3, 1);
tcg_gen_neg_i32(tmp_4, tmp_4);
tcg_gen_deposit_i32(PdV, PdV, tmp_4, ((int32_t) 0x0), 4);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_6, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_GT, tmp_7, tmp_5, tmp_6);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_7);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_9, tmp_8, 1);
tcg_gen_neg_i32(tmp_9, tmp_9);
tcg_gen_deposit_i32(PdV, PdV, tmp_9, ((int32_t) 0x4), 4);
}

void emit_A2_vcmpwgtu(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETBITS(3,0,PdV,(fGETUWORD(0,RssV)>fGETUWORD(0,RttV))); fSETBITS(7,4,PdV,(fGETUWORD(1,RssV)>fGETUWORD(1,RttV))); } */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_GTU, tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_2);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_4, tmp_3, 1);
tcg_gen_neg_i32(tmp_4, tmp_4);
tcg_gen_deposit_i32(PdV, PdV, tmp_4, ((int32_t) 0x0), 4);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_5, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_6, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_GTU, tmp_7, tmp_5, tmp_6);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_7);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_9, tmp_8, 1);
tcg_gen_neg_i32(tmp_9, tmp_9);
tcg_gen_deposit_i32(PdV, PdV, tmp_9, ((int32_t) 0x4), 4);
}

void emit_A4_vcmpweqi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, int siV)
/* { fSETBITS(3,0,PdV,(fGETWORD(0,RssV)==siV)); fSETBITS(7,4,PdV,(fGETWORD(1,RssV)==siV)); } */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
int64_t qemu_tmp_0 = (int64_t)siV;
tcg_gen_setcondi_i64(TCG_COND_EQ, tmp_1, tmp_0, qemu_tmp_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_3, tmp_2, 1);
tcg_gen_neg_i32(tmp_3, tmp_3);
tcg_gen_deposit_i32(PdV, PdV, tmp_3, ((int32_t) 0x0), 4);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
int64_t qemu_tmp_1 = (int64_t)siV;
tcg_gen_setcondi_i64(TCG_COND_EQ, tmp_5, tmp_4, qemu_tmp_1);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_6, tmp_5);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_7, tmp_6, 1);
tcg_gen_neg_i32(tmp_7, tmp_7);
tcg_gen_deposit_i32(PdV, PdV, tmp_7, ((int32_t) 0x4), 4);
}

void emit_A4_vcmpwgti(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, int siV)
/* { fSETBITS(3,0,PdV,(fGETWORD(0,RssV)>siV)); fSETBITS(7,4,PdV,(fGETWORD(1,RssV)>siV)); } */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
int64_t qemu_tmp_0 = (int64_t)siV;
tcg_gen_setcondi_i64(TCG_COND_GT, tmp_1, tmp_0, qemu_tmp_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_3, tmp_2, 1);
tcg_gen_neg_i32(tmp_3, tmp_3);
tcg_gen_deposit_i32(PdV, PdV, tmp_3, ((int32_t) 0x0), 4);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
int64_t qemu_tmp_1 = (int64_t)siV;
tcg_gen_setcondi_i64(TCG_COND_GT, tmp_5, tmp_4, qemu_tmp_1);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_6, tmp_5);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_7, tmp_6, 1);
tcg_gen_neg_i32(tmp_7, tmp_7);
tcg_gen_deposit_i32(PdV, PdV, tmp_7, ((int32_t) 0x4), 4);
}

void emit_A4_vcmpwgtui(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, int uiV)
/* { fSETBITS(3,0,PdV,(fGETUWORD(0,RssV)>fCAST4u(uiV))); fSETBITS(7,4,PdV,(fGETUWORD(1,RssV)>fCAST4u(uiV))); } */
{
tcg_gen_movi_i32(PdV, 0);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
uint64_t qemu_tmp_0 = (uint64_t)uiV;
tcg_gen_setcondi_i64(TCG_COND_GTU, tmp_1, tmp_0, qemu_tmp_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_3, tmp_2, 1);
tcg_gen_neg_i32(tmp_3, tmp_3);
tcg_gen_deposit_i32(PdV, PdV, tmp_3, ((int32_t) 0x0), 4);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_4, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
uint64_t qemu_tmp_1 = (uint64_t)uiV;
tcg_gen_setcondi_i64(TCG_COND_GTU, tmp_5, tmp_4, qemu_tmp_1);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_6, tmp_5);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_7, tmp_6, 1);
tcg_gen_neg_i32(tmp_7, tmp_7);
tcg_gen_deposit_i32(PdV, PdV, tmp_7, ((int32_t) 0x4), 4);
}

void emit_A4_boundscheck_hi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { size4u_t src; src = fGETUWORD(1,RssV); PdV = (((fCAST4u(src) >= fGETUWORD(0,RttV)) && (fCAST4u(src) < fGETUWORD(1,RttV))) ? 0xff : 0x00); } */
{
TCGv_i32 src = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_1, tmp_0);
tcg_gen_mov_i32(src, tmp_1);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_2, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_4, src);
tcg_gen_setcond_i64(TCG_COND_GEU, tmp_3, tmp_4, tmp_2);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_5, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_7, src);
tcg_gen_setcond_i64(TCG_COND_LTU, tmp_6, tmp_7, tmp_5);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_constant_i32(0);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_11, tmp_9);
tcg_gen_setcond_i64(TCG_COND_NE, tmp_10, tmp_3, tmp_11);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_13, tmp_9);
tcg_gen_setcond_i64(TCG_COND_NE, tmp_12, tmp_6, tmp_13);
tcg_gen_and_i64(tmp_8, tmp_10, tmp_12);
TCGv_i32 tmp_14 = tcg_constant_i32(0);
TCGv_i32 tmp_15 = tcg_temp_new_i32();
TCGv_i32 tmp_16 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_16, tmp_8);
TCGv_i32 tmp_17 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_18 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_15, tmp_16, tmp_14, tmp_17, tmp_18);
tcg_gen_andi_i32(PdV, tmp_15, 0xff);
}

void emit_A4_boundscheck_lo(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { size4u_t src; src = fGETUWORD(0,RssV); PdV = (((fCAST4u(src) >= fGETUWORD(0,RttV)) && (fCAST4u(src) < fGETUWORD(1,RttV))) ? 0xff : 0x00); } */
{
TCGv_i32 src = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_1, tmp_0);
tcg_gen_mov_i32(src, tmp_1);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_2, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_4, src);
tcg_gen_setcond_i64(TCG_COND_GEU, tmp_3, tmp_4, tmp_2);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_5, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_7, src);
tcg_gen_setcond_i64(TCG_COND_LTU, tmp_6, tmp_7, tmp_5);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_constant_i32(0);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_11, tmp_9);
tcg_gen_setcond_i64(TCG_COND_NE, tmp_10, tmp_3, tmp_11);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_13, tmp_9);
tcg_gen_setcond_i64(TCG_COND_NE, tmp_12, tmp_6, tmp_13);
tcg_gen_and_i64(tmp_8, tmp_10, tmp_12);
TCGv_i32 tmp_14 = tcg_constant_i32(0);
TCGv_i32 tmp_15 = tcg_temp_new_i32();
TCGv_i32 tmp_16 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_16, tmp_8);
TCGv_i32 tmp_17 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_18 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_15, tmp_16, tmp_14, tmp_17, tmp_18);
tcg_gen_andi_i32(PdV, tmp_15, 0xff);
}

void emit_C2_tfrpr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv PsV)
/* { RdV = fZXTN(8,32,PsV); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, PsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(RdV, tmp_2);
}

void emit_C2_tfrrp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV)
/* { PdV = fGETUBYTE(0,RsV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 8, 8);
tcg_gen_andi_i32(PdV, tmp_0, 0xff);
}

void emit_C4_fastcorner9(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv PsV, TCGv PtV)
/* { size4u_t tmp = 0; size4u_t i; fSETHALF(0,tmp,(PsV<<8)|PtV); fSETHALF(1,tmp,(PsV<<8)|PtV); for (i = 1; i < 9; i++) { tmp &= tmp >> 1; } PdV = ((tmp != 0) ? 0xff : 0x00); } */
{
TCGv_i32 tmp = tcg_temp_new_i32();
tcg_gen_movi_i32(PdV, 0);
tcg_gen_movi_i32(tmp, ((int32_t) 0x0));
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (((int32_t) 0x8) >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, PsV, ((int32_t) 0x8));
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_1, tmp_0, PtV);
tcg_gen_deposit_i32(tmp, tmp, tmp_1, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
if (((int32_t) 0x8) >= 32) {
tcg_gen_movi_i32(tmp_2, 0);
} else {
tcg_gen_shli_i32(tmp_2, PsV, ((int32_t) 0x8));
}
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_3, tmp_2, PtV);
tcg_gen_deposit_i32(tmp, tmp, tmp_3, ((int32_t) 0x1) * 16, 16);
for (int i = ((int32_t) 0x1); i < ((int32_t) 0x9); i++) {
TCGv_i32 tmp_4 = tcg_temp_new_i32();
if (((int32_t) 0x1) >= 32) {
tcg_gen_movi_i32(tmp_4, 0);
} else {
tcg_gen_shri_i32(tmp_4, tmp, ((int32_t) 0x1));
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_5, tmp, tmp_4);
tcg_gen_mov_i32(tmp, tmp_5);
}
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_NE, tmp_6, tmp, ((int32_t) 0x0));
TCGv_i32 tmp_7 = tcg_constant_i32(0);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
TCGv_i32 tmp_9 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_10 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_8, tmp_6, tmp_7, tmp_9, tmp_10);
tcg_gen_andi_i32(PdV, tmp_8, 0xff);
}

void emit_C4_fastcorner9_not(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv PsV, TCGv PtV)
/* { size4u_t tmp = 0; size4u_t i; fSETHALF(0,tmp,(PsV<<8)|PtV); fSETHALF(1,tmp,(PsV<<8)|PtV); for (i = 1; i < 9; i++) { tmp &= tmp >> 1; } PdV = ((tmp == 0) ? 0xff : 0x00); } */
{
TCGv_i32 tmp = tcg_temp_new_i32();
tcg_gen_movi_i32(PdV, 0);
tcg_gen_movi_i32(tmp, ((int32_t) 0x0));
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (((int32_t) 0x8) >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, PsV, ((int32_t) 0x8));
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_1, tmp_0, PtV);
tcg_gen_deposit_i32(tmp, tmp, tmp_1, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
if (((int32_t) 0x8) >= 32) {
tcg_gen_movi_i32(tmp_2, 0);
} else {
tcg_gen_shli_i32(tmp_2, PsV, ((int32_t) 0x8));
}
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_3, tmp_2, PtV);
tcg_gen_deposit_i32(tmp, tmp, tmp_3, ((int32_t) 0x1) * 16, 16);
for (int i = ((int32_t) 0x1); i < ((int32_t) 0x9); i++) {
TCGv_i32 tmp_4 = tcg_temp_new_i32();
if (((int32_t) 0x1) >= 32) {
tcg_gen_movi_i32(tmp_4, 0);
} else {
tcg_gen_shri_i32(tmp_4, tmp, ((int32_t) 0x1));
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_5, tmp, tmp_4);
tcg_gen_mov_i32(tmp, tmp_5);
}
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_EQ, tmp_6, tmp, ((int32_t) 0x0));
TCGv_i32 tmp_7 = tcg_constant_i32(0);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
TCGv_i32 tmp_9 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_10 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_8, tmp_6, tmp_7, tmp_9, tmp_10);
tcg_gen_andi_i32(PdV, tmp_8, 0xff);
}

void emit_M2_mpy_acc_hh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV+ fMPY16SS( fGETHALF(1,RsV),fGETHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_5, tmp_4);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_mov_i32(RxV, tmp_7);
}

void emit_M2_mpy_acc_hh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV+ (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_7);
tcg_gen_mov_i32(RxV, tmp_8);
}

void emit_M2_mpy_acc_hl_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV+ fMPY16SS( fGETHALF(1,RsV),fGETHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_5, tmp_4);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_mov_i32(RxV, tmp_7);
}

void emit_M2_mpy_acc_hl_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV+ (fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_7);
tcg_gen_mov_i32(RxV, tmp_8);
}

void emit_M2_mpy_acc_lh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV+ fMPY16SS( fGETHALF(0,RsV),fGETHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_5, tmp_4);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_mov_i32(RxV, tmp_7);
}

void emit_M2_mpy_acc_lh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV+ (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_7);
tcg_gen_mov_i32(RxV, tmp_8);
}

void emit_M2_mpy_acc_ll_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV+ fMPY16SS( fGETHALF(0,RsV),fGETHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_5, tmp_4);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_mov_i32(RxV, tmp_7);
}

void emit_M2_mpy_acc_ll_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV+ (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_7);
tcg_gen_mov_i32(RxV, tmp_8);
}

void emit_M2_mpy_nac_hh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV- fMPY16SS( fGETHALF(1,RsV),fGETHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, tmp_5, tmp_4);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_mov_i32(RxV, tmp_7);
}

void emit_M2_mpy_nac_hh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV- (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_7);
tcg_gen_mov_i32(RxV, tmp_8);
}

void emit_M2_mpy_nac_hl_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV- fMPY16SS( fGETHALF(1,RsV),fGETHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, tmp_5, tmp_4);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_mov_i32(RxV, tmp_7);
}

void emit_M2_mpy_nac_hl_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV- (fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_7);
tcg_gen_mov_i32(RxV, tmp_8);
}

void emit_M2_mpy_nac_lh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV- fMPY16SS( fGETHALF(0,RsV),fGETHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, tmp_5, tmp_4);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_mov_i32(RxV, tmp_7);
}

void emit_M2_mpy_nac_lh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV- (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_7);
tcg_gen_mov_i32(RxV, tmp_8);
}

void emit_M2_mpy_nac_ll_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV- fMPY16SS( fGETHALF(0,RsV),fGETHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, tmp_5, tmp_4);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_mov_i32(RxV, tmp_7);
}

void emit_M2_mpy_nac_ll_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV- (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_7);
tcg_gen_mov_i32(RxV, tmp_8);
}

void emit_M2_mpy_acc_sat_hh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fSATN(32, fPASS(RxV+ fMPY16SS( fGETHALF(1,RsV),fGETHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_5, tmp_4);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
tcg_gen_mov_i32(RxV, tmp_9);
}

void emit_M2_mpy_acc_sat_hh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fSATN(32, fPASS(RxV+ (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_6, tmp_5);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
tcg_gen_mov_i32(RxV, tmp_10);
}

void emit_M2_mpy_acc_sat_hl_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fSATN(32, fPASS(RxV+ fMPY16SS( fGETHALF(1,RsV),fGETHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_5, tmp_4);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
tcg_gen_mov_i32(RxV, tmp_9);
}

void emit_M2_mpy_acc_sat_hl_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fSATN(32, fPASS(RxV+ (fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_6, tmp_5);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
tcg_gen_mov_i32(RxV, tmp_10);
}

void emit_M2_mpy_acc_sat_lh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fSATN(32, fPASS(RxV+ fMPY16SS( fGETHALF(0,RsV),fGETHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_5, tmp_4);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
tcg_gen_mov_i32(RxV, tmp_9);
}

void emit_M2_mpy_acc_sat_lh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fSATN(32, fPASS(RxV+ (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_6, tmp_5);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
tcg_gen_mov_i32(RxV, tmp_10);
}

void emit_M2_mpy_acc_sat_ll_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fSATN(32, fPASS(RxV+ fMPY16SS( fGETHALF(0,RsV),fGETHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_5, tmp_4);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
tcg_gen_mov_i32(RxV, tmp_9);
}

void emit_M2_mpy_acc_sat_ll_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fSATN(32, fPASS(RxV+ (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_6, tmp_5);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
tcg_gen_mov_i32(RxV, tmp_10);
}

void emit_M2_mpy_nac_sat_hh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fSATN(32, fPASS(RxV- fMPY16SS( fGETHALF(1,RsV),fGETHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, tmp_5, tmp_4);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
tcg_gen_mov_i32(RxV, tmp_9);
}

void emit_M2_mpy_nac_sat_hh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fSATN(32, fPASS(RxV- (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_7, tmp_6, tmp_5);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
tcg_gen_mov_i32(RxV, tmp_10);
}

void emit_M2_mpy_nac_sat_hl_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fSATN(32, fPASS(RxV- fMPY16SS( fGETHALF(1,RsV),fGETHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, tmp_5, tmp_4);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
tcg_gen_mov_i32(RxV, tmp_9);
}

void emit_M2_mpy_nac_sat_hl_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fSATN(32, fPASS(RxV- (fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_7, tmp_6, tmp_5);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
tcg_gen_mov_i32(RxV, tmp_10);
}

void emit_M2_mpy_nac_sat_lh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fSATN(32, fPASS(RxV- fMPY16SS( fGETHALF(0,RsV),fGETHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, tmp_5, tmp_4);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
tcg_gen_mov_i32(RxV, tmp_9);
}

void emit_M2_mpy_nac_sat_lh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fSATN(32, fPASS(RxV- (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_7, tmp_6, tmp_5);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
tcg_gen_mov_i32(RxV, tmp_10);
}

void emit_M2_mpy_nac_sat_ll_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fSATN(32, fPASS(RxV- fMPY16SS( fGETHALF(0,RsV),fGETHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, tmp_5, tmp_4);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
tcg_gen_mov_i32(RxV, tmp_9);
}

void emit_M2_mpy_nac_sat_ll_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fSATN(32, fPASS(RxV- (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_7, tmp_6, tmp_5);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
tcg_gen_mov_i32(RxV, tmp_10);
}

void emit_M2_mpy_hh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS(fPASS( fMPY16SS( fGETHALF(1,RsV),fGETHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_M2_mpy_hh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS(fPASS( (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_6, tmp_5);
tcg_gen_mov_i32(RdV, tmp_6);
}

void emit_M2_mpy_hl_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS(fPASS( fMPY16SS( fGETHALF(1,RsV),fGETHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_M2_mpy_hl_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS(fPASS( (fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_6, tmp_5);
tcg_gen_mov_i32(RdV, tmp_6);
}

void emit_M2_mpy_lh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS(fPASS( fMPY16SS( fGETHALF(0,RsV),fGETHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_M2_mpy_lh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS(fPASS( (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_6, tmp_5);
tcg_gen_mov_i32(RdV, tmp_6);
}

void emit_M2_mpy_ll_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS(fPASS( fMPY16SS( fGETHALF(0,RsV),fGETHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_M2_mpy_ll_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS(fPASS( (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_6, tmp_5);
tcg_gen_mov_i32(RdV, tmp_6);
}

void emit_M2_mpy_sat_hh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fSATN(32, fPASS( fMPY16SS( fGETHALF(1,RsV),fGETHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
TCGv_i32 tmp_6 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_6, tmp_5, tmp_4, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_6);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_5);
tcg_gen_mov_i32(RdV, tmp_7);
}

void emit_M2_mpy_sat_hh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fSATN(32, fPASS( (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_6);
tcg_gen_mov_i32(RdV, tmp_8);
}

void emit_M2_mpy_sat_hl_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fSATN(32, fPASS( fMPY16SS( fGETHALF(1,RsV),fGETHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
TCGv_i32 tmp_6 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_6, tmp_5, tmp_4, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_6);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_5);
tcg_gen_mov_i32(RdV, tmp_7);
}

void emit_M2_mpy_sat_hl_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fSATN(32, fPASS( (fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_6);
tcg_gen_mov_i32(RdV, tmp_8);
}

void emit_M2_mpy_sat_lh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fSATN(32, fPASS( fMPY16SS( fGETHALF(0,RsV),fGETHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
TCGv_i32 tmp_6 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_6, tmp_5, tmp_4, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_6);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_5);
tcg_gen_mov_i32(RdV, tmp_7);
}

void emit_M2_mpy_sat_lh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fSATN(32, fPASS( (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_6);
tcg_gen_mov_i32(RdV, tmp_8);
}

void emit_M2_mpy_sat_ll_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fSATN(32, fPASS( fMPY16SS( fGETHALF(0,RsV),fGETHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
TCGv_i32 tmp_6 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_6, tmp_5, tmp_4, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_6);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_5);
tcg_gen_mov_i32(RdV, tmp_7);
}

void emit_M2_mpy_sat_ll_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fSATN(32, fPASS( (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_6);
tcg_gen_mov_i32(RdV, tmp_8);
}

void emit_M2_mpy_rnd_hh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS((fMPY16SS( fGETHALF(1,RsV),fGETHALF(1,RtV)) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_1);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_6, tmp_5);
tcg_gen_mov_i32(RdV, tmp_6);
}

void emit_M2_mpy_rnd_hh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS(((fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_6, tmp_5, qemu_tmp_2);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_mov_i32(RdV, tmp_7);
}

void emit_M2_mpy_rnd_hl_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS((fMPY16SS( fGETHALF(1,RsV),fGETHALF(0,RtV)) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_1);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_6, tmp_5);
tcg_gen_mov_i32(RdV, tmp_6);
}

void emit_M2_mpy_rnd_hl_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS(((fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 1) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_6, tmp_5, qemu_tmp_2);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_mov_i32(RdV, tmp_7);
}

void emit_M2_mpy_rnd_lh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS((fMPY16SS( fGETHALF(0,RsV),fGETHALF(1,RtV)) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_1);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_6, tmp_5);
tcg_gen_mov_i32(RdV, tmp_6);
}

void emit_M2_mpy_rnd_lh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS(((fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 1) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_6, tmp_5, qemu_tmp_2);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_mov_i32(RdV, tmp_7);
}

void emit_M2_mpy_rnd_ll_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS((fMPY16SS( fGETHALF(0,RsV),fGETHALF(0,RtV)) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_1);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_6, tmp_5);
tcg_gen_mov_i32(RdV, tmp_6);
}

void emit_M2_mpy_rnd_ll_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS(((fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_6, tmp_5, qemu_tmp_2);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_mov_i32(RdV, tmp_7);
}

void emit_M2_mpy_sat_rnd_hh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fSATN(32, (fMPY16SS( fGETHALF(1,RsV),fGETHALF(1,RtV)) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_1);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_6);
tcg_gen_mov_i32(RdV, tmp_8);
}

void emit_M2_mpy_sat_rnd_hh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fSATN(32, ((fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_6, tmp_5, qemu_tmp_2);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
tcg_gen_mov_i32(RdV, tmp_9);
}

void emit_M2_mpy_sat_rnd_hl_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fSATN(32, (fMPY16SS( fGETHALF(1,RsV),fGETHALF(0,RtV)) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_1);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_6);
tcg_gen_mov_i32(RdV, tmp_8);
}

void emit_M2_mpy_sat_rnd_hl_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fSATN(32, ((fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 1) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_6, tmp_5, qemu_tmp_2);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
tcg_gen_mov_i32(RdV, tmp_9);
}

void emit_M2_mpy_sat_rnd_lh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fSATN(32, (fMPY16SS( fGETHALF(0,RsV),fGETHALF(1,RtV)) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_1);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_6);
tcg_gen_mov_i32(RdV, tmp_8);
}

void emit_M2_mpy_sat_rnd_lh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fSATN(32, ((fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 1) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_6, tmp_5, qemu_tmp_2);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
tcg_gen_mov_i32(RdV, tmp_9);
}

void emit_M2_mpy_sat_rnd_ll_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fSATN(32, (fMPY16SS( fGETHALF(0,RsV),fGETHALF(0,RtV)) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_1);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_6);
tcg_gen_mov_i32(RdV, tmp_8);
}

void emit_M2_mpy_sat_rnd_ll_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fSATN(32, ((fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_6, tmp_5, qemu_tmp_2);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
tcg_gen_mov_i32(RdV, tmp_9);
}

void emit_M2_mpyd_acc_hh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV+ fMPY16SS( fGETHALF(1,RsV),fGETHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_5, RxxV, tmp_4);
tcg_gen_mov_i64(RxxV, tmp_5);
}

void emit_M2_mpyd_acc_hh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV+ (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, RxxV, tmp_5);
tcg_gen_mov_i64(RxxV, tmp_6);
}

void emit_M2_mpyd_acc_hl_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV+ fMPY16SS( fGETHALF(1,RsV),fGETHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_5, RxxV, tmp_4);
tcg_gen_mov_i64(RxxV, tmp_5);
}

void emit_M2_mpyd_acc_hl_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV+ (fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, RxxV, tmp_5);
tcg_gen_mov_i64(RxxV, tmp_6);
}

void emit_M2_mpyd_acc_lh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV+ fMPY16SS( fGETHALF(0,RsV),fGETHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_5, RxxV, tmp_4);
tcg_gen_mov_i64(RxxV, tmp_5);
}

void emit_M2_mpyd_acc_lh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV+ (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, RxxV, tmp_5);
tcg_gen_mov_i64(RxxV, tmp_6);
}

void emit_M2_mpyd_acc_ll_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV+ fMPY16SS( fGETHALF(0,RsV),fGETHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_5, RxxV, tmp_4);
tcg_gen_mov_i64(RxxV, tmp_5);
}

void emit_M2_mpyd_acc_ll_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV+ (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, RxxV, tmp_5);
tcg_gen_mov_i64(RxxV, tmp_6);
}

void emit_M2_mpyd_nac_hh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV- fMPY16SS( fGETHALF(1,RsV),fGETHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_5, RxxV, tmp_4);
tcg_gen_mov_i64(RxxV, tmp_5);
}

void emit_M2_mpyd_nac_hh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV- (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, RxxV, tmp_5);
tcg_gen_mov_i64(RxxV, tmp_6);
}

void emit_M2_mpyd_nac_hl_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV- fMPY16SS( fGETHALF(1,RsV),fGETHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_5, RxxV, tmp_4);
tcg_gen_mov_i64(RxxV, tmp_5);
}

void emit_M2_mpyd_nac_hl_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV- (fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, RxxV, tmp_5);
tcg_gen_mov_i64(RxxV, tmp_6);
}

void emit_M2_mpyd_nac_lh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV- fMPY16SS( fGETHALF(0,RsV),fGETHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_5, RxxV, tmp_4);
tcg_gen_mov_i64(RxxV, tmp_5);
}

void emit_M2_mpyd_nac_lh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV- (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, RxxV, tmp_5);
tcg_gen_mov_i64(RxxV, tmp_6);
}

void emit_M2_mpyd_nac_ll_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV- fMPY16SS( fGETHALF(0,RsV),fGETHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_5, RxxV, tmp_4);
tcg_gen_mov_i64(RxxV, tmp_5);
}

void emit_M2_mpyd_nac_ll_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV- (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, RxxV, tmp_5);
tcg_gen_mov_i64(RxxV, tmp_6);
}

void emit_M2_mpyd_hh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS(fPASS( fMPY16SS( fGETHALF(1,RsV),fGETHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
tcg_gen_mov_i64(RddV, tmp_4);
}

void emit_M2_mpyd_hh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS(fPASS( (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
tcg_gen_mov_i64(RddV, tmp_5);
}

void emit_M2_mpyd_hl_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS(fPASS( fMPY16SS( fGETHALF(1,RsV),fGETHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
tcg_gen_mov_i64(RddV, tmp_4);
}

void emit_M2_mpyd_hl_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS(fPASS( (fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
tcg_gen_mov_i64(RddV, tmp_5);
}

void emit_M2_mpyd_lh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS(fPASS( fMPY16SS( fGETHALF(0,RsV),fGETHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
tcg_gen_mov_i64(RddV, tmp_4);
}

void emit_M2_mpyd_lh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS(fPASS( (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
tcg_gen_mov_i64(RddV, tmp_5);
}

void emit_M2_mpyd_ll_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS(fPASS( fMPY16SS( fGETHALF(0,RsV),fGETHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
tcg_gen_mov_i64(RddV, tmp_4);
}

void emit_M2_mpyd_ll_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS(fPASS( (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
tcg_gen_mov_i64(RddV, tmp_5);
}

void emit_M2_mpyd_rnd_hh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS((fMPY16SS( fGETHALF(1,RsV),fGETHALF(1,RtV)) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_1);
tcg_gen_mov_i64(RddV, tmp_5);
}

void emit_M2_mpyd_rnd_hh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS(((fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_6, tmp_5, qemu_tmp_2);
tcg_gen_mov_i64(RddV, tmp_6);
}

void emit_M2_mpyd_rnd_hl_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS((fMPY16SS( fGETHALF(1,RsV),fGETHALF(0,RtV)) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_1);
tcg_gen_mov_i64(RddV, tmp_5);
}

void emit_M2_mpyd_rnd_hl_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS(((fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 1) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_6, tmp_5, qemu_tmp_2);
tcg_gen_mov_i64(RddV, tmp_6);
}

void emit_M2_mpyd_rnd_lh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS((fMPY16SS( fGETHALF(0,RsV),fGETHALF(1,RtV)) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_1);
tcg_gen_mov_i64(RddV, tmp_5);
}

void emit_M2_mpyd_rnd_lh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS(((fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 1) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_6, tmp_5, qemu_tmp_2);
tcg_gen_mov_i64(RddV, tmp_6);
}

void emit_M2_mpyd_rnd_ll_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS((fMPY16SS( fGETHALF(0,RsV),fGETHALF(0,RtV)) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_1);
tcg_gen_mov_i64(RddV, tmp_5);
}

void emit_M2_mpyd_rnd_ll_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS(((fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1) + 0x8000));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_6, tmp_5, qemu_tmp_2);
tcg_gen_mov_i64(RddV, tmp_6);
}

void emit_M2_mpyu_acc_hh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV+ fMPY16UU( fGETUHALF(1,RsV),fGETUHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_5, tmp_4);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_mov_i32(RxV, tmp_7);
}

void emit_M2_mpyu_acc_hh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV+ (fMPY16UU(fGETUHALF(1,RsV),fGETUHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_7);
tcg_gen_mov_i32(RxV, tmp_8);
}

void emit_M2_mpyu_acc_hl_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV+ fMPY16UU( fGETUHALF(1,RsV),fGETUHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_5, tmp_4);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_mov_i32(RxV, tmp_7);
}

void emit_M2_mpyu_acc_hl_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV+ (fMPY16UU(fGETUHALF(1,RsV),fGETUHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_7);
tcg_gen_mov_i32(RxV, tmp_8);
}

void emit_M2_mpyu_acc_lh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV+ fMPY16UU( fGETUHALF(0,RsV),fGETUHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_5, tmp_4);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_mov_i32(RxV, tmp_7);
}

void emit_M2_mpyu_acc_lh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV+ (fMPY16UU(fGETUHALF(0,RsV),fGETUHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_7);
tcg_gen_mov_i32(RxV, tmp_8);
}

void emit_M2_mpyu_acc_ll_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV+ fMPY16UU( fGETUHALF(0,RsV),fGETUHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_5, tmp_4);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_mov_i32(RxV, tmp_7);
}

void emit_M2_mpyu_acc_ll_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV+ (fMPY16UU(fGETUHALF(0,RsV),fGETUHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_7);
tcg_gen_mov_i32(RxV, tmp_8);
}

void emit_M2_mpyu_nac_hh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV- fMPY16UU( fGETUHALF(1,RsV),fGETUHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, tmp_5, tmp_4);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_mov_i32(RxV, tmp_7);
}

void emit_M2_mpyu_nac_hh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV- (fMPY16UU(fGETUHALF(1,RsV),fGETUHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_7);
tcg_gen_mov_i32(RxV, tmp_8);
}

void emit_M2_mpyu_nac_hl_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV- fMPY16UU( fGETUHALF(1,RsV),fGETUHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, tmp_5, tmp_4);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_mov_i32(RxV, tmp_7);
}

void emit_M2_mpyu_nac_hl_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV- (fMPY16UU(fGETUHALF(1,RsV),fGETUHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_7);
tcg_gen_mov_i32(RxV, tmp_8);
}

void emit_M2_mpyu_nac_lh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV- fMPY16UU( fGETUHALF(0,RsV),fGETUHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, tmp_5, tmp_4);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_mov_i32(RxV, tmp_7);
}

void emit_M2_mpyu_nac_lh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV- (fMPY16UU(fGETUHALF(0,RsV),fGETUHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_7);
tcg_gen_mov_i32(RxV, tmp_8);
}

void emit_M2_mpyu_nac_ll_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV- fMPY16UU( fGETUHALF(0,RsV),fGETUHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RxV);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, tmp_5, tmp_4);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_7, tmp_6);
tcg_gen_mov_i32(RxV, tmp_7);
}

void emit_M2_mpyu_nac_ll_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fPASS(fPASS(RxV- (fMPY16UU(fGETUHALF(0,RsV),fGETUHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RxV);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_7);
tcg_gen_mov_i32(RxV, tmp_8);
}

void emit_M2_mpyu_hh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS(fPASS( fMPY16UU( fGETUHALF(1,RsV),fGETUHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_M2_mpyu_hh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS(fPASS( (fMPY16UU(fGETUHALF(1,RsV),fGETUHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_6, tmp_5);
tcg_gen_mov_i32(RdV, tmp_6);
}

void emit_M2_mpyu_hl_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS(fPASS( fMPY16UU( fGETUHALF(1,RsV),fGETUHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_M2_mpyu_hl_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS(fPASS( (fMPY16UU(fGETUHALF(1,RsV),fGETUHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_6, tmp_5);
tcg_gen_mov_i32(RdV, tmp_6);
}

void emit_M2_mpyu_lh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS(fPASS( fMPY16UU( fGETUHALF(0,RsV),fGETUHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_M2_mpyu_lh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS(fPASS( (fMPY16UU(fGETUHALF(0,RsV),fGETUHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_6, tmp_5);
tcg_gen_mov_i32(RdV, tmp_6);
}

void emit_M2_mpyu_ll_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS(fPASS( fMPY16UU( fGETUHALF(0,RsV),fGETUHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_M2_mpyu_ll_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fPASS(fPASS( (fMPY16UU(fGETUHALF(0,RsV),fGETUHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_6, tmp_5);
tcg_gen_mov_i32(RdV, tmp_6);
}

void emit_M2_mpyud_acc_hh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV+ fMPY16UU( fGETUHALF(1,RsV),fGETUHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_5, RxxV, tmp_4);
tcg_gen_mov_i64(RxxV, tmp_5);
}

void emit_M2_mpyud_acc_hh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV+ (fMPY16UU(fGETUHALF(1,RsV),fGETUHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, RxxV, tmp_5);
tcg_gen_mov_i64(RxxV, tmp_6);
}

void emit_M2_mpyud_acc_hl_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV+ fMPY16UU( fGETUHALF(1,RsV),fGETUHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_5, RxxV, tmp_4);
tcg_gen_mov_i64(RxxV, tmp_5);
}

void emit_M2_mpyud_acc_hl_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV+ (fMPY16UU(fGETUHALF(1,RsV),fGETUHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, RxxV, tmp_5);
tcg_gen_mov_i64(RxxV, tmp_6);
}

void emit_M2_mpyud_acc_lh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV+ fMPY16UU( fGETUHALF(0,RsV),fGETUHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_5, RxxV, tmp_4);
tcg_gen_mov_i64(RxxV, tmp_5);
}

void emit_M2_mpyud_acc_lh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV+ (fMPY16UU(fGETUHALF(0,RsV),fGETUHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, RxxV, tmp_5);
tcg_gen_mov_i64(RxxV, tmp_6);
}

void emit_M2_mpyud_acc_ll_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV+ fMPY16UU( fGETUHALF(0,RsV),fGETUHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_5, RxxV, tmp_4);
tcg_gen_mov_i64(RxxV, tmp_5);
}

void emit_M2_mpyud_acc_ll_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV+ (fMPY16UU(fGETUHALF(0,RsV),fGETUHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, RxxV, tmp_5);
tcg_gen_mov_i64(RxxV, tmp_6);
}

void emit_M2_mpyud_nac_hh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV- fMPY16UU( fGETUHALF(1,RsV),fGETUHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_5, RxxV, tmp_4);
tcg_gen_mov_i64(RxxV, tmp_5);
}

void emit_M2_mpyud_nac_hh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV- (fMPY16UU(fGETUHALF(1,RsV),fGETUHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, RxxV, tmp_5);
tcg_gen_mov_i64(RxxV, tmp_6);
}

void emit_M2_mpyud_nac_hl_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV- fMPY16UU( fGETUHALF(1,RsV),fGETUHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_5, RxxV, tmp_4);
tcg_gen_mov_i64(RxxV, tmp_5);
}

void emit_M2_mpyud_nac_hl_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV- (fMPY16UU(fGETUHALF(1,RsV),fGETUHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, RxxV, tmp_5);
tcg_gen_mov_i64(RxxV, tmp_6);
}

void emit_M2_mpyud_nac_lh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV- fMPY16UU( fGETUHALF(0,RsV),fGETUHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_5, RxxV, tmp_4);
tcg_gen_mov_i64(RxxV, tmp_5);
}

void emit_M2_mpyud_nac_lh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV- (fMPY16UU(fGETUHALF(0,RsV),fGETUHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, RxxV, tmp_5);
tcg_gen_mov_i64(RxxV, tmp_6);
}

void emit_M2_mpyud_nac_ll_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV- fMPY16UU( fGETUHALF(0,RsV),fGETUHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_5, RxxV, tmp_4);
tcg_gen_mov_i64(RxxV, tmp_5);
}

void emit_M2_mpyud_nac_ll_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV=fPASS(fPASS(RxxV- (fMPY16UU(fGETUHALF(0,RsV),fGETUHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, RxxV, tmp_5);
tcg_gen_mov_i64(RxxV, tmp_6);
}

void emit_M2_mpyud_hh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS(fPASS( fMPY16UU( fGETUHALF(1,RsV),fGETUHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
tcg_gen_mov_i64(RddV, tmp_4);
}

void emit_M2_mpyud_hh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS(fPASS( (fMPY16UU(fGETUHALF(1,RsV),fGETUHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
tcg_gen_mov_i64(RddV, tmp_5);
}

void emit_M2_mpyud_hl_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS(fPASS( fMPY16UU( fGETUHALF(1,RsV),fGETUHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
tcg_gen_mov_i64(RddV, tmp_4);
}

void emit_M2_mpyud_hl_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS(fPASS( (fMPY16UU(fGETUHALF(1,RsV),fGETUHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
tcg_gen_mov_i64(RddV, tmp_5);
}

void emit_M2_mpyud_lh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS(fPASS( fMPY16UU( fGETUHALF(0,RsV),fGETUHALF(1,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
tcg_gen_mov_i64(RddV, tmp_4);
}

void emit_M2_mpyud_lh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS(fPASS( (fMPY16UU(fGETUHALF(0,RsV),fGETUHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
tcg_gen_mov_i64(RddV, tmp_5);
}

void emit_M2_mpyud_ll_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS(fPASS( fMPY16UU( fGETUHALF(0,RsV),fGETUHALF(0,RtV))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
tcg_gen_mov_i64(RddV, tmp_4);
}

void emit_M2_mpyud_ll_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fPASS(fPASS( (fMPY16UU(fGETUHALF(0,RsV),fGETUHALF(0,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
tcg_gen_mov_i64(RddV, tmp_5);
}

void emit_M2_mpysip(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* { fIMMEXT(uiV); RdV=RsV*uiV; } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_muli_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_M2_mpysin(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* { RdV=RsV*-uiV; } */
{
int32_t qemu_tmp_0 = -(uiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_muli_i32(tmp_0, RsV, qemu_tmp_0);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_M2_macsip(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV)
/* { fIMMEXT(uiV); RxV=RxV + (RsV*uiV);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_muli_i32(tmp_0, RsV, uiV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_M2_macsin(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV)
/* { fIMMEXT(uiV); RxV=RxV - (RsV*uiV);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_muli_i32(tmp_0, RsV, uiV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_M2_dpmpyss_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fMPY32SS(RsV,RtV);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RtV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_mov_i64(RddV, tmp_2);
}

void emit_M2_dpmpyss_acc_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV= RxxV + fMPY32SS(RsV,RtV);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RtV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_3, RxxV, tmp_2);
tcg_gen_mov_i64(RxxV, tmp_3);
}

void emit_M2_dpmpyss_nac_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV= RxxV - fMPY32SS(RsV,RtV);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RtV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_3, RxxV, tmp_2);
tcg_gen_mov_i64(RxxV, tmp_3);
}

void emit_M2_dpmpyuu_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RddV=fMPY32UU(fCAST4u(RsV),fCAST4u(RtV));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_0, RsV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_1, RtV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_mov_i64(RddV, tmp_2);
}

void emit_M2_dpmpyuu_acc_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV= RxxV + fMPY32UU(fCAST4u(RsV),fCAST4u(RtV));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_0, RsV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_1, RtV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_3, RxxV, tmp_2);
tcg_gen_mov_i64(RxxV, tmp_3);
}

void emit_M2_dpmpyuu_nac_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxxV= RxxV - fMPY32UU(fCAST4u(RsV),fCAST4u(RtV));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_0, RsV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_1, RtV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_3, RxxV, tmp_2);
tcg_gen_mov_i64(RxxV, tmp_3);
}

void emit_M2_mpy_up(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fMPY32SS(RsV,RtV)>>32;} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RtV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_3, tmp_2, shift);
}
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_3);
tcg_gen_mov_i32(RdV, tmp_4);
}

void emit_M2_mpy_up_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fMPY32SS(RsV,RtV)>>31;} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RtV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1f);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_3, tmp_2, shift);
}
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_3);
tcg_gen_mov_i32(RdV, tmp_4);
}

void emit_M2_mpy_up_s1_sat(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fSATN(32, fMPY32SS(RsV,RtV)>>31);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RtV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1f);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_3, tmp_2, shift);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
TCGv_i32 tmp_5 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_5, tmp_4, tmp_3, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_5);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_6, tmp_4);
tcg_gen_mov_i32(RdV, tmp_6);
}

void emit_M2_mpyu_up(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fMPY32UU(fCAST4u(RsV),fCAST4u(RtV))>>32;} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_0, RsV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_1, RtV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shri_i64(tmp_3, tmp_2, qemu_tmp_0);
}
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_3);
tcg_gen_mov_i32(RdV, tmp_4);
}

void emit_M2_mpysu_up(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=fMPY32SU(RsV,fCAST4u(RtV))>>32;} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_1, RtV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_3, tmp_2, shift);
}
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_3);
tcg_gen_mov_i32(RdV, tmp_4);
}

void emit_M2_dpmpyss_rnd_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV=(fMPY32SS(RsV,RtV)+fCONSTLL(0x80000000))>>32;} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RtV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x80000000);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_3, tmp_2, qemu_tmp_0);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_4, tmp_3, shift);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_M4_mac_up_s1_sat(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fSATN(32, (fSE32_64(RxV)) + (fMPY32SS(RsV,RtV)>>31));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RxV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RsV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, RtV);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_1, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1f);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_4, tmp_3, shift);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_5, tmp_0, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_6);
tcg_gen_mov_i32(RxV, tmp_8);
}

void emit_M4_nac_up_s1_sat(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RxV=fSATN(32, (fSE32_64(RxV)) - (fMPY32SS(RsV,RtV)>>31));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RxV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RsV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, RtV);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_1, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1f);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_4, tmp_3, shift);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_5, tmp_0, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_6);
tcg_gen_mov_i32(RxV, tmp_8);
}

void emit_M2_mpyi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RdV=RsV*RtV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_0, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_M2_maci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RxV=RxV + RsV*RtV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_M2_mnaci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RxV=RxV - RsV*RtV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_M2_acci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RxV=RxV + RsV + RtV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, RsV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, tmp_0, RtV);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_M2_accii(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int siV)
/* { fIMMEXT(siV); RxV=RxV + RsV + siV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, RsV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, siV);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_M2_nacci(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RxV=RxV - (RsV + RtV);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_M2_naccii(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int siV)
/* { fIMMEXT(siV); RxV=RxV - (RsV + siV);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, siV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_M2_subacc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RtV, TCGv_i32 RsV)
/* { RxV=RxV + RtV - RsV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, RtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_1, tmp_0, RsV);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_M4_mpyrr_addr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RyV, TCGv_i32 RuV, TCGv_i32 RsV)
/* { RyV = RuV + RsV*RyV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_0, RsV, RyV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RuV, tmp_0);
tcg_gen_mov_i32(RyV, tmp_1);
}

void emit_M4_mpyri_addr_u2(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RuV, TCGv_i32 RsV, int uiV)
/* { RdV = RuV + RsV*uiV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_muli_i32(tmp_0, RsV, uiV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RuV, tmp_0);
tcg_gen_mov_i32(RdV, tmp_1);
}

void emit_M4_mpyri_addr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RuV, TCGv_i32 RsV, int uiV)
/* { fIMMEXT(uiV); RdV = RuV + RsV*uiV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_muli_i32(tmp_0, RsV, uiV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RuV, tmp_0);
tcg_gen_mov_i32(RdV, tmp_1);
}

void emit_M4_mpyri_addi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV, int UiV)
/* { fIMMEXT(uiV); RdV = uiV + RsV*UiV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_muli_i32(tmp_0, RsV, UiV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, uiV);
tcg_gen_mov_i32(RdV, tmp_1);
}

void emit_M4_mpyrr_addi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* { fIMMEXT(uiV); RdV = uiV + RsV*RtV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, uiV);
tcg_gen_mov_i32(RdV, tmp_1);
}

void emit_M2_vmpy2s_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETWORD(0,RddV,fSATN(32, (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 0))); fSETWORD(1,RddV,fSATN(32, (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 0)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
tcg_gen_deposit_i64(RddV, RddV, tmp_6, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_8, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_9, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_10, tmp_8, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, tmp_10);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_12, tmp_11, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_12, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_13, 0);
} else {
tcg_gen_shli_i64(tmp_13, tmp_12, qemu_tmp_3);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i32 tmp_15 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_15, tmp_14, tmp_13, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_15);
tcg_gen_deposit_i64(RddV, RddV, tmp_14, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_vmpy2s_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETWORD(0,RddV,fSATN(32, (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1))); fSETWORD(1,RddV,fSATN(32, (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
tcg_gen_deposit_i64(RddV, RddV, tmp_6, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_8, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_9, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_10, tmp_8, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, tmp_10);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_12, tmp_11, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_12, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_13, 0);
} else {
tcg_gen_shli_i64(tmp_13, tmp_12, qemu_tmp_3);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i32 tmp_15 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_15, tmp_14, tmp_13, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_15);
tcg_gen_deposit_i64(RddV, RddV, tmp_14, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_vmac2s_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 0))); fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 0)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_3, tmp_1, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, tmp_3);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_5, tmp_4, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_5, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_6, 0);
} else {
tcg_gen_shli_i64(tmp_6, tmp_5, qemu_tmp_1);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_0, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_8, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_11, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_12, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_13, tmp_11, tmp_12);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_14, tmp_13);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_15, tmp_14, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_15, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_16, 0);
} else {
tcg_gen_shli_i64(tmp_16, tmp_15, qemu_tmp_3);
}
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_17, tmp_10, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i32 tmp_19 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_19, tmp_18, tmp_17, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_19);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_18, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_vmac2s_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1))); fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_3, tmp_1, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, tmp_3);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_5, tmp_4, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_5, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_6, 0);
} else {
tcg_gen_shli_i64(tmp_6, tmp_5, qemu_tmp_1);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_0, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_8, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_11, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_12, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_13, tmp_11, tmp_12);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_14, tmp_13);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_15, tmp_14, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_15, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_16, 0);
} else {
tcg_gen_shli_i64(tmp_16, tmp_15, qemu_tmp_3);
}
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_17, tmp_10, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i32 tmp_19 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_19, tmp_18, tmp_17, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_19);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_18, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_vmpy2su_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETWORD(0,RddV,fSATN(32, (fMPY16SU(fGETHALF(0,RsV),fGETUHALF(0,RtV)) << 0))); fSETWORD(1,RddV,fSATN(32, (fMPY16SU(fGETHALF(1,RsV),fGETUHALF(1,RtV)) << 0)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
tcg_gen_deposit_i64(RddV, RddV, tmp_6, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_8, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_9, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_10, tmp_8, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, tmp_10);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_12, tmp_11, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_12, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_13, 0);
} else {
tcg_gen_shli_i64(tmp_13, tmp_12, qemu_tmp_3);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i32 tmp_15 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_15, tmp_14, tmp_13, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_15);
tcg_gen_deposit_i64(RddV, RddV, tmp_14, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_vmpy2su_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETWORD(0,RddV,fSATN(32, (fMPY16SU(fGETHALF(0,RsV),fGETUHALF(0,RtV)) << 1))); fSETWORD(1,RddV,fSATN(32, (fMPY16SU(fGETHALF(1,RsV),fGETUHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
tcg_gen_deposit_i64(RddV, RddV, tmp_6, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_8, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_9, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_10, tmp_8, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, tmp_10);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_12, tmp_11, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_12, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_13, 0);
} else {
tcg_gen_shli_i64(tmp_13, tmp_12, qemu_tmp_3);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i32 tmp_15 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_15, tmp_14, tmp_13, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_15);
tcg_gen_deposit_i64(RddV, RddV, tmp_14, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_vmac2su_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (fMPY16SU(fGETHALF(0,RsV),fGETUHALF(0,RtV)) << 0))); fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (fMPY16SU(fGETHALF(1,RsV),fGETUHALF(1,RtV)) << 0)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_3, tmp_1, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, tmp_3);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_5, tmp_4, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_5, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_6, 0);
} else {
tcg_gen_shli_i64(tmp_6, tmp_5, qemu_tmp_1);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_0, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_8, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_11, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_12, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_13, tmp_11, tmp_12);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_14, tmp_13);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_15, tmp_14, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_15, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_16, 0);
} else {
tcg_gen_shli_i64(tmp_16, tmp_15, qemu_tmp_3);
}
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_17, tmp_10, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i32 tmp_19 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_19, tmp_18, tmp_17, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_19);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_18, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_vmac2su_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (fMPY16SU(fGETHALF(0,RsV),fGETUHALF(0,RtV)) << 1))); fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (fMPY16SU(fGETHALF(1,RsV),fGETUHALF(1,RtV)) << 1)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_3, tmp_1, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, tmp_3);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_5, tmp_4, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_5, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_6, 0);
} else {
tcg_gen_shli_i64(tmp_6, tmp_5, qemu_tmp_1);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_0, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_8, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_11, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_12, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_13, tmp_11, tmp_12);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_14, tmp_13);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_15, tmp_14, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_15, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_16, 0);
} else {
tcg_gen_shli_i64(tmp_16, tmp_15, qemu_tmp_3);
}
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_17, tmp_10, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i32 tmp_19 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_19, tmp_18, tmp_17, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_19);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_18, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_vmpy2s_s0pack(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETHALF(1,RdV,fGETHALF(1,(fSATN(32, (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 0) + 0x8000)))); fSETHALF(0,RdV,fGETHALF(1,(fSATN(32, (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 0) + 0x8000))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_6, tmp_5, qemu_tmp_2);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, tmp_7, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_9);
tcg_gen_deposit_i32(RdV, RdV, tmp_10, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_11, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_12, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_13, tmp_11, tmp_12);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_14, tmp_13);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_15, tmp_14, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_15, 0);
}
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
if (qemu_tmp_4 >= 64) {
tcg_gen_movi_i64(tmp_16, 0);
} else {
tcg_gen_shli_i64(tmp_16, tmp_15, qemu_tmp_4);
}
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_17, tmp_16, qemu_tmp_5);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i32 tmp_19 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_19, tmp_18, tmp_17, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_19);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_20, tmp_18, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_21, tmp_20);
tcg_gen_deposit_i32(RdV, RdV, tmp_21, ((int32_t) 0x0) * 16, 16);
}

void emit_M2_vmpy2s_s1pack(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETHALF(1,RdV,fGETHALF(1,(fSATN(32, (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1) + 0x8000)))); fSETHALF(0,RdV,fGETHALF(1,(fSATN(32, (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1) + 0x8000))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_6, tmp_5, qemu_tmp_2);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, tmp_7, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_9);
tcg_gen_deposit_i32(RdV, RdV, tmp_10, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_11, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_12, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_13, tmp_11, tmp_12);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_14, tmp_13);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_15, tmp_14, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_15, 0);
}
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
if (qemu_tmp_4 >= 64) {
tcg_gen_movi_i64(tmp_16, 0);
} else {
tcg_gen_shli_i64(tmp_16, tmp_15, qemu_tmp_4);
}
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_17, tmp_16, qemu_tmp_5);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i32 tmp_19 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_19, tmp_18, tmp_17, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_19);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_20, tmp_18, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_21, tmp_20);
tcg_gen_deposit_i32(RdV, RdV, tmp_21, ((int32_t) 0x0) * 16, 16);
}

void emit_M2_vmac2(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETWORD(0,RxxV,fGETWORD(0,RxxV) + fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV))); fSETWORD(1,RxxV,fGETWORD(1,RxxV) + fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_3, tmp_1, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, tmp_3);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_5, tmp_4, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_5, 0);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_0, tmp_5);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_6, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_8, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_9, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_10, tmp_8, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, tmp_10);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_12, tmp_11, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_12, 0);
}
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_13, tmp_7, tmp_12);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_13, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_vmpy2es_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(0,RddV,fSATN(32, (fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,RttV)) << 0))); fSETWORD(1,RddV,fSATN(32, (fMPY16SS(fGETHALF(2,RssV),fGETHALF(2,RttV)) << 0)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_7, 0);
} else {
tcg_gen_shli_i64(tmp_7, tmp_6, qemu_tmp_1);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
tcg_gen_deposit_i64(RddV, RddV, tmp_8, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_12, tmp_10);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_13, tmp_11);
TCGv_i32 tmp_14 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_14, tmp_12, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_15, tmp_14);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_16, tmp_15, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_16, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_17, 0);
} else {
tcg_gen_shli_i64(tmp_17, tmp_16, qemu_tmp_3);
}
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i32 tmp_19 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_19, tmp_18, tmp_17, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_19);
tcg_gen_deposit_i64(RddV, RddV, tmp_18, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_vmpy2es_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(0,RddV,fSATN(32, (fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,RttV)) << 1))); fSETWORD(1,RddV,fSATN(32, (fMPY16SS(fGETHALF(2,RssV),fGETHALF(2,RttV)) << 1)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_7, 0);
} else {
tcg_gen_shli_i64(tmp_7, tmp_6, qemu_tmp_1);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
tcg_gen_deposit_i64(RddV, RddV, tmp_8, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_12, tmp_10);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_13, tmp_11);
TCGv_i32 tmp_14 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_14, tmp_12, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_15, tmp_14);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_16, tmp_15, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_16, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_17, 0);
} else {
tcg_gen_shli_i64(tmp_17, tmp_16, qemu_tmp_3);
}
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i32 tmp_19 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_19, tmp_18, tmp_17, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_19);
tcg_gen_deposit_i64(RddV, RddV, tmp_18, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_vmac2es_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,RttV)) << 0))); fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (fMPY16SS(fGETHALF(2,RssV),fGETHALF(2,RttV)) << 0)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_2);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_5, tmp_3, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_7, tmp_6, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_7, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_8, 0);
} else {
tcg_gen_shli_i64(tmp_8, tmp_7, qemu_tmp_1);
}
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_9, tmp_0, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
TCGv_i32 tmp_11 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_11, tmp_10, tmp_9, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_11);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_10, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_12, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_13, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_14, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_15 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_15, tmp_13);
TCGv_i32 tmp_16 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_16, tmp_14);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_17, tmp_15, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_18, tmp_17);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_19, tmp_18, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_19, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_20, 0);
} else {
tcg_gen_shli_i64(tmp_20, tmp_19, qemu_tmp_3);
}
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_21, tmp_12, tmp_20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
TCGv_i32 tmp_23 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_23, tmp_22, tmp_21, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_23);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_22, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_vmac2es_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,RttV)) << 1))); fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (fMPY16SS(fGETHALF(2,RssV),fGETHALF(2,RttV)) << 1)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_2);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_5, tmp_3, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_7, tmp_6, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_7, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_8, 0);
} else {
tcg_gen_shli_i64(tmp_8, tmp_7, qemu_tmp_1);
}
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_9, tmp_0, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
TCGv_i32 tmp_11 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_11, tmp_10, tmp_9, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_11);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_10, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_12, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_13, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_14, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_15 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_15, tmp_13);
TCGv_i32 tmp_16 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_16, tmp_14);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_17, tmp_15, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_18, tmp_17);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_19, tmp_18, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_19, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_20, 0);
} else {
tcg_gen_shli_i64(tmp_20, tmp_19, qemu_tmp_3);
}
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_21, tmp_12, tmp_20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
TCGv_i32 tmp_23 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_23, tmp_22, tmp_21, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_23);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_22, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_vmac2es(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(0,RxxV,fGETWORD(0,RxxV) + fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,RttV))); fSETWORD(1,RxxV,fGETWORD(1,RxxV) + fMPY16SS(fGETHALF(2,RssV),fGETHALF(2,RttV)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_2);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_5, tmp_3, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_7, tmp_6, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_7, 0);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_8, tmp_0, tmp_7);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_8, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_12, tmp_10);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_13, tmp_11);
TCGv_i32 tmp_14 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_14, tmp_12, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_15, tmp_14);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_16, tmp_15, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_16, 0);
}
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_17, tmp_9, tmp_16);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_17, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_vrmac_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RxxV = RxxV + fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,RttV)) + fMPY16SS(fGETHALF(1,RssV),fGETHALF(1,RttV)) + fMPY16SS(fGETHALF(2,RssV),fGETHALF(2,RttV)) + fMPY16SS(fGETHALF(3,RssV),fGETHALF(3,RttV));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, RxxV, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_11, tmp_9);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_12, tmp_10, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, tmp_12);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_14, tmp_13, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_14, 0);
}
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_15, tmp_7, tmp_14);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_16, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_17, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_18, tmp_16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_19, tmp_17);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_20, tmp_18, tmp_19);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_21, tmp_20);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_22, tmp_21, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_22, 0);
}
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_23, tmp_15, tmp_22);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_24, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_25, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_26, tmp_24);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_27, tmp_25);
TCGv_i32 tmp_28 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_28, tmp_26, tmp_27);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_29, tmp_28);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_30 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_30, tmp_29, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_30, 0);
}
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_31, tmp_23, tmp_30);
tcg_gen_mov_i64(RxxV, tmp_31);
}

void emit_M2_vrmpy_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RddV = fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,RttV)) + fMPY16SS(fGETHALF(1,RssV),fGETHALF(1,RttV)) + fMPY16SS(fGETHALF(2,RssV),fGETHALF(2,RttV)) + fMPY16SS(fGETHALF(3,RssV),fGETHALF(3,RttV));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_11, tmp_9, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, tmp_11);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_13, tmp_12, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_13, 0);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_14, tmp_6, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_15, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_16, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_17, tmp_15);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_18, tmp_16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_19, tmp_17, tmp_18);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_20, tmp_19);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_21, tmp_20, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_21, 0);
}
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_22, tmp_14, tmp_21);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_23, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_24, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_25, tmp_23);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_26, tmp_24);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_27, tmp_25, tmp_26);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_28, tmp_27);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_29, tmp_28, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_29, 0);
}
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_30, tmp_22, tmp_29);
tcg_gen_mov_i64(RddV, tmp_30);
}

void emit_M2_vdmpyrs_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETHALF(0,RdV,fGETHALF(1,(fSATN(32, (fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,RttV)) << 0) + (fMPY16SS(fGETHALF(1,RssV),fGETHALF(1,RttV)) << 0) + 0x8000)))); fSETHALF(1,RdV,fGETHALF(1,(fSATN(32, (fMPY16SS(fGETHALF(2,RssV),fGETHALF(2,RttV)) << 0) + (fMPY16SS(fGETHALF(3,RssV),fGETHALF(3,RttV)) << 0) + 0x8000))));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_7, 0);
} else {
tcg_gen_shli_i64(tmp_7, tmp_6, qemu_tmp_1);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_11, tmp_9);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_12, tmp_10, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, tmp_12);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_14, tmp_13, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_14, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_15, 0);
} else {
tcg_gen_shli_i64(tmp_15, tmp_14, qemu_tmp_3);
}
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_16, tmp_7, tmp_15);
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_17, tmp_16, qemu_tmp_4);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i32 tmp_19 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_19, tmp_18, tmp_17, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_19);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_20, tmp_18, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_21, tmp_20);
tcg_gen_deposit_i32(RdV, RdV, tmp_21, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_22, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_23, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_24 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_24, tmp_22);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_25, tmp_23);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_26, tmp_24, tmp_25);
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_27, tmp_26);
uint64_t qemu_tmp_5 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
if (qemu_tmp_5 != 0) {
tcg_gen_sextract_i64(tmp_28, tmp_27, 0, qemu_tmp_5);
} else {
tcg_gen_movi_i64(tmp_28, 0);
}
int64_t qemu_tmp_6 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_6 >= 64) {
tcg_gen_movi_i64(tmp_29, 0);
} else {
tcg_gen_shli_i64(tmp_29, tmp_28, qemu_tmp_6);
}
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_30, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_31, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_32 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_32, tmp_30);
TCGv_i32 tmp_33 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_33, tmp_31);
TCGv_i32 tmp_34 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_34, tmp_32, tmp_33);
TCGv_i64 tmp_35 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_35, tmp_34);
uint64_t qemu_tmp_7 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_36 = tcg_temp_new_i64();
if (qemu_tmp_7 != 0) {
tcg_gen_sextract_i64(tmp_36, tmp_35, 0, qemu_tmp_7);
} else {
tcg_gen_movi_i64(tmp_36, 0);
}
int64_t qemu_tmp_8 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_37 = tcg_temp_new_i64();
if (qemu_tmp_8 >= 64) {
tcg_gen_movi_i64(tmp_37, 0);
} else {
tcg_gen_shli_i64(tmp_37, tmp_36, qemu_tmp_8);
}
TCGv_i64 tmp_38 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_38, tmp_29, tmp_37);
int64_t qemu_tmp_9 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_39 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_39, tmp_38, qemu_tmp_9);
TCGv_i64 tmp_40 = tcg_temp_new_i64();
TCGv_i32 tmp_41 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_41, tmp_40, tmp_39, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_41);
TCGv_i64 tmp_42 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_42, tmp_40, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_43 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_43, tmp_42);
tcg_gen_deposit_i32(RdV, RdV, tmp_43, ((int32_t) 0x1) * 16, 16);
}

void emit_M2_vdmpyrs_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETHALF(0,RdV,fGETHALF(1,(fSATN(32, (fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,RttV)) << 1) + (fMPY16SS(fGETHALF(1,RssV),fGETHALF(1,RttV)) << 1) + 0x8000)))); fSETHALF(1,RdV,fGETHALF(1,(fSATN(32, (fMPY16SS(fGETHALF(2,RssV),fGETHALF(2,RttV)) << 1) + (fMPY16SS(fGETHALF(3,RssV),fGETHALF(3,RttV)) << 1) + 0x8000))));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_7, 0);
} else {
tcg_gen_shli_i64(tmp_7, tmp_6, qemu_tmp_1);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_11, tmp_9);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_12, tmp_10, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, tmp_12);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_14, tmp_13, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_14, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_15, 0);
} else {
tcg_gen_shli_i64(tmp_15, tmp_14, qemu_tmp_3);
}
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_16, tmp_7, tmp_15);
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_17, tmp_16, qemu_tmp_4);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i32 tmp_19 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_19, tmp_18, tmp_17, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_19);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_20, tmp_18, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_21, tmp_20);
tcg_gen_deposit_i32(RdV, RdV, tmp_21, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_22, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_23, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_24 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_24, tmp_22);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_25, tmp_23);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_26, tmp_24, tmp_25);
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_27, tmp_26);
uint64_t qemu_tmp_5 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
if (qemu_tmp_5 != 0) {
tcg_gen_sextract_i64(tmp_28, tmp_27, 0, qemu_tmp_5);
} else {
tcg_gen_movi_i64(tmp_28, 0);
}
int64_t qemu_tmp_6 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_6 >= 64) {
tcg_gen_movi_i64(tmp_29, 0);
} else {
tcg_gen_shli_i64(tmp_29, tmp_28, qemu_tmp_6);
}
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_30, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_31, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_32 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_32, tmp_30);
TCGv_i32 tmp_33 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_33, tmp_31);
TCGv_i32 tmp_34 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_34, tmp_32, tmp_33);
TCGv_i64 tmp_35 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_35, tmp_34);
uint64_t qemu_tmp_7 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_36 = tcg_temp_new_i64();
if (qemu_tmp_7 != 0) {
tcg_gen_sextract_i64(tmp_36, tmp_35, 0, qemu_tmp_7);
} else {
tcg_gen_movi_i64(tmp_36, 0);
}
int64_t qemu_tmp_8 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_37 = tcg_temp_new_i64();
if (qemu_tmp_8 >= 64) {
tcg_gen_movi_i64(tmp_37, 0);
} else {
tcg_gen_shli_i64(tmp_37, tmp_36, qemu_tmp_8);
}
TCGv_i64 tmp_38 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_38, tmp_29, tmp_37);
int64_t qemu_tmp_9 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_39 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_39, tmp_38, qemu_tmp_9);
TCGv_i64 tmp_40 = tcg_temp_new_i64();
TCGv_i32 tmp_41 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_41, tmp_40, tmp_39, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_41);
TCGv_i64 tmp_42 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_42, tmp_40, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_43 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_43, tmp_42);
tcg_gen_deposit_i32(RdV, RdV, tmp_43, ((int32_t) 0x1) * 16, 16);
}

void emit_M5_vrmpybuu(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(0,RddV,(fMPY16SS(fGETUBYTE(0,RssV),fGETUBYTE(0,RttV)) + fMPY16SS(fGETUBYTE(1,RssV),fGETUBYTE(1,RttV)) + fMPY16SS(fGETUBYTE(2,RssV),fGETUBYTE(2,RttV)) + fMPY16SS(fGETUBYTE(3,RssV),fGETUBYTE(3,RttV)))); fSETWORD(1,RddV,(fMPY16SS(fGETUBYTE(4,RssV),fGETUBYTE(4,RttV)) + fMPY16SS(fGETUBYTE(5,RssV),fGETUBYTE(5,RttV)) + fMPY16SS(fGETUBYTE(6,RssV),fGETUBYTE(6,RttV)) + fMPY16SS(fGETUBYTE(7,RssV),fGETUBYTE(7,RttV)))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, ((int32_t) 0x0) * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_7, RssV, ((int32_t) 0x1) * 8, 8);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_8, RttV, ((int32_t) 0x1) * 8, 8);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_11, tmp_9, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, tmp_11);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_13, tmp_12, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_13, 0);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_14, tmp_6, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_15, RssV, ((int32_t) 0x2) * 8, 8);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_16, RttV, ((int32_t) 0x2) * 8, 8);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_17, tmp_15);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_18, tmp_16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_19, tmp_17, tmp_18);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_20, tmp_19);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_21, tmp_20, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_21, 0);
}
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_22, tmp_14, tmp_21);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_23, RssV, ((int32_t) 0x3) * 8, 8);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_24, RttV, ((int32_t) 0x3) * 8, 8);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_25, tmp_23);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_26, tmp_24);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_27, tmp_25, tmp_26);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_28, tmp_27);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_29, tmp_28, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_29, 0);
}
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_30, tmp_22, tmp_29);
tcg_gen_deposit_i64(RddV, RddV, tmp_30, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_31, RssV, ((int32_t) 0x4) * 8, 8);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_32, RttV, ((int32_t) 0x4) * 8, 8);
TCGv_i32 tmp_33 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_33, tmp_31);
TCGv_i32 tmp_34 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_34, tmp_32);
TCGv_i32 tmp_35 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_35, tmp_33, tmp_34);
TCGv_i64 tmp_36 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_36, tmp_35);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_37 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_37, tmp_36, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_37, 0);
}
TCGv_i64 tmp_38 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_38, RssV, ((int32_t) 0x5) * 8, 8);
TCGv_i64 tmp_39 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_39, RttV, ((int32_t) 0x5) * 8, 8);
TCGv_i32 tmp_40 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_40, tmp_38);
TCGv_i32 tmp_41 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_41, tmp_39);
TCGv_i32 tmp_42 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_42, tmp_40, tmp_41);
TCGv_i64 tmp_43 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_43, tmp_42);
uint64_t qemu_tmp_5 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_44 = tcg_temp_new_i64();
if (qemu_tmp_5 != 0) {
tcg_gen_sextract_i64(tmp_44, tmp_43, 0, qemu_tmp_5);
} else {
tcg_gen_movi_i64(tmp_44, 0);
}
TCGv_i64 tmp_45 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_45, tmp_37, tmp_44);
TCGv_i64 tmp_46 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_46, RssV, ((int32_t) 0x6) * 8, 8);
TCGv_i64 tmp_47 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_47, RttV, ((int32_t) 0x6) * 8, 8);
TCGv_i32 tmp_48 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_48, tmp_46);
TCGv_i32 tmp_49 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_49, tmp_47);
TCGv_i32 tmp_50 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_50, tmp_48, tmp_49);
TCGv_i64 tmp_51 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_51, tmp_50);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_52 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_52, tmp_51, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_52, 0);
}
TCGv_i64 tmp_53 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_53, tmp_45, tmp_52);
TCGv_i64 tmp_54 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_54, RssV, ((int32_t) 0x7) * 8, 8);
TCGv_i64 tmp_55 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_55, RttV, ((int32_t) 0x7) * 8, 8);
TCGv_i32 tmp_56 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_56, tmp_54);
TCGv_i32 tmp_57 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_57, tmp_55);
TCGv_i32 tmp_58 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_58, tmp_56, tmp_57);
TCGv_i64 tmp_59 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_59, tmp_58);
uint64_t qemu_tmp_7 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_60 = tcg_temp_new_i64();
if (qemu_tmp_7 != 0) {
tcg_gen_sextract_i64(tmp_60, tmp_59, 0, qemu_tmp_7);
} else {
tcg_gen_movi_i64(tmp_60, 0);
}
TCGv_i64 tmp_61 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_61, tmp_53, tmp_60);
tcg_gen_deposit_i64(RddV, RddV, tmp_61, ((int32_t) 0x1) * 32, 32);
}

void emit_M5_vrmacbuu(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(0,RxxV,(fGETWORD(0,RxxV) + fMPY16SS(fGETUBYTE(0,RssV),fGETUBYTE(0,RttV)) + fMPY16SS(fGETUBYTE(1,RssV),fGETUBYTE(1,RttV)) + fMPY16SS(fGETUBYTE(2,RssV),fGETUBYTE(2,RttV)) + fMPY16SS(fGETUBYTE(3,RssV),fGETUBYTE(3,RttV)))); fSETWORD(1,RxxV,(fGETWORD(1,RxxV) + fMPY16SS(fGETUBYTE(4,RssV),fGETUBYTE(4,RttV)) + fMPY16SS(fGETUBYTE(5,RssV),fGETUBYTE(5,RttV)) + fMPY16SS(fGETUBYTE(6,RssV),fGETUBYTE(6,RttV)) + fMPY16SS(fGETUBYTE(7,RssV),fGETUBYTE(7,RttV)))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RssV, ((int32_t) 0x0) * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_2, RttV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_2);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_5, tmp_3, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_7, tmp_6, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_7, 0);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_8, tmp_0, tmp_7);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_9, RssV, ((int32_t) 0x1) * 8, 8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_10, RttV, ((int32_t) 0x1) * 8, 8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_11, tmp_9);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_12, tmp_10);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_13, tmp_11, tmp_12);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_14, tmp_13);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_15, tmp_14, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_15, 0);
}
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_16, tmp_8, tmp_15);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_17, RssV, ((int32_t) 0x2) * 8, 8);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_18, RttV, ((int32_t) 0x2) * 8, 8);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_19, tmp_17);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_20, tmp_18);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_21, tmp_19, tmp_20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_22, tmp_21);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_23, tmp_22, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_23, 0);
}
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_24, tmp_16, tmp_23);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_25, RssV, ((int32_t) 0x3) * 8, 8);
TCGv_i64 tmp_26 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_26, RttV, ((int32_t) 0x3) * 8, 8);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_27, tmp_25);
TCGv_i32 tmp_28 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_28, tmp_26);
TCGv_i32 tmp_29 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_29, tmp_27, tmp_28);
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_30, tmp_29);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_31, tmp_30, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_31, 0);
}
TCGv_i64 tmp_32 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_32, tmp_24, tmp_31);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_32, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_33 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_33, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_34 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_34, RssV, ((int32_t) 0x4) * 8, 8);
TCGv_i64 tmp_35 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_35, RttV, ((int32_t) 0x4) * 8, 8);
TCGv_i32 tmp_36 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_36, tmp_34);
TCGv_i32 tmp_37 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_37, tmp_35);
TCGv_i32 tmp_38 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_38, tmp_36, tmp_37);
TCGv_i64 tmp_39 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_39, tmp_38);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_40 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_40, tmp_39, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_40, 0);
}
TCGv_i64 tmp_41 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_41, tmp_33, tmp_40);
TCGv_i64 tmp_42 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_42, RssV, ((int32_t) 0x5) * 8, 8);
TCGv_i64 tmp_43 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_43, RttV, ((int32_t) 0x5) * 8, 8);
TCGv_i32 tmp_44 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_44, tmp_42);
TCGv_i32 tmp_45 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_45, tmp_43);
TCGv_i32 tmp_46 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_46, tmp_44, tmp_45);
TCGv_i64 tmp_47 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_47, tmp_46);
uint64_t qemu_tmp_5 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_48 = tcg_temp_new_i64();
if (qemu_tmp_5 != 0) {
tcg_gen_sextract_i64(tmp_48, tmp_47, 0, qemu_tmp_5);
} else {
tcg_gen_movi_i64(tmp_48, 0);
}
TCGv_i64 tmp_49 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_49, tmp_41, tmp_48);
TCGv_i64 tmp_50 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_50, RssV, ((int32_t) 0x6) * 8, 8);
TCGv_i64 tmp_51 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_51, RttV, ((int32_t) 0x6) * 8, 8);
TCGv_i32 tmp_52 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_52, tmp_50);
TCGv_i32 tmp_53 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_53, tmp_51);
TCGv_i32 tmp_54 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_54, tmp_52, tmp_53);
TCGv_i64 tmp_55 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_55, tmp_54);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_56 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_56, tmp_55, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_56, 0);
}
TCGv_i64 tmp_57 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_57, tmp_49, tmp_56);
TCGv_i64 tmp_58 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_58, RssV, ((int32_t) 0x7) * 8, 8);
TCGv_i64 tmp_59 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_59, RttV, ((int32_t) 0x7) * 8, 8);
TCGv_i32 tmp_60 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_60, tmp_58);
TCGv_i32 tmp_61 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_61, tmp_59);
TCGv_i32 tmp_62 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_62, tmp_60, tmp_61);
TCGv_i64 tmp_63 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_63, tmp_62);
uint64_t qemu_tmp_7 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_64 = tcg_temp_new_i64();
if (qemu_tmp_7 != 0) {
tcg_gen_sextract_i64(tmp_64, tmp_63, 0, qemu_tmp_7);
} else {
tcg_gen_movi_i64(tmp_64, 0);
}
TCGv_i64 tmp_65 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_65, tmp_57, tmp_64);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_65, ((int32_t) 0x1) * 32, 32);
}

void emit_M5_vrmpybsu(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(0,RddV,(fMPY16SS(fGETBYTE(0,RssV),fGETUBYTE(0,RttV)) + fMPY16SS(fGETBYTE(1,RssV),fGETUBYTE(1,RttV)) + fMPY16SS(fGETBYTE(2,RssV),fGETUBYTE(2,RttV)) + fMPY16SS(fGETBYTE(3,RssV),fGETUBYTE(3,RttV)))); fSETWORD(1,RddV,(fMPY16SS(fGETBYTE(4,RssV),fGETUBYTE(4,RttV)) + fMPY16SS(fGETBYTE(5,RssV),fGETUBYTE(5,RttV)) + fMPY16SS(fGETBYTE(6,RssV),fGETUBYTE(6,RttV)) + fMPY16SS(fGETBYTE(7,RssV),fGETUBYTE(7,RttV)))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RssV, ((int32_t) 0x1) * 8, 8);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_8, RttV, ((int32_t) 0x1) * 8, 8);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_11, tmp_9, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, tmp_11);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_13, tmp_12, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_13, 0);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_14, tmp_6, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_15, RssV, ((int32_t) 0x2) * 8, 8);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_16, RttV, ((int32_t) 0x2) * 8, 8);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_17, tmp_15);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_18, tmp_16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_19, tmp_17, tmp_18);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_20, tmp_19);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_21, tmp_20, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_21, 0);
}
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_22, tmp_14, tmp_21);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_23, RssV, ((int32_t) 0x3) * 8, 8);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_24, RttV, ((int32_t) 0x3) * 8, 8);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_25, tmp_23);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_26, tmp_24);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_27, tmp_25, tmp_26);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_28, tmp_27);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_29, tmp_28, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_29, 0);
}
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_30, tmp_22, tmp_29);
tcg_gen_deposit_i64(RddV, RddV, tmp_30, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_31, RssV, ((int32_t) 0x4) * 8, 8);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_32, RttV, ((int32_t) 0x4) * 8, 8);
TCGv_i32 tmp_33 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_33, tmp_31);
TCGv_i32 tmp_34 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_34, tmp_32);
TCGv_i32 tmp_35 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_35, tmp_33, tmp_34);
TCGv_i64 tmp_36 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_36, tmp_35);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_37 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_37, tmp_36, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_37, 0);
}
TCGv_i64 tmp_38 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_38, RssV, ((int32_t) 0x5) * 8, 8);
TCGv_i64 tmp_39 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_39, RttV, ((int32_t) 0x5) * 8, 8);
TCGv_i32 tmp_40 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_40, tmp_38);
TCGv_i32 tmp_41 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_41, tmp_39);
TCGv_i32 tmp_42 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_42, tmp_40, tmp_41);
TCGv_i64 tmp_43 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_43, tmp_42);
uint64_t qemu_tmp_5 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_44 = tcg_temp_new_i64();
if (qemu_tmp_5 != 0) {
tcg_gen_sextract_i64(tmp_44, tmp_43, 0, qemu_tmp_5);
} else {
tcg_gen_movi_i64(tmp_44, 0);
}
TCGv_i64 tmp_45 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_45, tmp_37, tmp_44);
TCGv_i64 tmp_46 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_46, RssV, ((int32_t) 0x6) * 8, 8);
TCGv_i64 tmp_47 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_47, RttV, ((int32_t) 0x6) * 8, 8);
TCGv_i32 tmp_48 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_48, tmp_46);
TCGv_i32 tmp_49 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_49, tmp_47);
TCGv_i32 tmp_50 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_50, tmp_48, tmp_49);
TCGv_i64 tmp_51 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_51, tmp_50);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_52 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_52, tmp_51, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_52, 0);
}
TCGv_i64 tmp_53 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_53, tmp_45, tmp_52);
TCGv_i64 tmp_54 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_54, RssV, ((int32_t) 0x7) * 8, 8);
TCGv_i64 tmp_55 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_55, RttV, ((int32_t) 0x7) * 8, 8);
TCGv_i32 tmp_56 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_56, tmp_54);
TCGv_i32 tmp_57 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_57, tmp_55);
TCGv_i32 tmp_58 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_58, tmp_56, tmp_57);
TCGv_i64 tmp_59 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_59, tmp_58);
uint64_t qemu_tmp_7 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_60 = tcg_temp_new_i64();
if (qemu_tmp_7 != 0) {
tcg_gen_sextract_i64(tmp_60, tmp_59, 0, qemu_tmp_7);
} else {
tcg_gen_movi_i64(tmp_60, 0);
}
TCGv_i64 tmp_61 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_61, tmp_53, tmp_60);
tcg_gen_deposit_i64(RddV, RddV, tmp_61, ((int32_t) 0x1) * 32, 32);
}

void emit_M5_vrmacbsu(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(0,RxxV,(fGETWORD(0,RxxV) + fMPY16SS(fGETBYTE(0,RssV),fGETUBYTE(0,RttV)) + fMPY16SS(fGETBYTE(1,RssV),fGETUBYTE(1,RttV)) + fMPY16SS(fGETBYTE(2,RssV),fGETUBYTE(2,RttV)) + fMPY16SS(fGETBYTE(3,RssV),fGETUBYTE(3,RttV)))); fSETWORD(1,RxxV,(fGETWORD(1,RxxV) + fMPY16SS(fGETBYTE(4,RssV),fGETUBYTE(4,RttV)) + fMPY16SS(fGETBYTE(5,RssV),fGETUBYTE(5,RttV)) + fMPY16SS(fGETBYTE(6,RssV),fGETUBYTE(6,RttV)) + fMPY16SS(fGETBYTE(7,RssV),fGETUBYTE(7,RttV)))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x0) * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_2, RttV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_2);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_5, tmp_3, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_7, tmp_6, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_7, 0);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_8, tmp_0, tmp_7);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RssV, ((int32_t) 0x1) * 8, 8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_10, RttV, ((int32_t) 0x1) * 8, 8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_11, tmp_9);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_12, tmp_10);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_13, tmp_11, tmp_12);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_14, tmp_13);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_15, tmp_14, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_15, 0);
}
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_16, tmp_8, tmp_15);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_17, RssV, ((int32_t) 0x2) * 8, 8);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_18, RttV, ((int32_t) 0x2) * 8, 8);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_19, tmp_17);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_20, tmp_18);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_21, tmp_19, tmp_20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_22, tmp_21);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_23, tmp_22, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_23, 0);
}
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_24, tmp_16, tmp_23);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_25, RssV, ((int32_t) 0x3) * 8, 8);
TCGv_i64 tmp_26 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_26, RttV, ((int32_t) 0x3) * 8, 8);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_27, tmp_25);
TCGv_i32 tmp_28 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_28, tmp_26);
TCGv_i32 tmp_29 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_29, tmp_27, tmp_28);
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_30, tmp_29);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_31, tmp_30, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_31, 0);
}
TCGv_i64 tmp_32 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_32, tmp_24, tmp_31);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_32, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_33 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_33, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_34 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_34, RssV, ((int32_t) 0x4) * 8, 8);
TCGv_i64 tmp_35 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_35, RttV, ((int32_t) 0x4) * 8, 8);
TCGv_i32 tmp_36 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_36, tmp_34);
TCGv_i32 tmp_37 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_37, tmp_35);
TCGv_i32 tmp_38 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_38, tmp_36, tmp_37);
TCGv_i64 tmp_39 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_39, tmp_38);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_40 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_40, tmp_39, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_40, 0);
}
TCGv_i64 tmp_41 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_41, tmp_33, tmp_40);
TCGv_i64 tmp_42 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_42, RssV, ((int32_t) 0x5) * 8, 8);
TCGv_i64 tmp_43 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_43, RttV, ((int32_t) 0x5) * 8, 8);
TCGv_i32 tmp_44 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_44, tmp_42);
TCGv_i32 tmp_45 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_45, tmp_43);
TCGv_i32 tmp_46 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_46, tmp_44, tmp_45);
TCGv_i64 tmp_47 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_47, tmp_46);
uint64_t qemu_tmp_5 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_48 = tcg_temp_new_i64();
if (qemu_tmp_5 != 0) {
tcg_gen_sextract_i64(tmp_48, tmp_47, 0, qemu_tmp_5);
} else {
tcg_gen_movi_i64(tmp_48, 0);
}
TCGv_i64 tmp_49 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_49, tmp_41, tmp_48);
TCGv_i64 tmp_50 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_50, RssV, ((int32_t) 0x6) * 8, 8);
TCGv_i64 tmp_51 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_51, RttV, ((int32_t) 0x6) * 8, 8);
TCGv_i32 tmp_52 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_52, tmp_50);
TCGv_i32 tmp_53 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_53, tmp_51);
TCGv_i32 tmp_54 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_54, tmp_52, tmp_53);
TCGv_i64 tmp_55 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_55, tmp_54);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_56 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_56, tmp_55, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_56, 0);
}
TCGv_i64 tmp_57 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_57, tmp_49, tmp_56);
TCGv_i64 tmp_58 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_58, RssV, ((int32_t) 0x7) * 8, 8);
TCGv_i64 tmp_59 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_59, RttV, ((int32_t) 0x7) * 8, 8);
TCGv_i32 tmp_60 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_60, tmp_58);
TCGv_i32 tmp_61 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_61, tmp_59);
TCGv_i32 tmp_62 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_62, tmp_60, tmp_61);
TCGv_i64 tmp_63 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_63, tmp_62);
uint64_t qemu_tmp_7 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_64 = tcg_temp_new_i64();
if (qemu_tmp_7 != 0) {
tcg_gen_sextract_i64(tmp_64, tmp_63, 0, qemu_tmp_7);
} else {
tcg_gen_movi_i64(tmp_64, 0);
}
TCGv_i64 tmp_65 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_65, tmp_57, tmp_64);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_65, ((int32_t) 0x1) * 32, 32);
}

void emit_M5_vmpybuu(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETHALF(0,RddV,(fMPY16SS(fGETUBYTE(0,RsV),fGETUBYTE(0,RtV)))); fSETHALF(1,RddV,(fMPY16SS(fGETUBYTE(1,RsV),fGETUBYTE(1,RtV)))); fSETHALF(2,RddV,(fMPY16SS(fGETUBYTE(2,RsV),fGETUBYTE(2,RtV)))); fSETHALF(3,RddV,(fMPY16SS(fGETUBYTE(3,RsV),fGETUBYTE(3,RtV)))); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_4, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_5, RsV, ((int32_t) 0x1) * 8, 8);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_6, RtV, ((int32_t) 0x1) * 8, 8);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_7, tmp_5, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_8, tmp_7);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_9, tmp_8, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_9, 0);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_9, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_10, RsV, ((int32_t) 0x2) * 8, 8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_11, RtV, ((int32_t) 0x2) * 8, 8);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_12, tmp_10, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, tmp_12);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_14, tmp_13, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_14, 0);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_14, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_15 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_15, RsV, ((int32_t) 0x3) * 8, 8);
TCGv_i32 tmp_16 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_16, RtV, ((int32_t) 0x3) * 8, 8);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_17, tmp_15, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_18, tmp_17);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_19, tmp_18, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_19, 0);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_19, ((int32_t) 0x3) * 16, 16);
}

void emit_M5_vmpybsu(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETHALF(0,RddV,(fMPY16SS(fGETBYTE(0,RsV),fGETUBYTE(0,RtV)))); fSETHALF(1,RddV,(fMPY16SS(fGETBYTE(1,RsV),fGETUBYTE(1,RtV)))); fSETHALF(2,RddV,(fMPY16SS(fGETBYTE(2,RsV),fGETUBYTE(2,RtV)))); fSETHALF(3,RddV,(fMPY16SS(fGETBYTE(3,RsV),fGETUBYTE(3,RtV)))); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_4, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_5, RsV, ((int32_t) 0x1) * 8, 8);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_6, RtV, ((int32_t) 0x1) * 8, 8);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_7, tmp_5, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_8, tmp_7);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_9, tmp_8, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_9, 0);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_9, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_10, RsV, ((int32_t) 0x2) * 8, 8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_11, RtV, ((int32_t) 0x2) * 8, 8);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_12, tmp_10, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, tmp_12);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_14, tmp_13, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_14, 0);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_14, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_15 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_15, RsV, ((int32_t) 0x3) * 8, 8);
TCGv_i32 tmp_16 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_16, RtV, ((int32_t) 0x3) * 8, 8);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_17, tmp_15, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_18, tmp_17);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_19, tmp_18, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_19, 0);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_19, ((int32_t) 0x3) * 16, 16);
}

void emit_M5_vmacbuu(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETHALF(0,RxxV,(fGETHALF(0,RxxV)+fMPY16SS(fGETUBYTE(0,RsV),fGETUBYTE(0,RtV)))); fSETHALF(1,RxxV,(fGETHALF(1,RxxV)+fMPY16SS(fGETUBYTE(1,RsV),fGETUBYTE(1,RtV)))); fSETHALF(2,RxxV,(fGETHALF(2,RxxV)+fMPY16SS(fGETUBYTE(2,RsV),fGETUBYTE(2,RtV)))); fSETHALF(3,RxxV,(fGETHALF(3,RxxV)+fMPY16SS(fGETUBYTE(3,RsV),fGETUBYTE(3,RtV)))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RsV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, RtV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_3, tmp_1, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, tmp_3);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_5, tmp_4, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_5, 0);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_0, tmp_5);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_6, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RxxV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_8, RsV, ((int32_t) 0x1) * 8, 8);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_9, RtV, ((int32_t) 0x1) * 8, 8);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_10, tmp_8, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, tmp_10);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_12, tmp_11, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_12, 0);
}
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_13, tmp_7, tmp_12);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_13, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_14, RxxV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_15 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_15, RsV, ((int32_t) 0x2) * 8, 8);
TCGv_i32 tmp_16 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_16, RtV, ((int32_t) 0x2) * 8, 8);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_17, tmp_15, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_18, tmp_17);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_19, tmp_18, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_19, 0);
}
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_20, tmp_14, tmp_19);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_20, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_21, RxxV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_22, RsV, ((int32_t) 0x3) * 8, 8);
TCGv_i32 tmp_23 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_23, RtV, ((int32_t) 0x3) * 8, 8);
TCGv_i32 tmp_24 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_24, tmp_22, tmp_23);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_25, tmp_24);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_26 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_26, tmp_25, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_26, 0);
}
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_27, tmp_21, tmp_26);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_27, ((int32_t) 0x3) * 16, 16);
}

void emit_M5_vmacbsu(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETHALF(0,RxxV,(fGETHALF(0,RxxV)+fMPY16SS(fGETBYTE(0,RsV),fGETUBYTE(0,RtV)))); fSETHALF(1,RxxV,(fGETHALF(1,RxxV)+fMPY16SS(fGETBYTE(1,RsV),fGETUBYTE(1,RtV)))); fSETHALF(2,RxxV,(fGETHALF(2,RxxV)+fMPY16SS(fGETBYTE(2,RsV),fGETUBYTE(2,RtV)))); fSETHALF(3,RxxV,(fGETHALF(3,RxxV)+fMPY16SS(fGETBYTE(3,RsV),fGETUBYTE(3,RtV)))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, RtV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_3, tmp_1, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, tmp_3);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_5, tmp_4, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_5, 0);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_0, tmp_5);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_6, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RxxV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_8, RsV, ((int32_t) 0x1) * 8, 8);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_9, RtV, ((int32_t) 0x1) * 8, 8);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_10, tmp_8, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, tmp_10);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_12, tmp_11, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_12, 0);
}
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_13, tmp_7, tmp_12);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_13, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_14, RxxV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_15 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_15, RsV, ((int32_t) 0x2) * 8, 8);
TCGv_i32 tmp_16 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_16, RtV, ((int32_t) 0x2) * 8, 8);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_17, tmp_15, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_18, tmp_17);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_19, tmp_18, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_19, 0);
}
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_20, tmp_14, tmp_19);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_20, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_21, RxxV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_22, RsV, ((int32_t) 0x3) * 8, 8);
TCGv_i32 tmp_23 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_23, RtV, ((int32_t) 0x3) * 8, 8);
TCGv_i32 tmp_24 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_24, tmp_22, tmp_23);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_25, tmp_24);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_26 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_26, tmp_25, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_26, 0);
}
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_27, tmp_21, tmp_26);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_27, ((int32_t) 0x3) * 16, 16);
}

void emit_M5_vdmpybsu(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETHALF(0,RddV,fSATN(16,(fMPY16SS(fGETBYTE(0,RssV),fGETUBYTE(0,RttV)) + fMPY16SS(fGETBYTE(1,RssV),fGETUBYTE(1,RttV))))); fSETHALF(1,RddV,fSATN(16,(fMPY16SS(fGETBYTE(2,RssV),fGETUBYTE(2,RttV)) + fMPY16SS(fGETBYTE(3,RssV),fGETUBYTE(3,RttV))))); fSETHALF(2,RddV,fSATN(16,(fMPY16SS(fGETBYTE(4,RssV),fGETUBYTE(4,RttV)) + fMPY16SS(fGETBYTE(5,RssV),fGETUBYTE(5,RttV))))); fSETHALF(3,RddV,fSATN(16,(fMPY16SS(fGETBYTE(6,RssV),fGETUBYTE(6,RttV)) + fMPY16SS(fGETBYTE(7,RssV),fGETUBYTE(7,RttV))))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RssV, ((int32_t) 0x1) * 8, 8);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_8, RttV, ((int32_t) 0x1) * 8, 8);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_11, tmp_9, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, tmp_11);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_13, tmp_12, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_13, 0);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_14, tmp_6, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i32 tmp_16 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_16, tmp_15, tmp_14, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_16);
tcg_gen_deposit_i64(RddV, RddV, tmp_15, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_17, RssV, ((int32_t) 0x2) * 8, 8);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_18, RttV, ((int32_t) 0x2) * 8, 8);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_19, tmp_17);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_20, tmp_18);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_21, tmp_19, tmp_20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_22, tmp_21);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_23, tmp_22, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_23, 0);
}
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_24, RssV, ((int32_t) 0x3) * 8, 8);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_25, RttV, ((int32_t) 0x3) * 8, 8);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_26, tmp_24);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_27, tmp_25);
TCGv_i32 tmp_28 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_28, tmp_26, tmp_27);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_29, tmp_28);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_30 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_30, tmp_29, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_30, 0);
}
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_31, tmp_23, tmp_30);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
TCGv_i32 tmp_33 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_33, tmp_32, tmp_31, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_33);
tcg_gen_deposit_i64(RddV, RddV, tmp_32, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_34 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_34, RssV, ((int32_t) 0x4) * 8, 8);
TCGv_i64 tmp_35 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_35, RttV, ((int32_t) 0x4) * 8, 8);
TCGv_i32 tmp_36 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_36, tmp_34);
TCGv_i32 tmp_37 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_37, tmp_35);
TCGv_i32 tmp_38 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_38, tmp_36, tmp_37);
TCGv_i64 tmp_39 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_39, tmp_38);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_40 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_40, tmp_39, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_40, 0);
}
TCGv_i64 tmp_41 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_41, RssV, ((int32_t) 0x5) * 8, 8);
TCGv_i64 tmp_42 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_42, RttV, ((int32_t) 0x5) * 8, 8);
TCGv_i32 tmp_43 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_43, tmp_41);
TCGv_i32 tmp_44 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_44, tmp_42);
TCGv_i32 tmp_45 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_45, tmp_43, tmp_44);
TCGv_i64 tmp_46 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_46, tmp_45);
uint64_t qemu_tmp_5 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_47 = tcg_temp_new_i64();
if (qemu_tmp_5 != 0) {
tcg_gen_sextract_i64(tmp_47, tmp_46, 0, qemu_tmp_5);
} else {
tcg_gen_movi_i64(tmp_47, 0);
}
TCGv_i64 tmp_48 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_48, tmp_40, tmp_47);
TCGv_i64 tmp_49 = tcg_temp_new_i64();
TCGv_i32 tmp_50 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_50, tmp_49, tmp_48, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_50);
tcg_gen_deposit_i64(RddV, RddV, tmp_49, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_51 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_51, RssV, ((int32_t) 0x6) * 8, 8);
TCGv_i64 tmp_52 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_52, RttV, ((int32_t) 0x6) * 8, 8);
TCGv_i32 tmp_53 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_53, tmp_51);
TCGv_i32 tmp_54 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_54, tmp_52);
TCGv_i32 tmp_55 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_55, tmp_53, tmp_54);
TCGv_i64 tmp_56 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_56, tmp_55);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_57 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_57, tmp_56, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_57, 0);
}
TCGv_i64 tmp_58 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_58, RssV, ((int32_t) 0x7) * 8, 8);
TCGv_i64 tmp_59 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_59, RttV, ((int32_t) 0x7) * 8, 8);
TCGv_i32 tmp_60 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_60, tmp_58);
TCGv_i32 tmp_61 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_61, tmp_59);
TCGv_i32 tmp_62 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_62, tmp_60, tmp_61);
TCGv_i64 tmp_63 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_63, tmp_62);
uint64_t qemu_tmp_7 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_64 = tcg_temp_new_i64();
if (qemu_tmp_7 != 0) {
tcg_gen_sextract_i64(tmp_64, tmp_63, 0, qemu_tmp_7);
} else {
tcg_gen_movi_i64(tmp_64, 0);
}
TCGv_i64 tmp_65 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_65, tmp_57, tmp_64);
TCGv_i64 tmp_66 = tcg_temp_new_i64();
TCGv_i32 tmp_67 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_67, tmp_66, tmp_65, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_67);
tcg_gen_deposit_i64(RddV, RddV, tmp_66, ((int32_t) 0x3) * 16, 16);
}

void emit_M5_vdmacbsu(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETHALF(0,RxxV,fSATN(16,(fGETHALF(0,RxxV) + fMPY16SS(fGETBYTE(0,RssV),fGETUBYTE(0,RttV)) + fMPY16SS(fGETBYTE(1,RssV),fGETUBYTE(1,RttV))))); fSETHALF(1,RxxV,fSATN(16,(fGETHALF(1,RxxV) + fMPY16SS(fGETBYTE(2,RssV),fGETUBYTE(2,RttV)) + fMPY16SS(fGETBYTE(3,RssV),fGETUBYTE(3,RttV))))); fSETHALF(2,RxxV,fSATN(16,(fGETHALF(2,RxxV) + fMPY16SS(fGETBYTE(4,RssV),fGETUBYTE(4,RttV)) + fMPY16SS(fGETBYTE(5,RssV),fGETUBYTE(5,RttV))))); fSETHALF(3,RxxV,fSATN(16,(fGETHALF(3,RxxV) + fMPY16SS(fGETBYTE(6,RssV),fGETUBYTE(6,RttV)) + fMPY16SS(fGETBYTE(7,RssV),fGETUBYTE(7,RttV))))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x0) * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_2, RttV, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_2);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_5, tmp_3, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_7, tmp_6, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_7, 0);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_8, tmp_0, tmp_7);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RssV, ((int32_t) 0x1) * 8, 8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_10, RttV, ((int32_t) 0x1) * 8, 8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_11, tmp_9);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_12, tmp_10);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_13, tmp_11, tmp_12);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_14, tmp_13);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_15, tmp_14, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_15, 0);
}
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_16, tmp_8, tmp_15);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
TCGv_i32 tmp_18 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_18, tmp_17, tmp_16, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_18);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_17, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_19, RxxV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_20, RssV, ((int32_t) 0x2) * 8, 8);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_21, RttV, ((int32_t) 0x2) * 8, 8);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_22, tmp_20);
TCGv_i32 tmp_23 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_23, tmp_21);
TCGv_i32 tmp_24 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_24, tmp_22, tmp_23);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_25, tmp_24);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_26 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_26, tmp_25, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_26, 0);
}
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_27, tmp_19, tmp_26);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_28, RssV, ((int32_t) 0x3) * 8, 8);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_29, RttV, ((int32_t) 0x3) * 8, 8);
TCGv_i32 tmp_30 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_30, tmp_28);
TCGv_i32 tmp_31 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_31, tmp_29);
TCGv_i32 tmp_32 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_32, tmp_30, tmp_31);
TCGv_i64 tmp_33 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_33, tmp_32);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_34 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_34, tmp_33, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_34, 0);
}
TCGv_i64 tmp_35 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_35, tmp_27, tmp_34);
TCGv_i64 tmp_36 = tcg_temp_new_i64();
TCGv_i32 tmp_37 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_37, tmp_36, tmp_35, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_37);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_36, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_38 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_38, RxxV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_39 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_39, RssV, ((int32_t) 0x4) * 8, 8);
TCGv_i64 tmp_40 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_40, RttV, ((int32_t) 0x4) * 8, 8);
TCGv_i32 tmp_41 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_41, tmp_39);
TCGv_i32 tmp_42 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_42, tmp_40);
TCGv_i32 tmp_43 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_43, tmp_41, tmp_42);
TCGv_i64 tmp_44 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_44, tmp_43);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_45 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_45, tmp_44, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_45, 0);
}
TCGv_i64 tmp_46 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_46, tmp_38, tmp_45);
TCGv_i64 tmp_47 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_47, RssV, ((int32_t) 0x5) * 8, 8);
TCGv_i64 tmp_48 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_48, RttV, ((int32_t) 0x5) * 8, 8);
TCGv_i32 tmp_49 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_49, tmp_47);
TCGv_i32 tmp_50 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_50, tmp_48);
TCGv_i32 tmp_51 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_51, tmp_49, tmp_50);
TCGv_i64 tmp_52 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_52, tmp_51);
uint64_t qemu_tmp_5 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_53 = tcg_temp_new_i64();
if (qemu_tmp_5 != 0) {
tcg_gen_sextract_i64(tmp_53, tmp_52, 0, qemu_tmp_5);
} else {
tcg_gen_movi_i64(tmp_53, 0);
}
TCGv_i64 tmp_54 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_54, tmp_46, tmp_53);
TCGv_i64 tmp_55 = tcg_temp_new_i64();
TCGv_i32 tmp_56 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_56, tmp_55, tmp_54, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_56);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_55, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_57 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_57, RxxV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_58 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_58, RssV, ((int32_t) 0x6) * 8, 8);
TCGv_i64 tmp_59 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_59, RttV, ((int32_t) 0x6) * 8, 8);
TCGv_i32 tmp_60 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_60, tmp_58);
TCGv_i32 tmp_61 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_61, tmp_59);
TCGv_i32 tmp_62 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_62, tmp_60, tmp_61);
TCGv_i64 tmp_63 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_63, tmp_62);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_64 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_64, tmp_63, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_64, 0);
}
TCGv_i64 tmp_65 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_65, tmp_57, tmp_64);
TCGv_i64 tmp_66 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_66, RssV, ((int32_t) 0x7) * 8, 8);
TCGv_i64 tmp_67 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_67, RttV, ((int32_t) 0x7) * 8, 8);
TCGv_i32 tmp_68 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_68, tmp_66);
TCGv_i32 tmp_69 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_69, tmp_67);
TCGv_i32 tmp_70 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_70, tmp_68, tmp_69);
TCGv_i64 tmp_71 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_71, tmp_70);
uint64_t qemu_tmp_7 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_72 = tcg_temp_new_i64();
if (qemu_tmp_7 != 0) {
tcg_gen_sextract_i64(tmp_72, tmp_71, 0, qemu_tmp_7);
} else {
tcg_gen_movi_i64(tmp_72, 0);
}
TCGv_i64 tmp_73 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_73, tmp_65, tmp_72);
TCGv_i64 tmp_74 = tcg_temp_new_i64();
TCGv_i32 tmp_75 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_75, tmp_74, tmp_73, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_75);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_74, ((int32_t) 0x3) * 16, 16);
}

void emit_M2_vdmacs_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,RttV)) << 0) + (fMPY16SS(fGETHALF(1,RssV),fGETHALF(1,RttV)) << 0))); fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (fMPY16SS(fGETHALF(2,RssV),fGETHALF(2,RttV)) << 0) + (fMPY16SS(fGETHALF(3,RssV),fGETHALF(3,RttV)) << 0)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_2);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_5, tmp_3, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_7, tmp_6, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_7, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_8, 0);
} else {
tcg_gen_shli_i64(tmp_8, tmp_7, qemu_tmp_1);
}
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_9, tmp_0, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_12, tmp_10);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_13, tmp_11);
TCGv_i32 tmp_14 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_14, tmp_12, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_15, tmp_14);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_16, tmp_15, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_16, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_17, 0);
} else {
tcg_gen_shli_i64(tmp_17, tmp_16, qemu_tmp_3);
}
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_18, tmp_9, tmp_17);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
TCGv_i32 tmp_20 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_20, tmp_19, tmp_18, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_20);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_19, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_21, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_22, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_23, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_24 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_24, tmp_22);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_25, tmp_23);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_26, tmp_24, tmp_25);
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_27, tmp_26);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_28, tmp_27, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_28, 0);
}
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_29, 0);
} else {
tcg_gen_shli_i64(tmp_29, tmp_28, qemu_tmp_5);
}
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_30, tmp_21, tmp_29);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_31, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_32, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_33 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_33, tmp_31);
TCGv_i32 tmp_34 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_34, tmp_32);
TCGv_i32 tmp_35 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_35, tmp_33, tmp_34);
TCGv_i64 tmp_36 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_36, tmp_35);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_37 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_37, tmp_36, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_37, 0);
}
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_38 = tcg_temp_new_i64();
if (qemu_tmp_7 >= 64) {
tcg_gen_movi_i64(tmp_38, 0);
} else {
tcg_gen_shli_i64(tmp_38, tmp_37, qemu_tmp_7);
}
TCGv_i64 tmp_39 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_39, tmp_30, tmp_38);
TCGv_i64 tmp_40 = tcg_temp_new_i64();
TCGv_i32 tmp_41 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_41, tmp_40, tmp_39, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_41);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_40, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_vdmacs_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,RttV)) << 1) + (fMPY16SS(fGETHALF(1,RssV),fGETHALF(1,RttV)) << 1))); fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (fMPY16SS(fGETHALF(2,RssV),fGETHALF(2,RttV)) << 1) + (fMPY16SS(fGETHALF(3,RssV),fGETHALF(3,RttV)) << 1)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_2);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_5, tmp_3, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_7, tmp_6, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_7, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_8, 0);
} else {
tcg_gen_shli_i64(tmp_8, tmp_7, qemu_tmp_1);
}
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_9, tmp_0, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_12, tmp_10);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_13, tmp_11);
TCGv_i32 tmp_14 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_14, tmp_12, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_15, tmp_14);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_16, tmp_15, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_16, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_17, 0);
} else {
tcg_gen_shli_i64(tmp_17, tmp_16, qemu_tmp_3);
}
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_18, tmp_9, tmp_17);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
TCGv_i32 tmp_20 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_20, tmp_19, tmp_18, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_20);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_19, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_21, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_22, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_23, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_24 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_24, tmp_22);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_25, tmp_23);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_26, tmp_24, tmp_25);
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_27, tmp_26);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_28, tmp_27, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_28, 0);
}
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_29, 0);
} else {
tcg_gen_shli_i64(tmp_29, tmp_28, qemu_tmp_5);
}
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_30, tmp_21, tmp_29);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_31, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_32, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_33 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_33, tmp_31);
TCGv_i32 tmp_34 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_34, tmp_32);
TCGv_i32 tmp_35 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_35, tmp_33, tmp_34);
TCGv_i64 tmp_36 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_36, tmp_35);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_37 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_37, tmp_36, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_37, 0);
}
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_38 = tcg_temp_new_i64();
if (qemu_tmp_7 >= 64) {
tcg_gen_movi_i64(tmp_38, 0);
} else {
tcg_gen_shli_i64(tmp_38, tmp_37, qemu_tmp_7);
}
TCGv_i64 tmp_39 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_39, tmp_30, tmp_38);
TCGv_i64 tmp_40 = tcg_temp_new_i64();
TCGv_i32 tmp_41 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_41, tmp_40, tmp_39, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_41);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_40, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_vdmpys_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(0,RddV,fSATN(32, (fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,RttV)) << 0) + (fMPY16SS(fGETHALF(1,RssV),fGETHALF(1,RttV)) << 0))); fSETWORD(1,RddV,fSATN(32, (fMPY16SS(fGETHALF(2,RssV),fGETHALF(2,RttV)) << 0) + (fMPY16SS(fGETHALF(3,RssV),fGETHALF(3,RttV)) << 0)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_7, 0);
} else {
tcg_gen_shli_i64(tmp_7, tmp_6, qemu_tmp_1);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_11, tmp_9);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_12, tmp_10, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, tmp_12);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_14, tmp_13, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_14, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_15, 0);
} else {
tcg_gen_shli_i64(tmp_15, tmp_14, qemu_tmp_3);
}
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_16, tmp_7, tmp_15);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
TCGv_i32 tmp_18 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_18, tmp_17, tmp_16, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_18);
tcg_gen_deposit_i64(RddV, RddV, tmp_17, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_19, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_20, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_21, tmp_19);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_22, tmp_20);
TCGv_i32 tmp_23 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_23, tmp_21, tmp_22);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_24, tmp_23);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_25, tmp_24, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_25, 0);
}
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_26 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_26, 0);
} else {
tcg_gen_shli_i64(tmp_26, tmp_25, qemu_tmp_5);
}
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_27, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_28, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_29 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_29, tmp_27);
TCGv_i32 tmp_30 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_30, tmp_28);
TCGv_i32 tmp_31 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_31, tmp_29, tmp_30);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_32, tmp_31);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_33 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_33, tmp_32, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_33, 0);
}
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_34 = tcg_temp_new_i64();
if (qemu_tmp_7 >= 64) {
tcg_gen_movi_i64(tmp_34, 0);
} else {
tcg_gen_shli_i64(tmp_34, tmp_33, qemu_tmp_7);
}
TCGv_i64 tmp_35 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_35, tmp_26, tmp_34);
TCGv_i64 tmp_36 = tcg_temp_new_i64();
TCGv_i32 tmp_37 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_37, tmp_36, tmp_35, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_37);
tcg_gen_deposit_i64(RddV, RddV, tmp_36, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_vdmpys_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(0,RddV,fSATN(32, (fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,RttV)) << 1) + (fMPY16SS(fGETHALF(1,RssV),fGETHALF(1,RttV)) << 1))); fSETWORD(1,RddV,fSATN(32, (fMPY16SS(fGETHALF(2,RssV),fGETHALF(2,RttV)) << 1) + (fMPY16SS(fGETHALF(3,RssV),fGETHALF(3,RttV)) << 1)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_7, 0);
} else {
tcg_gen_shli_i64(tmp_7, tmp_6, qemu_tmp_1);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_11, tmp_9);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_12, tmp_10, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, tmp_12);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_14, tmp_13, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_14, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_15, 0);
} else {
tcg_gen_shli_i64(tmp_15, tmp_14, qemu_tmp_3);
}
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_16, tmp_7, tmp_15);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
TCGv_i32 tmp_18 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_18, tmp_17, tmp_16, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_18);
tcg_gen_deposit_i64(RddV, RddV, tmp_17, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_19, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_20, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_21, tmp_19);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_22, tmp_20);
TCGv_i32 tmp_23 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_23, tmp_21, tmp_22);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_24, tmp_23);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_25, tmp_24, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_25, 0);
}
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_26 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_26, 0);
} else {
tcg_gen_shli_i64(tmp_26, tmp_25, qemu_tmp_5);
}
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_27, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_28, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_29 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_29, tmp_27);
TCGv_i32 tmp_30 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_30, tmp_28);
TCGv_i32 tmp_31 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_31, tmp_29, tmp_30);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_32, tmp_31);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_33 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_33, tmp_32, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_33, 0);
}
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_34 = tcg_temp_new_i64();
if (qemu_tmp_7 >= 64) {
tcg_gen_movi_i64(tmp_34, 0);
} else {
tcg_gen_shli_i64(tmp_34, tmp_33, qemu_tmp_7);
}
TCGv_i64 tmp_35 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_35, tmp_26, tmp_34);
TCGv_i64 tmp_36 = tcg_temp_new_i64();
TCGv_i32 tmp_37 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_37, tmp_36, tmp_35, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_37);
tcg_gen_deposit_i64(RddV, RddV, tmp_36, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_cmpyrs_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETHALF(1,RdV,fGETHALF(1,(fSATN(32, (fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 0) + (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 0) + 0x8000)))); fSETHALF(0,RdV,fGETHALF(1,(fSATN(32, (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 0) - (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 0) + 0x8000))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_6, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_7, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_8, tmp_6, tmp_7);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_10, tmp_9, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_10, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_11, 0);
} else {
tcg_gen_shli_i64(tmp_11, tmp_10, qemu_tmp_3);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_12, tmp_5, tmp_11);
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_13, tmp_12, qemu_tmp_4);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i32 tmp_15 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_15, tmp_14, tmp_13, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_15);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_16, tmp_14, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_17, tmp_16);
tcg_gen_deposit_i32(RdV, RdV, tmp_17, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_18, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_19, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_20, tmp_18, tmp_19);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_21, tmp_20);
uint64_t qemu_tmp_5 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
if (qemu_tmp_5 != 0) {
tcg_gen_sextract_i64(tmp_22, tmp_21, 0, qemu_tmp_5);
} else {
tcg_gen_movi_i64(tmp_22, 0);
}
int64_t qemu_tmp_6 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
if (qemu_tmp_6 >= 64) {
tcg_gen_movi_i64(tmp_23, 0);
} else {
tcg_gen_shli_i64(tmp_23, tmp_22, qemu_tmp_6);
}
TCGv_i32 tmp_24 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_24, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_25, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_26, tmp_24, tmp_25);
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_27, tmp_26);
uint64_t qemu_tmp_7 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
if (qemu_tmp_7 != 0) {
tcg_gen_sextract_i64(tmp_28, tmp_27, 0, qemu_tmp_7);
} else {
tcg_gen_movi_i64(tmp_28, 0);
}
int64_t qemu_tmp_8 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_8 >= 64) {
tcg_gen_movi_i64(tmp_29, 0);
} else {
tcg_gen_shli_i64(tmp_29, tmp_28, qemu_tmp_8);
}
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_30, tmp_23, tmp_29);
int64_t qemu_tmp_9 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_31, tmp_30, qemu_tmp_9);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
TCGv_i32 tmp_33 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_33, tmp_32, tmp_31, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_33);
TCGv_i64 tmp_34 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_34, tmp_32, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_35 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_35, tmp_34);
tcg_gen_deposit_i32(RdV, RdV, tmp_35, ((int32_t) 0x0) * 16, 16);
}

void emit_M2_cmpyrs_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETHALF(1,RdV,fGETHALF(1,(fSATN(32, (fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 1) + (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 1) + 0x8000)))); fSETHALF(0,RdV,fGETHALF(1,(fSATN(32, (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1) - (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1) + 0x8000))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_6, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_7, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_8, tmp_6, tmp_7);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_10, tmp_9, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_10, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_11, 0);
} else {
tcg_gen_shli_i64(tmp_11, tmp_10, qemu_tmp_3);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_12, tmp_5, tmp_11);
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_13, tmp_12, qemu_tmp_4);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i32 tmp_15 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_15, tmp_14, tmp_13, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_15);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_16, tmp_14, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_17, tmp_16);
tcg_gen_deposit_i32(RdV, RdV, tmp_17, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_18, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_19, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_20, tmp_18, tmp_19);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_21, tmp_20);
uint64_t qemu_tmp_5 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
if (qemu_tmp_5 != 0) {
tcg_gen_sextract_i64(tmp_22, tmp_21, 0, qemu_tmp_5);
} else {
tcg_gen_movi_i64(tmp_22, 0);
}
int64_t qemu_tmp_6 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
if (qemu_tmp_6 >= 64) {
tcg_gen_movi_i64(tmp_23, 0);
} else {
tcg_gen_shli_i64(tmp_23, tmp_22, qemu_tmp_6);
}
TCGv_i32 tmp_24 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_24, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_25, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_26, tmp_24, tmp_25);
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_27, tmp_26);
uint64_t qemu_tmp_7 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
if (qemu_tmp_7 != 0) {
tcg_gen_sextract_i64(tmp_28, tmp_27, 0, qemu_tmp_7);
} else {
tcg_gen_movi_i64(tmp_28, 0);
}
int64_t qemu_tmp_8 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_8 >= 64) {
tcg_gen_movi_i64(tmp_29, 0);
} else {
tcg_gen_shli_i64(tmp_29, tmp_28, qemu_tmp_8);
}
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_30, tmp_23, tmp_29);
int64_t qemu_tmp_9 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_31, tmp_30, qemu_tmp_9);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
TCGv_i32 tmp_33 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_33, tmp_32, tmp_31, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_33);
TCGv_i64 tmp_34 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_34, tmp_32, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_35 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_35, tmp_34);
tcg_gen_deposit_i32(RdV, RdV, tmp_35, ((int32_t) 0x0) * 16, 16);
}

void emit_M2_cmpyrsc_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETHALF(1,RdV,fGETHALF(1,(fSATN(32, (fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 0) - (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 0) + 0x8000)))); fSETHALF(0,RdV,fGETHALF(1,(fSATN(32, (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 0) + (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 0) + 0x8000))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_6, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_7, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_8, tmp_6, tmp_7);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_10, tmp_9, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_10, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_11, 0);
} else {
tcg_gen_shli_i64(tmp_11, tmp_10, qemu_tmp_3);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_12, tmp_5, tmp_11);
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_13, tmp_12, qemu_tmp_4);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i32 tmp_15 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_15, tmp_14, tmp_13, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_15);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_16, tmp_14, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_17, tmp_16);
tcg_gen_deposit_i32(RdV, RdV, tmp_17, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_18, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_19, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_20, tmp_18, tmp_19);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_21, tmp_20);
uint64_t qemu_tmp_5 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
if (qemu_tmp_5 != 0) {
tcg_gen_sextract_i64(tmp_22, tmp_21, 0, qemu_tmp_5);
} else {
tcg_gen_movi_i64(tmp_22, 0);
}
int64_t qemu_tmp_6 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
if (qemu_tmp_6 >= 64) {
tcg_gen_movi_i64(tmp_23, 0);
} else {
tcg_gen_shli_i64(tmp_23, tmp_22, qemu_tmp_6);
}
TCGv_i32 tmp_24 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_24, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_25, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_26, tmp_24, tmp_25);
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_27, tmp_26);
uint64_t qemu_tmp_7 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
if (qemu_tmp_7 != 0) {
tcg_gen_sextract_i64(tmp_28, tmp_27, 0, qemu_tmp_7);
} else {
tcg_gen_movi_i64(tmp_28, 0);
}
int64_t qemu_tmp_8 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_8 >= 64) {
tcg_gen_movi_i64(tmp_29, 0);
} else {
tcg_gen_shli_i64(tmp_29, tmp_28, qemu_tmp_8);
}
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_30, tmp_23, tmp_29);
int64_t qemu_tmp_9 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_31, tmp_30, qemu_tmp_9);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
TCGv_i32 tmp_33 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_33, tmp_32, tmp_31, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_33);
TCGv_i64 tmp_34 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_34, tmp_32, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_35 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_35, tmp_34);
tcg_gen_deposit_i32(RdV, RdV, tmp_35, ((int32_t) 0x0) * 16, 16);
}

void emit_M2_cmpyrsc_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETHALF(1,RdV,fGETHALF(1,(fSATN(32, (fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 1) - (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 1) + 0x8000)))); fSETHALF(0,RdV,fGETHALF(1,(fSATN(32, (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1) + (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1) + 0x8000))));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_6, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_7, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_8, tmp_6, tmp_7);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_10, tmp_9, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_10, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_11, 0);
} else {
tcg_gen_shli_i64(tmp_11, tmp_10, qemu_tmp_3);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_12, tmp_5, tmp_11);
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_13, tmp_12, qemu_tmp_4);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i32 tmp_15 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_15, tmp_14, tmp_13, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_15);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_16, tmp_14, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_17, tmp_16);
tcg_gen_deposit_i32(RdV, RdV, tmp_17, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_18, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_19, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_20, tmp_18, tmp_19);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_21, tmp_20);
uint64_t qemu_tmp_5 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
if (qemu_tmp_5 != 0) {
tcg_gen_sextract_i64(tmp_22, tmp_21, 0, qemu_tmp_5);
} else {
tcg_gen_movi_i64(tmp_22, 0);
}
int64_t qemu_tmp_6 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
if (qemu_tmp_6 >= 64) {
tcg_gen_movi_i64(tmp_23, 0);
} else {
tcg_gen_shli_i64(tmp_23, tmp_22, qemu_tmp_6);
}
TCGv_i32 tmp_24 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_24, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_25, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_26, tmp_24, tmp_25);
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_27, tmp_26);
uint64_t qemu_tmp_7 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
if (qemu_tmp_7 != 0) {
tcg_gen_sextract_i64(tmp_28, tmp_27, 0, qemu_tmp_7);
} else {
tcg_gen_movi_i64(tmp_28, 0);
}
int64_t qemu_tmp_8 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_8 >= 64) {
tcg_gen_movi_i64(tmp_29, 0);
} else {
tcg_gen_shli_i64(tmp_29, tmp_28, qemu_tmp_8);
}
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_30, tmp_23, tmp_29);
int64_t qemu_tmp_9 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_31, tmp_30, qemu_tmp_9);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
TCGv_i32 tmp_33 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_33, tmp_32, tmp_31, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_33);
TCGv_i64 tmp_34 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_34, tmp_32, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_35 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_35, tmp_34);
tcg_gen_deposit_i32(RdV, RdV, tmp_35, ((int32_t) 0x0) * 16, 16);
}

void emit_M2_cmacs_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 0) + (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 0))); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 0) - (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 0)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_3, tmp_1, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, tmp_3);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_5, tmp_4, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_5, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_6, 0);
} else {
tcg_gen_shli_i64(tmp_6, tmp_5, qemu_tmp_1);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_0, tmp_6);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_8, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_9, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_10, tmp_8, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, tmp_10);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_12, tmp_11, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_12, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_13, 0);
} else {
tcg_gen_shli_i64(tmp_13, tmp_12, qemu_tmp_3);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_14, tmp_7, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i32 tmp_16 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_16, tmp_15, tmp_14, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_16);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_15, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_17, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_18, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_19, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_20, tmp_18, tmp_19);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_21, tmp_20);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_22, tmp_21, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_22, 0);
}
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_23, 0);
} else {
tcg_gen_shli_i64(tmp_23, tmp_22, qemu_tmp_5);
}
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_24, tmp_17, tmp_23);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_25, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_26, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_27, tmp_25, tmp_26);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_28, tmp_27);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_29, tmp_28, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_29, 0);
}
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_30 = tcg_temp_new_i64();
if (qemu_tmp_7 >= 64) {
tcg_gen_movi_i64(tmp_30, 0);
} else {
tcg_gen_shli_i64(tmp_30, tmp_29, qemu_tmp_7);
}
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_31, tmp_24, tmp_30);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
TCGv_i32 tmp_33 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_33, tmp_32, tmp_31, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_33);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_32, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_cmacs_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 1) + (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 1))); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1) - (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_3, tmp_1, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, tmp_3);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_5, tmp_4, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_5, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_6, 0);
} else {
tcg_gen_shli_i64(tmp_6, tmp_5, qemu_tmp_1);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_0, tmp_6);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_8, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_9, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_10, tmp_8, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, tmp_10);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_12, tmp_11, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_12, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_13, 0);
} else {
tcg_gen_shli_i64(tmp_13, tmp_12, qemu_tmp_3);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_14, tmp_7, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i32 tmp_16 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_16, tmp_15, tmp_14, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_16);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_15, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_17, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_18, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_19, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_20, tmp_18, tmp_19);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_21, tmp_20);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_22, tmp_21, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_22, 0);
}
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_23, 0);
} else {
tcg_gen_shli_i64(tmp_23, tmp_22, qemu_tmp_5);
}
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_24, tmp_17, tmp_23);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_25, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_26, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_27, tmp_25, tmp_26);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_28, tmp_27);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_29, tmp_28, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_29, 0);
}
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_30 = tcg_temp_new_i64();
if (qemu_tmp_7 >= 64) {
tcg_gen_movi_i64(tmp_30, 0);
} else {
tcg_gen_shli_i64(tmp_30, tmp_29, qemu_tmp_7);
}
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_31, tmp_24, tmp_30);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
TCGv_i32 tmp_33 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_33, tmp_32, tmp_31, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_33);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_32, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_cmacsc_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 0) - (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 0))); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 0) + (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 0)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_3, tmp_1, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, tmp_3);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_5, tmp_4, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_5, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_6, 0);
} else {
tcg_gen_shli_i64(tmp_6, tmp_5, qemu_tmp_1);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_0, tmp_6);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_8, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_9, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_10, tmp_8, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, tmp_10);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_12, tmp_11, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_12, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_13, 0);
} else {
tcg_gen_shli_i64(tmp_13, tmp_12, qemu_tmp_3);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_14, tmp_7, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i32 tmp_16 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_16, tmp_15, tmp_14, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_16);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_15, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_17, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_18, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_19, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_20, tmp_18, tmp_19);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_21, tmp_20);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_22, tmp_21, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_22, 0);
}
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_23, 0);
} else {
tcg_gen_shli_i64(tmp_23, tmp_22, qemu_tmp_5);
}
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_24, tmp_17, tmp_23);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_25, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_26, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_27, tmp_25, tmp_26);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_28, tmp_27);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_29, tmp_28, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_29, 0);
}
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_30 = tcg_temp_new_i64();
if (qemu_tmp_7 >= 64) {
tcg_gen_movi_i64(tmp_30, 0);
} else {
tcg_gen_shli_i64(tmp_30, tmp_29, qemu_tmp_7);
}
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_31, tmp_24, tmp_30);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
TCGv_i32 tmp_33 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_33, tmp_32, tmp_31, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_33);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_32, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_cmacsc_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 1) - (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 1))); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1) + (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_3, tmp_1, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, tmp_3);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_5, tmp_4, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_5, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_6, 0);
} else {
tcg_gen_shli_i64(tmp_6, tmp_5, qemu_tmp_1);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_0, tmp_6);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_8, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_9, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_10, tmp_8, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, tmp_10);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_12, tmp_11, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_12, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_13, 0);
} else {
tcg_gen_shli_i64(tmp_13, tmp_12, qemu_tmp_3);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_14, tmp_7, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i32 tmp_16 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_16, tmp_15, tmp_14, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_16);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_15, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_17, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_18, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_19, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_20, tmp_18, tmp_19);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_21, tmp_20);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_22, tmp_21, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_22, 0);
}
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_23, 0);
} else {
tcg_gen_shli_i64(tmp_23, tmp_22, qemu_tmp_5);
}
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_24, tmp_17, tmp_23);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_25, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_26, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_27, tmp_25, tmp_26);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_28, tmp_27);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_29, tmp_28, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_29, 0);
}
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_30 = tcg_temp_new_i64();
if (qemu_tmp_7 >= 64) {
tcg_gen_movi_i64(tmp_30, 0);
} else {
tcg_gen_shli_i64(tmp_30, tmp_29, qemu_tmp_7);
}
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_31, tmp_24, tmp_30);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
TCGv_i32 tmp_33 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_33, tmp_32, tmp_31, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_33);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_32, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_cmpys_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETWORD(1,RddV,fSATN(32, (fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 0) + (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 0))); fSETWORD(0,RddV,fSATN(32, (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 0) - (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 0)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_6, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_7, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_8, tmp_6, tmp_7);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_10, tmp_9, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_10, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_11, 0);
} else {
tcg_gen_shli_i64(tmp_11, tmp_10, qemu_tmp_3);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_12, tmp_5, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
TCGv_i32 tmp_14 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_14, tmp_13, tmp_12, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_14);
tcg_gen_deposit_i64(RddV, RddV, tmp_13, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_15 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_15, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_16 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_16, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_17, tmp_15, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_18, tmp_17);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_19, tmp_18, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_19, 0);
}
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_20, 0);
} else {
tcg_gen_shli_i64(tmp_20, tmp_19, qemu_tmp_5);
}
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_21, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_22, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_23 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_23, tmp_21, tmp_22);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_24, tmp_23);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_25, tmp_24, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_25, 0);
}
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_26 = tcg_temp_new_i64();
if (qemu_tmp_7 >= 64) {
tcg_gen_movi_i64(tmp_26, 0);
} else {
tcg_gen_shli_i64(tmp_26, tmp_25, qemu_tmp_7);
}
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_27, tmp_20, tmp_26);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
TCGv_i32 tmp_29 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_29, tmp_28, tmp_27, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_29);
tcg_gen_deposit_i64(RddV, RddV, tmp_28, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_cmpys_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETWORD(1,RddV,fSATN(32, (fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 1) + (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 1))); fSETWORD(0,RddV,fSATN(32, (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1) - (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_6, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_7, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_8, tmp_6, tmp_7);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_10, tmp_9, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_10, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_11, 0);
} else {
tcg_gen_shli_i64(tmp_11, tmp_10, qemu_tmp_3);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_12, tmp_5, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
TCGv_i32 tmp_14 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_14, tmp_13, tmp_12, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_14);
tcg_gen_deposit_i64(RddV, RddV, tmp_13, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_15 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_15, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_16 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_16, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_17, tmp_15, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_18, tmp_17);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_19, tmp_18, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_19, 0);
}
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_20, 0);
} else {
tcg_gen_shli_i64(tmp_20, tmp_19, qemu_tmp_5);
}
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_21, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_22, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_23 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_23, tmp_21, tmp_22);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_24, tmp_23);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_25, tmp_24, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_25, 0);
}
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_26 = tcg_temp_new_i64();
if (qemu_tmp_7 >= 64) {
tcg_gen_movi_i64(tmp_26, 0);
} else {
tcg_gen_shli_i64(tmp_26, tmp_25, qemu_tmp_7);
}
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_27, tmp_20, tmp_26);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
TCGv_i32 tmp_29 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_29, tmp_28, tmp_27, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_29);
tcg_gen_deposit_i64(RddV, RddV, tmp_28, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_cmpysc_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETWORD(1,RddV,fSATN(32, (fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 0) - (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 0))); fSETWORD(0,RddV,fSATN(32, (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 0) + (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 0)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_6, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_7, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_8, tmp_6, tmp_7);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_10, tmp_9, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_10, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_11, 0);
} else {
tcg_gen_shli_i64(tmp_11, tmp_10, qemu_tmp_3);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_12, tmp_5, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
TCGv_i32 tmp_14 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_14, tmp_13, tmp_12, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_14);
tcg_gen_deposit_i64(RddV, RddV, tmp_13, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_15 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_15, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_16 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_16, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_17, tmp_15, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_18, tmp_17);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_19, tmp_18, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_19, 0);
}
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_20, 0);
} else {
tcg_gen_shli_i64(tmp_20, tmp_19, qemu_tmp_5);
}
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_21, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_22, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_23 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_23, tmp_21, tmp_22);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_24, tmp_23);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_25, tmp_24, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_25, 0);
}
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_26 = tcg_temp_new_i64();
if (qemu_tmp_7 >= 64) {
tcg_gen_movi_i64(tmp_26, 0);
} else {
tcg_gen_shli_i64(tmp_26, tmp_25, qemu_tmp_7);
}
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_27, tmp_20, tmp_26);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
TCGv_i32 tmp_29 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_29, tmp_28, tmp_27, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_29);
tcg_gen_deposit_i64(RddV, RddV, tmp_28, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_cmpysc_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETWORD(1,RddV,fSATN(32, (fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 1) - (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 1))); fSETWORD(0,RddV,fSATN(32, (fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1) + (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_1);
}
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_6, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_7, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_8, tmp_6, tmp_7);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_10, tmp_9, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_10, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_11, 0);
} else {
tcg_gen_shli_i64(tmp_11, tmp_10, qemu_tmp_3);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_12, tmp_5, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
TCGv_i32 tmp_14 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_14, tmp_13, tmp_12, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_14);
tcg_gen_deposit_i64(RddV, RddV, tmp_13, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_15 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_15, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_16 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_16, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_17, tmp_15, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_18, tmp_17);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_19, tmp_18, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_19, 0);
}
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_20, 0);
} else {
tcg_gen_shli_i64(tmp_20, tmp_19, qemu_tmp_5);
}
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_21, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_22, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_23 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_23, tmp_21, tmp_22);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_24, tmp_23);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_25, tmp_24, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_25, 0);
}
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_26 = tcg_temp_new_i64();
if (qemu_tmp_7 >= 64) {
tcg_gen_movi_i64(tmp_26, 0);
} else {
tcg_gen_shli_i64(tmp_26, tmp_25, qemu_tmp_7);
}
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_27, tmp_20, tmp_26);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
TCGv_i32 tmp_29 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_29, tmp_28, tmp_27, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_29);
tcg_gen_deposit_i64(RddV, RddV, tmp_28, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_cnacs_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) - ((fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 0) + (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 0)))); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) - ((fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 0) - (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 0))));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_3, tmp_1, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, tmp_3);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_5, tmp_4, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_5, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_6, 0);
} else {
tcg_gen_shli_i64(tmp_6, tmp_5, qemu_tmp_1);
}
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_7, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_8, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_9, tmp_7, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_10, tmp_9);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_11, tmp_10, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_11, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_12, 0);
} else {
tcg_gen_shli_i64(tmp_12, tmp_11, qemu_tmp_3);
}
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_13, tmp_6, tmp_12);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_14, tmp_0, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i32 tmp_16 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_16, tmp_15, tmp_14, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_16);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_15, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_17, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_18, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_19, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_20, tmp_18, tmp_19);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_21, tmp_20);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_22, tmp_21, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_22, 0);
}
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_23, 0);
} else {
tcg_gen_shli_i64(tmp_23, tmp_22, qemu_tmp_5);
}
TCGv_i32 tmp_24 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_24, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_25, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_26, tmp_24, tmp_25);
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_27, tmp_26);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_28, tmp_27, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_28, 0);
}
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_7 >= 64) {
tcg_gen_movi_i64(tmp_29, 0);
} else {
tcg_gen_shli_i64(tmp_29, tmp_28, qemu_tmp_7);
}
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_30, tmp_23, tmp_29);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_31, tmp_17, tmp_30);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
TCGv_i32 tmp_33 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_33, tmp_32, tmp_31, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_33);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_32, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_cnacs_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) - ((fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 1) + (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 1)))); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) - ((fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1) - (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1))));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_3, tmp_1, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, tmp_3);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_5, tmp_4, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_5, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_6, 0);
} else {
tcg_gen_shli_i64(tmp_6, tmp_5, qemu_tmp_1);
}
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_7, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_8, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_9, tmp_7, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_10, tmp_9);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_11, tmp_10, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_11, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_12, 0);
} else {
tcg_gen_shli_i64(tmp_12, tmp_11, qemu_tmp_3);
}
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_13, tmp_6, tmp_12);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_14, tmp_0, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i32 tmp_16 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_16, tmp_15, tmp_14, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_16);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_15, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_17, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_18, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_19, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_20, tmp_18, tmp_19);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_21, tmp_20);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_22, tmp_21, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_22, 0);
}
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_23, 0);
} else {
tcg_gen_shli_i64(tmp_23, tmp_22, qemu_tmp_5);
}
TCGv_i32 tmp_24 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_24, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_25, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_26, tmp_24, tmp_25);
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_27, tmp_26);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_28, tmp_27, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_28, 0);
}
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_7 >= 64) {
tcg_gen_movi_i64(tmp_29, 0);
} else {
tcg_gen_shli_i64(tmp_29, tmp_28, qemu_tmp_7);
}
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_30, tmp_23, tmp_29);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_31, tmp_17, tmp_30);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
TCGv_i32 tmp_33 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_33, tmp_32, tmp_31, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_33);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_32, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_cnacsc_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) - ((fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 0) - (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 0)))); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) - ((fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 0) + (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 0))));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_3, tmp_1, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, tmp_3);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_5, tmp_4, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_5, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_6, 0);
} else {
tcg_gen_shli_i64(tmp_6, tmp_5, qemu_tmp_1);
}
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_7, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_8, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_9, tmp_7, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_10, tmp_9);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_11, tmp_10, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_11, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_12, 0);
} else {
tcg_gen_shli_i64(tmp_12, tmp_11, qemu_tmp_3);
}
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_13, tmp_6, tmp_12);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_14, tmp_0, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i32 tmp_16 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_16, tmp_15, tmp_14, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_16);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_15, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_17, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_18, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_19, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_20, tmp_18, tmp_19);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_21, tmp_20);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_22, tmp_21, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_22, 0);
}
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_23, 0);
} else {
tcg_gen_shli_i64(tmp_23, tmp_22, qemu_tmp_5);
}
TCGv_i32 tmp_24 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_24, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_25, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_26, tmp_24, tmp_25);
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_27, tmp_26);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_28, tmp_27, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_28, 0);
}
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_7 >= 64) {
tcg_gen_movi_i64(tmp_29, 0);
} else {
tcg_gen_shli_i64(tmp_29, tmp_28, qemu_tmp_7);
}
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_30, tmp_23, tmp_29);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_31, tmp_17, tmp_30);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
TCGv_i32 tmp_33 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_33, tmp_32, tmp_31, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_33);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_32, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_cnacsc_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) - ((fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) << 1) - (fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)) << 1)))); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) - ((fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) << 1) + (fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)) << 1))));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_3, tmp_1, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, tmp_3);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_5, tmp_4, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_5, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_6, 0);
} else {
tcg_gen_shli_i64(tmp_6, tmp_5, qemu_tmp_1);
}
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_7, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_8, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_9, tmp_7, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_10, tmp_9);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_11, tmp_10, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_11, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_12, 0);
} else {
tcg_gen_shli_i64(tmp_12, tmp_11, qemu_tmp_3);
}
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_13, tmp_6, tmp_12);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_14, tmp_0, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i32 tmp_16 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_16, tmp_15, tmp_14, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_16);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_15, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_17, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_18, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_19, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_20, tmp_18, tmp_19);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_21, tmp_20);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_22, tmp_21, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_22, 0);
}
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_23, 0);
} else {
tcg_gen_shli_i64(tmp_23, tmp_22, qemu_tmp_5);
}
TCGv_i32 tmp_24 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_24, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_25, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_26, tmp_24, tmp_25);
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_27, tmp_26);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_28, tmp_27, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_28, 0);
}
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_7 >= 64) {
tcg_gen_movi_i64(tmp_29, 0);
} else {
tcg_gen_shli_i64(tmp_29, tmp_28, qemu_tmp_7);
}
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_30, tmp_23, tmp_29);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_31, tmp_17, tmp_30);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
TCGv_i32 tmp_33 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_33, tmp_32, tmp_31, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_33);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_32, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_vrcmpys_s1_h(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RddV,fSATN(32, (fMPY16SS(fGETHALF(1,RssV),fGETHALF(0,fGETWORD(1,RttV))) << 1) + (fMPY16SS(fGETHALF(3,RssV),fGETHALF(1,fGETWORD(1,RttV))) << 1))); fSETWORD(0,RddV,fSATN(32, (fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,fGETWORD(1,RttV))) << 1) + (fMPY16SS(fGETHALF(2,RssV),fGETHALF(1,fGETWORD(1,RttV))) << 1)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, tmp_1, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_0);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_2);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_5, tmp_3, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_7, tmp_6, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_7, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_8, 0);
} else {
tcg_gen_shli_i64(tmp_8, tmp_7, qemu_tmp_1);
}
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, tmp_10, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_12, tmp_9);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_13, tmp_11);
TCGv_i32 tmp_14 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_14, tmp_12, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_15, tmp_14);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_16, tmp_15, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_16, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_17, 0);
} else {
tcg_gen_shli_i64(tmp_17, tmp_16, qemu_tmp_3);
}
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_18, tmp_8, tmp_17);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
TCGv_i32 tmp_20 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_20, tmp_19, tmp_18, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_20);
tcg_gen_deposit_i64(RddV, RddV, tmp_19, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_21, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_22, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_23, tmp_22, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_24 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_24, tmp_21);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_25, tmp_23);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_26, tmp_24, tmp_25);
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_27, tmp_26);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_28, tmp_27, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_28, 0);
}
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_29, 0);
} else {
tcg_gen_shli_i64(tmp_29, tmp_28, qemu_tmp_5);
}
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_30, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_31, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_32, tmp_31, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_33 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_33, tmp_30);
TCGv_i32 tmp_34 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_34, tmp_32);
TCGv_i32 tmp_35 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_35, tmp_33, tmp_34);
TCGv_i64 tmp_36 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_36, tmp_35);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_37 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_37, tmp_36, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_37, 0);
}
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_38 = tcg_temp_new_i64();
if (qemu_tmp_7 >= 64) {
tcg_gen_movi_i64(tmp_38, 0);
} else {
tcg_gen_shli_i64(tmp_38, tmp_37, qemu_tmp_7);
}
TCGv_i64 tmp_39 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_39, tmp_29, tmp_38);
TCGv_i64 tmp_40 = tcg_temp_new_i64();
TCGv_i32 tmp_41 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_41, tmp_40, tmp_39, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_41);
tcg_gen_deposit_i64(RddV, RddV, tmp_40, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_vrcmpys_s1_l(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RddV,fSATN(32, (fMPY16SS(fGETHALF(1,RssV),fGETHALF(0,fGETWORD(0,RttV))) << 1) + (fMPY16SS(fGETHALF(3,RssV),fGETHALF(1,fGETWORD(0,RttV))) << 1))); fSETWORD(0,RddV,fSATN(32, (fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,fGETWORD(0,RttV))) << 1) + (fMPY16SS(fGETHALF(2,RssV),fGETHALF(1,fGETWORD(0,RttV))) << 1)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, tmp_1, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_0);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_2);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_5, tmp_3, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_7, tmp_6, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_7, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_8, 0);
} else {
tcg_gen_shli_i64(tmp_8, tmp_7, qemu_tmp_1);
}
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, tmp_10, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_12, tmp_9);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_13, tmp_11);
TCGv_i32 tmp_14 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_14, tmp_12, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_15, tmp_14);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_16, tmp_15, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_16, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_17, 0);
} else {
tcg_gen_shli_i64(tmp_17, tmp_16, qemu_tmp_3);
}
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_18, tmp_8, tmp_17);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
TCGv_i32 tmp_20 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_20, tmp_19, tmp_18, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_20);
tcg_gen_deposit_i64(RddV, RddV, tmp_19, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_21, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_22, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_23, tmp_22, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_24 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_24, tmp_21);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_25, tmp_23);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_26, tmp_24, tmp_25);
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_27, tmp_26);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_28, tmp_27, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_28, 0);
}
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_29, 0);
} else {
tcg_gen_shli_i64(tmp_29, tmp_28, qemu_tmp_5);
}
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_30, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_31, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_32, tmp_31, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_33 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_33, tmp_30);
TCGv_i32 tmp_34 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_34, tmp_32);
TCGv_i32 tmp_35 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_35, tmp_33, tmp_34);
TCGv_i64 tmp_36 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_36, tmp_35);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_37 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_37, tmp_36, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_37, 0);
}
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_38 = tcg_temp_new_i64();
if (qemu_tmp_7 >= 64) {
tcg_gen_movi_i64(tmp_38, 0);
} else {
tcg_gen_shli_i64(tmp_38, tmp_37, qemu_tmp_7);
}
TCGv_i64 tmp_39 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_39, tmp_29, tmp_38);
TCGv_i64 tmp_40 = tcg_temp_new_i64();
TCGv_i32 tmp_41 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_41, tmp_40, tmp_39, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_41);
tcg_gen_deposit_i64(RddV, RddV, tmp_40, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_vrcmpys_acc_s1_h(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (fMPY16SS(fGETHALF(1,RssV),fGETHALF(0,fGETWORD(1,RttV))) << 1) + (fMPY16SS(fGETHALF(3,RssV),fGETHALF(1,fGETWORD(1,RttV))) << 1))); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,fGETWORD(1,RttV))) << 1) + (fMPY16SS(fGETHALF(2,RssV),fGETHALF(1,fGETWORD(1,RttV))) << 1)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, tmp_2, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_1);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_3);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_6, tmp_4, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_7, tmp_6);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_8, tmp_7, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_8, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_9, 0);
} else {
tcg_gen_shli_i64(tmp_9, tmp_8, qemu_tmp_1);
}
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_10, tmp_0, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_12, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_13, tmp_12, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_14 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_14, tmp_11);
TCGv_i32 tmp_15 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_15, tmp_13);
TCGv_i32 tmp_16 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_16, tmp_14, tmp_15);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_17, tmp_16);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_18, tmp_17, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_18, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_19, 0);
} else {
tcg_gen_shli_i64(tmp_19, tmp_18, qemu_tmp_3);
}
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_20, tmp_10, tmp_19);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
TCGv_i32 tmp_22 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_22, tmp_21, tmp_20, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_22);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_21, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_23, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_24, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_25, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_26 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_26, tmp_25, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_27, tmp_24);
TCGv_i32 tmp_28 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_28, tmp_26);
TCGv_i32 tmp_29 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_29, tmp_27, tmp_28);
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_30, tmp_29);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_31, tmp_30, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_31, 0);
}
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_32, 0);
} else {
tcg_gen_shli_i64(tmp_32, tmp_31, qemu_tmp_5);
}
TCGv_i64 tmp_33 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_33, tmp_23, tmp_32);
TCGv_i64 tmp_34 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_34, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_35 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_35, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_36 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_36, tmp_35, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_37 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_37, tmp_34);
TCGv_i32 tmp_38 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_38, tmp_36);
TCGv_i32 tmp_39 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_39, tmp_37, tmp_38);
TCGv_i64 tmp_40 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_40, tmp_39);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_41 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_41, tmp_40, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_41, 0);
}
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_42 = tcg_temp_new_i64();
if (qemu_tmp_7 >= 64) {
tcg_gen_movi_i64(tmp_42, 0);
} else {
tcg_gen_shli_i64(tmp_42, tmp_41, qemu_tmp_7);
}
TCGv_i64 tmp_43 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_43, tmp_33, tmp_42);
TCGv_i64 tmp_44 = tcg_temp_new_i64();
TCGv_i32 tmp_45 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_45, tmp_44, tmp_43, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_45);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_44, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_vrcmpys_acc_s1_l(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (fMPY16SS(fGETHALF(1,RssV),fGETHALF(0,fGETWORD(0,RttV))) << 1) + (fMPY16SS(fGETHALF(3,RssV),fGETHALF(1,fGETWORD(0,RttV))) << 1))); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,fGETWORD(0,RttV))) << 1) + (fMPY16SS(fGETHALF(2,RssV),fGETHALF(1,fGETWORD(0,RttV))) << 1)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, tmp_2, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_1);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_3);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_6, tmp_4, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_7, tmp_6);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_8, tmp_7, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_8, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_9, 0);
} else {
tcg_gen_shli_i64(tmp_9, tmp_8, qemu_tmp_1);
}
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_10, tmp_0, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_12, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_13, tmp_12, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_14 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_14, tmp_11);
TCGv_i32 tmp_15 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_15, tmp_13);
TCGv_i32 tmp_16 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_16, tmp_14, tmp_15);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_17, tmp_16);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_18, tmp_17, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_18, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_19, 0);
} else {
tcg_gen_shli_i64(tmp_19, tmp_18, qemu_tmp_3);
}
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_20, tmp_10, tmp_19);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
TCGv_i32 tmp_22 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_22, tmp_21, tmp_20, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_22);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_21, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_23, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_24, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_25, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_26 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_26, tmp_25, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_27, tmp_24);
TCGv_i32 tmp_28 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_28, tmp_26);
TCGv_i32 tmp_29 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_29, tmp_27, tmp_28);
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_30, tmp_29);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_31, tmp_30, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_31, 0);
}
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_32, 0);
} else {
tcg_gen_shli_i64(tmp_32, tmp_31, qemu_tmp_5);
}
TCGv_i64 tmp_33 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_33, tmp_23, tmp_32);
TCGv_i64 tmp_34 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_34, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_35 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_35, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_36 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_36, tmp_35, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_37 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_37, tmp_34);
TCGv_i32 tmp_38 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_38, tmp_36);
TCGv_i32 tmp_39 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_39, tmp_37, tmp_38);
TCGv_i64 tmp_40 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_40, tmp_39);
uint64_t qemu_tmp_6 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_41 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_sextract_i64(tmp_41, tmp_40, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_41, 0);
}
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_42 = tcg_temp_new_i64();
if (qemu_tmp_7 >= 64) {
tcg_gen_movi_i64(tmp_42, 0);
} else {
tcg_gen_shli_i64(tmp_42, tmp_41, qemu_tmp_7);
}
TCGv_i64 tmp_43 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_43, tmp_33, tmp_42);
TCGv_i64 tmp_44 = tcg_temp_new_i64();
TCGv_i32 tmp_45 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_45, tmp_44, tmp_43, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_45);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_44, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_vrcmpys_s1rp_h(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETHALF(1,RdV,fGETHALF(1,fSATN(32, (fMPY16SS(fGETHALF(1,RssV),fGETHALF(0,fGETWORD(1,RttV))) << 1) + (fMPY16SS(fGETHALF(3,RssV),fGETHALF(1,fGETWORD(1,RttV))) << 1) + 0x8000))); fSETHALF(0,RdV,fGETHALF(1,fSATN(32, (fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,fGETWORD(1,RttV))) << 1) + (fMPY16SS(fGETHALF(2,RssV),fGETHALF(1,fGETWORD(1,RttV))) << 1) + 0x8000)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, tmp_1, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_0);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_2);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_5, tmp_3, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_7, tmp_6, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_7, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_8, 0);
} else {
tcg_gen_shli_i64(tmp_8, tmp_7, qemu_tmp_1);
}
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, tmp_10, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_12, tmp_9);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_13, tmp_11);
TCGv_i32 tmp_14 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_14, tmp_12, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_15, tmp_14);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_16, tmp_15, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_16, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_17, 0);
} else {
tcg_gen_shli_i64(tmp_17, tmp_16, qemu_tmp_3);
}
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_18, tmp_8, tmp_17);
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_19, tmp_18, qemu_tmp_4);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
TCGv_i32 tmp_21 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_21, tmp_20, tmp_19, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_21);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_22, tmp_20, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_23 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_23, tmp_22);
tcg_gen_deposit_i32(RdV, RdV, tmp_23, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_24, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_25, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_26 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_26, tmp_25, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_27, tmp_24);
TCGv_i32 tmp_28 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_28, tmp_26);
TCGv_i32 tmp_29 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_29, tmp_27, tmp_28);
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_30, tmp_29);
uint64_t qemu_tmp_5 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
if (qemu_tmp_5 != 0) {
tcg_gen_sextract_i64(tmp_31, tmp_30, 0, qemu_tmp_5);
} else {
tcg_gen_movi_i64(tmp_31, 0);
}
int64_t qemu_tmp_6 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
if (qemu_tmp_6 >= 64) {
tcg_gen_movi_i64(tmp_32, 0);
} else {
tcg_gen_shli_i64(tmp_32, tmp_31, qemu_tmp_6);
}
TCGv_i64 tmp_33 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_33, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_34 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_34, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_35 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_35, tmp_34, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_36 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_36, tmp_33);
TCGv_i32 tmp_37 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_37, tmp_35);
TCGv_i32 tmp_38 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_38, tmp_36, tmp_37);
TCGv_i64 tmp_39 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_39, tmp_38);
uint64_t qemu_tmp_7 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_40 = tcg_temp_new_i64();
if (qemu_tmp_7 != 0) {
tcg_gen_sextract_i64(tmp_40, tmp_39, 0, qemu_tmp_7);
} else {
tcg_gen_movi_i64(tmp_40, 0);
}
int64_t qemu_tmp_8 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_41 = tcg_temp_new_i64();
if (qemu_tmp_8 >= 64) {
tcg_gen_movi_i64(tmp_41, 0);
} else {
tcg_gen_shli_i64(tmp_41, tmp_40, qemu_tmp_8);
}
TCGv_i64 tmp_42 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_42, tmp_32, tmp_41);
int64_t qemu_tmp_9 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_43 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_43, tmp_42, qemu_tmp_9);
TCGv_i64 tmp_44 = tcg_temp_new_i64();
TCGv_i32 tmp_45 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_45, tmp_44, tmp_43, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_45);
TCGv_i64 tmp_46 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_46, tmp_44, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_47 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_47, tmp_46);
tcg_gen_deposit_i32(RdV, RdV, tmp_47, ((int32_t) 0x0) * 16, 16);
}

void emit_M2_vrcmpys_s1rp_l(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETHALF(1,RdV,fGETHALF(1,fSATN(32, (fMPY16SS(fGETHALF(1,RssV),fGETHALF(0,fGETWORD(0,RttV))) << 1) + (fMPY16SS(fGETHALF(3,RssV),fGETHALF(1,fGETWORD(0,RttV))) << 1) + 0x8000))); fSETHALF(0,RdV,fGETHALF(1,fSATN(32, (fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,fGETWORD(0,RttV))) << 1) + (fMPY16SS(fGETHALF(2,RssV),fGETHALF(1,fGETWORD(0,RttV))) << 1) + 0x8000)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, tmp_1, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_0);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_2);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_5, tmp_3, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_7, tmp_6, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_7, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_8, 0);
} else {
tcg_gen_shli_i64(tmp_8, tmp_7, qemu_tmp_1);
}
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, tmp_10, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_12, tmp_9);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_13, tmp_11);
TCGv_i32 tmp_14 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_14, tmp_12, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_15, tmp_14);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_16, tmp_15, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_16, 0);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_17, 0);
} else {
tcg_gen_shli_i64(tmp_17, tmp_16, qemu_tmp_3);
}
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_18, tmp_8, tmp_17);
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_19, tmp_18, qemu_tmp_4);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
TCGv_i32 tmp_21 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_21, tmp_20, tmp_19, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_21);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_22, tmp_20, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_23 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_23, tmp_22);
tcg_gen_deposit_i32(RdV, RdV, tmp_23, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_24, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_25, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_26 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_26, tmp_25, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_27, tmp_24);
TCGv_i32 tmp_28 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_28, tmp_26);
TCGv_i32 tmp_29 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_29, tmp_27, tmp_28);
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_30, tmp_29);
uint64_t qemu_tmp_5 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
if (qemu_tmp_5 != 0) {
tcg_gen_sextract_i64(tmp_31, tmp_30, 0, qemu_tmp_5);
} else {
tcg_gen_movi_i64(tmp_31, 0);
}
int64_t qemu_tmp_6 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
if (qemu_tmp_6 >= 64) {
tcg_gen_movi_i64(tmp_32, 0);
} else {
tcg_gen_shli_i64(tmp_32, tmp_31, qemu_tmp_6);
}
TCGv_i64 tmp_33 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_33, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_34 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_34, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_35 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_35, tmp_34, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_36 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_36, tmp_33);
TCGv_i32 tmp_37 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_37, tmp_35);
TCGv_i32 tmp_38 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_38, tmp_36, tmp_37);
TCGv_i64 tmp_39 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_39, tmp_38);
uint64_t qemu_tmp_7 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_40 = tcg_temp_new_i64();
if (qemu_tmp_7 != 0) {
tcg_gen_sextract_i64(tmp_40, tmp_39, 0, qemu_tmp_7);
} else {
tcg_gen_movi_i64(tmp_40, 0);
}
int64_t qemu_tmp_8 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_41 = tcg_temp_new_i64();
if (qemu_tmp_8 >= 64) {
tcg_gen_movi_i64(tmp_41, 0);
} else {
tcg_gen_shli_i64(tmp_41, tmp_40, qemu_tmp_8);
}
TCGv_i64 tmp_42 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_42, tmp_32, tmp_41);
int64_t qemu_tmp_9 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_43 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_43, tmp_42, qemu_tmp_9);
TCGv_i64 tmp_44 = tcg_temp_new_i64();
TCGv_i32 tmp_45 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_45, tmp_44, tmp_43, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_45);
TCGv_i64 tmp_46 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_46, tmp_44, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_47 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_47, tmp_46);
tcg_gen_deposit_i32(RdV, RdV, tmp_47, ((int32_t) 0x0) * 16, 16);
}

void emit_M2_mmacls_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (((fMPY3216SS(fGETWORD(1,RssV),fGETHALF(2,RttV)) << 0))>>16)) ); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (((fMPY3216SS(fGETWORD(0,RssV),fGETHALF(0,RttV)) << 0))>>16)) ); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_1, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_4, 0);
} else {
tcg_gen_shli_i64(tmp_4, tmp_3, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_5, tmp_4, shift);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_0, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_7, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_12, tmp_10, tmp_11);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_13, 0);
} else {
tcg_gen_shli_i64(tmp_13, tmp_12, qemu_tmp_2);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_3;
if (qemu_tmp_3 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_14, tmp_13, shift);
}
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_15, tmp_9, tmp_14);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i32 tmp_17 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_17, tmp_16, tmp_15, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_17);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_16, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmacls_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (((fMPY3216SS(fGETWORD(1,RssV),fGETHALF(2,RttV)) << 1))>>16)) ); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (((fMPY3216SS(fGETWORD(0,RssV),fGETHALF(0,RttV)) << 1))>>16)) ); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_1, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_4, 0);
} else {
tcg_gen_shli_i64(tmp_4, tmp_3, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_5, tmp_4, shift);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_0, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_7, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_12, tmp_10, tmp_11);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_13, 0);
} else {
tcg_gen_shli_i64(tmp_13, tmp_12, qemu_tmp_2);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_3;
if (qemu_tmp_3 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_14, tmp_13, shift);
}
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_15, tmp_9, tmp_14);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i32 tmp_17 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_17, tmp_16, tmp_15, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_17);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_16, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmachs_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (((fMPY3216SS(fGETWORD(1,RssV),fGETHALF(3,RttV)) << 0))>>16))); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (((fMPY3216SS(fGETWORD(0,RssV),fGETHALF(1,RttV)) << 0))>>16 ))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_1, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_4, 0);
} else {
tcg_gen_shli_i64(tmp_4, tmp_3, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_5, tmp_4, shift);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_0, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_7, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_12, tmp_10, tmp_11);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_13, 0);
} else {
tcg_gen_shli_i64(tmp_13, tmp_12, qemu_tmp_2);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_3;
if (qemu_tmp_3 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_14, tmp_13, shift);
}
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_15, tmp_9, tmp_14);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i32 tmp_17 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_17, tmp_16, tmp_15, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_17);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_16, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmachs_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (((fMPY3216SS(fGETWORD(1,RssV),fGETHALF(3,RttV)) << 1))>>16))); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (((fMPY3216SS(fGETWORD(0,RssV),fGETHALF(1,RttV)) << 1))>>16 ))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_1, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_4, 0);
} else {
tcg_gen_shli_i64(tmp_4, tmp_3, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_5, tmp_4, shift);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_0, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_7, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_12, tmp_10, tmp_11);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_13, 0);
} else {
tcg_gen_shli_i64(tmp_13, tmp_12, qemu_tmp_2);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_3;
if (qemu_tmp_3 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_14, tmp_13, shift);
}
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_15, tmp_9, tmp_14);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i32 tmp_17 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_17, tmp_16, tmp_15, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_17);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_16, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmpyl_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RddV,fSATN(32, ((fMPY3216SS(fGETWORD(1,RssV),fGETHALF(2,RttV)) << 0))>>16)); fSETWORD(0,RddV,fSATN(32, ((fMPY3216SS(fGETWORD(0,RssV),fGETHALF(0,RttV)) << 0))>>16)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_4, tmp_3, shift);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
TCGv_i32 tmp_6 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_6, tmp_5, tmp_4, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_6);
tcg_gen_deposit_i64(RddV, RddV, tmp_5, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_9, tmp_7, tmp_8);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_10, 0);
} else {
tcg_gen_shli_i64(tmp_10, tmp_9, qemu_tmp_2);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_3;
if (qemu_tmp_3 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_11, tmp_10, shift);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
TCGv_i32 tmp_13 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_13, tmp_12, tmp_11, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_13);
tcg_gen_deposit_i64(RddV, RddV, tmp_12, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmpyl_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RddV,fSATN(32, ((fMPY3216SS(fGETWORD(1,RssV),fGETHALF(2,RttV)) << 1))>>16)); fSETWORD(0,RddV,fSATN(32, ((fMPY3216SS(fGETWORD(0,RssV),fGETHALF(0,RttV)) << 1))>>16)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_4, tmp_3, shift);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
TCGv_i32 tmp_6 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_6, tmp_5, tmp_4, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_6);
tcg_gen_deposit_i64(RddV, RddV, tmp_5, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_9, tmp_7, tmp_8);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_10, 0);
} else {
tcg_gen_shli_i64(tmp_10, tmp_9, qemu_tmp_2);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_3;
if (qemu_tmp_3 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_11, tmp_10, shift);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
TCGv_i32 tmp_13 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_13, tmp_12, tmp_11, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_13);
tcg_gen_deposit_i64(RddV, RddV, tmp_12, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmpyh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RddV,fSATN(32, ((fMPY3216SS(fGETWORD(1,RssV),fGETHALF(3,RttV)) << 0))>>16)); fSETWORD(0,RddV,fSATN(32, ((fMPY3216SS(fGETWORD(0,RssV),fGETHALF(1,RttV)) << 0))>>16)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_4, tmp_3, shift);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
TCGv_i32 tmp_6 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_6, tmp_5, tmp_4, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_6);
tcg_gen_deposit_i64(RddV, RddV, tmp_5, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_9, tmp_7, tmp_8);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_10, 0);
} else {
tcg_gen_shli_i64(tmp_10, tmp_9, qemu_tmp_2);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_3;
if (qemu_tmp_3 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_11, tmp_10, shift);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
TCGv_i32 tmp_13 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_13, tmp_12, tmp_11, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_13);
tcg_gen_deposit_i64(RddV, RddV, tmp_12, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmpyh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RddV,fSATN(32, ((fMPY3216SS(fGETWORD(1,RssV),fGETHALF(3,RttV)) << 1))>>16)); fSETWORD(0,RddV,fSATN(32, ((fMPY3216SS(fGETWORD(0,RssV),fGETHALF(1,RttV)) << 1))>>16)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_4, tmp_3, shift);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
TCGv_i32 tmp_6 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_6, tmp_5, tmp_4, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_6);
tcg_gen_deposit_i64(RddV, RddV, tmp_5, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_9, tmp_7, tmp_8);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_10, 0);
} else {
tcg_gen_shli_i64(tmp_10, tmp_9, qemu_tmp_2);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_3;
if (qemu_tmp_3 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_11, tmp_10, shift);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
TCGv_i32 tmp_13 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_13, tmp_12, tmp_11, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_13);
tcg_gen_deposit_i64(RddV, RddV, tmp_12, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmacls_rs0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (((fMPY3216SS(fGETWORD(1,RssV),fGETHALF(2,RttV)) << 0)+0x8000)>>16)) ); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (((fMPY3216SS(fGETWORD(0,RssV),fGETHALF(0,RttV)) << 0)+0x8000)>>16)) ); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_1, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_4, 0);
} else {
tcg_gen_shli_i64(tmp_4, tmp_3, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_6, tmp_5, shift);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_0, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_8, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_12, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_13, tmp_11, tmp_12);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_14, 0);
} else {
tcg_gen_shli_i64(tmp_14, tmp_13, qemu_tmp_3);
}
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_15, tmp_14, qemu_tmp_4);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_5;
if (qemu_tmp_5 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_16, tmp_15, shift);
}
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_17, tmp_10, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i32 tmp_19 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_19, tmp_18, tmp_17, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_19);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_18, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmacls_rs1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (((fMPY3216SS(fGETWORD(1,RssV),fGETHALF(2,RttV)) << 1)+0x8000)>>16)) ); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (((fMPY3216SS(fGETWORD(0,RssV),fGETHALF(0,RttV)) << 1)+0x8000)>>16)) ); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_1, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_4, 0);
} else {
tcg_gen_shli_i64(tmp_4, tmp_3, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_6, tmp_5, shift);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_0, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_8, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_12, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_13, tmp_11, tmp_12);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_14, 0);
} else {
tcg_gen_shli_i64(tmp_14, tmp_13, qemu_tmp_3);
}
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_15, tmp_14, qemu_tmp_4);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_5;
if (qemu_tmp_5 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_16, tmp_15, shift);
}
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_17, tmp_10, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i32 tmp_19 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_19, tmp_18, tmp_17, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_19);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_18, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmachs_rs0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (((fMPY3216SS(fGETWORD(1,RssV),fGETHALF(3,RttV)) << 0)+0x8000)>>16))); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (((fMPY3216SS(fGETWORD(0,RssV),fGETHALF(1,RttV)) << 0)+0x8000)>>16 ))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_1, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_4, 0);
} else {
tcg_gen_shli_i64(tmp_4, tmp_3, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_6, tmp_5, shift);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_0, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_8, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_12, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_13, tmp_11, tmp_12);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_14, 0);
} else {
tcg_gen_shli_i64(tmp_14, tmp_13, qemu_tmp_3);
}
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_15, tmp_14, qemu_tmp_4);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_5;
if (qemu_tmp_5 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_16, tmp_15, shift);
}
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_17, tmp_10, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i32 tmp_19 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_19, tmp_18, tmp_17, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_19);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_18, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmachs_rs1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (((fMPY3216SS(fGETWORD(1,RssV),fGETHALF(3,RttV)) << 1)+0x8000)>>16))); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (((fMPY3216SS(fGETWORD(0,RssV),fGETHALF(1,RttV)) << 1)+0x8000)>>16 ))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_1, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_4, 0);
} else {
tcg_gen_shli_i64(tmp_4, tmp_3, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_6, tmp_5, shift);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_0, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_8, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_12, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_13, tmp_11, tmp_12);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_14, 0);
} else {
tcg_gen_shli_i64(tmp_14, tmp_13, qemu_tmp_3);
}
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_15, tmp_14, qemu_tmp_4);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_5;
if (qemu_tmp_5 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_16, tmp_15, shift);
}
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_17, tmp_10, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i32 tmp_19 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_19, tmp_18, tmp_17, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_19);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_18, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmpyl_rs0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RddV,fSATN(32, ((fMPY3216SS(fGETWORD(1,RssV),fGETHALF(2,RttV)) << 0)+0x8000)>>16)); fSETWORD(0,RddV,fSATN(32, ((fMPY3216SS(fGETWORD(0,RssV),fGETHALF(0,RttV)) << 0)+0x8000)>>16)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_4, tmp_3, qemu_tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_5, tmp_4, shift);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
tcg_gen_deposit_i64(RddV, RddV, tmp_6, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_10, tmp_8, tmp_9);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_11, 0);
} else {
tcg_gen_shli_i64(tmp_11, tmp_10, qemu_tmp_3);
}
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_12, tmp_11, qemu_tmp_4);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_5;
if (qemu_tmp_5 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_13, tmp_12, shift);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i32 tmp_15 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_15, tmp_14, tmp_13, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_15);
tcg_gen_deposit_i64(RddV, RddV, tmp_14, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmpyl_rs1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RddV,fSATN(32, ((fMPY3216SS(fGETWORD(1,RssV),fGETHALF(2,RttV)) << 1)+0x8000)>>16)); fSETWORD(0,RddV,fSATN(32, ((fMPY3216SS(fGETWORD(0,RssV),fGETHALF(0,RttV)) << 1)+0x8000)>>16)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_4, tmp_3, qemu_tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_5, tmp_4, shift);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
tcg_gen_deposit_i64(RddV, RddV, tmp_6, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_10, tmp_8, tmp_9);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_11, 0);
} else {
tcg_gen_shli_i64(tmp_11, tmp_10, qemu_tmp_3);
}
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_12, tmp_11, qemu_tmp_4);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_5;
if (qemu_tmp_5 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_13, tmp_12, shift);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i32 tmp_15 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_15, tmp_14, tmp_13, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_15);
tcg_gen_deposit_i64(RddV, RddV, tmp_14, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmpyh_rs0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RddV,fSATN(32, ((fMPY3216SS(fGETWORD(1,RssV),fGETHALF(3,RttV)) << 0)+0x8000)>>16)); fSETWORD(0,RddV,fSATN(32, ((fMPY3216SS(fGETWORD(0,RssV),fGETHALF(1,RttV)) << 0)+0x8000)>>16)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_4, tmp_3, qemu_tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_5, tmp_4, shift);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
tcg_gen_deposit_i64(RddV, RddV, tmp_6, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_10, tmp_8, tmp_9);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_11, 0);
} else {
tcg_gen_shli_i64(tmp_11, tmp_10, qemu_tmp_3);
}
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_12, tmp_11, qemu_tmp_4);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_5;
if (qemu_tmp_5 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_13, tmp_12, shift);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i32 tmp_15 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_15, tmp_14, tmp_13, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_15);
tcg_gen_deposit_i64(RddV, RddV, tmp_14, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmpyh_rs1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RddV,fSATN(32, ((fMPY3216SS(fGETWORD(1,RssV),fGETHALF(3,RttV)) << 1)+0x8000)>>16)); fSETWORD(0,RddV,fSATN(32, ((fMPY3216SS(fGETWORD(0,RssV),fGETHALF(1,RttV)) << 1)+0x8000)>>16)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_4, tmp_3, qemu_tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_5, tmp_4, shift);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
tcg_gen_deposit_i64(RddV, RddV, tmp_6, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_10, tmp_8, tmp_9);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_11, 0);
} else {
tcg_gen_shli_i64(tmp_11, tmp_10, qemu_tmp_3);
}
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_12, tmp_11, qemu_tmp_4);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_5;
if (qemu_tmp_5 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_13, tmp_12, shift);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i32 tmp_15 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_15, tmp_14, tmp_13, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_15);
tcg_gen_deposit_i64(RddV, RddV, tmp_14, ((int32_t) 0x0) * 32, 32);
}

void emit_M4_vrmpyeh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RddV = (fMPY3216SS(fGETWORD(1,RssV),fGETHALF(2,RttV)) << 0) + (fMPY3216SS(fGETWORD(0,RssV),fGETHALF(0,RttV)) << 0);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_6, tmp_4, tmp_5);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_7, 0);
} else {
tcg_gen_shli_i64(tmp_7, tmp_6, qemu_tmp_1);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_8, tmp_3, tmp_7);
tcg_gen_mov_i64(RddV, tmp_8);
}

void emit_M4_vrmpyeh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RddV = (fMPY3216SS(fGETWORD(1,RssV),fGETHALF(2,RttV)) << 1) + (fMPY3216SS(fGETWORD(0,RssV),fGETHALF(0,RttV)) << 1);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_6, tmp_4, tmp_5);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_7, 0);
} else {
tcg_gen_shli_i64(tmp_7, tmp_6, qemu_tmp_1);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_8, tmp_3, tmp_7);
tcg_gen_mov_i64(RddV, tmp_8);
}

void emit_M4_vrmpyeh_acc_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RxxV += (fMPY3216SS(fGETWORD(1,RssV),fGETHALF(2,RttV)) << 0) + (fMPY3216SS(fGETWORD(0,RssV),fGETHALF(0,RttV)) << 0);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_6, tmp_4, tmp_5);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_7, 0);
} else {
tcg_gen_shli_i64(tmp_7, tmp_6, qemu_tmp_1);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_8, tmp_3, tmp_7);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_9, RxxV, tmp_8);
tcg_gen_mov_i64(RxxV, tmp_9);
}

void emit_M4_vrmpyeh_acc_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RxxV += (fMPY3216SS(fGETWORD(1,RssV),fGETHALF(2,RttV)) << 1) + (fMPY3216SS(fGETWORD(0,RssV),fGETHALF(0,RttV)) << 1);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_6, tmp_4, tmp_5);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_7, 0);
} else {
tcg_gen_shli_i64(tmp_7, tmp_6, qemu_tmp_1);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_8, tmp_3, tmp_7);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_9, RxxV, tmp_8);
tcg_gen_mov_i64(RxxV, tmp_9);
}

void emit_M4_vrmpyoh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RddV = (fMPY3216SS(fGETWORD(1,RssV),fGETHALF(3,RttV)) << 0) + (fMPY3216SS(fGETWORD(0,RssV),fGETHALF(1,RttV)) << 0);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_6, tmp_4, tmp_5);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_7, 0);
} else {
tcg_gen_shli_i64(tmp_7, tmp_6, qemu_tmp_1);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_8, tmp_3, tmp_7);
tcg_gen_mov_i64(RddV, tmp_8);
}

void emit_M4_vrmpyoh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RddV = (fMPY3216SS(fGETWORD(1,RssV),fGETHALF(3,RttV)) << 1) + (fMPY3216SS(fGETWORD(0,RssV),fGETHALF(1,RttV)) << 1);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_6, tmp_4, tmp_5);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_7, 0);
} else {
tcg_gen_shli_i64(tmp_7, tmp_6, qemu_tmp_1);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_8, tmp_3, tmp_7);
tcg_gen_mov_i64(RddV, tmp_8);
}

void emit_M4_vrmpyoh_acc_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RxxV += (fMPY3216SS(fGETWORD(1,RssV),fGETHALF(3,RttV)) << 0) + (fMPY3216SS(fGETWORD(0,RssV),fGETHALF(1,RttV)) << 0);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_6, tmp_4, tmp_5);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_7, 0);
} else {
tcg_gen_shli_i64(tmp_7, tmp_6, qemu_tmp_1);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_8, tmp_3, tmp_7);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_9, RxxV, tmp_8);
tcg_gen_mov_i64(RxxV, tmp_9);
}

void emit_M4_vrmpyoh_acc_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RxxV += (fMPY3216SS(fGETWORD(1,RssV),fGETHALF(3,RttV)) << 1) + (fMPY3216SS(fGETWORD(0,RssV),fGETHALF(1,RttV)) << 1);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_6, tmp_4, tmp_5);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_7, 0);
} else {
tcg_gen_shli_i64(tmp_7, tmp_6, qemu_tmp_1);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_8, tmp_3, tmp_7);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_9, RxxV, tmp_8);
tcg_gen_mov_i64(RxxV, tmp_9);
}

void emit_M2_hmmpyl_rs1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RdV = fSATN(32, ((fMPY3216SS(RsV,fGETHALF(0,RtV)) << 1)+0x8000)>>16); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RsV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, tmp_0);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_1, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_4, 0);
} else {
tcg_gen_shli_i64(tmp_4, tmp_3, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_6, tmp_5, shift);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
tcg_gen_mov_i32(RdV, tmp_9);
}

void emit_M2_hmmpyh_rs1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RdV = fSATN(32, ((fMPY3216SS(RsV,fGETHALF(1,RtV)) << 1)+0x8000)>>16); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RsV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, tmp_0);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_1, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_4, 0);
} else {
tcg_gen_shli_i64(tmp_4, tmp_3, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_6, tmp_5, shift);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
tcg_gen_mov_i32(RdV, tmp_9);
}

void emit_M2_hmmpyl_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RdV = fSATN(32, ((fMPY3216SS(RsV,fGETHALF(0,RtV)) << 1))>>16); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RsV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, tmp_0);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_1, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_4, 0);
} else {
tcg_gen_shli_i64(tmp_4, tmp_3, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_5, tmp_4, shift);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_6);
tcg_gen_mov_i32(RdV, tmp_8);
}

void emit_M2_hmmpyh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RdV = fSATN(32, ((fMPY3216SS(RsV,fGETHALF(1,RtV)) << 1))>>16); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RsV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, tmp_0);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_1, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_4, 0);
} else {
tcg_gen_shli_i64(tmp_4, tmp_3, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_5, tmp_4, shift);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_6);
tcg_gen_mov_i32(RdV, tmp_8);
}

void emit_M2_mmaculs_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (((fMPY3216SU(fGETWORD(1,RssV),fGETUHALF(2,RttV)) << 0))>>16)) ); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (((fMPY3216SU(fGETWORD(0,RssV),fGETUHALF(0,RttV)) << 0))>>16)) ); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_2, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_1, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_4, 0);
} else {
tcg_gen_shli_i64(tmp_4, tmp_3, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_5, tmp_4, shift);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_0, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_7, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_11, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_12, tmp_10, tmp_11);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_13, 0);
} else {
tcg_gen_shli_i64(tmp_13, tmp_12, qemu_tmp_2);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_3;
if (qemu_tmp_3 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_14, tmp_13, shift);
}
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_15, tmp_9, tmp_14);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i32 tmp_17 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_17, tmp_16, tmp_15, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_17);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_16, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmaculs_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (((fMPY3216SU(fGETWORD(1,RssV),fGETUHALF(2,RttV)) << 1))>>16)) ); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (((fMPY3216SU(fGETWORD(0,RssV),fGETUHALF(0,RttV)) << 1))>>16)) ); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_2, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_1, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_4, 0);
} else {
tcg_gen_shli_i64(tmp_4, tmp_3, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_5, tmp_4, shift);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_0, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_7, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_11, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_12, tmp_10, tmp_11);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_13, 0);
} else {
tcg_gen_shli_i64(tmp_13, tmp_12, qemu_tmp_2);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_3;
if (qemu_tmp_3 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_14, tmp_13, shift);
}
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_15, tmp_9, tmp_14);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i32 tmp_17 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_17, tmp_16, tmp_15, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_17);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_16, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmacuhs_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (((fMPY3216SU(fGETWORD(1,RssV),fGETUHALF(3,RttV)) << 0))>>16))); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (((fMPY3216SU(fGETWORD(0,RssV),fGETUHALF(1,RttV)) << 0))>>16 ))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_2, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_1, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_4, 0);
} else {
tcg_gen_shli_i64(tmp_4, tmp_3, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_5, tmp_4, shift);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_0, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_7, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_11, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_12, tmp_10, tmp_11);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_13, 0);
} else {
tcg_gen_shli_i64(tmp_13, tmp_12, qemu_tmp_2);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_3;
if (qemu_tmp_3 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_14, tmp_13, shift);
}
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_15, tmp_9, tmp_14);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i32 tmp_17 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_17, tmp_16, tmp_15, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_17);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_16, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmacuhs_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (((fMPY3216SU(fGETWORD(1,RssV),fGETUHALF(3,RttV)) << 1))>>16))); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (((fMPY3216SU(fGETWORD(0,RssV),fGETUHALF(1,RttV)) << 1))>>16 ))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_2, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_1, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_4, 0);
} else {
tcg_gen_shli_i64(tmp_4, tmp_3, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_5, tmp_4, shift);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_0, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_7, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_11, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_12, tmp_10, tmp_11);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_13, 0);
} else {
tcg_gen_shli_i64(tmp_13, tmp_12, qemu_tmp_2);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_3;
if (qemu_tmp_3 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_14, tmp_13, shift);
}
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_15, tmp_9, tmp_14);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i32 tmp_17 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_17, tmp_16, tmp_15, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_17);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_16, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmpyul_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RddV,fSATN(32, ((fMPY3216SU(fGETWORD(1,RssV),fGETUHALF(2,RttV)) << 0))>>16)); fSETWORD(0,RddV,fSATN(32, ((fMPY3216SU(fGETWORD(0,RssV),fGETUHALF(0,RttV)) << 0))>>16)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_4, tmp_3, shift);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
TCGv_i32 tmp_6 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_6, tmp_5, tmp_4, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_6);
tcg_gen_deposit_i64(RddV, RddV, tmp_5, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_8, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_9, tmp_7, tmp_8);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_10, 0);
} else {
tcg_gen_shli_i64(tmp_10, tmp_9, qemu_tmp_2);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_3;
if (qemu_tmp_3 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_11, tmp_10, shift);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
TCGv_i32 tmp_13 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_13, tmp_12, tmp_11, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_13);
tcg_gen_deposit_i64(RddV, RddV, tmp_12, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmpyul_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RddV,fSATN(32, ((fMPY3216SU(fGETWORD(1,RssV),fGETUHALF(2,RttV)) << 1))>>16)); fSETWORD(0,RddV,fSATN(32, ((fMPY3216SU(fGETWORD(0,RssV),fGETUHALF(0,RttV)) << 1))>>16)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_4, tmp_3, shift);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
TCGv_i32 tmp_6 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_6, tmp_5, tmp_4, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_6);
tcg_gen_deposit_i64(RddV, RddV, tmp_5, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_8, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_9, tmp_7, tmp_8);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_10, 0);
} else {
tcg_gen_shli_i64(tmp_10, tmp_9, qemu_tmp_2);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_3;
if (qemu_tmp_3 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_11, tmp_10, shift);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
TCGv_i32 tmp_13 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_13, tmp_12, tmp_11, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_13);
tcg_gen_deposit_i64(RddV, RddV, tmp_12, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmpyuh_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RddV,fSATN(32, ((fMPY3216SU(fGETWORD(1,RssV),fGETUHALF(3,RttV)) << 0))>>16)); fSETWORD(0,RddV,fSATN(32, ((fMPY3216SU(fGETWORD(0,RssV),fGETUHALF(1,RttV)) << 0))>>16)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_4, tmp_3, shift);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
TCGv_i32 tmp_6 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_6, tmp_5, tmp_4, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_6);
tcg_gen_deposit_i64(RddV, RddV, tmp_5, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_8, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_9, tmp_7, tmp_8);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_10, 0);
} else {
tcg_gen_shli_i64(tmp_10, tmp_9, qemu_tmp_2);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_3;
if (qemu_tmp_3 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_11, tmp_10, shift);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
TCGv_i32 tmp_13 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_13, tmp_12, tmp_11, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_13);
tcg_gen_deposit_i64(RddV, RddV, tmp_12, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmpyuh_s1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RddV,fSATN(32, ((fMPY3216SU(fGETWORD(1,RssV),fGETUHALF(3,RttV)) << 1))>>16)); fSETWORD(0,RddV,fSATN(32, ((fMPY3216SU(fGETWORD(0,RssV),fGETUHALF(1,RttV)) << 1))>>16)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_4, tmp_3, shift);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
TCGv_i32 tmp_6 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_6, tmp_5, tmp_4, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_6);
tcg_gen_deposit_i64(RddV, RddV, tmp_5, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_8, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_9, tmp_7, tmp_8);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_10, 0);
} else {
tcg_gen_shli_i64(tmp_10, tmp_9, qemu_tmp_2);
}
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_3;
if (qemu_tmp_3 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_11, tmp_10, shift);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
TCGv_i32 tmp_13 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_13, tmp_12, tmp_11, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_13);
tcg_gen_deposit_i64(RddV, RddV, tmp_12, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmaculs_rs0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (((fMPY3216SU(fGETWORD(1,RssV),fGETUHALF(2,RttV)) << 0)+0x8000)>>16)) ); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (((fMPY3216SU(fGETWORD(0,RssV),fGETUHALF(0,RttV)) << 0)+0x8000)>>16)) ); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_2, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_1, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_4, 0);
} else {
tcg_gen_shli_i64(tmp_4, tmp_3, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_6, tmp_5, shift);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_0, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_8, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_12, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_13, tmp_11, tmp_12);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_14, 0);
} else {
tcg_gen_shli_i64(tmp_14, tmp_13, qemu_tmp_3);
}
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_15, tmp_14, qemu_tmp_4);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_5;
if (qemu_tmp_5 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_16, tmp_15, shift);
}
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_17, tmp_10, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i32 tmp_19 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_19, tmp_18, tmp_17, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_19);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_18, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmaculs_rs1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (((fMPY3216SU(fGETWORD(1,RssV),fGETUHALF(2,RttV)) << 1)+0x8000)>>16)) ); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (((fMPY3216SU(fGETWORD(0,RssV),fGETUHALF(0,RttV)) << 1)+0x8000)>>16)) ); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_2, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_1, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_4, 0);
} else {
tcg_gen_shli_i64(tmp_4, tmp_3, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_6, tmp_5, shift);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_0, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_8, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_12, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_13, tmp_11, tmp_12);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_14, 0);
} else {
tcg_gen_shli_i64(tmp_14, tmp_13, qemu_tmp_3);
}
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_15, tmp_14, qemu_tmp_4);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_5;
if (qemu_tmp_5 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_16, tmp_15, shift);
}
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_17, tmp_10, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i32 tmp_19 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_19, tmp_18, tmp_17, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_19);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_18, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmacuhs_rs0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (((fMPY3216SU(fGETWORD(1,RssV),fGETUHALF(3,RttV)) << 0)+0x8000)>>16))); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (((fMPY3216SU(fGETWORD(0,RssV),fGETUHALF(1,RttV)) << 0)+0x8000)>>16 ))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_2, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_1, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_4, 0);
} else {
tcg_gen_shli_i64(tmp_4, tmp_3, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_6, tmp_5, shift);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_0, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_8, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_12, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_13, tmp_11, tmp_12);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_14, 0);
} else {
tcg_gen_shli_i64(tmp_14, tmp_13, qemu_tmp_3);
}
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_15, tmp_14, qemu_tmp_4);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_5;
if (qemu_tmp_5 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_16, tmp_15, shift);
}
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_17, tmp_10, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i32 tmp_19 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_19, tmp_18, tmp_17, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_19);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_18, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmacuhs_rs1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (((fMPY3216SU(fGETWORD(1,RssV),fGETUHALF(3,RttV)) << 1)+0x8000)>>16))); fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (((fMPY3216SU(fGETWORD(0,RssV),fGETUHALF(1,RttV)) << 1)+0x8000)>>16 ))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_2, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_1, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_4, 0);
} else {
tcg_gen_shli_i64(tmp_4, tmp_3, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_6, tmp_5, shift);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_0, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_8, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_12, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_13, tmp_11, tmp_12);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_14, 0);
} else {
tcg_gen_shli_i64(tmp_14, tmp_13, qemu_tmp_3);
}
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_15, tmp_14, qemu_tmp_4);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_5;
if (qemu_tmp_5 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_16, tmp_15, shift);
}
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_17, tmp_10, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i32 tmp_19 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_19, tmp_18, tmp_17, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_19);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_18, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmpyul_rs0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RddV,fSATN(32, ((fMPY3216SU(fGETWORD(1,RssV),fGETUHALF(2,RttV)) << 0)+0x8000)>>16)); fSETWORD(0,RddV,fSATN(32, ((fMPY3216SU(fGETWORD(0,RssV),fGETUHALF(0,RttV)) << 0)+0x8000)>>16)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_4, tmp_3, qemu_tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_5, tmp_4, shift);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
tcg_gen_deposit_i64(RddV, RddV, tmp_6, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_9, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_10, tmp_8, tmp_9);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_11, 0);
} else {
tcg_gen_shli_i64(tmp_11, tmp_10, qemu_tmp_3);
}
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_12, tmp_11, qemu_tmp_4);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_5;
if (qemu_tmp_5 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_13, tmp_12, shift);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i32 tmp_15 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_15, tmp_14, tmp_13, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_15);
tcg_gen_deposit_i64(RddV, RddV, tmp_14, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmpyul_rs1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RddV,fSATN(32, ((fMPY3216SU(fGETWORD(1,RssV),fGETUHALF(2,RttV)) << 1)+0x8000)>>16)); fSETWORD(0,RddV,fSATN(32, ((fMPY3216SU(fGETWORD(0,RssV),fGETUHALF(0,RttV)) << 1)+0x8000)>>16)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_4, tmp_3, qemu_tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_5, tmp_4, shift);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
tcg_gen_deposit_i64(RddV, RddV, tmp_6, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_9, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_10, tmp_8, tmp_9);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_11, 0);
} else {
tcg_gen_shli_i64(tmp_11, tmp_10, qemu_tmp_3);
}
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_12, tmp_11, qemu_tmp_4);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_5;
if (qemu_tmp_5 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_13, tmp_12, shift);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i32 tmp_15 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_15, tmp_14, tmp_13, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_15);
tcg_gen_deposit_i64(RddV, RddV, tmp_14, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmpyuh_rs0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RddV,fSATN(32, ((fMPY3216SU(fGETWORD(1,RssV),fGETUHALF(3,RttV)) << 0)+0x8000)>>16)); fSETWORD(0,RddV,fSATN(32, ((fMPY3216SU(fGETWORD(0,RssV),fGETUHALF(1,RttV)) << 0)+0x8000)>>16)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_4, tmp_3, qemu_tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_5, tmp_4, shift);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
tcg_gen_deposit_i64(RddV, RddV, tmp_6, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_9, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_10, tmp_8, tmp_9);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_11, 0);
} else {
tcg_gen_shli_i64(tmp_11, tmp_10, qemu_tmp_3);
}
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_12, tmp_11, qemu_tmp_4);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_5;
if (qemu_tmp_5 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_13, tmp_12, shift);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i32 tmp_15 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_15, tmp_14, tmp_13, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_15);
tcg_gen_deposit_i64(RddV, RddV, tmp_14, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_mmpyuh_rs1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(1,RddV,fSATN(32, ((fMPY3216SU(fGETWORD(1,RssV),fGETUHALF(3,RttV)) << 1)+0x8000)>>16)); fSETWORD(0,RddV,fSATN(32, ((fMPY3216SU(fGETWORD(0,RssV),fGETUHALF(1,RttV)) << 1)+0x8000)>>16)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shli_i64(tmp_3, tmp_2, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_4, tmp_3, qemu_tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_5, tmp_4, shift);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_7, tmp_6, tmp_5, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_7);
tcg_gen_deposit_i64(RddV, RddV, tmp_6, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_9, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_10, tmp_8, tmp_9);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_3 >= 64) {
tcg_gen_movi_i64(tmp_11, 0);
} else {
tcg_gen_shli_i64(tmp_11, tmp_10, qemu_tmp_3);
}
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_12, tmp_11, qemu_tmp_4);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_5;
if (qemu_tmp_5 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_13, tmp_12, shift);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i32 tmp_15 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_15, tmp_14, tmp_13, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_15);
tcg_gen_deposit_i64(RddV, RddV, tmp_14, ((int32_t) 0x0) * 32, 32);
}

void emit_M2_vrcmaci_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RxxV = RxxV + fMPY16SS(fGETHALF(1,RssV),fGETHALF(0,RttV)) + fMPY16SS(fGETHALF(0,RssV),fGETHALF(1,RttV)) + fMPY16SS(fGETHALF(3,RssV),fGETHALF(2,RttV)) + fMPY16SS(fGETHALF(2,RssV),fGETHALF(3,RttV));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, RxxV, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_11, tmp_9);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_12, tmp_10, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, tmp_12);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_14, tmp_13, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_14, 0);
}
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_15, tmp_7, tmp_14);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_16, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_17, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_18, tmp_16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_19, tmp_17);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_20, tmp_18, tmp_19);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_21, tmp_20);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_22, tmp_21, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_22, 0);
}
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_23, tmp_15, tmp_22);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_24, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_25, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_26, tmp_24);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_27, tmp_25);
TCGv_i32 tmp_28 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_28, tmp_26, tmp_27);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_29, tmp_28);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_30 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_30, tmp_29, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_30, 0);
}
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_31, tmp_23, tmp_30);
tcg_gen_mov_i64(RxxV, tmp_31);
}

void emit_M2_vrcmacr_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RxxV = RxxV + fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,RttV)) - fMPY16SS(fGETHALF(1,RssV),fGETHALF(1,RttV)) + fMPY16SS(fGETHALF(2,RssV),fGETHALF(2,RttV)) - fMPY16SS(fGETHALF(3,RssV),fGETHALF(3,RttV));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, RxxV, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_11, tmp_9);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_12, tmp_10, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, tmp_12);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_14, tmp_13, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_14, 0);
}
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_15, tmp_7, tmp_14);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_16, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_17, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_18, tmp_16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_19, tmp_17);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_20, tmp_18, tmp_19);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_21, tmp_20);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_22, tmp_21, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_22, 0);
}
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_23, tmp_15, tmp_22);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_24, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_25, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_26, tmp_24);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_27, tmp_25);
TCGv_i32 tmp_28 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_28, tmp_26, tmp_27);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_29, tmp_28);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_30 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_30, tmp_29, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_30, 0);
}
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_31, tmp_23, tmp_30);
tcg_gen_mov_i64(RxxV, tmp_31);
}

void emit_M2_vrcmaci_s0c(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RxxV = RxxV + fMPY16SS(fGETHALF(1,RssV),fGETHALF(0,RttV)) - fMPY16SS(fGETHALF(0,RssV),fGETHALF(1,RttV)) + fMPY16SS(fGETHALF(3,RssV),fGETHALF(2,RttV)) - fMPY16SS(fGETHALF(2,RssV),fGETHALF(3,RttV));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, RxxV, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_11, tmp_9);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_12, tmp_10, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, tmp_12);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_14, tmp_13, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_14, 0);
}
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_15, tmp_7, tmp_14);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_16, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_17, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_18, tmp_16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_19, tmp_17);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_20, tmp_18, tmp_19);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_21, tmp_20);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_22, tmp_21, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_22, 0);
}
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_23, tmp_15, tmp_22);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_24, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_25, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_26, tmp_24);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_27, tmp_25);
TCGv_i32 tmp_28 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_28, tmp_26, tmp_27);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_29, tmp_28);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_30 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_30, tmp_29, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_30, 0);
}
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_31, tmp_23, tmp_30);
tcg_gen_mov_i64(RxxV, tmp_31);
}

void emit_M2_vrcmacr_s0c(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RxxV = RxxV + fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,RttV)) + fMPY16SS(fGETHALF(1,RssV),fGETHALF(1,RttV)) + fMPY16SS(fGETHALF(2,RssV),fGETHALF(2,RttV)) + fMPY16SS(fGETHALF(3,RssV),fGETHALF(3,RttV));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, RxxV, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_11, tmp_9);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_12, tmp_10, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, tmp_12);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_14, tmp_13, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_14, 0);
}
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_15, tmp_7, tmp_14);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_16, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_17, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_18, tmp_16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_19, tmp_17);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_20, tmp_18, tmp_19);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_21, tmp_20);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_22, tmp_21, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_22, 0);
}
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_23, tmp_15, tmp_22);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_24, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_25, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_26, tmp_24);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_27, tmp_25);
TCGv_i32 tmp_28 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_28, tmp_26, tmp_27);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_29, tmp_28);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_30 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_30, tmp_29, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_30, 0);
}
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_31, tmp_23, tmp_30);
tcg_gen_mov_i64(RxxV, tmp_31);
}

void emit_M2_cmaci_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RxxV = RxxV + fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) + fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_5, RxxV, tmp_4);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_6, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_7, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_8, tmp_6, tmp_7);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_10, tmp_9, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_10, 0);
}
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_11, tmp_5, tmp_10);
tcg_gen_mov_i64(RxxV, tmp_11);
}

void emit_M2_cmacr_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RxxV = RxxV + fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) - fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_5, RxxV, tmp_4);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_6, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_7, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_8, tmp_6, tmp_7);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_10, tmp_9, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_10, 0);
}
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_11, tmp_5, tmp_10);
tcg_gen_mov_i64(RxxV, tmp_11);
}

void emit_M2_vrcmpyi_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RddV = fMPY16SS(fGETHALF(1,RssV),fGETHALF(0,RttV)) + fMPY16SS(fGETHALF(0,RssV),fGETHALF(1,RttV)) + fMPY16SS(fGETHALF(3,RssV),fGETHALF(2,RttV)) + fMPY16SS(fGETHALF(2,RssV),fGETHALF(3,RttV));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_11, tmp_9, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, tmp_11);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_13, tmp_12, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_13, 0);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_14, tmp_6, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_15, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_16, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_17, tmp_15);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_18, tmp_16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_19, tmp_17, tmp_18);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_20, tmp_19);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_21, tmp_20, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_21, 0);
}
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_22, tmp_14, tmp_21);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_23, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_24, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_25, tmp_23);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_26, tmp_24);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_27, tmp_25, tmp_26);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_28, tmp_27);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_29, tmp_28, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_29, 0);
}
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_30, tmp_22, tmp_29);
tcg_gen_mov_i64(RddV, tmp_30);
}

void emit_M2_vrcmpyr_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RddV = fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,RttV)) - fMPY16SS(fGETHALF(1,RssV),fGETHALF(1,RttV)) + fMPY16SS(fGETHALF(2,RssV),fGETHALF(2,RttV)) - fMPY16SS(fGETHALF(3,RssV),fGETHALF(3,RttV));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_11, tmp_9, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, tmp_11);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_13, tmp_12, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_13, 0);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_14, tmp_6, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_15, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_16, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_17, tmp_15);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_18, tmp_16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_19, tmp_17, tmp_18);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_20, tmp_19);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_21, tmp_20, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_21, 0);
}
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_22, tmp_14, tmp_21);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_23, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_24, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_25, tmp_23);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_26, tmp_24);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_27, tmp_25, tmp_26);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_28, tmp_27);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_29, tmp_28, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_29, 0);
}
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_30, tmp_22, tmp_29);
tcg_gen_mov_i64(RddV, tmp_30);
}

void emit_M2_vrcmpyi_s0c(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RddV = fMPY16SS(fGETHALF(1,RssV),fGETHALF(0,RttV)) - fMPY16SS(fGETHALF(0,RssV),fGETHALF(1,RttV)) + fMPY16SS(fGETHALF(3,RssV),fGETHALF(2,RttV)) - fMPY16SS(fGETHALF(2,RssV),fGETHALF(3,RttV));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_11, tmp_9, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, tmp_11);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_13, tmp_12, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_13, 0);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_14, tmp_6, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_15, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_16, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_17, tmp_15);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_18, tmp_16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_19, tmp_17, tmp_18);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_20, tmp_19);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_21, tmp_20, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_21, 0);
}
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_22, tmp_14, tmp_21);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_23, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_24, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_25, tmp_23);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_26, tmp_24);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_27, tmp_25, tmp_26);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_28, tmp_27);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_29, tmp_28, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_29, 0);
}
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_30, tmp_22, tmp_29);
tcg_gen_mov_i64(RddV, tmp_30);
}

void emit_M2_vrcmpyr_s0c(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RddV = fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,RttV)) + fMPY16SS(fGETHALF(1,RssV),fGETHALF(1,RttV)) + fMPY16SS(fGETHALF(2,RssV),fGETHALF(2,RttV)) + fMPY16SS(fGETHALF(3,RssV),fGETHALF(3,RttV));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_11, tmp_9, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, tmp_11);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_13, tmp_12, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_13, 0);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_14, tmp_6, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_15, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_16, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_17, tmp_15);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_18, tmp_16);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_19, tmp_17, tmp_18);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_20, tmp_19);
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_21, tmp_20, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_21, 0);
}
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_22, tmp_14, tmp_21);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_23, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_24, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_25, tmp_23);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_26, tmp_24);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_27, tmp_25, tmp_26);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_28, tmp_27);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_29, tmp_28, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_29, 0);
}
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_30, tmp_22, tmp_29);
tcg_gen_mov_i64(RddV, tmp_30);
}

void emit_M2_cmpyi_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RddV = fMPY16SS(fGETHALF(1,RsV),fGETHALF(0,RtV)) + fMPY16SS(fGETHALF(0,RsV),fGETHALF(1,RtV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_5, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_6, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_7, tmp_5, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_8, tmp_7);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_9, tmp_8, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_9, 0);
}
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_10, tmp_4, tmp_9);
tcg_gen_mov_i64(RddV, tmp_10);
}

void emit_M2_cmpyr_s0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RddV = fMPY16SS(fGETHALF(0,RsV),fGETHALF(0,RtV)) - fMPY16SS(fGETHALF(1,RsV),fGETHALF(1,RtV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_5, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_6, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_7, tmp_5, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_8, tmp_7);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_9, tmp_8, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_9, 0);
}
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_10, tmp_4, tmp_9);
tcg_gen_mov_i64(RddV, tmp_10);
}

void emit_M4_cmpyi_wh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { RdV = fSATN(32, ( fMPY3216SS(fGETWORD(0,RssV),fGETHALF(1,RtV)) + fMPY3216SS(fGETWORD(1,RssV),fGETHALF(0,RtV)) + 0x4000)>>15); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_0, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_5, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_7, tmp_4, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_8, tmp_3, tmp_7);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x4000);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_9, tmp_8, qemu_tmp_0);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0xf);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_10, tmp_9, shift);
}
TCGv_i64 tmp_11 = tcg_temp_new_i64();
TCGv_i32 tmp_12 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_12, tmp_11, tmp_10, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_12);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_13, tmp_11);
tcg_gen_mov_i32(RdV, tmp_13);
}

void emit_M4_cmpyr_wh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { RdV = fSATN(32, ( fMPY3216SS(fGETWORD(0,RssV),fGETHALF(0,RtV)) - fMPY3216SS(fGETWORD(1,RssV),fGETHALF(1,RtV)) + 0x4000)>>15); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_0, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_5, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_7, tmp_4, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_8, tmp_3, tmp_7);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x4000);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_9, tmp_8, qemu_tmp_0);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0xf);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_10, tmp_9, shift);
}
TCGv_i64 tmp_11 = tcg_temp_new_i64();
TCGv_i32 tmp_12 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_12, tmp_11, tmp_10, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_12);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_13, tmp_11);
tcg_gen_mov_i32(RdV, tmp_13);
}

void emit_M4_cmpyi_whc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { RdV = fSATN(32, ( fMPY3216SS(fGETWORD(1,RssV),fGETHALF(0,RtV)) - fMPY3216SS(fGETWORD(0,RssV),fGETHALF(1,RtV)) + 0x4000)>>15); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_0, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_5, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_7, tmp_4, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_8, tmp_3, tmp_7);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x4000);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_9, tmp_8, qemu_tmp_0);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0xf);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_10, tmp_9, shift);
}
TCGv_i64 tmp_11 = tcg_temp_new_i64();
TCGv_i32 tmp_12 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_12, tmp_11, tmp_10, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_12);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_13, tmp_11);
tcg_gen_mov_i32(RdV, tmp_13);
}

void emit_M4_cmpyr_whc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { RdV = fSATN(32, ( fMPY3216SS(fGETWORD(0,RssV),fGETHALF(0,RtV)) + fMPY3216SS(fGETWORD(1,RssV),fGETHALF(1,RtV)) + 0x4000)>>15); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_3, tmp_0, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_5, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_7, tmp_4, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_8, tmp_3, tmp_7);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x4000);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_9, tmp_8, qemu_tmp_0);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0xf);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_10, tmp_9, shift);
}
TCGv_i64 tmp_11 = tcg_temp_new_i64();
TCGv_i32 tmp_12 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_12, tmp_11, tmp_10, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_12);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_13, tmp_11);
tcg_gen_mov_i32(RdV, tmp_13);
}

void emit_M2_vcmpy_s0_sat_i(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(0,RddV,fSATN(32, (fMPY16SS(fGETHALF(1,RssV),fGETHALF(0,RttV)) + fMPY16SS(fGETHALF(0,RssV),fGETHALF(1,RttV)) << 0))); fSETWORD(1,RddV,fSATN(32, (fMPY16SS(fGETHALF(3,RssV),fGETHALF(2,RttV)) + fMPY16SS(fGETHALF(2,RssV),fGETHALF(3,RttV)) << 0)));; } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_11, tmp_9, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, tmp_11);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_13, tmp_12, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_13, 0);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_14, tmp_6, tmp_13);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_15, 0);
} else {
tcg_gen_shli_i64(tmp_15, tmp_14, qemu_tmp_2);
}
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i32 tmp_17 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_17, tmp_16, tmp_15, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_17);
tcg_gen_deposit_i64(RddV, RddV, tmp_16, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_18, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_19, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_20, tmp_18);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_21, tmp_19);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_22, tmp_20, tmp_21);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_23, tmp_22);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_24, tmp_23, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_24, 0);
}
TCGv_i64 tmp_25 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_25, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_26 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_26, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_27, tmp_25);
TCGv_i32 tmp_28 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_28, tmp_26);
TCGv_i32 tmp_29 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_29, tmp_27, tmp_28);
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_30, tmp_29);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_31, tmp_30, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_31, 0);
}
TCGv_i64 tmp_32 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_32, tmp_24, tmp_31);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_33 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_33, 0);
} else {
tcg_gen_shli_i64(tmp_33, tmp_32, qemu_tmp_5);
}
TCGv_i64 tmp_34 = tcg_temp_new_i64();
TCGv_i32 tmp_35 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_35, tmp_34, tmp_33, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_35);
tcg_gen_deposit_i64(RddV, RddV, tmp_34, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_vcmpy_s0_sat_r(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(0,RddV,fSATN(32, (fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,RttV)) - fMPY16SS(fGETHALF(1,RssV),fGETHALF(1,RttV)) << 0))); fSETWORD(1,RddV,fSATN(32, (fMPY16SS(fGETHALF(2,RssV),fGETHALF(2,RttV)) - fMPY16SS(fGETHALF(3,RssV),fGETHALF(3,RttV)) << 0)));; } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_11, tmp_9, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, tmp_11);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_13, tmp_12, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_13, 0);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_14, tmp_6, tmp_13);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_15, 0);
} else {
tcg_gen_shli_i64(tmp_15, tmp_14, qemu_tmp_2);
}
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i32 tmp_17 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_17, tmp_16, tmp_15, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_17);
tcg_gen_deposit_i64(RddV, RddV, tmp_16, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_18, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_19, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_20, tmp_18);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_21, tmp_19);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_22, tmp_20, tmp_21);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_23, tmp_22);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_24, tmp_23, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_24, 0);
}
TCGv_i64 tmp_25 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_25, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_26 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_26, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_27, tmp_25);
TCGv_i32 tmp_28 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_28, tmp_26);
TCGv_i32 tmp_29 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_29, tmp_27, tmp_28);
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_30, tmp_29);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_31, tmp_30, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_31, 0);
}
TCGv_i64 tmp_32 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_32, tmp_24, tmp_31);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_33 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_33, 0);
} else {
tcg_gen_shli_i64(tmp_33, tmp_32, qemu_tmp_5);
}
TCGv_i64 tmp_34 = tcg_temp_new_i64();
TCGv_i32 tmp_35 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_35, tmp_34, tmp_33, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_35);
tcg_gen_deposit_i64(RddV, RddV, tmp_34, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_vcmpy_s1_sat_i(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(0,RddV,fSATN(32, (fMPY16SS(fGETHALF(1,RssV),fGETHALF(0,RttV)) + fMPY16SS(fGETHALF(0,RssV),fGETHALF(1,RttV)) << 1))); fSETWORD(1,RddV,fSATN(32, (fMPY16SS(fGETHALF(3,RssV),fGETHALF(2,RttV)) + fMPY16SS(fGETHALF(2,RssV),fGETHALF(3,RttV)) << 1)));; } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_11, tmp_9, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, tmp_11);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_13, tmp_12, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_13, 0);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_14, tmp_6, tmp_13);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_15, 0);
} else {
tcg_gen_shli_i64(tmp_15, tmp_14, qemu_tmp_2);
}
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i32 tmp_17 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_17, tmp_16, tmp_15, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_17);
tcg_gen_deposit_i64(RddV, RddV, tmp_16, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_18, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_19, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_20, tmp_18);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_21, tmp_19);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_22, tmp_20, tmp_21);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_23, tmp_22);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_24, tmp_23, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_24, 0);
}
TCGv_i64 tmp_25 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_25, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_26 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_26, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_27, tmp_25);
TCGv_i32 tmp_28 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_28, tmp_26);
TCGv_i32 tmp_29 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_29, tmp_27, tmp_28);
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_30, tmp_29);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_31, tmp_30, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_31, 0);
}
TCGv_i64 tmp_32 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_32, tmp_24, tmp_31);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_33 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_33, 0);
} else {
tcg_gen_shli_i64(tmp_33, tmp_32, qemu_tmp_5);
}
TCGv_i64 tmp_34 = tcg_temp_new_i64();
TCGv_i32 tmp_35 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_35, tmp_34, tmp_33, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_35);
tcg_gen_deposit_i64(RddV, RddV, tmp_34, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_vcmpy_s1_sat_r(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(0,RddV,fSATN(32, (fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,RttV)) - fMPY16SS(fGETHALF(1,RssV),fGETHALF(1,RttV)) << 1))); fSETWORD(1,RddV,fSATN(32, (fMPY16SS(fGETHALF(2,RssV),fGETHALF(2,RttV)) - fMPY16SS(fGETHALF(3,RssV),fGETHALF(3,RttV)) << 1)));; } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_11, tmp_9, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, tmp_11);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_13, tmp_12, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_13, 0);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_14, tmp_6, tmp_13);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_15, 0);
} else {
tcg_gen_shli_i64(tmp_15, tmp_14, qemu_tmp_2);
}
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i32 tmp_17 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_17, tmp_16, tmp_15, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_17);
tcg_gen_deposit_i64(RddV, RddV, tmp_16, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_18, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_19, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_20, tmp_18);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_21, tmp_19);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_22, tmp_20, tmp_21);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_23, tmp_22);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_24, tmp_23, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_24, 0);
}
TCGv_i64 tmp_25 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_25, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_26 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_26, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_27 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_27, tmp_25);
TCGv_i32 tmp_28 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_28, tmp_26);
TCGv_i32 tmp_29 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_29, tmp_27, tmp_28);
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_30, tmp_29);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_31, tmp_30, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_31, 0);
}
TCGv_i64 tmp_32 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_32, tmp_24, tmp_31);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_33 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_33, 0);
} else {
tcg_gen_shli_i64(tmp_33, tmp_32, qemu_tmp_5);
}
TCGv_i64 tmp_34 = tcg_temp_new_i64();
TCGv_i32 tmp_35 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_35, tmp_34, tmp_33, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_35);
tcg_gen_deposit_i64(RddV, RddV, tmp_34, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_vcmac_s0_sat_i(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (fMPY16SS(fGETHALF(1,RssV),fGETHALF(0,RttV)) + fMPY16SS(fGETHALF(0,RssV),fGETHALF(1,RttV)) << 0))); fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (fMPY16SS(fGETHALF(3,RssV),fGETHALF(2,RttV)) + fMPY16SS(fGETHALF(2,RssV),fGETHALF(3,RttV)) << 0)));; } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_2);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_5, tmp_3, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_7, tmp_6, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_7, 0);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_11, tmp_9);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_12, tmp_10, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, tmp_12);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_14, tmp_13, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_14, 0);
}
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_15, tmp_7, tmp_14);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_16, 0);
} else {
tcg_gen_shli_i64(tmp_16, tmp_15, qemu_tmp_2);
}
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_17, tmp_0, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i32 tmp_19 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_19, tmp_18, tmp_17, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_19);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_18, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_20, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_21, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_22, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_23 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_23, tmp_21);
TCGv_i32 tmp_24 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_24, tmp_22);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_25, tmp_23, tmp_24);
TCGv_i64 tmp_26 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_26, tmp_25);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_27 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_27, tmp_26, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_27, 0);
}
TCGv_i64 tmp_28 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_28, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_29, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_30 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_30, tmp_28);
TCGv_i32 tmp_31 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_31, tmp_29);
TCGv_i32 tmp_32 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_32, tmp_30, tmp_31);
TCGv_i64 tmp_33 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_33, tmp_32);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_34 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_34, tmp_33, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_34, 0);
}
TCGv_i64 tmp_35 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_35, tmp_27, tmp_34);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_36 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_36, 0);
} else {
tcg_gen_shli_i64(tmp_36, tmp_35, qemu_tmp_5);
}
TCGv_i64 tmp_37 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_37, tmp_20, tmp_36);
TCGv_i64 tmp_38 = tcg_temp_new_i64();
TCGv_i32 tmp_39 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_39, tmp_38, tmp_37, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_39);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_38, ((int32_t) 0x1) * 32, 32);
}

void emit_M2_vcmac_s0_sat_r(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(0,RxxV,fSATN(32, fGETWORD(0,RxxV) + (fMPY16SS(fGETHALF(0,RssV),fGETHALF(0,RttV)) - fMPY16SS(fGETHALF(1,RssV),fGETHALF(1,RttV)) << 0))); fSETWORD(1,RxxV,fSATN(32, fGETWORD(1,RxxV) + (fMPY16SS(fGETHALF(2,RssV),fGETHALF(2,RttV)) - fMPY16SS(fGETHALF(3,RssV),fGETHALF(3,RttV)) << 0)));; } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_2);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_5, tmp_3, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_7, tmp_6, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_7, 0);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_10, tmp_8);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_11, tmp_9);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_12, tmp_10, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, tmp_12);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_14, tmp_13, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_14, 0);
}
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_15, tmp_7, tmp_14);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_16, 0);
} else {
tcg_gen_shli_i64(tmp_16, tmp_15, qemu_tmp_2);
}
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_17, tmp_0, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i32 tmp_19 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_19, tmp_18, tmp_17, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_19);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_18, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_20, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_21, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_22, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_23 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_23, tmp_21);
TCGv_i32 tmp_24 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_24, tmp_22);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_25, tmp_23, tmp_24);
TCGv_i64 tmp_26 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_26, tmp_25);
uint64_t qemu_tmp_3 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_27 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_27, tmp_26, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_27, 0);
}
TCGv_i64 tmp_28 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_28, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_29, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_30 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_30, tmp_28);
TCGv_i32 tmp_31 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_31, tmp_29);
TCGv_i32 tmp_32 = tcg_temp_new_i32();
tcg_gen_mul_i32(tmp_32, tmp_30, tmp_31);
TCGv_i64 tmp_33 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_33, tmp_32);
uint64_t qemu_tmp_4 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_34 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_34, tmp_33, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_34, 0);
}
TCGv_i64 tmp_35 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_35, tmp_27, tmp_34);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_36 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_36, 0);
} else {
tcg_gen_shli_i64(tmp_36, tmp_35, qemu_tmp_5);
}
TCGv_i64 tmp_37 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_37, tmp_20, tmp_36);
TCGv_i64 tmp_38 = tcg_temp_new_i64();
TCGv_i32 tmp_39 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_39, tmp_38, tmp_37, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_39);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_38, ((int32_t) 0x1) * 32, 32);
}

void emit_S2_vcrotate(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size1u_t tmp; tmp = fEXTRACTU_RANGE(RtV,1,0); if (tmp == 0) { fSETHALF(0,RddV,fGETHALF(0,RssV)); fSETHALF(1,RddV,fGETHALF(1,RssV)); } else if (tmp == 1) { fSETHALF(0,RddV,fGETHALF(1,RssV)); fSETHALF(1,RddV,fSATN(16, -fGETHALF(0,RssV))); } else if (tmp == 2) { fSETHALF(0,RddV,fSATN(16, -fGETHALF(1,RssV))); fSETHALF(1,RddV,fGETHALF(0,RssV)); } else { if (tmp != 3) fatal("C is broken"); fSETHALF(0,RddV,fSATN(16, -fGETHALF(0,RssV))); fSETHALF(1,RddV,fSATN(16, -fGETHALF(1,RssV))); } tmp = fEXTRACTU_RANGE(RtV,3,2); if (tmp == 0) { fSETHALF(2,RddV,fGETHALF(2,RssV)); fSETHALF(3,RddV,fGETHALF(3,RssV)); } else if (tmp == 1) { fSETHALF(2,RddV,fGETHALF(3,RssV)); fSETHALF(3,RddV,fSATN(16, -fGETHALF(2,RssV))); } else if (tmp == 2) { fSETHALF(2,RddV,fSATN(16, -fGETHALF(3,RssV))); fSETHALF(3,RddV,fGETHALF(2,RssV)); } else { if (tmp != 3) fatal("C is broken"); fSETHALF(2,RddV,fSATN(16, -fGETHALF(2,RssV))); fSETHALF(3,RddV,fSATN(16, -fGETHALF(3,RssV))); } } */
{
TCGv_i32 tmp = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RtV, 0, 2);
tcg_gen_mov_i32(tmp, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_EQ, tmp_1, tmp, ((int32_t) 0x0));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RssV, ((int32_t) 0x0) * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RssV, ((int32_t) 0x1) * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, ((int32_t) 0x1) * 16, 16);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_EQ, tmp_4, tmp, ((int32_t) 0x1));
TCGLabel *if_label_2 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_4, 0, if_label_2);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RssV, ((int32_t) 0x1) * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_5, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_6, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_7, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
tcg_gen_deposit_i64(RddV, RddV, tmp_8, ((int32_t) 0x1) * 16, 16);
TCGLabel *if_label_3 = gen_new_label();
tcg_gen_br(if_label_3);
gen_set_label(if_label_2);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_EQ, tmp_10, tmp, ((int32_t) 0x2));
TCGLabel *if_label_4 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_10, 0, if_label_4);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_12, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
TCGv_i32 tmp_14 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_14, tmp_13, tmp_12, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_14);
tcg_gen_deposit_i64(RddV, RddV, tmp_13, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_15, RssV, ((int32_t) 0x0) * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_15, ((int32_t) 0x1) * 16, 16);
TCGLabel *if_label_5 = gen_new_label();
tcg_gen_br(if_label_5);
gen_set_label(if_label_4);
TCGv_i32 tmp_16 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_NE, tmp_16, tmp, ((int32_t) 0x3));
TCGLabel *if_label_6 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_16, 0, if_label_6);
gen_set_label(if_label_6);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_17, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_18, tmp_17);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
TCGv_i32 tmp_20 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_20, tmp_19, tmp_18, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_20);
tcg_gen_deposit_i64(RddV, RddV, tmp_19, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_21, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_22, tmp_21);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
TCGv_i32 tmp_24 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_24, tmp_23, tmp_22, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_24);
tcg_gen_deposit_i64(RddV, RddV, tmp_23, ((int32_t) 0x1) * 16, 16);
gen_set_label(if_label_5);
gen_set_label(if_label_3);
gen_set_label(if_label_1);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_25, RtV, 2, 2);
tcg_gen_mov_i32(tmp, tmp_25);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_EQ, tmp_26, tmp, ((int32_t) 0x0));
TCGLabel *if_label_7 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_26, 0, if_label_7);
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_27, RssV, ((int32_t) 0x2) * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_27, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_28 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_28, RssV, ((int32_t) 0x3) * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_28, ((int32_t) 0x3) * 16, 16);
TCGLabel *if_label_8 = gen_new_label();
tcg_gen_br(if_label_8);
gen_set_label(if_label_7);
TCGv_i32 tmp_29 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_EQ, tmp_29, tmp, ((int32_t) 0x1));
TCGLabel *if_label_9 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_29, 0, if_label_9);
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_30, RssV, ((int32_t) 0x3) * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_30, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_31 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_31, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_32 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_32, tmp_31);
TCGv_i64 tmp_33 = tcg_temp_new_i64();
TCGv_i32 tmp_34 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_34, tmp_33, tmp_32, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_34);
tcg_gen_deposit_i64(RddV, RddV, tmp_33, ((int32_t) 0x3) * 16, 16);
TCGLabel *if_label_10 = gen_new_label();
tcg_gen_br(if_label_10);
gen_set_label(if_label_9);
TCGv_i32 tmp_35 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_EQ, tmp_35, tmp, ((int32_t) 0x2));
TCGLabel *if_label_11 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_35, 0, if_label_11);
TCGv_i64 tmp_36 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_36, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_37 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_37, tmp_36);
TCGv_i64 tmp_38 = tcg_temp_new_i64();
TCGv_i32 tmp_39 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_39, tmp_38, tmp_37, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_39);
tcg_gen_deposit_i64(RddV, RddV, tmp_38, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_40 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_40, RssV, ((int32_t) 0x2) * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_40, ((int32_t) 0x3) * 16, 16);
TCGLabel *if_label_12 = gen_new_label();
tcg_gen_br(if_label_12);
gen_set_label(if_label_11);
TCGv_i32 tmp_41 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_NE, tmp_41, tmp, ((int32_t) 0x3));
TCGLabel *if_label_13 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_41, 0, if_label_13);
gen_set_label(if_label_13);
TCGv_i64 tmp_42 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_42, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_43 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_43, tmp_42);
TCGv_i64 tmp_44 = tcg_temp_new_i64();
TCGv_i32 tmp_45 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_45, tmp_44, tmp_43, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_45);
tcg_gen_deposit_i64(RddV, RddV, tmp_44, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_46 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_46, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_47 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_47, tmp_46);
TCGv_i64 tmp_48 = tcg_temp_new_i64();
TCGv_i32 tmp_49 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_49, tmp_48, tmp_47, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_49);
tcg_gen_deposit_i64(RddV, RddV, tmp_48, ((int32_t) 0x3) * 16, 16);
gen_set_label(if_label_12);
gen_set_label(if_label_10);
gen_set_label(if_label_8);
}

void emit_S2_vcnegh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { int i; for (i = 0; i < 4; i++) { if (fGETBIT(i,RtV)) { fSETHALF(i,RddV,fSATN(16, -fGETHALF(i,RssV))); } else { fSETHALF(i,RddV,fGETHALF(i,RssV)); } } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RtV, i * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_2, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 16, 16);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RssV, i * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_5, i * 16, 16);
gen_set_label(if_label_1);
}
}

void emit_S2_vrcnegh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { int i; for (i = 0; i < 4; i++) { if (fGETBIT(i,RtV)) { RxxV += -fGETHALF(i,RssV); } else { RxxV += fGETHALF(i,RssV); } } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RtV, i * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_2, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_3, RxxV, tmp_2);
tcg_gen_mov_i64(RxxV, tmp_3);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RssV, i * 16, 16);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_5, RxxV, tmp_4);
tcg_gen_mov_i64(RxxV, tmp_5);
gen_set_label(if_label_1);
}
}

void emit_M4_pmpyw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { int i; unsigned int y; unsigned long long x; unsigned long long prod; x = fGETUWORD(0, RsV); y = fGETUWORD(0, RtV); prod = 0; for(i=0; i < 32; i++) { if((y >> i) & 1) prod ^= (x << i); } RddV = prod; } */
{
TCGv_i32 y = tcg_temp_new_i32();
TCGv_i64 x = tcg_temp_new_i64();
TCGv_i64 prod = tcg_temp_new_i64();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_1, tmp_0);
tcg_gen_mov_i64(x, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, RtV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_3);
tcg_gen_mov_i32(y, tmp_4);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
tcg_gen_movi_i64(prod, qemu_tmp_0);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x20); i++) {
TCGv_i32 tmp_5 = tcg_temp_new_i32();
if (i >= 32) {
tcg_gen_movi_i32(tmp_5, 0);
} else {
tcg_gen_shri_i32(tmp_5, y, i);
}
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_6, tmp_5, ((int32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_6, 0, if_label_0);
int64_t qemu_tmp_1 = (int64_t)i;
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_7, 0);
} else {
tcg_gen_shli_i64(tmp_7, x, qemu_tmp_1);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_xor_i64(tmp_8, prod, tmp_7);
tcg_gen_mov_i64(prod, tmp_8);
gen_set_label(if_label_0);
}
tcg_gen_mov_i64(RddV, prod);
}

void emit_M4_vpmpyh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { int i; unsigned int x0; unsigned int x1; unsigned int y0; unsigned int y1; unsigned int prod0; unsigned int prod1; x0 = fGETUHALF(0, RsV); x1 = fGETUHALF(1, RsV); y0 = fGETUHALF(0, RtV); y1 = fGETUHALF(1, RtV); prod0 = prod1 = 0; for(i=0; i < 16; i++) { if((y0 >> i) & 1) prod0 ^= (x0 << i); if((y1 >> i) & 1) prod1 ^= (x1 << i); } fSETHALF(0,RddV,fGETUHALF(0,prod0)); fSETHALF(1,RddV,fGETUHALF(0,prod1)); fSETHALF(2,RddV,fGETUHALF(1,prod0)); fSETHALF(3,RddV,fGETUHALF(1,prod1)); } */
{
TCGv_i32 x0 = tcg_temp_new_i32();
TCGv_i32 x1 = tcg_temp_new_i32();
TCGv_i32 y0 = tcg_temp_new_i32();
TCGv_i32 y1 = tcg_temp_new_i32();
TCGv_i32 prod0 = tcg_temp_new_i32();
TCGv_i32 prod1 = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
tcg_gen_mov_i32(x0, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RsV, ((int32_t) 0x1) * 16, 16);
tcg_gen_mov_i32(x1, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
tcg_gen_mov_i32(y0, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_3, RtV, ((int32_t) 0x1) * 16, 16);
tcg_gen_mov_i32(y1, tmp_3);
tcg_gen_movi_i32(prod1, ((int32_t) 0x0));
tcg_gen_mov_i32(prod0, prod1);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x10); i++) {
TCGv_i32 tmp_4 = tcg_temp_new_i32();
if (i >= 32) {
tcg_gen_movi_i32(tmp_4, 0);
} else {
tcg_gen_shri_i32(tmp_4, y0, i);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_5, tmp_4, ((int32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_5, 0, if_label_0);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
if (i >= 32) {
tcg_gen_movi_i32(tmp_6, 0);
} else {
tcg_gen_shli_i32(tmp_6, x0, i);
}
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_xor_i32(tmp_7, prod0, tmp_6);
tcg_gen_mov_i32(prod0, tmp_7);
gen_set_label(if_label_0);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
if (i >= 32) {
tcg_gen_movi_i32(tmp_8, 0);
} else {
tcg_gen_shri_i32(tmp_8, y1, i);
}
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_9, tmp_8, ((int32_t) 0x1));
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_9, 0, if_label_1);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
if (i >= 32) {
tcg_gen_movi_i32(tmp_10, 0);
} else {
tcg_gen_shli_i32(tmp_10, x1, i);
}
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_xor_i32(tmp_11, prod1, tmp_10);
tcg_gen_mov_i32(prod1, tmp_11);
gen_set_label(if_label_1);
}
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_12, prod0, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_13, tmp_12);
tcg_gen_deposit_i64(RddV, RddV, tmp_13, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_14 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_14, prod1, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_15, tmp_14);
tcg_gen_deposit_i64(RddV, RddV, tmp_15, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_16 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_16, prod0, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_17, tmp_16);
tcg_gen_deposit_i64(RddV, RddV, tmp_17, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_18, prod1, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_19, tmp_18);
tcg_gen_deposit_i64(RddV, RddV, tmp_19, ((int32_t) 0x3) * 16, 16);
}

void emit_M4_pmpyw_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { int i; unsigned int y; unsigned long long x; unsigned long long prod; x = fGETUWORD(0, RsV); y = fGETUWORD(0, RtV); prod = 0; for(i=0; i < 32; i++) { if((y >> i) & 1) prod ^= (x << i); } RxxV ^= prod; } */
{
TCGv_i32 y = tcg_temp_new_i32();
TCGv_i64 x = tcg_temp_new_i64();
TCGv_i64 prod = tcg_temp_new_i64();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_1, tmp_0);
tcg_gen_mov_i64(x, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, RtV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_3);
tcg_gen_mov_i32(y, tmp_4);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
tcg_gen_movi_i64(prod, qemu_tmp_0);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x20); i++) {
TCGv_i32 tmp_5 = tcg_temp_new_i32();
if (i >= 32) {
tcg_gen_movi_i32(tmp_5, 0);
} else {
tcg_gen_shri_i32(tmp_5, y, i);
}
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_6, tmp_5, ((int32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_6, 0, if_label_0);
int64_t qemu_tmp_1 = (int64_t)i;
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_7, 0);
} else {
tcg_gen_shli_i64(tmp_7, x, qemu_tmp_1);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_xor_i64(tmp_8, prod, tmp_7);
tcg_gen_mov_i64(prod, tmp_8);
gen_set_label(if_label_0);
}
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_xor_i64(tmp_9, RxxV, prod);
tcg_gen_mov_i64(RxxV, tmp_9);
}

void emit_M4_vpmpyh_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { int i; unsigned int x0; unsigned int x1; unsigned int y0; unsigned int y1; unsigned int prod0; unsigned int prod1; x0 = fGETUHALF(0, RsV); x1 = fGETUHALF(1, RsV); y0 = fGETUHALF(0, RtV); y1 = fGETUHALF(1, RtV); prod0 = prod1 = 0; for(i=0; i < 16; i++) { if((y0 >> i) & 1) prod0 ^= (x0 << i); if((y1 >> i) & 1) prod1 ^= (x1 << i); } fSETHALF(0,RxxV,fGETUHALF(0,RxxV) ^ fGETUHALF(0,prod0)); fSETHALF(1,RxxV,fGETUHALF(1,RxxV) ^ fGETUHALF(0,prod1)); fSETHALF(2,RxxV,fGETUHALF(2,RxxV) ^ fGETUHALF(1,prod0)); fSETHALF(3,RxxV,fGETUHALF(3,RxxV) ^ fGETUHALF(1,prod1)); } */
{
TCGv_i32 x0 = tcg_temp_new_i32();
TCGv_i32 x1 = tcg_temp_new_i32();
TCGv_i32 y0 = tcg_temp_new_i32();
TCGv_i32 y1 = tcg_temp_new_i32();
TCGv_i32 prod0 = tcg_temp_new_i32();
TCGv_i32 prod1 = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
tcg_gen_mov_i32(x0, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RsV, ((int32_t) 0x1) * 16, 16);
tcg_gen_mov_i32(x1, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, RtV, ((int32_t) 0x0) * 16, 16);
tcg_gen_mov_i32(y0, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_3, RtV, ((int32_t) 0x1) * 16, 16);
tcg_gen_mov_i32(y1, tmp_3);
tcg_gen_movi_i32(prod1, ((int32_t) 0x0));
tcg_gen_mov_i32(prod0, prod1);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x10); i++) {
TCGv_i32 tmp_4 = tcg_temp_new_i32();
if (i >= 32) {
tcg_gen_movi_i32(tmp_4, 0);
} else {
tcg_gen_shri_i32(tmp_4, y0, i);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_5, tmp_4, ((int32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_5, 0, if_label_0);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
if (i >= 32) {
tcg_gen_movi_i32(tmp_6, 0);
} else {
tcg_gen_shli_i32(tmp_6, x0, i);
}
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_xor_i32(tmp_7, prod0, tmp_6);
tcg_gen_mov_i32(prod0, tmp_7);
gen_set_label(if_label_0);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
if (i >= 32) {
tcg_gen_movi_i32(tmp_8, 0);
} else {
tcg_gen_shri_i32(tmp_8, y1, i);
}
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_9, tmp_8, ((int32_t) 0x1));
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_9, 0, if_label_1);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
if (i >= 32) {
tcg_gen_movi_i32(tmp_10, 0);
} else {
tcg_gen_shli_i32(tmp_10, x1, i);
}
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_xor_i32(tmp_11, prod1, tmp_10);
tcg_gen_mov_i32(prod1, tmp_11);
gen_set_label(if_label_1);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_12, RxxV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_13, prod0, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_14, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_xor_i64(tmp_15, tmp_12, tmp_14);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_15, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_16, RxxV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_17, prod1, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_18, tmp_17);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_xor_i64(tmp_19, tmp_16, tmp_18);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_19, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_20, RxxV, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_21, prod0, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_22, tmp_21);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_xor_i64(tmp_23, tmp_20, tmp_22);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_23, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_24, RxxV, ((int32_t) 0x3) * 16, 16);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_25, prod1, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_26 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_26, tmp_25);
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_xor_i64(tmp_27, tmp_24, tmp_26);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_27, ((int32_t) 0x3) * 16, 16);
}

void emit_M7_dcmpyrw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RddV = (fMPY32SS(fGETWORD(0, RssV), fGETWORD(0, RttV)) - fMPY32SS(fGETWORD(1, RssV), fGETWORD(1, RttV)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_5, tmp_3, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, tmp_2, tmp_5);
tcg_gen_mov_i64(RddV, tmp_6);
}

void emit_M7_dcmpyrw_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RxxV += (fMPY32SS(fGETWORD(0, RssV), fGETWORD(0, RttV)) - fMPY32SS(fGETWORD(1, RssV), fGETWORD(1, RttV)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_5, tmp_3, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, tmp_2, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, RxxV, tmp_6);
tcg_gen_mov_i64(RxxV, tmp_7);
}

void emit_M7_dcmpyrwc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RddV = (fMPY32SS(fGETWORD(0, RssV), fGETWORD(0, RttV)) + fMPY32SS(fGETWORD(1, RssV), fGETWORD(1, RttV)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_5, tmp_3, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_2, tmp_5);
tcg_gen_mov_i64(RddV, tmp_6);
}

void emit_M7_dcmpyrwc_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RxxV += (fMPY32SS(fGETWORD(0, RssV), fGETWORD(0, RttV)) + fMPY32SS(fGETWORD(1, RssV), fGETWORD(1, RttV)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_5, tmp_3, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_2, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, RxxV, tmp_6);
tcg_gen_mov_i64(RxxV, tmp_7);
}

void emit_M7_dcmpyiw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RddV = (fMPY32SS(fGETWORD(0, RssV), fGETWORD(1, RttV)) + fMPY32SS(fGETWORD(1, RssV), fGETWORD(0, RttV)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_5, tmp_3, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_2, tmp_5);
tcg_gen_mov_i64(RddV, tmp_6);
}

void emit_M7_dcmpyiw_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RxxV += (fMPY32SS(fGETWORD(0, RssV), fGETWORD(1, RttV)) + fMPY32SS(fGETWORD(1, RssV), fGETWORD(0, RttV)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_5, tmp_3, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, tmp_2, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, RxxV, tmp_6);
tcg_gen_mov_i64(RxxV, tmp_7);
}

void emit_M7_dcmpyiwc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RddV = (fMPY32SS(fGETWORD(1, RssV), fGETWORD(0, RttV)) - fMPY32SS(fGETWORD(0, RssV), fGETWORD(1, RttV)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_5, tmp_3, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, tmp_2, tmp_5);
tcg_gen_mov_i64(RddV, tmp_6);
}

void emit_M7_dcmpyiwc_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RxxV += (fMPY32SS(fGETWORD(1, RssV), fGETWORD(0, RttV)) - fMPY32SS(fGETWORD(0, RssV), fGETWORD(1, RttV)));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_5, tmp_3, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, tmp_2, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, RxxV, tmp_6);
tcg_gen_mov_i64(RxxV, tmp_7);
}

void emit_A2_add(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RdV=RsV+RtV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_A2_sub(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* { RdV=RtV-RsV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_0, RtV, RsV);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_A2_paddt(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {if((fGETBIT(0, PuV))){RdV=RsV+RtV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PuV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_1);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_paddf(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {if(fGETBIT(0, ~PuV)){RdV=RsV+RtV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_2, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_2);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_paddtnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {if(fLSBNEW(PuN)){RdV=RsV+RtV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PuN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_1);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_paddfnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {if((fLSBNEW(~PuN))){RdV=RsV+RtV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_2, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_2);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_psubt(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {if((fGETBIT(0, PuV))){RdV=RtV-RsV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PuV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_1, RtV, RsV);
tcg_gen_mov_i32(RdV, tmp_1);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_psubf(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {if(fGETBIT(0, ~PuV)){RdV=RtV-RsV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_2, RtV, RsV);
tcg_gen_mov_i32(RdV, tmp_2);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_psubtnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {if(fLSBNEW(PuN)){RdV=RtV-RsV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PuN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_1, RtV, RsV);
tcg_gen_mov_i32(RdV, tmp_1);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_psubfnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {if((fLSBNEW(~PuN))){RdV=RtV-RsV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_2, RtV, RsV);
tcg_gen_mov_i32(RdV, tmp_2);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_paddit(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RsV, int siV)
/* {if((fGETBIT(0, PuV))){fIMMEXT(siV); RdV=RsV+siV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PuV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RsV, siV);
tcg_gen_mov_i32(RdV, tmp_1);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_paddif(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RsV, int siV)
/* {if(fGETBIT(0, ~PuV)){fIMMEXT(siV); RdV=RsV+siV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RsV, siV);
tcg_gen_mov_i32(RdV, tmp_2);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_padditnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RsV, int siV)
/* {if(fLSBNEW(PuN)){fIMMEXT(siV); RdV=RsV+siV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PuN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, RsV, siV);
tcg_gen_mov_i32(RdV, tmp_1);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_paddifnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RsV, int siV)
/* {if((fLSBNEW(~PuN))){fIMMEXT(siV); RdV=RsV+siV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_2, RsV, siV);
tcg_gen_mov_i32(RdV, tmp_2);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_pxort(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {if((fGETBIT(0, PuV))){RdV=RsV^RtV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PuV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_xor_i32(tmp_1, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_1);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_pxorf(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {if(fGETBIT(0, ~PuV)){RdV=RsV^RtV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_xor_i32(tmp_2, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_2);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_pxortnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {if(fLSBNEW(PuN)){RdV=RsV^RtV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PuN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_xor_i32(tmp_1, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_1);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_pxorfnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {if((fLSBNEW(~PuN))){RdV=RsV^RtV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_xor_i32(tmp_2, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_2);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_pandt(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {if((fGETBIT(0, PuV))){RdV=RsV&RtV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PuV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_1, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_1);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_pandf(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {if(fGETBIT(0, ~PuV)){RdV=RsV&RtV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_2, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_2);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_pandtnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {if(fLSBNEW(PuN)){RdV=RsV&RtV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PuN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_1, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_1);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_pandfnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {if((fLSBNEW(~PuN))){RdV=RsV&RtV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_2, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_2);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_port(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {if((fGETBIT(0, PuV))){RdV=RsV|RtV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PuV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_1, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_1);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_porf(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {if(fGETBIT(0, ~PuV)){RdV=RsV|RtV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_2, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_2);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_portnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {if(fLSBNEW(PuN)){RdV=RsV|RtV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PuN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_1, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_1);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_porfnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {if((fLSBNEW(~PuN))){RdV=RsV|RtV;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_2, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_2);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_psxtbt(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if((fGETBIT(0, PuV))){RdV=fSXTN(8,32,RsV);} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PuV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_2, tmp_1, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_2, 0);
}
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_2);
tcg_gen_mov_i32(RdV, tmp_3);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_psxtbf(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if(fGETBIT(0, ~PuV)){RdV=fSXTN(8,32,RsV);} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x8);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_3, tmp_2, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_3, 0);
}
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_3);
tcg_gen_mov_i32(RdV, tmp_4);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_psxtbtnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if(fLSBNEW(PuN)){RdV=fSXTN(8,32,RsV);} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PuN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_2, tmp_1, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_2, 0);
}
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_2);
tcg_gen_mov_i32(RdV, tmp_3);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_psxtbfnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if((fLSBNEW(~PuN))){RdV=fSXTN(8,32,RsV);} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x8);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_3, tmp_2, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_3, 0);
}
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_3);
tcg_gen_mov_i32(RdV, tmp_4);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_pzxtbt(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if((fGETBIT(0, PuV))){RdV=fZXTN(8,32,RsV);} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PuV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_2, tmp_1, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_2, 0);
}
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_2);
tcg_gen_mov_i32(RdV, tmp_3);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_pzxtbf(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if(fGETBIT(0, ~PuV)){RdV=fZXTN(8,32,RsV);} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x8);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_3, tmp_2, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_3, 0);
}
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_3);
tcg_gen_mov_i32(RdV, tmp_4);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_pzxtbtnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if(fLSBNEW(PuN)){RdV=fZXTN(8,32,RsV);} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PuN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_2, tmp_1, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_2, 0);
}
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_2);
tcg_gen_mov_i32(RdV, tmp_3);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_pzxtbfnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if((fLSBNEW(~PuN))){RdV=fZXTN(8,32,RsV);} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x8);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_3, tmp_2, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_3, 0);
}
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_3);
tcg_gen_mov_i32(RdV, tmp_4);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_psxtht(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if((fGETBIT(0, PuV))){RdV=fSXTN(16,32,RsV);} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PuV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_2, tmp_1, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_2, 0);
}
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_2);
tcg_gen_mov_i32(RdV, tmp_3);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_psxthf(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if(fGETBIT(0, ~PuV)){RdV=fSXTN(16,32,RsV);} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_3, tmp_2, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_3, 0);
}
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_3);
tcg_gen_mov_i32(RdV, tmp_4);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_psxthtnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if(fLSBNEW(PuN)){RdV=fSXTN(16,32,RsV);} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PuN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_2, tmp_1, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_2, 0);
}
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_2);
tcg_gen_mov_i32(RdV, tmp_3);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_psxthfnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if((fLSBNEW(~PuN))){RdV=fSXTN(16,32,RsV);} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_3, tmp_2, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_3, 0);
}
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_3);
tcg_gen_mov_i32(RdV, tmp_4);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_pzxtht(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if((fGETBIT(0, PuV))){RdV=fZXTN(16,32,RsV);} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PuV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_2, tmp_1, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_2, 0);
}
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_2);
tcg_gen_mov_i32(RdV, tmp_3);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_pzxthf(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if(fGETBIT(0, ~PuV)){RdV=fZXTN(16,32,RsV);} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_3, tmp_2, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_3, 0);
}
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_3);
tcg_gen_mov_i32(RdV, tmp_4);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_pzxthtnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if(fLSBNEW(PuN)){RdV=fZXTN(16,32,RsV);} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PuN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_2, tmp_1, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_2, 0);
}
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_2);
tcg_gen_mov_i32(RdV, tmp_3);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_pzxthfnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if((fLSBNEW(~PuN))){RdV=fZXTN(16,32,RsV);} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_3, tmp_2, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_3, 0);
}
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_3);
tcg_gen_mov_i32(RdV, tmp_4);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_paslht(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if((fGETBIT(0, PuV))){RdV=RsV<<16;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PuV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_1, 0);
} else {
tcg_gen_shli_i32(tmp_1, RsV, ((int32_t) 0x10));
}
tcg_gen_mov_i32(RdV, tmp_1);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_paslhf(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if(fGETBIT(0, ~PuV)){RdV=RsV<<16;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_2, 0);
} else {
tcg_gen_shli_i32(tmp_2, RsV, ((int32_t) 0x10));
}
tcg_gen_mov_i32(RdV, tmp_2);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_paslhtnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if(fLSBNEW(PuN)){RdV=RsV<<16;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PuN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_1, 0);
} else {
tcg_gen_shli_i32(tmp_1, RsV, ((int32_t) 0x10));
}
tcg_gen_mov_i32(RdV, tmp_1);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_paslhfnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if((fLSBNEW(~PuN))){RdV=RsV<<16;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_2, 0);
} else {
tcg_gen_shli_i32(tmp_2, RsV, ((int32_t) 0x10));
}
tcg_gen_mov_i32(RdV, tmp_2);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_pasrht(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if((fGETBIT(0, PuV))){RdV=RsV>>16;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, PuV, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
{
int32_t shift = ((int32_t) 0x10);
if (((int32_t) 0x10) >= 32) {
    shift = 32 - 1;
}
tcg_gen_sari_i32(tmp_1, RsV, shift);
}
tcg_gen_mov_i32(RdV, tmp_1);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_pasrhf(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuV, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if(fGETBIT(0, ~PuV)){RdV=RsV>>16;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
{
int32_t shift = ((int32_t) 0x10);
if (((int32_t) 0x10) >= 32) {
    shift = 32 - 1;
}
tcg_gen_sari_i32(tmp_2, RsV, shift);
}
tcg_gen_mov_i32(RdV, tmp_2);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_pasrhtnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if(fLSBNEW(PuN)){RdV=RsV>>16;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PuN, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
{
int32_t shift = ((int32_t) 0x10);
if (((int32_t) 0x10) >= 32) {
    shift = 32 - 1;
}
tcg_gen_sari_i32(tmp_1, RsV, shift);
}
tcg_gen_mov_i32(RdV, tmp_1);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A4_pasrhfnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PuN, TCGv_i32 RdV, TCGv_i32 RsV)
/* {if((fLSBNEW(~PuN))){RdV=RsV>>16;} else {CANCEL;}} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, PuN);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
{
int32_t shift = ((int32_t) 0x10);
if (((int32_t) 0x10) >= 32) {
    shift = 32 - 1;
}
tcg_gen_sari_i32(tmp_2, RsV, shift);
}
tcg_gen_mov_i32(RdV, tmp_2);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_A2_addsat(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RdV=fSATN(32, fSE32_64(RsV)+fSE32_64(RtV)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RtV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_4, tmp_3, tmp_2, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_3);
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_A2_subsat(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* { RdV=fSATN(32, fSE32_64(RtV) - fSE32_64(RsV)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RsV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_4, tmp_3, tmp_2, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_3);
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_A2_addi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int siV)
/* { fIMMEXT(siV); RdV=RsV+siV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_C4_addipc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, int uiV)
/* { RdV=fREAD_PC()+fIMMEXT(uiV);} */
{
int32_t qemu_tmp_0 = ctx->base.pc_next + uiV;
tcg_gen_movi_i32(RdV, qemu_tmp_0);
}

void emit_A2_addh_l16_ll(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=fSXTN(16,32,(fGETHALF(0,RtV)+fGETHALF(0,RsV)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_A2_addh_l16_hl(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=fSXTN(16,32,(fGETHALF(0,RtV)+fGETHALF(1,RsV)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_A2_addh_l16_sat_ll(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=fSATN(16, fGETHALF(0,RtV)+fGETHALF(0,RsV));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i32_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
tcg_gen_mov_i32(RdV, tmp_3);
}

void emit_A2_addh_l16_sat_hl(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=fSATN(16, fGETHALF(0,RtV)+fGETHALF(1,RsV));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i32_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
tcg_gen_mov_i32(RdV, tmp_3);
}

void emit_A2_subh_l16_ll(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=fSXTN(16,32,(fGETHALF(0,RtV)-fGETHALF(0,RsV)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_A2_subh_l16_hl(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=fSXTN(16,32,(fGETHALF(0,RtV)-fGETHALF(1,RsV)));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_A2_subh_l16_sat_ll(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=fSATN(16, fGETHALF(0,RtV)-fGETHALF(0,RsV));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i32_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
tcg_gen_mov_i32(RdV, tmp_3);
}

void emit_A2_subh_l16_sat_hl(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=fSATN(16, fGETHALF(0,RtV)-fGETHALF(1,RsV));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i32_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
tcg_gen_mov_i32(RdV, tmp_3);
}

void emit_A2_addh_h16_ll(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=(fGETHALF(0,RtV)+fGETHALF(0,RsV))<<16;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_3, 0);
} else {
tcg_gen_shli_i32(tmp_3, tmp_2, ((int32_t) 0x10));
}
tcg_gen_mov_i32(RdV, tmp_3);
}

void emit_A2_addh_h16_lh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=(fGETHALF(0,RtV)+fGETHALF(1,RsV))<<16;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_3, 0);
} else {
tcg_gen_shli_i32(tmp_3, tmp_2, ((int32_t) 0x10));
}
tcg_gen_mov_i32(RdV, tmp_3);
}

void emit_A2_addh_h16_hl(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=(fGETHALF(1,RtV)+fGETHALF(0,RsV))<<16;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_3, 0);
} else {
tcg_gen_shli_i32(tmp_3, tmp_2, ((int32_t) 0x10));
}
tcg_gen_mov_i32(RdV, tmp_3);
}

void emit_A2_addh_h16_hh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=(fGETHALF(1,RtV)+fGETHALF(1,RsV))<<16;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_3, 0);
} else {
tcg_gen_shli_i32(tmp_3, tmp_2, ((int32_t) 0x10));
}
tcg_gen_mov_i32(RdV, tmp_3);
}

void emit_A2_addh_h16_sat_ll(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=(fSATN(16, fGETHALF(0,RtV)+fGETHALF(0,RsV)))<<16;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i32_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_5, 0);
} else {
tcg_gen_shli_i32(tmp_5, tmp_3, ((int32_t) 0x10));
}
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_A2_addh_h16_sat_lh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=(fSATN(16, fGETHALF(0,RtV)+fGETHALF(1,RsV)))<<16;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i32_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_5, 0);
} else {
tcg_gen_shli_i32(tmp_5, tmp_3, ((int32_t) 0x10));
}
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_A2_addh_h16_sat_hl(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=(fSATN(16, fGETHALF(1,RtV)+fGETHALF(0,RsV)))<<16;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i32_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_5, 0);
} else {
tcg_gen_shli_i32(tmp_5, tmp_3, ((int32_t) 0x10));
}
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_A2_addh_h16_sat_hh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=(fSATN(16, fGETHALF(1,RtV)+fGETHALF(1,RsV)))<<16;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i32_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_5, 0);
} else {
tcg_gen_shli_i32(tmp_5, tmp_3, ((int32_t) 0x10));
}
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_A2_subh_h16_ll(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=(fGETHALF(0,RtV)-fGETHALF(0,RsV))<<16;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_3, 0);
} else {
tcg_gen_shli_i32(tmp_3, tmp_2, ((int32_t) 0x10));
}
tcg_gen_mov_i32(RdV, tmp_3);
}

void emit_A2_subh_h16_lh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=(fGETHALF(0,RtV)-fGETHALF(1,RsV))<<16;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_3, 0);
} else {
tcg_gen_shli_i32(tmp_3, tmp_2, ((int32_t) 0x10));
}
tcg_gen_mov_i32(RdV, tmp_3);
}

void emit_A2_subh_h16_hl(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=(fGETHALF(1,RtV)-fGETHALF(0,RsV))<<16;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_3, 0);
} else {
tcg_gen_shli_i32(tmp_3, tmp_2, ((int32_t) 0x10));
}
tcg_gen_mov_i32(RdV, tmp_3);
}

void emit_A2_subh_h16_hh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=(fGETHALF(1,RtV)-fGETHALF(1,RsV))<<16;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_3, 0);
} else {
tcg_gen_shli_i32(tmp_3, tmp_2, ((int32_t) 0x10));
}
tcg_gen_mov_i32(RdV, tmp_3);
}

void emit_A2_subh_h16_sat_ll(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=(fSATN(16, fGETHALF(0,RtV)-fGETHALF(0,RsV)))<<16;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i32_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_5, 0);
} else {
tcg_gen_shli_i32(tmp_5, tmp_3, ((int32_t) 0x10));
}
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_A2_subh_h16_sat_lh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=(fSATN(16, fGETHALF(0,RtV)-fGETHALF(1,RsV)))<<16;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i32_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_5, 0);
} else {
tcg_gen_shli_i32(tmp_5, tmp_3, ((int32_t) 0x10));
}
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_A2_subh_h16_sat_hl(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=(fSATN(16, fGETHALF(1,RtV)-fGETHALF(0,RsV)))<<16;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i32_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_5, 0);
} else {
tcg_gen_shli_i32(tmp_5, tmp_3, ((int32_t) 0x10));
}
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_A2_subh_h16_sat_hh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV=(fSATN(16, fGETHALF(1,RtV)-fGETHALF(1,RsV)))<<16;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i32_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_5, 0);
} else {
tcg_gen_shli_i32(tmp_5, tmp_3, ((int32_t) 0x10));
}
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_A2_aslh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* { RdV=RsV<<16; } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RsV, ((int32_t) 0x10));
}
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_A2_asrh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* { RdV=RsV>>16; } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
{
int32_t shift = ((int32_t) 0x10);
if (((int32_t) 0x10) >= 32) {
    shift = 32 - 1;
}
tcg_gen_sari_i32(tmp_0, RsV, shift);
}
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_A2_addp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RddV=RssV+RttV;} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_0, RssV, RttV);
tcg_gen_mov_i64(RddV, tmp_0);
}

void emit_A2_addpsat(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fADDSAT64(RddV,RssV,RttV);} */
{
gen_add_sat_i64(ctx, RddV, RssV, RttV);
}

void emit_A2_addspl(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RddV=RttV+fSXTN(32,64,fGETWORD(0,RssV));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 32, 32);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, RttV, tmp_1);
tcg_gen_mov_i64(RddV, tmp_2);
}

void emit_A2_addsph(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RddV=RttV+fSXTN(32,64,fGETWORD(1,RssV));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 32, 32);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, RttV, tmp_1);
tcg_gen_mov_i64(RddV, tmp_2);
}

void emit_A2_subp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { RddV=RttV-RssV;} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_0, RttV, RssV);
tcg_gen_mov_i64(RddV, tmp_0);
}

void emit_A4_addp_c(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV, TCGv PxV)
/* { RddV = RssV + RttV + (fGETBIT(0, PxV)); PxV = ((fCARRY_FROM_ADD(RssV,RttV,(fGETBIT(0, PxV)))) ? 0xff : 0x00); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_0, RssV, RttV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, PxV, ((int32_t) 0x0) * 1, 1);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_2, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_3, tmp_0, tmp_2);
tcg_gen_mov_i64(RddV, tmp_3);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_4, PxV, ((int32_t) 0x0) * 1, 1);
TCGv_i64 tmp_5 = tcg_constant_i64(0);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_8, tmp_4);
tcg_gen_add2_i64(tmp_6, tmp_7, RssV, tmp_5, tmp_8, tmp_5);
tcg_gen_add2_i64(tmp_6, tmp_7, tmp_6, tmp_7, RttV, tmp_5);
TCGv_i32 tmp_9 = tcg_constant_i32(0);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_11, tmp_7);
TCGv_i32 tmp_12 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_13 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_10, tmp_11, tmp_9, tmp_12, tmp_13);
tcg_gen_andi_i32(PxV, tmp_10, 0xff);
}

void emit_A4_subp_c(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV, TCGv PxV)
/* { RddV = RssV + ~RttV + (fGETBIT(0, PxV)); PxV = ((fCARRY_FROM_ADD(RssV,~RttV,(fGETBIT(0, PxV)))) ? 0xff : 0x00); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_not_i64(tmp_0, RttV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_1, RssV, tmp_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, PxV, ((int32_t) 0x0) * 1, 1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_4, tmp_1, tmp_3);
tcg_gen_mov_i64(RddV, tmp_4);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_not_i64(tmp_5, RttV);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_6, PxV, ((int32_t) 0x0) * 1, 1);
TCGv_i64 tmp_7 = tcg_constant_i64(0);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i64 tmp_9 = tcg_temp_new_i64();
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_10, tmp_6);
tcg_gen_add2_i64(tmp_8, tmp_9, RssV, tmp_7, tmp_10, tmp_7);
tcg_gen_add2_i64(tmp_8, tmp_9, tmp_8, tmp_9, tmp_5, tmp_7);
TCGv_i32 tmp_11 = tcg_constant_i32(0);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
TCGv_i32 tmp_13 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_13, tmp_9);
TCGv_i32 tmp_14 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_15 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_12, tmp_13, tmp_11, tmp_14, tmp_15);
tcg_gen_andi_i32(PxV, tmp_12, 0xff);
}

void emit_A2_negsat(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* { RdV = fSATN(32, -fCAST8s(RsV)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_1, tmp_0);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
TCGv_i32 tmp_3 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_3, tmp_2, tmp_1, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_3);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_2);
tcg_gen_mov_i32(RdV, tmp_4);
}

void emit_A2_abs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* { RdV = fABS(RsV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_abs_i32(tmp_0, RsV);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_A2_abssat(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* { RdV = fSATN(32, fABS(fCAST4_8s(RsV))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_abs_i64(tmp_1, tmp_0);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
TCGv_i32 tmp_3 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_3, tmp_2, tmp_1, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_3);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_2);
tcg_gen_mov_i32(RdV, tmp_4);
}

void emit_A2_vconj(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV)
/* { fSETHALF(1,RddV,fSATN(16,-fGETHALF(1,RssV))); fSETHALF(0,RddV,fGETHALF(0,RssV)); fSETHALF(3,RddV,fSATN(16,-fGETHALF(3,RssV))); fSETHALF(2,RddV,fGETHALF(2,RssV)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_1, tmp_0);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
TCGv_i32 tmp_3 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_3, tmp_2, tmp_1, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_3);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, RssV, ((int32_t) 0x0) * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_4, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_6, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
tcg_gen_deposit_i64(RddV, RddV, tmp_7, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RssV, ((int32_t) 0x2) * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_9, ((int32_t) 0x2) * 16, 16);
}

void emit_A2_negp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV)
/* { RddV = -RssV; } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_0, RssV);
tcg_gen_mov_i64(RddV, tmp_0);
}

void emit_A2_absp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV)
/* { RddV = fABS(RssV); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_abs_i64(tmp_0, RssV);
tcg_gen_mov_i64(RddV, tmp_0);
}

void emit_A2_max(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RdV = fMAX(RsV,RtV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_smax_i32(tmp_0, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_A2_maxu(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RdV = fMAX(fCAST4u(RsV),fCAST4u(RtV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_umax_i32(tmp_0, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_A2_min(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* { RdV = fMIN(RtV,RsV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_smin_i32(tmp_0, RtV, RsV);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_A2_minu(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* { RdV = fMIN(fCAST4u(RtV),fCAST4u(RsV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_umin_i32(tmp_0, RtV, RsV);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_A2_maxp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RddV = fMAX(RssV,RttV); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_smax_i64(tmp_0, RssV, RttV);
tcg_gen_mov_i64(RddV, tmp_0);
}

void emit_A2_maxup(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RddV = fMAX(fCAST8u(RssV),fCAST8u(RttV)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_umax_i64(tmp_0, RssV, RttV);
tcg_gen_mov_i64(RddV, tmp_0);
}

void emit_A2_minp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { RddV = fMIN(RttV,RssV); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_smin_i64(tmp_0, RttV, RssV);
tcg_gen_mov_i64(RddV, tmp_0);
}

void emit_A2_minup(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { RddV = fMIN(fCAST8u(RttV),fCAST8u(RssV)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_umin_i64(tmp_0, RttV, RssV);
tcg_gen_mov_i64(RddV, tmp_0);
}

void emit_A2_nop(DisasContext *ctx, Insn *insn, Packet *pkt)
/* { } */
{
}

void emit_A4_ext(DisasContext *ctx, Insn *insn, Packet *pkt, int uiV)
/* { ; } */
{
}

void emit_A2_tfr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* { RdV=RsV;} */
{
tcg_gen_mov_i32(RdV, RsV);
}

void emit_A2_tfrsi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, int siV)
/* { fIMMEXT(siV); RdV=siV;} */
{
tcg_gen_movi_i32(RdV, siV);
}

void emit_A2_sxtb(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* {RdV = fSXTN(8,32,RsV);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(RdV, tmp_2);
}

void emit_A2_zxth(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* {RdV = fZXTN(16,32,RsV);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(RdV, tmp_2);
}

void emit_A2_sxth(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* {RdV = fSXTN(16,32,RsV);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(RdV, tmp_2);
}

void emit_A2_combinew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETWORD(0,RddV,RtV); fSETWORD(1,RddV,RsV); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
tcg_gen_deposit_i64(RddV, RddV, tmp_0, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RsV);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, ((int32_t) 0x1) * 32, 32);
}

void emit_A4_combineri(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, int siV)
/* { fIMMEXT(siV); fSETWORD(0,RddV,siV); fSETWORD(1,RddV,RsV); } */
{
int64_t qemu_tmp_0 = (int64_t)siV;
TCGv_i64 tmp_0 = tcg_constant_i64((int64_t) (qemu_tmp_0));
tcg_gen_deposit_i64(RddV, RddV, tmp_0, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RsV);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, ((int32_t) 0x1) * 32, 32);
}

void emit_A4_combineir(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, int siV)
/* { fIMMEXT(siV); fSETWORD(0,RddV,RsV); fSETWORD(1,RddV,siV); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
tcg_gen_deposit_i64(RddV, RddV, tmp_0, ((int32_t) 0x0) * 32, 32);
int64_t qemu_tmp_0 = (int64_t)siV;
TCGv_i64 tmp_1 = tcg_constant_i64((int64_t) (qemu_tmp_0));
tcg_gen_deposit_i64(RddV, RddV, tmp_1, ((int32_t) 0x1) * 32, 32);
}

void emit_A2_combineii(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, int siV, int SiV)
/* { fIMMEXT(siV); fSETWORD(0,RddV,SiV); fSETWORD(1,RddV,siV); } */
{
int64_t qemu_tmp_0 = (int64_t)SiV;
TCGv_i64 tmp_0 = tcg_constant_i64((int64_t) (qemu_tmp_0));
tcg_gen_deposit_i64(RddV, RddV, tmp_0, ((int32_t) 0x0) * 32, 32);
int64_t qemu_tmp_1 = (int64_t)siV;
TCGv_i64 tmp_1 = tcg_constant_i64((int64_t) (qemu_tmp_1));
tcg_gen_deposit_i64(RddV, RddV, tmp_1, ((int32_t) 0x1) * 32, 32);
}

void emit_A4_combineii(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, int siV, int UiV)
/* { fIMMEXT(UiV); fSETWORD(0,RddV,UiV); fSETWORD(1,RddV,siV); } */
{
int64_t qemu_tmp_0 = (int64_t)UiV;
TCGv_i64 tmp_0 = tcg_constant_i64((int64_t) (qemu_tmp_0));
tcg_gen_deposit_i64(RddV, RddV, tmp_0, ((int32_t) 0x0) * 32, 32);
int64_t qemu_tmp_1 = (int64_t)siV;
TCGv_i64 tmp_1 = tcg_constant_i64((int64_t) (qemu_tmp_1));
tcg_gen_deposit_i64(RddV, RddV, tmp_1, ((int32_t) 0x1) * 32, 32);
}

void emit_A2_combine_hh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV = (fGETUHALF(1,RtV)<<16) | fGETUHALF(1,RsV);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_1, 0);
} else {
tcg_gen_shli_i32(tmp_1, tmp_0, ((int32_t) 0x10));
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_3, tmp_1, tmp_2);
tcg_gen_mov_i32(RdV, tmp_3);
}

void emit_A2_combine_hl(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV = (fGETUHALF(1,RtV)<<16) | fGETUHALF(0,RsV);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_1, 0);
} else {
tcg_gen_shli_i32(tmp_1, tmp_0, ((int32_t) 0x10));
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_3, tmp_1, tmp_2);
tcg_gen_mov_i32(RdV, tmp_3);
}

void emit_A2_combine_lh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV = (fGETUHALF(0,RtV)<<16) | fGETUHALF(1,RsV);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_1, 0);
} else {
tcg_gen_shli_i32(tmp_1, tmp_0, ((int32_t) 0x10));
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_3, tmp_1, tmp_2);
tcg_gen_mov_i32(RdV, tmp_3);
}

void emit_A2_combine_ll(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* {RdV = (fGETUHALF(0,RtV)<<16) | fGETUHALF(0,RsV);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
if (((int32_t) 0x10) >= 32) {
tcg_gen_movi_i32(tmp_1, 0);
} else {
tcg_gen_shli_i32(tmp_1, tmp_0, ((int32_t) 0x10));
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_3, tmp_1, tmp_2);
tcg_gen_mov_i32(RdV, tmp_3);
}

void emit_A2_tfril(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, int uiV)
/* { fSETHALF(0,RxV,uiV);} */
{
TCGv_i32 tmp_0 = tcg_constant_i32((int32_t) (uiV));
tcg_gen_deposit_i32(RxV, RxV, tmp_0, ((int32_t) 0x0) * 16, 16);
}

void emit_A2_tfrih(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, int uiV)
/* { fSETHALF(1,RxV,uiV);} */
{
TCGv_i32 tmp_0 = tcg_constant_i32((int32_t) (uiV));
tcg_gen_deposit_i32(RxV, RxV, tmp_0, ((int32_t) 0x1) * 16, 16);
}

void emit_A2_tfrcrr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 CsV)
/* { RdV=CsV;} */
{
tcg_gen_mov_i32(RdV, CsV);
}

void emit_A2_tfrrcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 CdV, TCGv_i32 RsV)
/* { CdV=RsV;} */
{
tcg_gen_mov_i32(CdV, RsV);
}

void emit_A4_tfrcpp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 CssV)
/* { RddV=CssV;} */
{
tcg_gen_mov_i64(RddV, CssV);
}

void emit_A4_tfrpcp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 CddV, TCGv_i64 RssV)
/* { CddV=RssV;} */
{
tcg_gen_mov_i64(CddV, RssV);
}

void emit_A2_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RdV=RsV&RtV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_0, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_A2_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RdV=RsV|RtV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_0, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_A2_xor(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RdV=RsV^RtV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_xor_i32(tmp_0, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_M2_xor_xacc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RxV^=RsV^RtV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_xor_i32(tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_xor_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_M4_xor_xacc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RxxV^=RssV^RttV;} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_xor_i64(tmp_0, RssV, RttV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_xor_i64(tmp_1, RxxV, tmp_0);
tcg_gen_mov_i64(RxxV, tmp_1);
}

void emit_A4_andn(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* { RdV = (RtV & ~RsV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, RsV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_1, RtV, tmp_0);
tcg_gen_mov_i32(RdV, tmp_1);
}

void emit_A4_orn(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* { RdV = (RtV | ~RsV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, RsV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_1, RtV, tmp_0);
tcg_gen_mov_i32(RdV, tmp_1);
}

void emit_A4_andnp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { RddV = (RttV & ~RssV); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_not_i64(tmp_0, RssV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_1, RttV, tmp_0);
tcg_gen_mov_i64(RddV, tmp_1);
}

void emit_A4_ornp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { RddV = (RttV | ~RssV); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_not_i64(tmp_0, RssV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_1, RttV, tmp_0);
tcg_gen_mov_i64(RddV, tmp_1);
}

void emit_S4_addaddi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RuV, int siV)
/* { RdV = RsV + RuV + fIMMEXT(siV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RsV, RuV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, siV);
tcg_gen_mov_i32(RdV, tmp_1);
}

void emit_S4_subaddi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RuV, int siV)
/* { RdV = RsV - RuV + fIMMEXT(siV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_0, RsV, RuV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, siV);
tcg_gen_mov_i32(RdV, tmp_1);
}

void emit_M4_and_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RxV &= (RsV & RtV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_M4_and_andn(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RxV &= (RsV & ~RtV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, RtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_1, RsV, tmp_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_2, RxV, tmp_1);
tcg_gen_mov_i32(RxV, tmp_2);
}

void emit_M4_and_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RxV &= (RsV | RtV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_M4_and_xor(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RxV &= (RsV ^ RtV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_xor_i32(tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_M4_or_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RxV |= (RsV & RtV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_M4_or_andn(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RxV |= (RsV & ~RtV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, RtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_1, RsV, tmp_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_2, RxV, tmp_1);
tcg_gen_mov_i32(RxV, tmp_2);
}

void emit_M4_or_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RxV |= (RsV | RtV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_M4_or_xor(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RxV |= (RsV ^ RtV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_xor_i32(tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S4_or_andix(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RuV, int siV)
/* { RxV = RuV | (RxV & fIMMEXT(siV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, RxV, siV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_1, RuV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S4_or_andi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int siV)
/* { RxV = RxV | (RsV & fIMMEXT(siV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, RsV, siV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S4_or_ori(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int siV)
/* { RxV = RxV | (RsV | fIMMEXT(siV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_ori_i32(tmp_0, RsV, siV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_M4_xor_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RxV ^= (RsV & RtV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_xor_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_M4_xor_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RxV ^= (RsV | RtV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_xor_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_M4_xor_andn(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RxV ^= (RsV & ~RtV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, RtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_1, RsV, tmp_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_xor_i32(tmp_2, RxV, tmp_1);
tcg_gen_mov_i32(RxV, tmp_2);
}

void emit_A2_subri(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int siV)
/* { fIMMEXT(siV); RdV=siV-RsV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_subfi_i32(tmp_0, siV, RsV);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_A2_andir(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int siV)
/* { fIMMEXT(siV); RdV=RsV&siV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_A2_orir(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int siV)
/* { fIMMEXT(siV); RdV=RsV|siV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_ori_i32(tmp_0, RsV, siV);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_A2_andp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RddV=RssV&RttV;} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_0, RssV, RttV);
tcg_gen_mov_i64(RddV, tmp_0);
}

void emit_A2_orp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RddV=RssV|RttV;} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_0, RssV, RttV);
tcg_gen_mov_i64(RddV, tmp_0);
}

void emit_A2_xorp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RddV=RssV^RttV;} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_xor_i64(tmp_0, RssV, RttV);
tcg_gen_mov_i64(RddV, tmp_0);
}

void emit_A2_notp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV)
/* { RddV=~RssV;} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_not_i64(tmp_0, RssV);
tcg_gen_mov_i64(RddV, tmp_0);
}

void emit_A2_sxtw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV)
/* { RddV = fCAST4_8s(RsV); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
tcg_gen_mov_i64(RddV, tmp_0);
}

void emit_A2_sat(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV)
/* { RdV = fSATN(32, RssV); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_1, tmp_0, RssV, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_0);
tcg_gen_mov_i32(RdV, tmp_2);
}

void emit_A2_roundsat(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV)
/* { size8s_t tmp; fADDSAT64(tmp,RssV,0x080000000ULL); RdV = fGETWORD(1,tmp); } */
{
TCGv_i64 tmp = tcg_temp_new_i64();
TCGv_i64 tmp_0 = tcg_constant_i64((int64_t) (((uint64_t) 0x80000000ULL)));
gen_add_sat_i64(ctx, tmp, RssV, tmp_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, tmp, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(RdV, tmp_2);
}

void emit_A2_sath(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* { RdV = fSATN(16, RsV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_sat_i32_ovfl(tmp_1, tmp_0, RsV, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_1);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_A2_satuh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* { RdV = fSATUN(16, RsV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_satu_i32_ovfl(tmp_1, tmp_0, RsV, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_1);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_A2_satub(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* { RdV = fSATUN(8, RsV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_satu_i32_ovfl(tmp_1, tmp_0, RsV, 8);
gen_set_usr_field_if(ctx, USR_OVF,tmp_1);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_A2_satb(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* { RdV = fSATN(8, RsV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_temp_new_i32();
gen_sat_i32_ovfl(tmp_1, tmp_0, RsV, 8);
gen_set_usr_field_if(ctx, USR_OVF,tmp_1);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_A2_vaddub(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i = 0; i < 8; i++) { fSETBYTE(i,RddV,(fGETUBYTE(i,RssV)+fGETUBYTE(i,RttV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 8, 8);
}
}

void emit_A2_vaddubs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i = 0; i < 8; i++) { fSETBYTE(i,RddV,fSATUN(8,fGETUBYTE(i,RssV)+fGETUBYTE(i,RttV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_satu_i64_ovfl(tmp_4, tmp_3, tmp_2, 8);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 8, 8);
}
}

void emit_A2_vaddh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV,fGETHALF(i,RssV)+fGETHALF(i,RttV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 16, 16);
}
}

void emit_A2_vaddhs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV,fSATN(16,fGETHALF(i,RssV)+fGETHALF(i,RttV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 16, 16);
}
}

void emit_A2_vadduhs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV,fSATUN(16,fGETUHALF(i,RssV)+fGETUHALF(i,RttV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_satu_i64_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 16, 16);
}
}

void emit_A5_vaddhubs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i=0;i<4;i++) { fSETBYTE(i,RdV,fSATUN(8, fGETHALF(i,RssV)+fGETHALF(i,RttV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_satu_i64_ovfl(tmp_4, tmp_3, tmp_2, 8);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_3);
tcg_gen_deposit_i32(RdV, RdV, tmp_5, i * 8, 8);
}
}

void emit_A2_vaddw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV,fGETWORD(i,RssV)+fGETWORD(i,RttV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, i * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 32, 32);
}
}

void emit_A2_vaddws(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV,fSATN(32,fGETWORD(i,RssV)+fGETWORD(i,RttV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, i * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_4, tmp_3, tmp_2, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 32, 32);
}
}

void emit_S4_vxaddsubw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(0,RddV,fSATN(32, fGETWORD(0,RssV)+fGETWORD(1,RttV))); fSETWORD(1,RddV,fSATN(32, fGETWORD(1,RssV)-fGETWORD(0,RttV))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_4, tmp_3, tmp_2, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_6, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_7, tmp_5, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
tcg_gen_deposit_i64(RddV, RddV, tmp_8, ((int32_t) 0x1) * 32, 32);
}

void emit_S4_vxsubaddw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETWORD(0,RddV,fSATN(32, fGETWORD(0,RssV)-fGETWORD(1,RttV))); fSETWORD(1,RddV,fSATN(32, fGETWORD(1,RssV)+fGETWORD(0,RttV))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_4, tmp_3, tmp_2, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RssV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_6, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_5, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
tcg_gen_deposit_i64(RddV, RddV, tmp_8, ((int32_t) 0x1) * 32, 32);
}

void emit_S4_vxaddsubh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETHALF(0,RddV,fSATN(16, fGETHALF(0,RssV)+fGETHALF(1,RttV))); fSETHALF(1,RddV,fSATN(16, fGETHALF(1,RssV)-fGETHALF(0,RttV))); fSETHALF(2,RddV,fSATN(16, fGETHALF(2,RssV)+fGETHALF(3,RttV))); fSETHALF(3,RddV,fSATN(16, fGETHALF(3,RssV)-fGETHALF(2,RttV))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_6, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_7, tmp_5, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
tcg_gen_deposit_i64(RddV, RddV, tmp_8, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_12, tmp_10, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
TCGv_i32 tmp_14 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_14, tmp_13, tmp_12, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_14);
tcg_gen_deposit_i64(RddV, RddV, tmp_13, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_15, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_16, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_17, tmp_15, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i32 tmp_19 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_19, tmp_18, tmp_17, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_19);
tcg_gen_deposit_i64(RddV, RddV, tmp_18, ((int32_t) 0x3) * 16, 16);
}

void emit_S4_vxsubaddh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETHALF(0,RddV,fSATN(16, fGETHALF(0,RssV)-fGETHALF(1,RttV))); fSETHALF(1,RddV,fSATN(16, fGETHALF(1,RssV)+fGETHALF(0,RttV))); fSETHALF(2,RddV,fSATN(16, fGETHALF(2,RssV)-fGETHALF(3,RttV))); fSETHALF(3,RddV,fSATN(16, fGETHALF(3,RssV)+fGETHALF(2,RttV))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_6, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_5, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_9, tmp_8, tmp_7, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_9);
tcg_gen_deposit_i64(RddV, RddV, tmp_8, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_12, tmp_10, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
TCGv_i32 tmp_14 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_14, tmp_13, tmp_12, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_14);
tcg_gen_deposit_i64(RddV, RddV, tmp_13, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_15, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_16, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_17, tmp_15, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i32 tmp_19 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_19, tmp_18, tmp_17, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_19);
tcg_gen_deposit_i64(RddV, RddV, tmp_18, ((int32_t) 0x3) * 16, 16);
}

void emit_S4_vxaddsubhr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETHALF(0,RddV,fSATN(16, (fGETHALF(0,RssV)+fGETHALF(1,RttV)+1)>>1)); fSETHALF(1,RddV,fSATN(16, (fGETHALF(1,RssV)-fGETHALF(0,RttV)+1)>>1)); fSETHALF(2,RddV,fSATN(16, (fGETHALF(2,RssV)+fGETHALF(3,RttV)+1)>>1)); fSETHALF(3,RddV,fSATN(16, (fGETHALF(3,RssV)-fGETHALF(2,RttV)+1)>>1)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_3, tmp_2, qemu_tmp_0);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_4, tmp_3, shift);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
TCGv_i32 tmp_6 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_6, tmp_5, tmp_4, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_6);
tcg_gen_deposit_i64(RddV, RddV, tmp_5, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_9, tmp_7, tmp_8);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_10, tmp_9, qemu_tmp_2);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_3;
if (qemu_tmp_3 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_11, tmp_10, shift);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
TCGv_i32 tmp_13 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_13, tmp_12, tmp_11, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_13);
tcg_gen_deposit_i64(RddV, RddV, tmp_12, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_14, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_15, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_16, tmp_14, tmp_15);
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_17, tmp_16, qemu_tmp_4);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_5;
if (qemu_tmp_5 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_18, tmp_17, shift);
}
TCGv_i64 tmp_19 = tcg_temp_new_i64();
TCGv_i32 tmp_20 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_20, tmp_19, tmp_18, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_20);
tcg_gen_deposit_i64(RddV, RddV, tmp_19, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_21, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_22, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_23, tmp_21, tmp_22);
int64_t qemu_tmp_6 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_24, tmp_23, qemu_tmp_6);
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_7;
if (qemu_tmp_7 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_25, tmp_24, shift);
}
TCGv_i64 tmp_26 = tcg_temp_new_i64();
TCGv_i32 tmp_27 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_27, tmp_26, tmp_25, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_27);
tcg_gen_deposit_i64(RddV, RddV, tmp_26, ((int32_t) 0x3) * 16, 16);
}

void emit_S4_vxsubaddhr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETHALF(0,RddV,fSATN(16, (fGETHALF(0,RssV)-fGETHALF(1,RttV)+1)>>1)); fSETHALF(1,RddV,fSATN(16, (fGETHALF(1,RssV)+fGETHALF(0,RttV)+1)>>1)); fSETHALF(2,RddV,fSATN(16, (fGETHALF(2,RssV)-fGETHALF(3,RttV)+1)>>1)); fSETHALF(3,RddV,fSATN(16, (fGETHALF(3,RssV)+fGETHALF(2,RttV)+1)>>1)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_3, tmp_2, qemu_tmp_0);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_4, tmp_3, shift);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
TCGv_i32 tmp_6 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_6, tmp_5, tmp_4, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_6);
tcg_gen_deposit_i64(RddV, RddV, tmp_5, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RssV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_8, RttV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_9, tmp_7, tmp_8);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_10, tmp_9, qemu_tmp_2);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_3;
if (qemu_tmp_3 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_11, tmp_10, shift);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
TCGv_i32 tmp_13 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_13, tmp_12, tmp_11, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_13);
tcg_gen_deposit_i64(RddV, RddV, tmp_12, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_14, RssV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_15, RttV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_16, tmp_14, tmp_15);
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_17, tmp_16, qemu_tmp_4);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_5;
if (qemu_tmp_5 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_18, tmp_17, shift);
}
TCGv_i64 tmp_19 = tcg_temp_new_i64();
TCGv_i32 tmp_20 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_20, tmp_19, tmp_18, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_20);
tcg_gen_deposit_i64(RddV, RddV, tmp_19, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_21, RssV, ((int32_t) 0x3) * 16, 16);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_22, RttV, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_23, tmp_21, tmp_22);
int64_t qemu_tmp_6 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_24, tmp_23, qemu_tmp_6);
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_7;
if (qemu_tmp_7 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_25, tmp_24, shift);
}
TCGv_i64 tmp_26 = tcg_temp_new_i64();
TCGv_i32 tmp_27 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_27, tmp_26, tmp_25, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_27);
tcg_gen_deposit_i64(RddV, RddV, tmp_26, ((int32_t) 0x3) * 16, 16);
}

void emit_A2_svavgh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { int i; for (i=0;i<2;i++) { fSETHALF(i,RdV,((fGETHALF(i,RsV)+fGETHALF(i,RtV))>>1)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, i * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, i * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
{
int32_t shift = ((int32_t) 0x1);
if (((int32_t) 0x1) >= 32) {
    shift = 32 - 1;
}
tcg_gen_sari_i32(tmp_3, tmp_2, shift);
}
tcg_gen_deposit_i32(RdV, RdV, tmp_3, i * 16, 16);
}
}

void emit_A2_svavghs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { int i; for (i=0;i<2;i++) { fSETHALF(i,RdV,((fGETHALF(i,RsV)+fGETHALF(i,RtV)+1)>>1)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, i * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, i * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_3, tmp_2, ((int32_t) 0x1));
TCGv_i32 tmp_4 = tcg_temp_new_i32();
{
int32_t shift = ((int32_t) 0x1);
if (((int32_t) 0x1) >= 32) {
    shift = 32 - 1;
}
tcg_gen_sari_i32(tmp_4, tmp_3, shift);
}
tcg_gen_deposit_i32(RdV, RdV, tmp_4, i * 16, 16);
}
}

void emit_A2_svnavgh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* { int i; for (i=0;i<2;i++) { fSETHALF(i,RdV,((fGETHALF(i,RtV)-fGETHALF(i,RsV))>>1)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, i * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, i * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
{
int32_t shift = ((int32_t) 0x1);
if (((int32_t) 0x1) >= 32) {
    shift = 32 - 1;
}
tcg_gen_sari_i32(tmp_3, tmp_2, shift);
}
tcg_gen_deposit_i32(RdV, RdV, tmp_3, i * 16, 16);
}
}

void emit_A2_svaddh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { int i; for (i=0;i<2;i++) { fSETHALF(i,RdV,fGETHALF(i,RsV)+fGETHALF(i,RtV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, i * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, i * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_2, tmp_0, tmp_1);
tcg_gen_deposit_i32(RdV, RdV, tmp_2, i * 16, 16);
}
}

void emit_A2_svaddhs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { int i; for (i=0;i<2;i++) { fSETHALF(i,RdV,fSATN(16,fGETHALF(i,RsV)+fGETHALF(i,RtV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, i * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, i * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i32_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
tcg_gen_deposit_i32(RdV, RdV, tmp_3, i * 16, 16);
}
}

void emit_A2_svadduhs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { int i; for (i=0;i<2;i++) { fSETHALF(i,RdV,fSATUN(16,fGETUHALF(i,RsV)+fGETUHALF(i,RtV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, i * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RtV, i * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_satu_i32_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
tcg_gen_deposit_i32(RdV, RdV, tmp_3, i * 16, 16);
}
}

void emit_A2_svsubh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* { int i; for (i=0;i<2;i++) { fSETHALF(i,RdV,fGETHALF(i,RtV)-fGETHALF(i,RsV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, i * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, i * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_2, tmp_0, tmp_1);
tcg_gen_deposit_i32(RdV, RdV, tmp_2, i * 16, 16);
}
}

void emit_A2_svsubhs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* { int i; for (i=0;i<2;i++) { fSETHALF(i,RdV,fSATN(16,fGETHALF(i,RtV)-fGETHALF(i,RsV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, i * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RsV, i * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i32_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
tcg_gen_deposit_i32(RdV, RdV, tmp_3, i * 16, 16);
}
}

void emit_A2_svsubuhs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV)
/* { int i; for (i=0;i<2;i++) { fSETHALF(i,RdV,fSATUN(16,fGETUHALF(i,RtV)-fGETUHALF(i,RsV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RtV, i * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, RsV, i * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_satu_i32_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
tcg_gen_deposit_i32(RdV, RdV, tmp_3, i * 16, 16);
}
}

void emit_A2_vraddub(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; RddV = 0; for (i=0;i<4;i++) { fSETWORD(0,RddV,(fGETWORD(0,RddV) + (fGETUBYTE(i,RssV)+fGETUBYTE(i,RttV)))); } for (i=4;i<8;i++) { fSETWORD(1,RddV,(fGETWORD(1,RddV) + (fGETUBYTE(i,RssV)+fGETUBYTE(i,RttV)))); } } */
{
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
tcg_gen_movi_i64(RddV, qemu_tmp_0);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RddV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RssV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_2, RttV, i * 8, 8);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_3, tmp_1, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_4, tmp_0, tmp_3);
tcg_gen_deposit_i64(RddV, RddV, tmp_4, ((int32_t) 0x0) * 32, 32);
}
for (int i = ((int32_t) 0x4); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RddV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_6, RssV, i * 8, 8);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_7, RttV, i * 8, 8);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_8, tmp_6, tmp_7);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_9, tmp_5, tmp_8);
tcg_gen_deposit_i64(RddV, RddV, tmp_9, ((int32_t) 0x1) * 32, 32);
}
}

void emit_A2_vraddub_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i = 0; i < 4; i++) { fSETWORD(0,RxxV,(fGETWORD(0,RxxV) + (fGETUBYTE(i,RssV)+fGETUBYTE(i,RttV)))); } for (i = 4; i < 8; i++) { fSETWORD(1,RxxV,(fGETWORD(1,RxxV) + (fGETUBYTE(i,RssV)+fGETUBYTE(i,RttV)))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RssV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_2, RttV, i * 8, 8);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_3, tmp_1, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_4, tmp_0, tmp_3);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_4, ((int32_t) 0x0) * 32, 32);
}
for (int i = ((int32_t) 0x4); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_6, RssV, i * 8, 8);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_7, RttV, i * 8, 8);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_8, tmp_6, tmp_7);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_9, tmp_5, tmp_8);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_9, ((int32_t) 0x1) * 32, 32);
}
}

void emit_M2_vraddh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; RdV = 0; for (i=0;i<4;i++) { RdV += (fGETHALF(i,RssV)+fGETHALF(i,RttV)); } } */
{
tcg_gen_movi_i32(RdV, ((int32_t) 0x0));
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, RdV);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_4, tmp_3, tmp_2);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_mov_i32(RdV, tmp_5);
}
}

void emit_M2_vradduh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; RdV = 0; for (i=0;i<4;i++) { RdV += (fGETUHALF(i,RssV)+fGETUHALF(i,RttV)); } } */
{
tcg_gen_movi_i32(RdV, ((int32_t) 0x0));
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, RdV);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_4, tmp_3, tmp_2);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_mov_i32(RdV, tmp_5);
}
}

void emit_A2_vsubub(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i = 0; i < 8; i++) { fSETBYTE(i,RddV,(fGETUBYTE(i,RttV)-fGETUBYTE(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RttV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RssV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 8, 8);
}
}

void emit_A2_vsububs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i = 0; i < 8; i++) { fSETBYTE(i,RddV,fSATUN(8,fGETUBYTE(i,RttV)-fGETUBYTE(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RttV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RssV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_satu_i64_ovfl(tmp_4, tmp_3, tmp_2, 8);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 8, 8);
}
}

void emit_A2_vsubh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV,fGETHALF(i,RttV)-fGETHALF(i,RssV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 16, 16);
}
}

void emit_A2_vsubhs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV,fSATN(16,fGETHALF(i,RttV)-fGETHALF(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 16, 16);
}
}

void emit_A2_vsubuhs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV,fSATUN(16,fGETUHALF(i,RttV)-fGETUHALF(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RttV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RssV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_satu_i64_ovfl(tmp_4, tmp_3, tmp_2, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 16, 16);
}
}

void emit_A2_vsubw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV,fGETWORD(i,RttV)-fGETWORD(i,RssV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, i * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, i * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 32, 32);
}
}

void emit_A2_vsubws(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV,fSATN(32,fGETWORD(i,RttV)-fGETWORD(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, i * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, i * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_4, tmp_3, tmp_2, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_4);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 32, 32);
}
}

void emit_A2_vabsh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV,fABS(fGETHALF(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_abs_i64(tmp_1, tmp_0);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, i * 16, 16);
}
}

void emit_A2_vabshsat(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV,fSATN(16, fABS(fGETHALF(i,RssV)))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_abs_i64(tmp_1, tmp_0);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
TCGv_i32 tmp_3 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_3, tmp_2, tmp_1, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_3);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 16, 16);
}
}

void emit_A2_vabsw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV,fABS(fGETWORD(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_abs_i64(tmp_1, tmp_0);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, i * 32, 32);
}
}

void emit_A2_vabswsat(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV,fSATN(32, fABS(fGETWORD(i,RssV)))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_abs_i64(tmp_1, tmp_0);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
TCGv_i32 tmp_3 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_3, tmp_2, tmp_1, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_3);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 32, 32);
}
}

void emit_M2_vabsdiffw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV,fABS(fGETWORD(i,RttV) - fGETWORD(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, i * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, i * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_abs_i64(tmp_3, tmp_2);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 32, 32);
}
}

void emit_M2_vabsdiffh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV,fABS(fGETHALF(i,RttV) - fGETHALF(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_abs_i64(tmp_3, tmp_2);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 16, 16);
}
}

void emit_M6_vabsdiffb(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i=0;i<8;i++) { fSETBYTE(i,RddV,fABS(fGETBYTE(i,RttV) - fGETBYTE(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_abs_i64(tmp_3, tmp_2);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 8, 8);
}
}

void emit_M6_vabsdiffub(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i=0;i<8;i++) { fSETBYTE(i,RddV,fABS(fGETUBYTE(i,RttV) - fGETUBYTE(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RttV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RssV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_abs_i64(tmp_3, tmp_2);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 8, 8);
}
}

void emit_A2_vrsadub(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; RddV = 0; for (i = 0; i < 4; i++) { fSETWORD(0,RddV,(fGETWORD(0,RddV) + fABS((fGETUBYTE(i,RssV) - fGETUBYTE(i,RttV))))); } for (i = 4; i < 8; i++) { fSETWORD(1,RddV,(fGETWORD(1,RddV) + fABS((fGETUBYTE(i,RssV) - fGETUBYTE(i,RttV))))); } } */
{
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
tcg_gen_movi_i64(RddV, qemu_tmp_0);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RddV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RssV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_2, RttV, i * 8, 8);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_3, tmp_1, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_abs_i64(tmp_4, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_5, tmp_0, tmp_4);
tcg_gen_deposit_i64(RddV, RddV, tmp_5, ((int32_t) 0x0) * 32, 32);
}
for (int i = ((int32_t) 0x4); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_6, RddV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_7, RssV, i * 8, 8);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_8, RttV, i * 8, 8);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_9, tmp_7, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_abs_i64(tmp_10, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_11, tmp_6, tmp_10);
tcg_gen_deposit_i64(RddV, RddV, tmp_11, ((int32_t) 0x1) * 32, 32);
}
}

void emit_A2_vrsadub_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i = 0; i < 4; i++) { fSETWORD(0,RxxV,(fGETWORD(0,RxxV) + fABS((fGETUBYTE(i,RssV) - fGETUBYTE(i,RttV))))); } for (i = 4; i < 8; i++) { fSETWORD(1,RxxV,(fGETWORD(1,RxxV) + fABS((fGETUBYTE(i,RssV) - fGETUBYTE(i,RttV))))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RssV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_2, RttV, i * 8, 8);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_3, tmp_1, tmp_2);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_abs_i64(tmp_4, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_5, tmp_0, tmp_4);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_5, ((int32_t) 0x0) * 32, 32);
}
for (int i = ((int32_t) 0x4); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_6, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_7, RssV, i * 8, 8);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_8, RttV, i * 8, 8);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_9, tmp_7, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_abs_i64(tmp_10, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_11, tmp_6, tmp_10);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_11, ((int32_t) 0x1) * 32, 32);
}
}

void emit_A2_vavgub(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i = 0; i < 8; i++) { fSETBYTE(i,RddV,((fGETUBYTE(i,RssV) + fGETUBYTE(i,RttV))>>1)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shri_i64(tmp_3, tmp_2, qemu_tmp_0);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 8, 8);
}
}

void emit_A2_vavguh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV,(fGETUHALF(i,RssV)+fGETUHALF(i,RttV))>>1); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shri_i64(tmp_3, tmp_2, qemu_tmp_0);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 16, 16);
}
}

void emit_A2_vavgh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV,(fGETHALF(i,RssV)+fGETHALF(i,RttV))>>1); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_3, tmp_2, shift);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 16, 16);
}
}

void emit_A2_vnavgh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV,(fGETHALF(i,RttV)-fGETHALF(i,RssV))>>1); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_3, tmp_2, shift);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 16, 16);
}
}

void emit_A2_vavgw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV,(fSXTN(32,33,fGETWORD(i,RssV))+fSXTN(32,33,fGETWORD(i,RttV)))>>1); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 32, 32);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, i * 32, 32);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_3, tmp_2, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_3, 0);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_4, tmp_1, tmp_3);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_5, tmp_4, shift);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_5, i * 32, 32);
}
}

void emit_A2_vnavgw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV,(fSXTN(32,33,fGETWORD(i,RttV))-fSXTN(32,33,fGETWORD(i,RssV)))>>1); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, i * 32, 32);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RssV, i * 32, 32);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_3, tmp_2, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_3, 0);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_4, tmp_1, tmp_3);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_5, tmp_4, shift);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_5, i * 32, 32);
}
}

void emit_A2_vavgwr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV,(fSXTN(32,33,fGETWORD(i,RssV))+fSXTN(32,33,fGETWORD(i,RttV))+1)>>1); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 32, 32);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, i * 32, 32);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_3, tmp_2, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_3, 0);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_4, tmp_1, tmp_3);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_2);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_3;
if (qemu_tmp_3 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_6, tmp_5, shift);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_6, i * 32, 32);
}
}

void emit_A2_vnavgwr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV,fSATN(32, (fSXTN(32,33,fGETWORD(i,RttV))-fSXTN(32,33,fGETWORD(i,RssV))+1)>>1)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, i * 32, 32);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RssV, i * 32, 32);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_3, tmp_2, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_3, 0);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_4, tmp_1, tmp_3);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_2);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_3;
if (qemu_tmp_3 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_6, tmp_5, shift);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i32 tmp_8 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_8, tmp_7, tmp_6, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_8);
tcg_gen_deposit_i64(RddV, RddV, tmp_7, i * 32, 32);
}
}

void emit_A2_vavgwcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV,(fCRND(fSXTN(32,33,fGETWORD(i,RssV))+fSXTN(32,33,fGETWORD(i,RttV)))>>1)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 32, 32);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RttV, i * 32, 32);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_3, tmp_2, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_3, 0);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_4, tmp_1, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
TCGv_i64 tmp_6 = tcg_constant_i64(0x3);
TCGv_i64 tmp_7 = tcg_constant_i64(1);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_8, tmp_4, tmp_6);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_9, tmp_4, tmp_7);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_5, tmp_8, tmp_6, tmp_9, tmp_4);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_10, tmp_5, shift);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_10, i * 32, 32);
}
}

void emit_A2_vnavgwcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV,fSATN(32, fCRND(fSXTN(32,33,fGETWORD(i,RttV))-fSXTN(32,33,fGETWORD(i,RssV)))>>1)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, i * 32, 32);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RssV, i * 32, 32);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_3, tmp_2, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_3, 0);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_4, tmp_1, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
TCGv_i64 tmp_6 = tcg_constant_i64(0x3);
TCGv_i64 tmp_7 = tcg_constant_i64(1);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_8, tmp_4, tmp_6);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_9, tmp_4, tmp_7);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_5, tmp_8, tmp_6, tmp_9, tmp_4);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_10, tmp_5, shift);
}
TCGv_i64 tmp_11 = tcg_temp_new_i64();
TCGv_i32 tmp_12 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_12, tmp_11, tmp_10, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_12);
tcg_gen_deposit_i64(RddV, RddV, tmp_11, i * 32, 32);
}
}

void emit_A2_vavghcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV,fCRND(fGETHALF(i,RssV)+fGETHALF(i,RttV))>>1); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
TCGv_i64 tmp_4 = tcg_constant_i64(0x3);
TCGv_i64 tmp_5 = tcg_constant_i64(1);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_6, tmp_2, tmp_4);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_2, tmp_5);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_3, tmp_6, tmp_4, tmp_7, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_8, tmp_3, shift);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_8, i * 16, 16);
}
}

void emit_A2_vnavghcr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV,fSATN(16, fCRND(fGETHALF(i,RttV)-fGETHALF(i,RssV))>>1)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_2, tmp_0, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
TCGv_i64 tmp_4 = tcg_constant_i64(0x3);
TCGv_i64 tmp_5 = tcg_constant_i64(1);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_6, tmp_2, tmp_4);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_7, tmp_2, tmp_5);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_3, tmp_6, tmp_4, tmp_7, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_8, tmp_3, shift);
}
TCGv_i64 tmp_9 = tcg_temp_new_i64();
TCGv_i32 tmp_10 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_10, tmp_9, tmp_8, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_10);
tcg_gen_deposit_i64(RddV, RddV, tmp_9, i * 16, 16);
}
}

void emit_A2_vavguw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV,(fZXTN(32,33,fGETUWORD(i,RssV))+fZXTN(32,33,fGETUWORD(i,RttV)))>>1); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, i * 32, 32);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_2, RttV, i * 32, 32);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_extract_i64(tmp_3, tmp_2, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_3, 0);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_4, tmp_1, tmp_3);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shri_i64(tmp_5, tmp_4, qemu_tmp_2);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_5, i * 32, 32);
}
}

void emit_A2_vavguwr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV,(fZXTN(32,33,fGETUWORD(i,RssV))+fZXTN(32,33,fGETUWORD(i,RttV))+1)>>1); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, i * 32, 32);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_2, RttV, i * 32, 32);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_extract_i64(tmp_3, tmp_2, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_3, 0);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_4, tmp_1, tmp_3);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_5, tmp_4, qemu_tmp_2);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_3;
if (qemu_tmp_3 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_6, tmp_5, shift);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_6, i * 32, 32);
}
}

void emit_A2_vavgubr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i = 0; i < 8; i++) { fSETBYTE(i,RddV,((fGETUBYTE(i,RssV)+fGETUBYTE(i,RttV)+1)>>1)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_3, tmp_2, qemu_tmp_0);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_4, tmp_3, shift);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_4, i * 8, 8);
}
}

void emit_A2_vavguhr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV,(fGETUHALF(i,RssV)+fGETUHALF(i,RttV)+1)>>1); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_3, tmp_2, qemu_tmp_0);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_4, tmp_3, shift);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_4, i * 16, 16);
}
}

void emit_A2_vavghr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV,(fGETHALF(i,RssV)+fGETHALF(i,RttV)+1)>>1); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_3, tmp_2, qemu_tmp_0);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_4, tmp_3, shift);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_4, i * 16, 16);
}
}

void emit_A2_vnavghr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV,fSATN(16, (fGETHALF(i,RttV)-fGETHALF(i,RssV)+1)>>1)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_2, tmp_0, tmp_1);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_3, tmp_2, qemu_tmp_0);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_1;
if (qemu_tmp_1 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_4, tmp_3, shift);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
TCGv_i32 tmp_6 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_6, tmp_5, tmp_4, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_6);
tcg_gen_deposit_i64(RddV, RddV, tmp_5, i * 16, 16);
}
}

void emit_A4_round_ri(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* {RdV = fRNDN(RsV,uiV)>>uiV; } */
{
TCGv_i64 tmp_0 = tcg_constant_i64(0);
TCGv_i64 tmp_1 = tcg_constant_i64(1);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, RsV);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)uiV;
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x5);
uint64_t qemu_tmp_3 = 0;
if (qemu_tmp_2 != 0) {
qemu_tmp_3 = extract64(qemu_tmp_1, 0, qemu_tmp_2);
}
TCGv_i64 tmp_5 = tcg_constant_i64((int64_t) (qemu_tmp_3));
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, tmp_5, tmp_1);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_7, tmp_1, tmp_6);
TCGv_i64 tmp_8 = tcg_constant_i64(0);
TCGv_i64 tmp_9 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_7, tmp_6, tmp_9, tmp_8, tmp_7);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_10, tmp_7, tmp_4);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_2, tmp_5, tmp_0, tmp_4, tmp_10);
int64_t qemu_tmp_4 = (int64_t)uiV;
TCGv_i64 tmp_11 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_4;
if (qemu_tmp_4 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_11, tmp_2, shift);
}
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_12, tmp_11);
tcg_gen_mov_i32(RdV, tmp_12);
}

void emit_A4_round_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV = fRNDN(RsV,fZXTN(5,32,RtV))>>fZXTN(5,32,RtV); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x5);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_constant_i64(0);
TCGv_i64 tmp_3 = tcg_constant_i64(1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RsV);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_extract_i64(tmp_7, tmp_1, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_7, 0);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_8, tmp_7, tmp_3);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_9, tmp_3, tmp_8);
TCGv_i64 tmp_10 = tcg_constant_i64(0);
TCGv_i64 tmp_11 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_9, tmp_8, tmp_11, tmp_10, tmp_9);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_12, tmp_9, tmp_6);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_4, tmp_7, tmp_2, tmp_6, tmp_12);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, RtV);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x5);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_extract_i64(tmp_14, tmp_13, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_14, 0);
}
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_15, tmp_4, tmp_14);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i64 tmp_17 = tcg_constant_i64(0);
TCGv_i64 tmp_18 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_16, tmp_4, 63, 1);
tcg_gen_sub_i64(tmp_16, tmp_17, tmp_16);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_15, tmp_14, tmp_18, tmp_16, tmp_15);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_19, tmp_15);
tcg_gen_mov_i32(RdV, tmp_19);
}

void emit_A4_round_ri_sat(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* {RdV = (fSATN(32, fRNDN(RsV,uiV)))>>uiV; } */
{
TCGv_i64 tmp_0 = tcg_constant_i64(0);
TCGv_i64 tmp_1 = tcg_constant_i64(1);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, RsV);
uint64_t qemu_tmp_0 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
int64_t qemu_tmp_1 = (int64_t)uiV;
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x5);
uint64_t qemu_tmp_3 = 0;
if (qemu_tmp_2 != 0) {
qemu_tmp_3 = extract64(qemu_tmp_1, 0, qemu_tmp_2);
}
TCGv_i64 tmp_5 = tcg_constant_i64((int64_t) (qemu_tmp_3));
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_6, tmp_5, tmp_1);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_7, tmp_1, tmp_6);
TCGv_i64 tmp_8 = tcg_constant_i64(0);
TCGv_i64 tmp_9 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_7, tmp_6, tmp_9, tmp_8, tmp_7);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_10, tmp_7, tmp_4);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_2, tmp_5, tmp_0, tmp_4, tmp_10);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
TCGv_i32 tmp_12 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_12, tmp_11, tmp_2, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_12);
int64_t qemu_tmp_4 = (int64_t)uiV;
TCGv_i64 tmp_13 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_4;
if (qemu_tmp_4 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_13, tmp_11, shift);
}
TCGv_i32 tmp_14 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_14, tmp_13);
tcg_gen_mov_i32(RdV, tmp_14);
}

void emit_A4_round_rr_sat(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV = (fSATN(32, fRNDN(RsV,fZXTN(5,32,RtV))))>>fZXTN(5,32,RtV); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x5);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_constant_i64(0);
TCGv_i64 tmp_3 = tcg_constant_i64(1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RsV);
uint64_t qemu_tmp_1 = (uint64_t)((uint32_t) 0x20);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
uint64_t qemu_tmp_2 = (uint64_t)((uint32_t) 0x5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_extract_i64(tmp_7, tmp_1, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_7, 0);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_8, tmp_7, tmp_3);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_9, tmp_3, tmp_8);
TCGv_i64 tmp_10 = tcg_constant_i64(0);
TCGv_i64 tmp_11 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_9, tmp_8, tmp_11, tmp_10, tmp_9);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_12, tmp_9, tmp_6);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_4, tmp_7, tmp_2, tmp_6, tmp_12);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
TCGv_i32 tmp_14 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_14, tmp_13, tmp_4, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_14);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_15, RtV);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x5);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_extract_i64(tmp_16, tmp_15, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_16, 0);
}
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_17, tmp_13, tmp_16);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i64 tmp_19 = tcg_constant_i64(0);
TCGv_i64 tmp_20 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_18, tmp_13, 63, 1);
tcg_gen_sub_i64(tmp_18, tmp_19, tmp_18);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_17, tmp_16, tmp_20, tmp_18, tmp_17);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_21, tmp_17);
tcg_gen_mov_i32(RdV, tmp_21);
}

void emit_A4_cround_ri(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* {RdV = fCRNDN(RsV,uiV); } */
{
TCGv_i64 tmp_0 = tcg_constant_i64(0);
TCGv_i32 tmp_1 = tcg_constant_i32(1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i64 tmp_3 = tcg_temp_new_i64();
TCGv_i32 tmp_4 = tcg_temp_new_i32();
TCGv_i64 tmp_5 = tcg_temp_new_i64();
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_constant_i32((int32_t) (uiV));
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_8, RsV);
TCGv_i32 tmp_9 = tcg_constant_i32(1);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
TCGv_i32 tmp_11 = tcg_temp_new_i32();
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_10, RsV);
tcg_gen_shl_i32(tmp_11, tmp_9, tmp_7);
tcg_gen_and_i32(tmp_11, tmp_11, RsV);
tcg_gen_shri_i32(tmp_11, tmp_11, 1);
tcg_gen_ext_i32_i64(tmp_12, tmp_11);
tcg_gen_add_i64(tmp_10, tmp_10, tmp_12);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
TCGv_i32 tmp_14 = tcg_constant_i32(1);
TCGv_i32 tmp_15 = tcg_temp_new_i32();
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, RsV);
tcg_gen_subi_i32(tmp_15, tmp_7, 1);
tcg_gen_shl_i32(tmp_15, tmp_14, tmp_15);
tcg_gen_ext_i32_i64(tmp_16, tmp_15);
tcg_gen_add_i64(tmp_13, tmp_13, tmp_16);
tcg_gen_sub_i32(tmp_4, tmp_7, tmp_1);
tcg_gen_shl_i32(tmp_4, tmp_1, tmp_4);
tcg_gen_sub_i32(tmp_4, tmp_4, tmp_1);
tcg_gen_and_i32(tmp_2, RsV, tmp_4);
tcg_gen_extu_i32_i64(tmp_3, tmp_2);
tcg_gen_ext_i32_i64(tmp_5, tmp_7);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_6, tmp_3, tmp_0, tmp_10, tmp_13);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_6, tmp_5, tmp_0, tmp_8, tmp_6);
tcg_gen_shr_i64(tmp_6, tmp_6, tmp_5);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_17, tmp_6);
tcg_gen_mov_i32(RdV, tmp_17);
}

void emit_A4_cround_rr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* {RdV = fCRNDN(RsV,fZXTN(5,32,RtV)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x5);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_constant_i64(0);
TCGv_i32 tmp_3 = tcg_constant_i32(1);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
TCGv_i64 tmp_5 = tcg_temp_new_i64();
TCGv_i32 tmp_6 = tcg_temp_new_i32();
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_1);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_10, RsV);
TCGv_i32 tmp_11 = tcg_constant_i32(1);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
TCGv_i32 tmp_13 = tcg_temp_new_i32();
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, RsV);
tcg_gen_shl_i32(tmp_13, tmp_11, tmp_9);
tcg_gen_and_i32(tmp_13, tmp_13, RsV);
tcg_gen_shri_i32(tmp_13, tmp_13, 1);
tcg_gen_ext_i32_i64(tmp_14, tmp_13);
tcg_gen_add_i64(tmp_12, tmp_12, tmp_14);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i32 tmp_16 = tcg_constant_i32(1);
TCGv_i32 tmp_17 = tcg_temp_new_i32();
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_15, RsV);
tcg_gen_subi_i32(tmp_17, tmp_9, 1);
tcg_gen_shl_i32(tmp_17, tmp_16, tmp_17);
tcg_gen_ext_i32_i64(tmp_18, tmp_17);
tcg_gen_add_i64(tmp_15, tmp_15, tmp_18);
tcg_gen_sub_i32(tmp_6, tmp_9, tmp_3);
tcg_gen_shl_i32(tmp_6, tmp_3, tmp_6);
tcg_gen_sub_i32(tmp_6, tmp_6, tmp_3);
tcg_gen_and_i32(tmp_4, RsV, tmp_6);
tcg_gen_extu_i32_i64(tmp_5, tmp_4);
tcg_gen_ext_i32_i64(tmp_7, tmp_9);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_8, tmp_5, tmp_2, tmp_12, tmp_15);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_8, tmp_7, tmp_2, tmp_10, tmp_8);
tcg_gen_shr_i64(tmp_8, tmp_8, tmp_7);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_19, tmp_8);
tcg_gen_mov_i32(RdV, tmp_19);
}

void emit_A7_clip(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* { (RdV = fMIN((1 << uiV) - 1, fMAX(RsV, -(1 << uiV))));} */
{
int32_t qemu_tmp_0 = ((int32_t) 0x1) << uiV;
int32_t qemu_tmp_1 = qemu_tmp_0 - ((int32_t) 0x1);
int32_t qemu_tmp_2 = ((int32_t) 0x1) << uiV;
int32_t qemu_tmp_3 = -(qemu_tmp_2);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (qemu_tmp_3));
tcg_gen_smax_i32(tmp_0, RsV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (qemu_tmp_1));
tcg_gen_smin_i32(tmp_2, tmp_3, tmp_0);
tcg_gen_mov_i32(RdV, tmp_2);
}

void emit_A7_vclip(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, int uiV)
/* { size4s_t tmp; (tmp = fMIN((1 << uiV) - 1, fMAX(fGETWORD(0, RssV), -(1 << uiV)))); fSETWORD(0, RddV, tmp); (tmp = fMIN((1 << uiV) - 1, fMAX(fGETWORD(1, RssV), -(1 << uiV)))); fSETWORD(1, RddV, tmp); } */
{
TCGv_i32 tmp = tcg_temp_new_i32();
int32_t qemu_tmp_0 = ((int32_t) 0x1) << uiV;
int32_t qemu_tmp_1 = qemu_tmp_0 - ((int32_t) 0x1);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, ((int32_t) 0x0) * 32, 32);
int32_t qemu_tmp_2 = ((int32_t) 0x1) << uiV;
int32_t qemu_tmp_3 = -(qemu_tmp_2);
int64_t qemu_tmp_4 = (int64_t)qemu_tmp_3;
TCGv_i64 tmp_1 = tcg_temp_new_i64();
TCGv_i64 tmp_2 = tcg_constant_i64((int64_t) (qemu_tmp_4));
tcg_gen_smax_i64(tmp_1, tmp_0, tmp_2);
int64_t qemu_tmp_5 = (int64_t)qemu_tmp_1;
TCGv_i64 tmp_3 = tcg_temp_new_i64();
TCGv_i64 tmp_4 = tcg_constant_i64((int64_t) (qemu_tmp_5));
tcg_gen_smin_i64(tmp_3, tmp_4, tmp_1);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_3);
tcg_gen_mov_i32(tmp, tmp_5);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp);
tcg_gen_deposit_i64(RddV, RddV, tmp_6, ((int32_t) 0x0) * 32, 32);
int32_t qemu_tmp_6 = ((int32_t) 0x1) << uiV;
int32_t qemu_tmp_7 = qemu_tmp_6 - ((int32_t) 0x1);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_7, RssV, ((int32_t) 0x1) * 32, 32);
int32_t qemu_tmp_8 = ((int32_t) 0x1) << uiV;
int32_t qemu_tmp_9 = -(qemu_tmp_8);
int64_t qemu_tmp_10 = (int64_t)qemu_tmp_9;
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i64 tmp_9 = tcg_constant_i64((int64_t) (qemu_tmp_10));
tcg_gen_smax_i64(tmp_8, tmp_7, tmp_9);
int64_t qemu_tmp_11 = (int64_t)qemu_tmp_7;
TCGv_i64 tmp_10 = tcg_temp_new_i64();
TCGv_i64 tmp_11 = tcg_constant_i64((int64_t) (qemu_tmp_11));
tcg_gen_smin_i64(tmp_10, tmp_11, tmp_8);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_12, tmp_10);
tcg_gen_mov_i32(tmp, tmp_12);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, tmp);
tcg_gen_deposit_i64(RddV, RddV, tmp_13, ((int32_t) 0x1) * 32, 32);
}

void emit_A4_vrminh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RuV)
/* { int i; size8s_t min; size4s_t addr; min = fGETHALF(0,RxxV); addr = fGETWORD(1,RxxV); for (i = 0; i < 4; i++) { if (min > fGETHALF(i,RssV)) { min = fGETHALF(i,RssV); addr = RuV | i<<1; } } fSETWORD(0,RxxV,min); fSETWORD(1,RxxV,addr); } */
{
TCGv_i64 min = tcg_temp_new_i64();
TCGv_i32 addr = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 16, 16);
tcg_gen_mov_i64(min, tmp_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(addr, tmp_2);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RssV, i * 16, 16);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_GT, tmp_4, min, tmp_3);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i64(TCG_COND_EQ, tmp_4, 0, if_label_0);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RssV, i * 16, 16);
tcg_gen_mov_i64(min, tmp_5);
int32_t qemu_tmp_0 = i << ((int32_t) 0x1);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_ori_i32(tmp_6, RuV, qemu_tmp_0);
tcg_gen_mov_i32(addr, tmp_6);
gen_set_label(if_label_0);
}
tcg_gen_deposit_i64(RxxV, RxxV, min, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_7, addr);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_7, ((int32_t) 0x1) * 32, 32);
}

void emit_A4_vrmaxh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RuV)
/* { int i; size8s_t max; size4s_t addr; max = fGETHALF(0,RxxV); addr = fGETWORD(1,RxxV); for (i = 0; i < 4; i++) { if (max < fGETHALF(i,RssV)) { max = fGETHALF(i,RssV); addr = RuV | i<<1; } } fSETWORD(0,RxxV,max); fSETWORD(1,RxxV,addr); } */
{
TCGv_i64 max = tcg_temp_new_i64();
TCGv_i32 addr = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 16, 16);
tcg_gen_mov_i64(max, tmp_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(addr, tmp_2);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RssV, i * 16, 16);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_LT, tmp_4, max, tmp_3);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i64(TCG_COND_EQ, tmp_4, 0, if_label_0);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RssV, i * 16, 16);
tcg_gen_mov_i64(max, tmp_5);
int32_t qemu_tmp_0 = i << ((int32_t) 0x1);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_ori_i32(tmp_6, RuV, qemu_tmp_0);
tcg_gen_mov_i32(addr, tmp_6);
gen_set_label(if_label_0);
}
tcg_gen_deposit_i64(RxxV, RxxV, max, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_7, addr);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_7, ((int32_t) 0x1) * 32, 32);
}

void emit_A4_vrminuh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RuV)
/* { int i; size8s_t min; size4s_t addr; min = fGETUHALF(0,RxxV); addr = fGETWORD(1,RxxV); for (i = 0; i < 4; i++) { if (min > fGETUHALF(i,RssV)) { min = fGETUHALF(i,RssV); addr = RuV | i<<1; } } fSETWORD(0,RxxV,min); fSETWORD(1,RxxV,addr); } */
{
TCGv_i64 min = tcg_temp_new_i64();
TCGv_i32 addr = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 16, 16);
tcg_gen_mov_i64(min, tmp_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(addr, tmp_2);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_3, RssV, i * 16, 16);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_GTU, tmp_4, min, tmp_3);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i64(TCG_COND_EQ, tmp_4, 0, if_label_0);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_5, RssV, i * 16, 16);
tcg_gen_mov_i64(min, tmp_5);
int32_t qemu_tmp_0 = i << ((int32_t) 0x1);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_ori_i32(tmp_6, RuV, qemu_tmp_0);
tcg_gen_mov_i32(addr, tmp_6);
gen_set_label(if_label_0);
}
tcg_gen_deposit_i64(RxxV, RxxV, min, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_7, addr);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_7, ((int32_t) 0x1) * 32, 32);
}

void emit_A4_vrmaxuh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RuV)
/* { int i; size8s_t max; size4s_t addr; max = fGETUHALF(0,RxxV); addr = fGETWORD(1,RxxV); for (i = 0; i < 4; i++) { if (max < fGETUHALF(i,RssV)) { max = fGETUHALF(i,RssV); addr = RuV | i<<1; } } fSETWORD(0,RxxV,max); fSETWORD(1,RxxV,addr); } */
{
TCGv_i64 max = tcg_temp_new_i64();
TCGv_i32 addr = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 16, 16);
tcg_gen_mov_i64(max, tmp_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(addr, tmp_2);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_3, RssV, i * 16, 16);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_LTU, tmp_4, max, tmp_3);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i64(TCG_COND_EQ, tmp_4, 0, if_label_0);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_5, RssV, i * 16, 16);
tcg_gen_mov_i64(max, tmp_5);
int32_t qemu_tmp_0 = i << ((int32_t) 0x1);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_ori_i32(tmp_6, RuV, qemu_tmp_0);
tcg_gen_mov_i32(addr, tmp_6);
gen_set_label(if_label_0);
}
tcg_gen_deposit_i64(RxxV, RxxV, max, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_7, addr);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_7, ((int32_t) 0x1) * 32, 32);
}

void emit_A4_vrminw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RuV)
/* { int i; size8s_t min; size4s_t addr; min = fGETWORD(0,RxxV); addr = fGETWORD(1,RxxV); for (i = 0; i < 2; i++) { if (min > fGETWORD(i,RssV)) { min = fGETWORD(i,RssV); addr = RuV | i<<2; } } fSETWORD(0,RxxV,min); fSETWORD(1,RxxV,addr); } */
{
TCGv_i64 min = tcg_temp_new_i64();
TCGv_i32 addr = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 32, 32);
tcg_gen_mov_i64(min, tmp_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(addr, tmp_2);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RssV, i * 32, 32);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_GT, tmp_4, min, tmp_3);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i64(TCG_COND_EQ, tmp_4, 0, if_label_0);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RssV, i * 32, 32);
tcg_gen_mov_i64(min, tmp_5);
int32_t qemu_tmp_0 = i << ((int32_t) 0x2);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_ori_i32(tmp_6, RuV, qemu_tmp_0);
tcg_gen_mov_i32(addr, tmp_6);
gen_set_label(if_label_0);
}
tcg_gen_deposit_i64(RxxV, RxxV, min, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_7, addr);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_7, ((int32_t) 0x1) * 32, 32);
}

void emit_A4_vrmaxw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RuV)
/* { int i; size8s_t max; size4s_t addr; max = fGETWORD(0,RxxV); addr = fGETWORD(1,RxxV); for (i = 0; i < 2; i++) { if (max < fGETWORD(i,RssV)) { max = fGETWORD(i,RssV); addr = RuV | i<<2; } } fSETWORD(0,RxxV,max); fSETWORD(1,RxxV,addr); } */
{
TCGv_i64 max = tcg_temp_new_i64();
TCGv_i32 addr = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 32, 32);
tcg_gen_mov_i64(max, tmp_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(addr, tmp_2);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RssV, i * 32, 32);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_LT, tmp_4, max, tmp_3);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i64(TCG_COND_EQ, tmp_4, 0, if_label_0);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, RssV, i * 32, 32);
tcg_gen_mov_i64(max, tmp_5);
int32_t qemu_tmp_0 = i << ((int32_t) 0x2);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_ori_i32(tmp_6, RuV, qemu_tmp_0);
tcg_gen_mov_i32(addr, tmp_6);
gen_set_label(if_label_0);
}
tcg_gen_deposit_i64(RxxV, RxxV, max, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_7, addr);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_7, ((int32_t) 0x1) * 32, 32);
}

void emit_A4_vrminuw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RuV)
/* { int i; size8s_t min; size4s_t addr; min = fGETUWORD(0,RxxV); addr = fGETWORD(1,RxxV); for (i = 0; i < 2; i++) { if (min > fGETUWORD(i,RssV)) { min = fGETUWORD(i,RssV); addr = RuV | i<<2; } } fSETWORD(0,RxxV,min); fSETWORD(1,RxxV,addr); } */
{
TCGv_i64 min = tcg_temp_new_i64();
TCGv_i32 addr = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 32, 32);
tcg_gen_mov_i64(min, tmp_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(addr, tmp_2);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_3, RssV, i * 32, 32);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_GTU, tmp_4, min, tmp_3);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i64(TCG_COND_EQ, tmp_4, 0, if_label_0);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_5, RssV, i * 32, 32);
tcg_gen_mov_i64(min, tmp_5);
int32_t qemu_tmp_0 = i << ((int32_t) 0x2);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_ori_i32(tmp_6, RuV, qemu_tmp_0);
tcg_gen_mov_i32(addr, tmp_6);
gen_set_label(if_label_0);
}
tcg_gen_deposit_i64(RxxV, RxxV, min, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_7, addr);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_7, ((int32_t) 0x1) * 32, 32);
}

void emit_A4_vrmaxuw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RuV)
/* { int i; size8s_t max; size4s_t addr; max = fGETUWORD(0,RxxV); addr = fGETWORD(1,RxxV); for (i = 0; i < 2; i++) { if (max < fGETUWORD(i,RssV)) { max = fGETUWORD(i,RssV); addr = RuV | i<<2; } } fSETWORD(0,RxxV,max); fSETWORD(1,RxxV,addr); } */
{
TCGv_i64 max = tcg_temp_new_i64();
TCGv_i32 addr = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RxxV, ((int32_t) 0x0) * 32, 32);
tcg_gen_mov_i64(max, tmp_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RxxV, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(addr, tmp_2);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_3, RssV, i * 32, 32);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_LTU, tmp_4, max, tmp_3);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i64(TCG_COND_EQ, tmp_4, 0, if_label_0);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_5, RssV, i * 32, 32);
tcg_gen_mov_i64(max, tmp_5);
int32_t qemu_tmp_0 = i << ((int32_t) 0x2);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_ori_i32(tmp_6, RuV, qemu_tmp_0);
tcg_gen_mov_i32(addr, tmp_6);
gen_set_label(if_label_0);
}
tcg_gen_deposit_i64(RxxV, RxxV, max, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_7, addr);
tcg_gen_deposit_i64(RxxV, RxxV, tmp_7, ((int32_t) 0x1) * 32, 32);
}

void emit_A2_vminb(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i = 0; i < 8; i++) { fSETBYTE(i,RddV,fMIN(fGETBYTE(i,RttV),fGETBYTE(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_smin_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 8, 8);
}
}

void emit_A2_vmaxb(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i = 0; i < 8; i++) { fSETBYTE(i,RddV,fMAX(fGETBYTE(i,RttV),fGETBYTE(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_smax_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 8, 8);
}
}

void emit_A2_vminub(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i = 0; i < 8; i++) { fSETBYTE(i,RddV,fMIN(fGETUBYTE(i,RttV),fGETUBYTE(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RttV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RssV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_umin_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 8, 8);
}
}

void emit_A2_vmaxub(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i = 0; i < 8; i++) { fSETBYTE(i,RddV,fMAX(fGETUBYTE(i,RttV),fGETUBYTE(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RttV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RssV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_umax_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 8, 8);
}
}

void emit_A2_vminh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i = 0; i < 4; i++) { fSETHALF(i,RddV,fMIN(fGETHALF(i,RttV),fGETHALF(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_smin_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 16, 16);
}
}

void emit_A2_vmaxh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i = 0; i < 4; i++) { fSETHALF(i,RddV,fMAX(fGETHALF(i,RttV),fGETHALF(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_smax_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 16, 16);
}
}

void emit_A2_vminuh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i = 0; i < 4; i++) { fSETHALF(i,RddV,fMIN(fGETUHALF(i,RttV),fGETUHALF(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RttV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RssV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_umin_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 16, 16);
}
}

void emit_A2_vmaxuh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i = 0; i < 4; i++) { fSETHALF(i,RddV,fMAX(fGETUHALF(i,RttV),fGETUHALF(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RttV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RssV, i * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_umax_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 16, 16);
}
}

void emit_A2_vminw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i = 0; i < 2; i++) { fSETWORD(i,RddV,fMIN(fGETWORD(i,RttV),fGETWORD(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, i * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, i * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_smin_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 32, 32);
}
}

void emit_A2_vmaxw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i = 0; i < 2; i++) { fSETWORD(i,RddV,fMAX(fGETWORD(i,RttV),fGETWORD(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, i * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, i * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_smax_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 32, 32);
}
}

void emit_A2_vminuw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i = 0; i < 2; i++) { fSETWORD(i,RddV,fMIN(fGETUWORD(i,RttV),fGETUWORD(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RttV, i * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RssV, i * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_umin_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 32, 32);
}
}

void emit_A2_vmaxuw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i = 0; i < 2; i++) { fSETWORD(i,RddV,fMAX(fGETUWORD(i,RttV),fGETUWORD(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RttV, i * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RssV, i * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_umax_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, i * 32, 32);
}
}

void emit_A6_vminub_RdP(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv PeV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i = 0; i < 8; i++) { fSETBIT(i, PeV, (fGETUBYTE(i,RttV) > fGETUBYTE(i,RssV))); fSETBYTE(i,RddV,fMIN(fGETUBYTE(i,RttV),fGETUBYTE(i,RssV))); } } */
{
tcg_gen_movi_i32(PeV, 0);
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RttV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RssV, i * 8, 8);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_setcond_i64(TCG_COND_GTU, tmp_2, tmp_0, tmp_1);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_2);
tcg_gen_deposit_i32(PeV, PeV, tmp_3, i * 1, 1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_4, RttV, i * 8, 8);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_5, RssV, i * 8, 8);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_umin_i64(tmp_6, tmp_4, tmp_5);
tcg_gen_deposit_i64(RddV, RddV, tmp_6, i * 8, 8);
}
}

void emit_A4_modwrapu(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { if (RsV < 0) { RdV = RsV + fCAST4u(RtV); } else if (fCAST4u(RsV) >= fCAST4u(RtV)) { RdV = RsV - fCAST4u(RtV); } else { RdV = RsV; } } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LT, tmp_0, RsV, ((int32_t) 0x0));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_1);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_setcond_i32(TCG_COND_GEU, tmp_2, RsV, RtV);
TCGLabel *if_label_2 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_3, RsV, RtV);
tcg_gen_mov_i32(RdV, tmp_3);
TCGLabel *if_label_3 = gen_new_label();
tcg_gen_br(if_label_3);
gen_set_label(if_label_2);
tcg_gen_mov_i32(RdV, RsV);
gen_set_label(if_label_3);
gen_set_label(if_label_1);
}

void emit_F2_sfimm_p(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, int uiV)
/* { RdV = (127 - 6) << 23; RdV += uiV << 17; } */
{
int32_t qemu_tmp_0 = ((int32_t) 0x7f) - ((int32_t) 0x6);
int32_t qemu_tmp_1 = qemu_tmp_0 << ((int32_t) 0x17);
tcg_gen_movi_i32(RdV, qemu_tmp_1);
int32_t qemu_tmp_2 = uiV << ((int32_t) 0x11);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RdV, qemu_tmp_2);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_F2_sfimm_n(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, int uiV)
/* { RdV = (127 - 6) << 23; RdV += (uiV << 17); RdV |= (1 << 31); } */
{
int32_t qemu_tmp_0 = ((int32_t) 0x7f) - ((int32_t) 0x6);
int32_t qemu_tmp_1 = qemu_tmp_0 << ((int32_t) 0x17);
tcg_gen_movi_i32(RdV, qemu_tmp_1);
int32_t qemu_tmp_2 = uiV << ((int32_t) 0x11);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RdV, qemu_tmp_2);
tcg_gen_mov_i32(RdV, tmp_0);
int32_t qemu_tmp_3 = ((int32_t) 0x1) << ((int32_t) 0x1f);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_ori_i32(tmp_1, RdV, qemu_tmp_3);
tcg_gen_mov_i32(RdV, tmp_1);
}

void emit_F2_dfmpyll(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { size8u_t prod; prod = fMPY32UU(fGETUWORD(0,RssV),fGETUWORD(0,RttV)); RddV = (prod >> 32) << 1; if (fGETUWORD(0,prod) != 0) fSETBIT(0,RddV,1); } */
{
TCGv_i64 prod = tcg_temp_new_i64();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_mov_i64(prod, tmp_2);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_3, 0);
} else {
tcg_gen_shri_i64(tmp_3, prod, qemu_tmp_0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_4, 0);
} else {
tcg_gen_shli_i64(tmp_4, tmp_3, qemu_tmp_1);
}
tcg_gen_mov_i64(RddV, tmp_4);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_5, prod, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x0);
tcg_gen_setcondi_i64(TCG_COND_NE, tmp_6, tmp_5, qemu_tmp_2);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i64(TCG_COND_EQ, tmp_6, 0, if_label_0);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_7 = tcg_constant_i64((int64_t) (qemu_tmp_3));
tcg_gen_deposit_i64(RddV, RddV, tmp_7, ((int32_t) 0x0) * 1, 1);
gen_set_label(if_label_0);
}

void emit_F2_dfmpylh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RxxV += (fGETUWORD(0,RssV) * (0x00100000 | fZXTN(20,64,fGETUWORD(1,RttV)))) << 1; } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_1, RttV, ((int32_t) 0x1) * 32, 32);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x14);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_2, tmp_1, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_2, 0);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x100000);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ori_i64(tmp_3, tmp_2, qemu_tmp_1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_mul_i64(tmp_4, tmp_0, tmp_3);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_5, 0);
} else {
tcg_gen_shli_i64(tmp_5, tmp_4, qemu_tmp_2);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_6, RxxV, tmp_5);
tcg_gen_mov_i64(RxxV, tmp_6);
}

void emit_F2_dfimm_p(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, int uiV)
/* { RddV = (1023ULL - 6) << 52; RddV += ((size8u_t)uiV) << 46; } */
{
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x6);
int64_t qemu_tmp_1 = ((uint64_t) 0x3ffULL) - qemu_tmp_0;
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x34);
int64_t qemu_tmp_3 = qemu_tmp_1 << qemu_tmp_2;
tcg_gen_movi_i64(RddV, qemu_tmp_3);
int64_t qemu_tmp_4 = (int64_t)uiV;
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x2e);
int64_t qemu_tmp_6 = qemu_tmp_4 << qemu_tmp_5;
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_0, RddV, qemu_tmp_6);
tcg_gen_mov_i64(RddV, tmp_0);
}

void emit_F2_dfimm_n(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, int uiV)
/* { RddV = (1023ULL - 6) << 52; RddV += ((size8u_t)uiV) << 46; RddV |= ((1ULL) << 63); } */
{
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x6);
int64_t qemu_tmp_1 = ((uint64_t) 0x3ffULL) - qemu_tmp_0;
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x34);
int64_t qemu_tmp_3 = qemu_tmp_1 << qemu_tmp_2;
tcg_gen_movi_i64(RddV, qemu_tmp_3);
int64_t qemu_tmp_4 = (int64_t)uiV;
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x2e);
int64_t qemu_tmp_6 = qemu_tmp_4 << qemu_tmp_5;
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_0, RddV, qemu_tmp_6);
tcg_gen_mov_i64(RddV, tmp_0);
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x3f);
int64_t qemu_tmp_8 = ((uint64_t) 0x1ULL) << qemu_tmp_7;
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ori_i64(tmp_1, RddV, qemu_tmp_8);
tcg_gen_mov_i64(RddV, tmp_1);
}

void emit_S2_asr_r_r(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RdV = fECHO( ((shamt > 0) ? (fCAST4_8s(RsV) >> shamt) : (fCAST4_8s(RsV) << -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, RsV);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, shamt);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_6, tmp_4, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i64 tmp_8 = tcg_constant_i64(0);
TCGv_i64 tmp_9 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_7, tmp_4, 63, 1);
tcg_gen_sub_i64(tmp_7, tmp_8, tmp_7);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_6, tmp_5, tmp_9, tmp_7, tmp_6);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_10, RsV);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_11, shamt);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_13, tmp_10, tmp_12);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_13, tmp_12, tmp_15, tmp_14, tmp_13);
TCGv_i64 tmp_16 = tcg_constant_i64(0);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_18, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_17, tmp_18, tmp_16, tmp_6, tmp_13);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_19, tmp_17);
tcg_gen_mov_i32(RdV, tmp_19);
}

void emit_S2_asl_r_r(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RdV = fECHO( ((shamt > 0) ? (fCAST4_8s(RsV) << shamt) : (fCAST4_8s(RsV) >> -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, RsV);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, shamt);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_6, tmp_4, tmp_5);
TCGv_i64 tmp_7 = tcg_constant_i64(0);
TCGv_i64 tmp_8 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_6, tmp_5, tmp_8, tmp_7, tmp_6);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, RsV);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_10, shamt);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_12, tmp_9, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_13, tmp_9, 63, 1);
tcg_gen_sub_i64(tmp_13, tmp_14, tmp_13);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_12, tmp_11, tmp_15, tmp_13, tmp_12);
TCGv_i64 tmp_16 = tcg_constant_i64(0);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_18, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_17, tmp_18, tmp_16, tmp_6, tmp_12);
TCGv_i32 tmp_19 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_19, tmp_17);
tcg_gen_mov_i32(RdV, tmp_19);
}

void emit_S2_lsr_r_r(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RdV = fECHO( (((shamt) < 0) ? ((fCAST4_8u(RsV) << ((-(shamt)) - 1)) << 1) : (fCAST4_8u(RsV) >> (shamt)))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_4, RsV);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_5, shamt);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_6, tmp_5, ((int32_t) 0x1));
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_7, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_8, tmp_4, tmp_7);
TCGv_i64 tmp_9 = tcg_constant_i64(0);
TCGv_i64 tmp_10 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_8, tmp_7, tmp_10, tmp_9, tmp_8);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_11, 0);
} else {
tcg_gen_shli_i64(tmp_11, tmp_8, qemu_tmp_1);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_12, RsV);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, shamt);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_14, tmp_12, tmp_13);
TCGv_i64 tmp_15 = tcg_constant_i64(0);
TCGv_i64 tmp_16 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_14, tmp_13, tmp_16, tmp_15, tmp_14);
TCGv_i64 tmp_17 = tcg_constant_i64(0);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_19, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_18, tmp_19, tmp_17, tmp_11, tmp_14);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_20, tmp_18);
tcg_gen_mov_i32(RdV, tmp_20);
}

void emit_S2_lsl_r_r(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RdV = fECHO( ((shamt > 0) ? (fCAST4_8u(RsV) << shamt) : (fCAST4_8u(RsV) >>> -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_4, RsV);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, shamt);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_6, tmp_4, tmp_5);
TCGv_i64 tmp_7 = tcg_constant_i64(0);
TCGv_i64 tmp_8 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_6, tmp_5, tmp_8, tmp_7, tmp_6);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_9, RsV);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_10, shamt);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_12, tmp_9, tmp_11);
TCGv_i64 tmp_13 = tcg_constant_i64(0);
TCGv_i64 tmp_14 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_12, tmp_11, tmp_14, tmp_13, tmp_12);
TCGv_i64 tmp_15 = tcg_constant_i64(0);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_17, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_16, tmp_17, tmp_15, tmp_6, tmp_12);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_18, tmp_16);
tcg_gen_mov_i32(RdV, tmp_18);
}

void emit_S2_asr_r_p(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RddV = fECHO( ((shamt > 0) ? (fCAST8_8s(RssV) >> shamt) : (fCAST8_8s(RssV) << -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, shamt);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_5, RssV, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i64 tmp_7 = tcg_constant_i64(0);
TCGv_i64 tmp_8 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_6, RssV, 63, 1);
tcg_gen_sub_i64(tmp_6, tmp_7, tmp_6);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_5, tmp_4, tmp_8, tmp_6, tmp_5);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_9, shamt);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_10, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_11, RssV, tmp_10);
TCGv_i64 tmp_12 = tcg_constant_i64(0);
TCGv_i64 tmp_13 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_11, tmp_10, tmp_13, tmp_12, tmp_11);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_16, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_15, tmp_16, tmp_14, tmp_5, tmp_11);
tcg_gen_mov_i64(RddV, tmp_15);
}

void emit_S2_asl_r_p(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RddV = fECHO( ((shamt > 0) ? (fCAST8_8s(RssV) << shamt) : (fCAST8_8s(RssV) >> -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, shamt);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_5, RssV, tmp_4);
TCGv_i64 tmp_6 = tcg_constant_i64(0);
TCGv_i64 tmp_7 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_5, tmp_4, tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_8, shamt);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_10, RssV, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
TCGv_i64 tmp_12 = tcg_constant_i64(0);
TCGv_i64 tmp_13 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_11, RssV, 63, 1);
tcg_gen_sub_i64(tmp_11, tmp_12, tmp_11);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_10, tmp_9, tmp_13, tmp_11, tmp_10);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_16, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_15, tmp_16, tmp_14, tmp_5, tmp_10);
tcg_gen_mov_i64(RddV, tmp_15);
}

void emit_S2_lsr_r_p(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RddV = fECHO( (((shamt) < 0) ? ((fCAST8_8u(RssV) << ((-(shamt)) - 1)) << 1) : (fCAST8_8u(RssV) >> (shamt)))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_4, shamt);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_5, tmp_4, ((int32_t) 0x1));
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_7, RssV, tmp_6);
TCGv_i64 tmp_8 = tcg_constant_i64(0);
TCGv_i64 tmp_9 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_7, tmp_6, tmp_9, tmp_8, tmp_7);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_10, 0);
} else {
tcg_gen_shli_i64(tmp_10, tmp_7, qemu_tmp_1);
}
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, shamt);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_12, RssV, tmp_11);
TCGv_i64 tmp_13 = tcg_constant_i64(0);
TCGv_i64 tmp_14 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_12, tmp_11, tmp_14, tmp_13, tmp_12);
TCGv_i64 tmp_15 = tcg_constant_i64(0);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_17, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_16, tmp_17, tmp_15, tmp_10, tmp_12);
tcg_gen_mov_i64(RddV, tmp_16);
}

void emit_S2_lsl_r_p(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RddV = fECHO( ((shamt > 0) ? (fCAST8_8u(RssV) << shamt) : (fCAST8_8u(RssV) >>> -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, shamt);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_5, RssV, tmp_4);
TCGv_i64 tmp_6 = tcg_constant_i64(0);
TCGv_i64 tmp_7 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_5, tmp_4, tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_8, shamt);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_10, RssV, tmp_9);
TCGv_i64 tmp_11 = tcg_constant_i64(0);
TCGv_i64 tmp_12 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_10, tmp_9, tmp_12, tmp_11, tmp_10);
TCGv_i64 tmp_13 = tcg_constant_i64(0);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_15, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_14, tmp_15, tmp_13, tmp_5, tmp_10);
tcg_gen_mov_i64(RddV, tmp_14);
}

void emit_S2_asr_r_r_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxV = fECHO(RxV + ((shamt > 0) ? (fCAST4_8s(RsV) >> shamt) : (fCAST4_8s(RsV) << -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, RsV);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, shamt);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_6, tmp_4, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i64 tmp_8 = tcg_constant_i64(0);
TCGv_i64 tmp_9 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_7, tmp_4, 63, 1);
tcg_gen_sub_i64(tmp_7, tmp_8, tmp_7);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_6, tmp_5, tmp_9, tmp_7, tmp_6);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_10, RsV);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_11, shamt);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_13, tmp_10, tmp_12);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_13, tmp_12, tmp_15, tmp_14, tmp_13);
TCGv_i64 tmp_16 = tcg_constant_i64(0);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_18, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_17, tmp_18, tmp_16, tmp_6, tmp_13);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_19, RxV);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_20, tmp_19, tmp_17);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_21, tmp_20);
tcg_gen_mov_i32(RxV, tmp_21);
}

void emit_S2_asl_r_r_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxV = fECHO(RxV + ((shamt > 0) ? (fCAST4_8s(RsV) << shamt) : (fCAST4_8s(RsV) >> -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, RsV);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, shamt);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_6, tmp_4, tmp_5);
TCGv_i64 tmp_7 = tcg_constant_i64(0);
TCGv_i64 tmp_8 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_6, tmp_5, tmp_8, tmp_7, tmp_6);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, RsV);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_10, shamt);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_12, tmp_9, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_13, tmp_9, 63, 1);
tcg_gen_sub_i64(tmp_13, tmp_14, tmp_13);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_12, tmp_11, tmp_15, tmp_13, tmp_12);
TCGv_i64 tmp_16 = tcg_constant_i64(0);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_18, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_17, tmp_18, tmp_16, tmp_6, tmp_12);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_19, RxV);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_20, tmp_19, tmp_17);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_21, tmp_20);
tcg_gen_mov_i32(RxV, tmp_21);
}

void emit_S2_lsr_r_r_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxV = fECHO(RxV + (((shamt) < 0) ? ((fCAST4_8u(RsV) << ((-(shamt)) - 1)) << 1) : (fCAST4_8u(RsV) >> (shamt)))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_4, RsV);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_5, shamt);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_6, tmp_5, ((int32_t) 0x1));
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_7, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_8, tmp_4, tmp_7);
TCGv_i64 tmp_9 = tcg_constant_i64(0);
TCGv_i64 tmp_10 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_8, tmp_7, tmp_10, tmp_9, tmp_8);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_11, 0);
} else {
tcg_gen_shli_i64(tmp_11, tmp_8, qemu_tmp_1);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_12, RsV);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, shamt);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_14, tmp_12, tmp_13);
TCGv_i64 tmp_15 = tcg_constant_i64(0);
TCGv_i64 tmp_16 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_14, tmp_13, tmp_16, tmp_15, tmp_14);
TCGv_i64 tmp_17 = tcg_constant_i64(0);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_19, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_18, tmp_19, tmp_17, tmp_11, tmp_14);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_20, RxV);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_21, tmp_20, tmp_18);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_22, tmp_21);
tcg_gen_mov_i32(RxV, tmp_22);
}

void emit_S2_lsl_r_r_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxV = fECHO(RxV + ((shamt > 0) ? (fCAST4_8u(RsV) << shamt) : (fCAST4_8u(RsV) >>> -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_4, RsV);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, shamt);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_6, tmp_4, tmp_5);
TCGv_i64 tmp_7 = tcg_constant_i64(0);
TCGv_i64 tmp_8 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_6, tmp_5, tmp_8, tmp_7, tmp_6);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_9, RsV);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_10, shamt);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_12, tmp_9, tmp_11);
TCGv_i64 tmp_13 = tcg_constant_i64(0);
TCGv_i64 tmp_14 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_12, tmp_11, tmp_14, tmp_13, tmp_12);
TCGv_i64 tmp_15 = tcg_constant_i64(0);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_17, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_16, tmp_17, tmp_15, tmp_6, tmp_12);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_18, RxV);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_19, tmp_18, tmp_16);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_20, tmp_19);
tcg_gen_mov_i32(RxV, tmp_20);
}

void emit_S2_asr_r_p_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxxV = fECHO(RxxV + ((shamt > 0) ? (fCAST8_8s(RssV) >> shamt) : (fCAST8_8s(RssV) << -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, shamt);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_5, RssV, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i64 tmp_7 = tcg_constant_i64(0);
TCGv_i64 tmp_8 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_6, RssV, 63, 1);
tcg_gen_sub_i64(tmp_6, tmp_7, tmp_6);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_5, tmp_4, tmp_8, tmp_6, tmp_5);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_9, shamt);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_10, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_11, RssV, tmp_10);
TCGv_i64 tmp_12 = tcg_constant_i64(0);
TCGv_i64 tmp_13 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_11, tmp_10, tmp_13, tmp_12, tmp_11);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_16, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_15, tmp_16, tmp_14, tmp_5, tmp_11);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_17, RxxV, tmp_15);
tcg_gen_mov_i64(RxxV, tmp_17);
}

void emit_S2_asl_r_p_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxxV = fECHO(RxxV + ((shamt > 0) ? (fCAST8_8s(RssV) << shamt) : (fCAST8_8s(RssV) >> -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, shamt);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_5, RssV, tmp_4);
TCGv_i64 tmp_6 = tcg_constant_i64(0);
TCGv_i64 tmp_7 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_5, tmp_4, tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_8, shamt);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_10, RssV, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
TCGv_i64 tmp_12 = tcg_constant_i64(0);
TCGv_i64 tmp_13 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_11, RssV, 63, 1);
tcg_gen_sub_i64(tmp_11, tmp_12, tmp_11);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_10, tmp_9, tmp_13, tmp_11, tmp_10);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_16, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_15, tmp_16, tmp_14, tmp_5, tmp_10);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_17, RxxV, tmp_15);
tcg_gen_mov_i64(RxxV, tmp_17);
}

void emit_S2_lsr_r_p_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxxV = fECHO(RxxV + (((shamt) < 0) ? ((fCAST8_8u(RssV) << ((-(shamt)) - 1)) << 1) : (fCAST8_8u(RssV) >> (shamt)))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_4, shamt);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_5, tmp_4, ((int32_t) 0x1));
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_7, RssV, tmp_6);
TCGv_i64 tmp_8 = tcg_constant_i64(0);
TCGv_i64 tmp_9 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_7, tmp_6, tmp_9, tmp_8, tmp_7);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_10, 0);
} else {
tcg_gen_shli_i64(tmp_10, tmp_7, qemu_tmp_1);
}
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, shamt);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_12, RssV, tmp_11);
TCGv_i64 tmp_13 = tcg_constant_i64(0);
TCGv_i64 tmp_14 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_12, tmp_11, tmp_14, tmp_13, tmp_12);
TCGv_i64 tmp_15 = tcg_constant_i64(0);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_17, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_16, tmp_17, tmp_15, tmp_10, tmp_12);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_18, RxxV, tmp_16);
tcg_gen_mov_i64(RxxV, tmp_18);
}

void emit_S2_lsl_r_p_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxxV = fECHO(RxxV + ((shamt > 0) ? (fCAST8_8u(RssV) << shamt) : (fCAST8_8u(RssV) >>> -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, shamt);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_5, RssV, tmp_4);
TCGv_i64 tmp_6 = tcg_constant_i64(0);
TCGv_i64 tmp_7 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_5, tmp_4, tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_8, shamt);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_10, RssV, tmp_9);
TCGv_i64 tmp_11 = tcg_constant_i64(0);
TCGv_i64 tmp_12 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_10, tmp_9, tmp_12, tmp_11, tmp_10);
TCGv_i64 tmp_13 = tcg_constant_i64(0);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_15, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_14, tmp_15, tmp_13, tmp_5, tmp_10);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_16, RxxV, tmp_14);
tcg_gen_mov_i64(RxxV, tmp_16);
}

void emit_S2_asr_r_r_nac(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxV = fECHO(RxV - ((shamt > 0) ? (fCAST4_8s(RsV) >> shamt) : (fCAST4_8s(RsV) << -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, RsV);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, shamt);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_6, tmp_4, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i64 tmp_8 = tcg_constant_i64(0);
TCGv_i64 tmp_9 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_7, tmp_4, 63, 1);
tcg_gen_sub_i64(tmp_7, tmp_8, tmp_7);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_6, tmp_5, tmp_9, tmp_7, tmp_6);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_10, RsV);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_11, shamt);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_13, tmp_10, tmp_12);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_13, tmp_12, tmp_15, tmp_14, tmp_13);
TCGv_i64 tmp_16 = tcg_constant_i64(0);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_18, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_17, tmp_18, tmp_16, tmp_6, tmp_13);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_19, RxV);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_20, tmp_19, tmp_17);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_21, tmp_20);
tcg_gen_mov_i32(RxV, tmp_21);
}

void emit_S2_asl_r_r_nac(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxV = fECHO(RxV - ((shamt > 0) ? (fCAST4_8s(RsV) << shamt) : (fCAST4_8s(RsV) >> -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, RsV);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, shamt);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_6, tmp_4, tmp_5);
TCGv_i64 tmp_7 = tcg_constant_i64(0);
TCGv_i64 tmp_8 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_6, tmp_5, tmp_8, tmp_7, tmp_6);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, RsV);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_10, shamt);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_12, tmp_9, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_13, tmp_9, 63, 1);
tcg_gen_sub_i64(tmp_13, tmp_14, tmp_13);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_12, tmp_11, tmp_15, tmp_13, tmp_12);
TCGv_i64 tmp_16 = tcg_constant_i64(0);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_18, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_17, tmp_18, tmp_16, tmp_6, tmp_12);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_19, RxV);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_20, tmp_19, tmp_17);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_21, tmp_20);
tcg_gen_mov_i32(RxV, tmp_21);
}

void emit_S2_lsr_r_r_nac(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxV = fECHO(RxV - (((shamt) < 0) ? ((fCAST4_8u(RsV) << ((-(shamt)) - 1)) << 1) : (fCAST4_8u(RsV) >> (shamt)))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_4, RsV);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_5, shamt);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_6, tmp_5, ((int32_t) 0x1));
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_7, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_8, tmp_4, tmp_7);
TCGv_i64 tmp_9 = tcg_constant_i64(0);
TCGv_i64 tmp_10 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_8, tmp_7, tmp_10, tmp_9, tmp_8);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_11, 0);
} else {
tcg_gen_shli_i64(tmp_11, tmp_8, qemu_tmp_1);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_12, RsV);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, shamt);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_14, tmp_12, tmp_13);
TCGv_i64 tmp_15 = tcg_constant_i64(0);
TCGv_i64 tmp_16 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_14, tmp_13, tmp_16, tmp_15, tmp_14);
TCGv_i64 tmp_17 = tcg_constant_i64(0);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_19, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_18, tmp_19, tmp_17, tmp_11, tmp_14);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_20, RxV);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_21, tmp_20, tmp_18);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_22, tmp_21);
tcg_gen_mov_i32(RxV, tmp_22);
}

void emit_S2_lsl_r_r_nac(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxV = fECHO(RxV - ((shamt > 0) ? (fCAST4_8u(RsV) << shamt) : (fCAST4_8u(RsV) >>> -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_4, RsV);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, shamt);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_6, tmp_4, tmp_5);
TCGv_i64 tmp_7 = tcg_constant_i64(0);
TCGv_i64 tmp_8 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_6, tmp_5, tmp_8, tmp_7, tmp_6);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_9, RsV);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_10, shamt);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_12, tmp_9, tmp_11);
TCGv_i64 tmp_13 = tcg_constant_i64(0);
TCGv_i64 tmp_14 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_12, tmp_11, tmp_14, tmp_13, tmp_12);
TCGv_i64 tmp_15 = tcg_constant_i64(0);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_17, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_16, tmp_17, tmp_15, tmp_6, tmp_12);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_18, RxV);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_19, tmp_18, tmp_16);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_20, tmp_19);
tcg_gen_mov_i32(RxV, tmp_20);
}

void emit_S2_asr_r_p_nac(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxxV = fECHO(RxxV - ((shamt > 0) ? (fCAST8_8s(RssV) >> shamt) : (fCAST8_8s(RssV) << -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, shamt);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_5, RssV, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i64 tmp_7 = tcg_constant_i64(0);
TCGv_i64 tmp_8 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_6, RssV, 63, 1);
tcg_gen_sub_i64(tmp_6, tmp_7, tmp_6);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_5, tmp_4, tmp_8, tmp_6, tmp_5);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_9, shamt);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_10, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_11, RssV, tmp_10);
TCGv_i64 tmp_12 = tcg_constant_i64(0);
TCGv_i64 tmp_13 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_11, tmp_10, tmp_13, tmp_12, tmp_11);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_16, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_15, tmp_16, tmp_14, tmp_5, tmp_11);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_17, RxxV, tmp_15);
tcg_gen_mov_i64(RxxV, tmp_17);
}

void emit_S2_asl_r_p_nac(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxxV = fECHO(RxxV - ((shamt > 0) ? (fCAST8_8s(RssV) << shamt) : (fCAST8_8s(RssV) >> -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, shamt);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_5, RssV, tmp_4);
TCGv_i64 tmp_6 = tcg_constant_i64(0);
TCGv_i64 tmp_7 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_5, tmp_4, tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_8, shamt);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_10, RssV, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
TCGv_i64 tmp_12 = tcg_constant_i64(0);
TCGv_i64 tmp_13 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_11, RssV, 63, 1);
tcg_gen_sub_i64(tmp_11, tmp_12, tmp_11);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_10, tmp_9, tmp_13, tmp_11, tmp_10);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_16, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_15, tmp_16, tmp_14, tmp_5, tmp_10);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_17, RxxV, tmp_15);
tcg_gen_mov_i64(RxxV, tmp_17);
}

void emit_S2_lsr_r_p_nac(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxxV = fECHO(RxxV - (((shamt) < 0) ? ((fCAST8_8u(RssV) << ((-(shamt)) - 1)) << 1) : (fCAST8_8u(RssV) >> (shamt)))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_4, shamt);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_5, tmp_4, ((int32_t) 0x1));
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_7, RssV, tmp_6);
TCGv_i64 tmp_8 = tcg_constant_i64(0);
TCGv_i64 tmp_9 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_7, tmp_6, tmp_9, tmp_8, tmp_7);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_10, 0);
} else {
tcg_gen_shli_i64(tmp_10, tmp_7, qemu_tmp_1);
}
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, shamt);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_12, RssV, tmp_11);
TCGv_i64 tmp_13 = tcg_constant_i64(0);
TCGv_i64 tmp_14 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_12, tmp_11, tmp_14, tmp_13, tmp_12);
TCGv_i64 tmp_15 = tcg_constant_i64(0);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_17, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_16, tmp_17, tmp_15, tmp_10, tmp_12);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_18, RxxV, tmp_16);
tcg_gen_mov_i64(RxxV, tmp_18);
}

void emit_S2_lsl_r_p_nac(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxxV = fECHO(RxxV - ((shamt > 0) ? (fCAST8_8u(RssV) << shamt) : (fCAST8_8u(RssV) >>> -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, shamt);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_5, RssV, tmp_4);
TCGv_i64 tmp_6 = tcg_constant_i64(0);
TCGv_i64 tmp_7 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_5, tmp_4, tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_8, shamt);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_10, RssV, tmp_9);
TCGv_i64 tmp_11 = tcg_constant_i64(0);
TCGv_i64 tmp_12 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_10, tmp_9, tmp_12, tmp_11, tmp_10);
TCGv_i64 tmp_13 = tcg_constant_i64(0);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_15, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_14, tmp_15, tmp_13, tmp_5, tmp_10);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_16, RxxV, tmp_14);
tcg_gen_mov_i64(RxxV, tmp_16);
}

void emit_S2_asr_r_r_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxV = fECHO(RxV & ((shamt > 0) ? (fCAST4_8s(RsV) >> shamt) : (fCAST4_8s(RsV) << -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, RsV);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, shamt);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_6, tmp_4, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i64 tmp_8 = tcg_constant_i64(0);
TCGv_i64 tmp_9 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_7, tmp_4, 63, 1);
tcg_gen_sub_i64(tmp_7, tmp_8, tmp_7);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_6, tmp_5, tmp_9, tmp_7, tmp_6);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_10, RsV);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_11, shamt);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_13, tmp_10, tmp_12);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_13, tmp_12, tmp_15, tmp_14, tmp_13);
TCGv_i64 tmp_16 = tcg_constant_i64(0);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_18, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_17, tmp_18, tmp_16, tmp_6, tmp_13);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_19, RxV);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_20, tmp_19, tmp_17);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_21, tmp_20);
tcg_gen_mov_i32(RxV, tmp_21);
}

void emit_S2_asl_r_r_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxV = fECHO(RxV & ((shamt > 0) ? (fCAST4_8s(RsV) << shamt) : (fCAST4_8s(RsV) >> -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, RsV);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, shamt);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_6, tmp_4, tmp_5);
TCGv_i64 tmp_7 = tcg_constant_i64(0);
TCGv_i64 tmp_8 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_6, tmp_5, tmp_8, tmp_7, tmp_6);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, RsV);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_10, shamt);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_12, tmp_9, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_13, tmp_9, 63, 1);
tcg_gen_sub_i64(tmp_13, tmp_14, tmp_13);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_12, tmp_11, tmp_15, tmp_13, tmp_12);
TCGv_i64 tmp_16 = tcg_constant_i64(0);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_18, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_17, tmp_18, tmp_16, tmp_6, tmp_12);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_19, RxV);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_20, tmp_19, tmp_17);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_21, tmp_20);
tcg_gen_mov_i32(RxV, tmp_21);
}

void emit_S2_lsr_r_r_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxV = fECHO(RxV & (((shamt) < 0) ? ((fCAST4_8u(RsV) << ((-(shamt)) - 1)) << 1) : (fCAST4_8u(RsV) >> (shamt)))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_4, RsV);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_5, shamt);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_6, tmp_5, ((int32_t) 0x1));
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_7, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_8, tmp_4, tmp_7);
TCGv_i64 tmp_9 = tcg_constant_i64(0);
TCGv_i64 tmp_10 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_8, tmp_7, tmp_10, tmp_9, tmp_8);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_11, 0);
} else {
tcg_gen_shli_i64(tmp_11, tmp_8, qemu_tmp_1);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_12, RsV);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, shamt);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_14, tmp_12, tmp_13);
TCGv_i64 tmp_15 = tcg_constant_i64(0);
TCGv_i64 tmp_16 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_14, tmp_13, tmp_16, tmp_15, tmp_14);
TCGv_i64 tmp_17 = tcg_constant_i64(0);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_19, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_18, tmp_19, tmp_17, tmp_11, tmp_14);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_20, RxV);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_21, tmp_20, tmp_18);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_22, tmp_21);
tcg_gen_mov_i32(RxV, tmp_22);
}

void emit_S2_lsl_r_r_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxV = fECHO(RxV & ((shamt > 0) ? (fCAST4_8u(RsV) << shamt) : (fCAST4_8u(RsV) >>> -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_4, RsV);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, shamt);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_6, tmp_4, tmp_5);
TCGv_i64 tmp_7 = tcg_constant_i64(0);
TCGv_i64 tmp_8 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_6, tmp_5, tmp_8, tmp_7, tmp_6);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_9, RsV);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_10, shamt);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_12, tmp_9, tmp_11);
TCGv_i64 tmp_13 = tcg_constant_i64(0);
TCGv_i64 tmp_14 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_12, tmp_11, tmp_14, tmp_13, tmp_12);
TCGv_i64 tmp_15 = tcg_constant_i64(0);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_17, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_16, tmp_17, tmp_15, tmp_6, tmp_12);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_18, RxV);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_19, tmp_18, tmp_16);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_20, tmp_19);
tcg_gen_mov_i32(RxV, tmp_20);
}

void emit_S2_asr_r_r_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxV = fECHO(RxV | ((shamt > 0) ? (fCAST4_8s(RsV) >> shamt) : (fCAST4_8s(RsV) << -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, RsV);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, shamt);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_6, tmp_4, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i64 tmp_8 = tcg_constant_i64(0);
TCGv_i64 tmp_9 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_7, tmp_4, 63, 1);
tcg_gen_sub_i64(tmp_7, tmp_8, tmp_7);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_6, tmp_5, tmp_9, tmp_7, tmp_6);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_10, RsV);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_11, shamt);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_13, tmp_10, tmp_12);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_13, tmp_12, tmp_15, tmp_14, tmp_13);
TCGv_i64 tmp_16 = tcg_constant_i64(0);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_18, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_17, tmp_18, tmp_16, tmp_6, tmp_13);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_19, RxV);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_20, tmp_19, tmp_17);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_21, tmp_20);
tcg_gen_mov_i32(RxV, tmp_21);
}

void emit_S2_asl_r_r_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxV = fECHO(RxV | ((shamt > 0) ? (fCAST4_8s(RsV) << shamt) : (fCAST4_8s(RsV) >> -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, RsV);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, shamt);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_6, tmp_4, tmp_5);
TCGv_i64 tmp_7 = tcg_constant_i64(0);
TCGv_i64 tmp_8 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_6, tmp_5, tmp_8, tmp_7, tmp_6);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, RsV);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_10, shamt);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_12, tmp_9, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_13, tmp_9, 63, 1);
tcg_gen_sub_i64(tmp_13, tmp_14, tmp_13);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_12, tmp_11, tmp_15, tmp_13, tmp_12);
TCGv_i64 tmp_16 = tcg_constant_i64(0);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_18, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_17, tmp_18, tmp_16, tmp_6, tmp_12);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_19, RxV);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_20, tmp_19, tmp_17);
TCGv_i32 tmp_21 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_21, tmp_20);
tcg_gen_mov_i32(RxV, tmp_21);
}

void emit_S2_lsr_r_r_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxV = fECHO(RxV | (((shamt) < 0) ? ((fCAST4_8u(RsV) << ((-(shamt)) - 1)) << 1) : (fCAST4_8u(RsV) >> (shamt)))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_4, RsV);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_5, shamt);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_6, tmp_5, ((int32_t) 0x1));
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_7, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_8, tmp_4, tmp_7);
TCGv_i64 tmp_9 = tcg_constant_i64(0);
TCGv_i64 tmp_10 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_8, tmp_7, tmp_10, tmp_9, tmp_8);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_11, 0);
} else {
tcg_gen_shli_i64(tmp_11, tmp_8, qemu_tmp_1);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_12, RsV);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, shamt);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_14, tmp_12, tmp_13);
TCGv_i64 tmp_15 = tcg_constant_i64(0);
TCGv_i64 tmp_16 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_14, tmp_13, tmp_16, tmp_15, tmp_14);
TCGv_i64 tmp_17 = tcg_constant_i64(0);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_19, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_18, tmp_19, tmp_17, tmp_11, tmp_14);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_20, RxV);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_21, tmp_20, tmp_18);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_22, tmp_21);
tcg_gen_mov_i32(RxV, tmp_22);
}

void emit_S2_lsl_r_r_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxV = fECHO(RxV | ((shamt > 0) ? (fCAST4_8u(RsV) << shamt) : (fCAST4_8u(RsV) >>> -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_4, RsV);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, shamt);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_6, tmp_4, tmp_5);
TCGv_i64 tmp_7 = tcg_constant_i64(0);
TCGv_i64 tmp_8 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_6, tmp_5, tmp_8, tmp_7, tmp_6);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_9, RsV);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_10, shamt);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_12, tmp_9, tmp_11);
TCGv_i64 tmp_13 = tcg_constant_i64(0);
TCGv_i64 tmp_14 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_12, tmp_11, tmp_14, tmp_13, tmp_12);
TCGv_i64 tmp_15 = tcg_constant_i64(0);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_17, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_16, tmp_17, tmp_15, tmp_6, tmp_12);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_18, RxV);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_19, tmp_18, tmp_16);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_20, tmp_19);
tcg_gen_mov_i32(RxV, tmp_20);
}

void emit_S2_asr_r_p_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxxV = fECHO(RxxV & ((shamt > 0) ? (fCAST8_8s(RssV) >> shamt) : (fCAST8_8s(RssV) << -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, shamt);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_5, RssV, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i64 tmp_7 = tcg_constant_i64(0);
TCGv_i64 tmp_8 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_6, RssV, 63, 1);
tcg_gen_sub_i64(tmp_6, tmp_7, tmp_6);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_5, tmp_4, tmp_8, tmp_6, tmp_5);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_9, shamt);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_10, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_11, RssV, tmp_10);
TCGv_i64 tmp_12 = tcg_constant_i64(0);
TCGv_i64 tmp_13 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_11, tmp_10, tmp_13, tmp_12, tmp_11);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_16, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_15, tmp_16, tmp_14, tmp_5, tmp_11);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_17, RxxV, tmp_15);
tcg_gen_mov_i64(RxxV, tmp_17);
}

void emit_S2_asl_r_p_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxxV = fECHO(RxxV & ((shamt > 0) ? (fCAST8_8s(RssV) << shamt) : (fCAST8_8s(RssV) >> -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, shamt);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_5, RssV, tmp_4);
TCGv_i64 tmp_6 = tcg_constant_i64(0);
TCGv_i64 tmp_7 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_5, tmp_4, tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_8, shamt);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_10, RssV, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
TCGv_i64 tmp_12 = tcg_constant_i64(0);
TCGv_i64 tmp_13 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_11, RssV, 63, 1);
tcg_gen_sub_i64(tmp_11, tmp_12, tmp_11);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_10, tmp_9, tmp_13, tmp_11, tmp_10);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_16, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_15, tmp_16, tmp_14, tmp_5, tmp_10);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_17, RxxV, tmp_15);
tcg_gen_mov_i64(RxxV, tmp_17);
}

void emit_S2_lsr_r_p_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxxV = fECHO(RxxV & (((shamt) < 0) ? ((fCAST8_8u(RssV) << ((-(shamt)) - 1)) << 1) : (fCAST8_8u(RssV) >> (shamt)))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_4, shamt);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_5, tmp_4, ((int32_t) 0x1));
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_7, RssV, tmp_6);
TCGv_i64 tmp_8 = tcg_constant_i64(0);
TCGv_i64 tmp_9 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_7, tmp_6, tmp_9, tmp_8, tmp_7);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_10, 0);
} else {
tcg_gen_shli_i64(tmp_10, tmp_7, qemu_tmp_1);
}
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, shamt);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_12, RssV, tmp_11);
TCGv_i64 tmp_13 = tcg_constant_i64(0);
TCGv_i64 tmp_14 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_12, tmp_11, tmp_14, tmp_13, tmp_12);
TCGv_i64 tmp_15 = tcg_constant_i64(0);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_17, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_16, tmp_17, tmp_15, tmp_10, tmp_12);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_18, RxxV, tmp_16);
tcg_gen_mov_i64(RxxV, tmp_18);
}

void emit_S2_lsl_r_p_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxxV = fECHO(RxxV & ((shamt > 0) ? (fCAST8_8u(RssV) << shamt) : (fCAST8_8u(RssV) >>> -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, shamt);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_5, RssV, tmp_4);
TCGv_i64 tmp_6 = tcg_constant_i64(0);
TCGv_i64 tmp_7 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_5, tmp_4, tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_8, shamt);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_10, RssV, tmp_9);
TCGv_i64 tmp_11 = tcg_constant_i64(0);
TCGv_i64 tmp_12 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_10, tmp_9, tmp_12, tmp_11, tmp_10);
TCGv_i64 tmp_13 = tcg_constant_i64(0);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_15, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_14, tmp_15, tmp_13, tmp_5, tmp_10);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_16, RxxV, tmp_14);
tcg_gen_mov_i64(RxxV, tmp_16);
}

void emit_S2_asr_r_p_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxxV = fECHO(RxxV | ((shamt > 0) ? (fCAST8_8s(RssV) >> shamt) : (fCAST8_8s(RssV) << -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, shamt);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_5, RssV, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i64 tmp_7 = tcg_constant_i64(0);
TCGv_i64 tmp_8 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_6, RssV, 63, 1);
tcg_gen_sub_i64(tmp_6, tmp_7, tmp_6);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_5, tmp_4, tmp_8, tmp_6, tmp_5);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_9, shamt);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_10, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_11, RssV, tmp_10);
TCGv_i64 tmp_12 = tcg_constant_i64(0);
TCGv_i64 tmp_13 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_11, tmp_10, tmp_13, tmp_12, tmp_11);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_16, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_15, tmp_16, tmp_14, tmp_5, tmp_11);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_17, RxxV, tmp_15);
tcg_gen_mov_i64(RxxV, tmp_17);
}

void emit_S2_asl_r_p_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxxV = fECHO(RxxV | ((shamt > 0) ? (fCAST8_8s(RssV) << shamt) : (fCAST8_8s(RssV) >> -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, shamt);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_5, RssV, tmp_4);
TCGv_i64 tmp_6 = tcg_constant_i64(0);
TCGv_i64 tmp_7 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_5, tmp_4, tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_8, shamt);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_10, RssV, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
TCGv_i64 tmp_12 = tcg_constant_i64(0);
TCGv_i64 tmp_13 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_11, RssV, 63, 1);
tcg_gen_sub_i64(tmp_11, tmp_12, tmp_11);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_10, tmp_9, tmp_13, tmp_11, tmp_10);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_16, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_15, tmp_16, tmp_14, tmp_5, tmp_10);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_17, RxxV, tmp_15);
tcg_gen_mov_i64(RxxV, tmp_17);
}

void emit_S2_lsr_r_p_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxxV = fECHO(RxxV | (((shamt) < 0) ? ((fCAST8_8u(RssV) << ((-(shamt)) - 1)) << 1) : (fCAST8_8u(RssV) >> (shamt)))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_4, shamt);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_5, tmp_4, ((int32_t) 0x1));
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_7, RssV, tmp_6);
TCGv_i64 tmp_8 = tcg_constant_i64(0);
TCGv_i64 tmp_9 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_7, tmp_6, tmp_9, tmp_8, tmp_7);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_10, 0);
} else {
tcg_gen_shli_i64(tmp_10, tmp_7, qemu_tmp_1);
}
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, shamt);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_12, RssV, tmp_11);
TCGv_i64 tmp_13 = tcg_constant_i64(0);
TCGv_i64 tmp_14 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_12, tmp_11, tmp_14, tmp_13, tmp_12);
TCGv_i64 tmp_15 = tcg_constant_i64(0);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_17, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_16, tmp_17, tmp_15, tmp_10, tmp_12);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_18, RxxV, tmp_16);
tcg_gen_mov_i64(RxxV, tmp_18);
}

void emit_S2_lsl_r_p_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxxV = fECHO(RxxV | ((shamt > 0) ? (fCAST8_8u(RssV) << shamt) : (fCAST8_8u(RssV) >>> -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, shamt);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_5, RssV, tmp_4);
TCGv_i64 tmp_6 = tcg_constant_i64(0);
TCGv_i64 tmp_7 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_5, tmp_4, tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_8, shamt);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_10, RssV, tmp_9);
TCGv_i64 tmp_11 = tcg_constant_i64(0);
TCGv_i64 tmp_12 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_10, tmp_9, tmp_12, tmp_11, tmp_10);
TCGv_i64 tmp_13 = tcg_constant_i64(0);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_15, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_14, tmp_15, tmp_13, tmp_5, tmp_10);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_16, RxxV, tmp_14);
tcg_gen_mov_i64(RxxV, tmp_16);
}

void emit_S2_asr_r_p_xor(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxxV = fECHO(RxxV ^ ((shamt > 0) ? (fCAST8_8s(RssV) >> shamt) : (fCAST8_8s(RssV) << -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, shamt);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_5, RssV, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i64 tmp_7 = tcg_constant_i64(0);
TCGv_i64 tmp_8 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_6, RssV, 63, 1);
tcg_gen_sub_i64(tmp_6, tmp_7, tmp_6);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_5, tmp_4, tmp_8, tmp_6, tmp_5);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_9, shamt);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_10, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_11, RssV, tmp_10);
TCGv_i64 tmp_12 = tcg_constant_i64(0);
TCGv_i64 tmp_13 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_11, tmp_10, tmp_13, tmp_12, tmp_11);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_16, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_15, tmp_16, tmp_14, tmp_5, tmp_11);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_xor_i64(tmp_17, RxxV, tmp_15);
tcg_gen_mov_i64(RxxV, tmp_17);
}

void emit_S2_asl_r_p_xor(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxxV = fECHO(RxxV ^ ((shamt > 0) ? (fCAST8_8s(RssV) << shamt) : (fCAST8_8s(RssV) >> -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, shamt);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_5, RssV, tmp_4);
TCGv_i64 tmp_6 = tcg_constant_i64(0);
TCGv_i64 tmp_7 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_5, tmp_4, tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_8, shamt);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_10, RssV, tmp_9);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
TCGv_i64 tmp_12 = tcg_constant_i64(0);
TCGv_i64 tmp_13 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_11, RssV, 63, 1);
tcg_gen_sub_i64(tmp_11, tmp_12, tmp_11);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_10, tmp_9, tmp_13, tmp_11, tmp_10);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_16, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_15, tmp_16, tmp_14, tmp_5, tmp_10);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_xor_i64(tmp_17, RxxV, tmp_15);
tcg_gen_mov_i64(RxxV, tmp_17);
}

void emit_S2_lsr_r_p_xor(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxxV = fECHO(RxxV ^ (((shamt) < 0) ? ((fCAST8_8u(RssV) << ((-(shamt)) - 1)) << 1) : (fCAST8_8u(RssV) >> (shamt)))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_4, shamt);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_5, tmp_4, ((int32_t) 0x1));
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_7, RssV, tmp_6);
TCGv_i64 tmp_8 = tcg_constant_i64(0);
TCGv_i64 tmp_9 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_7, tmp_6, tmp_9, tmp_8, tmp_7);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_10, 0);
} else {
tcg_gen_shli_i64(tmp_10, tmp_7, qemu_tmp_1);
}
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, shamt);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_12, RssV, tmp_11);
TCGv_i64 tmp_13 = tcg_constant_i64(0);
TCGv_i64 tmp_14 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_12, tmp_11, tmp_14, tmp_13, tmp_12);
TCGv_i64 tmp_15 = tcg_constant_i64(0);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_17, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_16, tmp_17, tmp_15, tmp_10, tmp_12);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_xor_i64(tmp_18, RxxV, tmp_16);
tcg_gen_mov_i64(RxxV, tmp_18);
}

void emit_S2_lsl_r_p_xor(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { size4s_t shamt=fSXTN(7,32,RtV); RxxV = fECHO(RxxV ^ ((shamt > 0) ? (fCAST8_8u(RssV) << shamt) : (fCAST8_8u(RssV) >>> -shamt))); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, shamt);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_5, RssV, tmp_4);
TCGv_i64 tmp_6 = tcg_constant_i64(0);
TCGv_i64 tmp_7 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_5, tmp_4, tmp_7, tmp_6, tmp_5);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_8, shamt);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_10, RssV, tmp_9);
TCGv_i64 tmp_11 = tcg_constant_i64(0);
TCGv_i64 tmp_12 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_10, tmp_9, tmp_12, tmp_11, tmp_10);
TCGv_i64 tmp_13 = tcg_constant_i64(0);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_15, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_14, tmp_15, tmp_13, tmp_5, tmp_10);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_xor_i64(tmp_16, RxxV, tmp_14);
tcg_gen_mov_i64(RxxV, tmp_16);
}

void emit_S2_asr_i_r(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* { RdV = fECHO( (fCAST4_4s(RsV) >> uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
{
int32_t shift = uiV;
if (uiV >= 32) {
    shift = 32 - 1;
}
tcg_gen_sari_i32(tmp_0, RsV, shift);
}
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_S2_lsr_i_r(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* { RdV = fECHO( (RsV >>> uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shri_i32(tmp_0, RsV, uiV);
}
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_S2_asl_i_r(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* { RdV = fECHO( (fCAST4_4s(RsV) << uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RsV, uiV);
}
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_S6_rol_i_r(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* { RdV = fECHO( fROTL(RsV, uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (uiV));
tcg_gen_rotl_i32(tmp_0, RsV, tmp_1);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_S2_asr_i_p(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, int uiV)
/* { RddV = fECHO( (fCAST8_8s(RssV) >> uiV)); } */
{
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_0 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_0, RssV, shift);
}
tcg_gen_mov_i64(RddV, tmp_0);
}

void emit_S2_lsr_i_p(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, int uiV)
/* { RddV = fECHO( (RssV >>> uiV)); } */
{
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_0 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_0, 0);
} else {
tcg_gen_shri_i64(tmp_0, RssV, qemu_tmp_0);
}
tcg_gen_mov_i64(RddV, tmp_0);
}

void emit_S2_asl_i_p(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, int uiV)
/* { RddV = fECHO( (fCAST8_8s(RssV) << uiV)); } */
{
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_0 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_0, 0);
} else {
tcg_gen_shli_i64(tmp_0, RssV, qemu_tmp_0);
}
tcg_gen_mov_i64(RddV, tmp_0);
}

void emit_S6_rol_i_p(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, int uiV)
/* { RddV = fECHO( fROTL(RssV, uiV)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_1 = tcg_constant_i64((int64_t) (qemu_tmp_0));
tcg_gen_rotl_i64(tmp_0, RssV, tmp_1);
tcg_gen_mov_i64(RddV, tmp_0);
}

void emit_S2_asr_i_r_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV)
/* { RxV = fECHO(RxV + (fCAST4_4s(RsV) >> uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
{
int32_t shift = uiV;
if (uiV >= 32) {
    shift = 32 - 1;
}
tcg_gen_sari_i32(tmp_0, RsV, shift);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S2_lsr_i_r_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV)
/* { RxV = fECHO(RxV + (RsV >>> uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shri_i32(tmp_0, RsV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S2_asl_i_r_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV)
/* { RxV = fECHO(RxV + (fCAST4_4s(RsV) << uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RsV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S6_rol_i_r_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV)
/* { RxV = fECHO(RxV + fROTL(RsV, uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (uiV));
tcg_gen_rotl_i32(tmp_0, RsV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_2, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_2);
}

void emit_S2_asr_i_p_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, int uiV)
/* { RxxV = fECHO(RxxV + (fCAST8_8s(RssV) >> uiV)); } */
{
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_0 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_0, RssV, shift);
}
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_1, RxxV, tmp_0);
tcg_gen_mov_i64(RxxV, tmp_1);
}

void emit_S2_lsr_i_p_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, int uiV)
/* { RxxV = fECHO(RxxV + (RssV >>> uiV)); } */
{
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_0 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_0, 0);
} else {
tcg_gen_shri_i64(tmp_0, RssV, qemu_tmp_0);
}
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_1, RxxV, tmp_0);
tcg_gen_mov_i64(RxxV, tmp_1);
}

void emit_S2_asl_i_p_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, int uiV)
/* { RxxV = fECHO(RxxV + (fCAST8_8s(RssV) << uiV)); } */
{
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_0 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_0, 0);
} else {
tcg_gen_shli_i64(tmp_0, RssV, qemu_tmp_0);
}
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_1, RxxV, tmp_0);
tcg_gen_mov_i64(RxxV, tmp_1);
}

void emit_S6_rol_i_p_acc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, int uiV)
/* { RxxV = fECHO(RxxV + fROTL(RssV, uiV)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_1 = tcg_constant_i64((int64_t) (qemu_tmp_0));
tcg_gen_rotl_i64(tmp_0, RssV, tmp_1);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_2, RxxV, tmp_0);
tcg_gen_mov_i64(RxxV, tmp_2);
}

void emit_S2_asr_i_r_nac(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV)
/* { RxV = fECHO(RxV - (fCAST4_4s(RsV) >> uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
{
int32_t shift = uiV;
if (uiV >= 32) {
    shift = 32 - 1;
}
tcg_gen_sari_i32(tmp_0, RsV, shift);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S2_lsr_i_r_nac(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV)
/* { RxV = fECHO(RxV - (RsV >>> uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shri_i32(tmp_0, RsV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S2_asl_i_r_nac(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV)
/* { RxV = fECHO(RxV - (fCAST4_4s(RsV) << uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RsV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S6_rol_i_r_nac(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV)
/* { RxV = fECHO(RxV - fROTL(RsV, uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (uiV));
tcg_gen_rotl_i32(tmp_0, RsV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_2, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_2);
}

void emit_S2_asr_i_p_nac(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, int uiV)
/* { RxxV = fECHO(RxxV - (fCAST8_8s(RssV) >> uiV)); } */
{
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_0 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_0, RssV, shift);
}
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_1, RxxV, tmp_0);
tcg_gen_mov_i64(RxxV, tmp_1);
}

void emit_S2_lsr_i_p_nac(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, int uiV)
/* { RxxV = fECHO(RxxV - (RssV >>> uiV)); } */
{
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_0 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_0, 0);
} else {
tcg_gen_shri_i64(tmp_0, RssV, qemu_tmp_0);
}
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_1, RxxV, tmp_0);
tcg_gen_mov_i64(RxxV, tmp_1);
}

void emit_S2_asl_i_p_nac(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, int uiV)
/* { RxxV = fECHO(RxxV - (fCAST8_8s(RssV) << uiV)); } */
{
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_0 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_0, 0);
} else {
tcg_gen_shli_i64(tmp_0, RssV, qemu_tmp_0);
}
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_1, RxxV, tmp_0);
tcg_gen_mov_i64(RxxV, tmp_1);
}

void emit_S6_rol_i_p_nac(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, int uiV)
/* { RxxV = fECHO(RxxV - fROTL(RssV, uiV)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_1 = tcg_constant_i64((int64_t) (qemu_tmp_0));
tcg_gen_rotl_i64(tmp_0, RssV, tmp_1);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sub_i64(tmp_2, RxxV, tmp_0);
tcg_gen_mov_i64(RxxV, tmp_2);
}

void emit_S2_lsr_i_r_xacc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV)
/* { RxV = fECHO(RxV ^ (RsV >>> uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shri_i32(tmp_0, RsV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_xor_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S2_asl_i_r_xacc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV)
/* { RxV = fECHO(RxV ^ (fCAST4_4s(RsV) << uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RsV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_xor_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S6_rol_i_r_xacc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV)
/* { RxV = fECHO(RxV ^ fROTL(RsV, uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (uiV));
tcg_gen_rotl_i32(tmp_0, RsV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_xor_i32(tmp_2, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_2);
}

void emit_S2_lsr_i_p_xacc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, int uiV)
/* { RxxV = fECHO(RxxV ^ (RssV >>> uiV)); } */
{
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_0 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_0, 0);
} else {
tcg_gen_shri_i64(tmp_0, RssV, qemu_tmp_0);
}
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_xor_i64(tmp_1, RxxV, tmp_0);
tcg_gen_mov_i64(RxxV, tmp_1);
}

void emit_S2_asl_i_p_xacc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, int uiV)
/* { RxxV = fECHO(RxxV ^ (fCAST8_8s(RssV) << uiV)); } */
{
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_0 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_0, 0);
} else {
tcg_gen_shli_i64(tmp_0, RssV, qemu_tmp_0);
}
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_xor_i64(tmp_1, RxxV, tmp_0);
tcg_gen_mov_i64(RxxV, tmp_1);
}

void emit_S6_rol_i_p_xacc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, int uiV)
/* { RxxV = fECHO(RxxV ^ fROTL(RssV, uiV)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_1 = tcg_constant_i64((int64_t) (qemu_tmp_0));
tcg_gen_rotl_i64(tmp_0, RssV, tmp_1);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_xor_i64(tmp_2, RxxV, tmp_0);
tcg_gen_mov_i64(RxxV, tmp_2);
}

void emit_S2_asr_i_r_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV)
/* { RxV = fECHO(RxV & (fCAST4_4s(RsV) >> uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
{
int32_t shift = uiV;
if (uiV >= 32) {
    shift = 32 - 1;
}
tcg_gen_sari_i32(tmp_0, RsV, shift);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S2_lsr_i_r_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV)
/* { RxV = fECHO(RxV & (RsV >>> uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shri_i32(tmp_0, RsV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S2_asl_i_r_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV)
/* { RxV = fECHO(RxV & (fCAST4_4s(RsV) << uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RsV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S6_rol_i_r_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV)
/* { RxV = fECHO(RxV & fROTL(RsV, uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (uiV));
tcg_gen_rotl_i32(tmp_0, RsV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_2, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_2);
}

void emit_S2_asr_i_r_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV)
/* { RxV = fECHO(RxV | (fCAST4_4s(RsV) >> uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
{
int32_t shift = uiV;
if (uiV >= 32) {
    shift = 32 - 1;
}
tcg_gen_sari_i32(tmp_0, RsV, shift);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S2_lsr_i_r_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV)
/* { RxV = fECHO(RxV | (RsV >>> uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shri_i32(tmp_0, RsV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S2_asl_i_r_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV)
/* { RxV = fECHO(RxV | (fCAST4_4s(RsV) << uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RsV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_1, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S6_rol_i_r_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV)
/* { RxV = fECHO(RxV | fROTL(RsV, uiV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (uiV));
tcg_gen_rotl_i32(tmp_0, RsV, tmp_1);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_2, RxV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_2);
}

void emit_S2_asr_i_p_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, int uiV)
/* { RxxV = fECHO(RxxV & (fCAST8_8s(RssV) >> uiV)); } */
{
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_0 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_0, RssV, shift);
}
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_1, RxxV, tmp_0);
tcg_gen_mov_i64(RxxV, tmp_1);
}

void emit_S2_lsr_i_p_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, int uiV)
/* { RxxV = fECHO(RxxV & (RssV >>> uiV)); } */
{
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_0 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_0, 0);
} else {
tcg_gen_shri_i64(tmp_0, RssV, qemu_tmp_0);
}
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_1, RxxV, tmp_0);
tcg_gen_mov_i64(RxxV, tmp_1);
}

void emit_S2_asl_i_p_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, int uiV)
/* { RxxV = fECHO(RxxV & (fCAST8_8s(RssV) << uiV)); } */
{
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_0 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_0, 0);
} else {
tcg_gen_shli_i64(tmp_0, RssV, qemu_tmp_0);
}
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_1, RxxV, tmp_0);
tcg_gen_mov_i64(RxxV, tmp_1);
}

void emit_S6_rol_i_p_and(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, int uiV)
/* { RxxV = fECHO(RxxV & fROTL(RssV, uiV)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_1 = tcg_constant_i64((int64_t) (qemu_tmp_0));
tcg_gen_rotl_i64(tmp_0, RssV, tmp_1);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_2, RxxV, tmp_0);
tcg_gen_mov_i64(RxxV, tmp_2);
}

void emit_S2_asr_i_p_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, int uiV)
/* { RxxV = fECHO(RxxV | (fCAST8_8s(RssV) >> uiV)); } */
{
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_0 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_0, RssV, shift);
}
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_1, RxxV, tmp_0);
tcg_gen_mov_i64(RxxV, tmp_1);
}

void emit_S2_lsr_i_p_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, int uiV)
/* { RxxV = fECHO(RxxV | (RssV >>> uiV)); } */
{
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_0 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_0, 0);
} else {
tcg_gen_shri_i64(tmp_0, RssV, qemu_tmp_0);
}
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_1, RxxV, tmp_0);
tcg_gen_mov_i64(RxxV, tmp_1);
}

void emit_S2_asl_i_p_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, int uiV)
/* { RxxV = fECHO(RxxV | (fCAST8_8s(RssV) << uiV)); } */
{
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_0 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_0, 0);
} else {
tcg_gen_shli_i64(tmp_0, RssV, qemu_tmp_0);
}
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_1, RxxV, tmp_0);
tcg_gen_mov_i64(RxxV, tmp_1);
}

void emit_S6_rol_i_p_or(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, int uiV)
/* { RxxV = fECHO(RxxV | fROTL(RssV, uiV)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_1 = tcg_constant_i64((int64_t) (qemu_tmp_0));
tcg_gen_rotl_i64(tmp_0, RssV, tmp_1);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_2, RxxV, tmp_0);
tcg_gen_mov_i64(RxxV, tmp_2);
}

void emit_S2_asl_i_r_sat(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* { RdV = fSATN(32, (fCAST4_8s(RsV) << uiV)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_1, 0);
} else {
tcg_gen_shli_i64(tmp_1, tmp_0, qemu_tmp_0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
TCGv_i32 tmp_3 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_3, tmp_2, tmp_1, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_3);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_2);
tcg_gen_mov_i32(RdV, tmp_4);
}

void emit_S2_asr_i_r_rnd(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* { RdV = (fCAST8_8s((((fCAST4_8s(RsV) >> uiV))+1)) >> 1); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_1 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_1, tmp_0, shift);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_2, tmp_1, qemu_tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_3, tmp_2, shift);
}
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_3);
tcg_gen_mov_i32(RdV, tmp_4);
}

void emit_S2_asr_i_p_rnd(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, int uiV)
/* { size8u_t tmp; size8u_t rnd; tmp = (fCAST8_8s(RssV) >> uiV); rnd = tmp & 1; RddV = (fCAST8_8s(tmp) >> 1) + rnd; } */
{
TCGv_i64 tmp = tcg_temp_new_i64();
TCGv_i64 rnd = tcg_temp_new_i64();
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_0 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_0, RssV, shift);
}
tcg_gen_mov_i64(tmp, tmp_0);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_andi_i64(tmp_1, tmp, qemu_tmp_1);
tcg_gen_mov_i64(rnd, tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_2, tmp, shift);
}
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_add_i64(tmp_3, tmp_2, rnd);
tcg_gen_mov_i64(RddV, tmp_3);
}

void emit_S4_lsli(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, int siV)
/* { size4s_t shamt = fSXTN(7,32,RtV); RdV = ((shamt > 0) ? (fCAST4_8u(siV) << shamt) : (fCAST4_8u(siV) >>> -shamt)); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_GT, tmp_3, shamt, ((int32_t) 0x0));
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (siV));
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_5, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, shamt);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_7, tmp_5, tmp_6);
TCGv_i64 tmp_8 = tcg_constant_i64(0);
TCGv_i64 tmp_9 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_7, tmp_6, tmp_9, tmp_8, tmp_7);
TCGv_i32 tmp_10 = tcg_constant_i32((int32_t) (siV));
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_11, tmp_10);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_12, shamt);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, tmp_12);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_14, tmp_11, tmp_13);
TCGv_i64 tmp_15 = tcg_constant_i64(0);
TCGv_i64 tmp_16 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_14, tmp_13, tmp_16, tmp_15, tmp_14);
TCGv_i64 tmp_17 = tcg_constant_i64(0);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_19, tmp_3);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_18, tmp_19, tmp_17, tmp_7, tmp_14);
TCGv_i32 tmp_20 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_20, tmp_18);
tcg_gen_mov_i32(RdV, tmp_20);
}

void emit_S2_addasl_rrri(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RtV, TCGv_i32 RsV, int uiV)
/* { RdV = RtV + (fCAST4_4s(RsV) << uiV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RsV, uiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_1, RtV, tmp_0);
tcg_gen_mov_i32(RdV, tmp_1);
}

void emit_S4_andi_asl_ri(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, int uiV, int UiV)
/* {RxV=fIMMEXT(uiV)&(RxV<<UiV);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (UiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RxV, UiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, uiV);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S4_ori_asl_ri(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, int uiV, int UiV)
/* {RxV=fIMMEXT(uiV)|(RxV<<UiV);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (UiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RxV, UiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_ori_i32(tmp_1, tmp_0, uiV);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S4_addi_asl_ri(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, int uiV, int UiV)
/* {RxV=fIMMEXT(uiV)+(RxV<<UiV);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (UiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RxV, UiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, uiV);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S4_subi_asl_ri(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, int uiV, int UiV)
/* {RxV=fIMMEXT(uiV)-(RxV<<UiV);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (UiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shli_i32(tmp_0, RxV, UiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_subfi_i32(tmp_1, uiV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S4_andi_lsr_ri(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, int uiV, int UiV)
/* {RxV=fIMMEXT(uiV)&(((unsigned int)RxV)>>UiV);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (UiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shri_i32(tmp_0, RxV, UiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, uiV);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S4_ori_lsr_ri(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, int uiV, int UiV)
/* {RxV=fIMMEXT(uiV)|(((unsigned int)RxV)>>UiV);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (UiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shri_i32(tmp_0, RxV, UiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_ori_i32(tmp_1, tmp_0, uiV);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S4_addi_lsr_ri(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, int uiV, int UiV)
/* {RxV=fIMMEXT(uiV)+(((unsigned int)RxV)>>UiV);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (UiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shri_i32(tmp_0, RxV, UiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_1, tmp_0, uiV);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S4_subi_lsr_ri(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, int uiV, int UiV)
/* {RxV=fIMMEXT(uiV)-(((unsigned int)RxV)>>UiV);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (UiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shri_i32(tmp_0, RxV, UiV);
}
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_subfi_i32(tmp_1, uiV, tmp_0);
tcg_gen_mov_i32(RxV, tmp_1);
}

void emit_S2_valignib(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV, int uiV)
/* { RddV = ((RssV >>> uiV*8))|((fCAST8_8s(RttV) << ((8-uiV)*8))); } */
{
int32_t qemu_tmp_0 = uiV * ((int32_t) 0x8);
int64_t qemu_tmp_1 = (int64_t)qemu_tmp_0;
TCGv_i64 tmp_0 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_0, 0);
} else {
tcg_gen_shri_i64(tmp_0, RssV, qemu_tmp_1);
}
int32_t qemu_tmp_2 = ((int32_t) 0x8) - uiV;
int32_t qemu_tmp_3 = qemu_tmp_2 * ((int32_t) 0x8);
int64_t qemu_tmp_4 = (int64_t)qemu_tmp_3;
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_4 >= 64) {
tcg_gen_movi_i64(tmp_1, 0);
} else {
tcg_gen_shli_i64(tmp_1, RttV, qemu_tmp_4);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_mov_i64(RddV, tmp_2);
}

void emit_S2_valignrb(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV, TCGv PuV)
/* { RddV = (RssV >>> (PuV&0x7)*8)|((fCAST8_8s(RttV) << (8-(PuV&0x7))*8));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PuV, ((int32_t) 0x7));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_muli_i32(tmp_1, tmp_0, ((int32_t) 0x8));
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_3, RssV, tmp_2);
TCGv_i64 tmp_4 = tcg_constant_i64(0);
TCGv_i64 tmp_5 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_3, tmp_2, tmp_5, tmp_4, tmp_3);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_6, PuV, ((int32_t) 0x7));
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_subfi_i32(tmp_7, ((int32_t) 0x8), tmp_6);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_muli_i32(tmp_8, tmp_7, ((int32_t) 0x8));
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_10, RttV, tmp_9);
TCGv_i64 tmp_11 = tcg_constant_i64(0);
TCGv_i64 tmp_12 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_10, tmp_9, tmp_12, tmp_11, tmp_10);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_13, tmp_3, tmp_10);
tcg_gen_mov_i64(RddV, tmp_13);
}

void emit_S2_vspliceib(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV, int uiV)
/* { RddV = (fCAST8_8s(RttV) << uiV*8) | fZXTN(uiV*8,64,RssV); } */
{
int32_t qemu_tmp_0 = uiV * ((int32_t) 0x8);
int64_t qemu_tmp_1 = (int64_t)qemu_tmp_0;
TCGv_i64 tmp_0 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_0, 0);
} else {
tcg_gen_shli_i64(tmp_0, RttV, qemu_tmp_1);
}
int32_t qemu_tmp_2 = uiV * ((int32_t) 0x8);
int64_t qemu_tmp_3 = (int64_t)qemu_tmp_2;
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_extract_i64(tmp_1, RssV, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_2, tmp_0, tmp_1);
tcg_gen_mov_i64(RddV, tmp_2);
}

void emit_S2_vsplicerb(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV, TCGv PuV)
/* { RddV = (fCAST8_8s(RttV) << (PuV&7)*8) | fZXTN((PuV&7)*8,64,RssV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, PuV, ((int32_t) 0x7));
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_muli_i32(tmp_1, tmp_0, ((int32_t) 0x8));
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_3, RttV, tmp_2);
TCGv_i64 tmp_4 = tcg_constant_i64(0);
TCGv_i64 tmp_5 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_3, tmp_2, tmp_5, tmp_4, tmp_3);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_6, PuV, ((int32_t) 0x7));
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_muli_i32(tmp_7, tmp_6, ((int32_t) 0x8));
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_8, tmp_7);
TCGv_i64 tmp_9 = tcg_constant_i64(0);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_subfi_i64(tmp_10, 64, tmp_8);
TCGv_i64 tmp_12 = tcg_constant_i64(-1);
tcg_gen_shr_i64(tmp_11, tmp_12, tmp_10);
tcg_gen_and_i64(tmp_11, tmp_11, RssV);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_11, tmp_8, tmp_9, tmp_9, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_13, tmp_3, tmp_11);
tcg_gen_mov_i64(RddV, tmp_13);
}

void emit_S2_vsplatrh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV, fGETHALF(0,RsV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, tmp_0);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, i * 16, 16);
}
}

void emit_S2_vsplatrb(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* { int i; for (i=0;i<4;i++) { fSETBYTE(i,RdV, fGETBYTE(0,RsV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 8, 8);
tcg_gen_deposit_i32(RdV, RdV, tmp_0, i * 8, 8);
}
}

void emit_S6_vsplatrbp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV)
/* { int i; for (i=0;i<8;i++) { fSETBYTE(i,RddV, fGETBYTE(0,RsV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x8); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, tmp_0);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, i * 8, 8);
}
}

void emit_S2_tableidxb(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV, int SiV)
/* { int width=uiV; int offset=SiV; int field = (fZXTN(width, 32, ((((offset)) < 0) ? ((fCAST4_8u((RsV)) << ((-((offset))) - 1)) << 1) : (fCAST4_8u((RsV)) >> ((offset)))))); fINSERT_BITS(RxV,width,0,field); } */
{
TCGv_i32 width = tcg_temp_new_i32();
TCGv_i32 offset = tcg_temp_new_i32();
TCGv_i32 field = tcg_temp_new_i32();
tcg_gen_movi_i32(width, uiV);
tcg_gen_movi_i32(offset, SiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LT, tmp_0, offset, ((int32_t) 0x0));
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_1, RsV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_2, offset);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_3, tmp_2, ((int32_t) 0x1));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_5, tmp_1, tmp_4);
TCGv_i64 tmp_6 = tcg_constant_i64(0);
TCGv_i64 tmp_7 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_5, tmp_4, tmp_7, tmp_6, tmp_5);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_8, 0);
} else {
tcg_gen_shli_i64(tmp_8, tmp_5, qemu_tmp_0);
}
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_9, RsV);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_10, offset);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_11, tmp_9, tmp_10);
TCGv_i64 tmp_12 = tcg_constant_i64(0);
TCGv_i64 tmp_13 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_11, tmp_10, tmp_13, tmp_12, tmp_11);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_16, tmp_0);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_15, tmp_16, tmp_14, tmp_8, tmp_11);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_17, width);
TCGv_i64 tmp_18 = tcg_constant_i64(0);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_subfi_i64(tmp_19, 64, tmp_17);
TCGv_i64 tmp_21 = tcg_constant_i64(-1);
tcg_gen_shr_i64(tmp_20, tmp_21, tmp_19);
tcg_gen_and_i64(tmp_20, tmp_20, tmp_15);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_20, tmp_17, tmp_18, tmp_18, tmp_20);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_22, tmp_20);
tcg_gen_mov_i32(field, tmp_22);
TCGv_i32 tmp_23 = tcg_constant_i32(0xffffffffUL);
TCGv_i32 tmp_24 = tcg_constant_i32(32);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_25, tmp_24, width);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_shr_i32(tmp_26, tmp_23, tmp_25);
TCGv_i32 tmp_27 = tcg_constant_i32(0);
TCGv_i32 tmp_28 = tcg_constant_i32((int32_t) (((uint32_t) 0x20)));
tcg_gen_movcond_i32(TCG_COND_GEU, tmp_26, tmp_25, tmp_28, tmp_27, tmp_26);
TCGv_i32 tmp_29 = tcg_temp_new_i32();
if (((int32_t) 0x0) >= 32) {
tcg_gen_movi_i32(tmp_29, 0);
} else {
tcg_gen_shli_i32(tmp_29, tmp_26, ((int32_t) 0x0));
}
TCGv_i32 tmp_30 = tcg_temp_new_i32();
if (((int32_t) 0x0) >= 32) {
tcg_gen_movi_i32(tmp_30, 0);
} else {
tcg_gen_shli_i32(tmp_30, field, ((int32_t) 0x0));
}
TCGv_i32 tmp_31 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_31, tmp_30, tmp_29);
tcg_gen_not_i32(tmp_29, tmp_29);
TCGv_i32 tmp_32 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_32, RxV, tmp_29);
TCGv_i32 tmp_33 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_33, tmp_32, tmp_31);
TCGv_i32 tmp_34 = tcg_constant_i32(0);
tcg_gen_movcond_i32(TCG_COND_NE, RxV, width, tmp_34, tmp_33, RxV);
}

void emit_S2_tableidxh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV, int SiV)
/* { int width=uiV; int offset=SiV+1; int field = (fZXTN(width, 32, ((((offset)) < 0) ? ((fCAST4_8u((RsV)) << ((-((offset))) - 1)) << 1) : (fCAST4_8u((RsV)) >> ((offset)))))); fINSERT_BITS(RxV,width,1,field); } */
{
TCGv_i32 width = tcg_temp_new_i32();
TCGv_i32 offset = tcg_temp_new_i32();
TCGv_i32 field = tcg_temp_new_i32();
tcg_gen_movi_i32(width, uiV);
int32_t qemu_tmp_0 = SiV + ((int32_t) 0x1);
tcg_gen_movi_i32(offset, qemu_tmp_0);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LT, tmp_0, offset, ((int32_t) 0x0));
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_1, RsV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_2, offset);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_3, tmp_2, ((int32_t) 0x1));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_5, tmp_1, tmp_4);
TCGv_i64 tmp_6 = tcg_constant_i64(0);
TCGv_i64 tmp_7 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_5, tmp_4, tmp_7, tmp_6, tmp_5);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_8, 0);
} else {
tcg_gen_shli_i64(tmp_8, tmp_5, qemu_tmp_1);
}
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_9, RsV);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_10, offset);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_11, tmp_9, tmp_10);
TCGv_i64 tmp_12 = tcg_constant_i64(0);
TCGv_i64 tmp_13 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_11, tmp_10, tmp_13, tmp_12, tmp_11);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_16, tmp_0);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_15, tmp_16, tmp_14, tmp_8, tmp_11);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_17, width);
TCGv_i64 tmp_18 = tcg_constant_i64(0);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_subfi_i64(tmp_19, 64, tmp_17);
TCGv_i64 tmp_21 = tcg_constant_i64(-1);
tcg_gen_shr_i64(tmp_20, tmp_21, tmp_19);
tcg_gen_and_i64(tmp_20, tmp_20, tmp_15);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_20, tmp_17, tmp_18, tmp_18, tmp_20);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_22, tmp_20);
tcg_gen_mov_i32(field, tmp_22);
TCGv_i32 tmp_23 = tcg_constant_i32(0xffffffffUL);
TCGv_i32 tmp_24 = tcg_constant_i32(32);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_25, tmp_24, width);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_shr_i32(tmp_26, tmp_23, tmp_25);
TCGv_i32 tmp_27 = tcg_constant_i32(0);
TCGv_i32 tmp_28 = tcg_constant_i32((int32_t) (((uint32_t) 0x20)));
tcg_gen_movcond_i32(TCG_COND_GEU, tmp_26, tmp_25, tmp_28, tmp_27, tmp_26);
TCGv_i32 tmp_29 = tcg_temp_new_i32();
if (((int32_t) 0x1) >= 32) {
tcg_gen_movi_i32(tmp_29, 0);
} else {
tcg_gen_shli_i32(tmp_29, tmp_26, ((int32_t) 0x1));
}
TCGv_i32 tmp_30 = tcg_temp_new_i32();
if (((int32_t) 0x1) >= 32) {
tcg_gen_movi_i32(tmp_30, 0);
} else {
tcg_gen_shli_i32(tmp_30, field, ((int32_t) 0x1));
}
TCGv_i32 tmp_31 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_31, tmp_30, tmp_29);
tcg_gen_not_i32(tmp_29, tmp_29);
TCGv_i32 tmp_32 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_32, RxV, tmp_29);
TCGv_i32 tmp_33 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_33, tmp_32, tmp_31);
TCGv_i32 tmp_34 = tcg_constant_i32(0);
tcg_gen_movcond_i32(TCG_COND_NE, RxV, width, tmp_34, tmp_33, RxV);
}

void emit_S2_tableidxw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV, int SiV)
/* { int width=uiV; int offset=SiV+2; int field = (fZXTN(width, 32, ((((offset)) < 0) ? ((fCAST4_8u((RsV)) << ((-((offset))) - 1)) << 1) : (fCAST4_8u((RsV)) >> ((offset)))))); fINSERT_BITS(RxV,width,2,field); } */
{
TCGv_i32 width = tcg_temp_new_i32();
TCGv_i32 offset = tcg_temp_new_i32();
TCGv_i32 field = tcg_temp_new_i32();
tcg_gen_movi_i32(width, uiV);
int32_t qemu_tmp_0 = SiV + ((int32_t) 0x2);
tcg_gen_movi_i32(offset, qemu_tmp_0);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LT, tmp_0, offset, ((int32_t) 0x0));
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_1, RsV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_2, offset);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_3, tmp_2, ((int32_t) 0x1));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_5, tmp_1, tmp_4);
TCGv_i64 tmp_6 = tcg_constant_i64(0);
TCGv_i64 tmp_7 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_5, tmp_4, tmp_7, tmp_6, tmp_5);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_8, 0);
} else {
tcg_gen_shli_i64(tmp_8, tmp_5, qemu_tmp_1);
}
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_9, RsV);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_10, offset);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_11, tmp_9, tmp_10);
TCGv_i64 tmp_12 = tcg_constant_i64(0);
TCGv_i64 tmp_13 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_11, tmp_10, tmp_13, tmp_12, tmp_11);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_16, tmp_0);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_15, tmp_16, tmp_14, tmp_8, tmp_11);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_17, width);
TCGv_i64 tmp_18 = tcg_constant_i64(0);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_subfi_i64(tmp_19, 64, tmp_17);
TCGv_i64 tmp_21 = tcg_constant_i64(-1);
tcg_gen_shr_i64(tmp_20, tmp_21, tmp_19);
tcg_gen_and_i64(tmp_20, tmp_20, tmp_15);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_20, tmp_17, tmp_18, tmp_18, tmp_20);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_22, tmp_20);
tcg_gen_mov_i32(field, tmp_22);
TCGv_i32 tmp_23 = tcg_constant_i32(0xffffffffUL);
TCGv_i32 tmp_24 = tcg_constant_i32(32);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_25, tmp_24, width);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_shr_i32(tmp_26, tmp_23, tmp_25);
TCGv_i32 tmp_27 = tcg_constant_i32(0);
TCGv_i32 tmp_28 = tcg_constant_i32((int32_t) (((uint32_t) 0x20)));
tcg_gen_movcond_i32(TCG_COND_GEU, tmp_26, tmp_25, tmp_28, tmp_27, tmp_26);
TCGv_i32 tmp_29 = tcg_temp_new_i32();
if (((int32_t) 0x2) >= 32) {
tcg_gen_movi_i32(tmp_29, 0);
} else {
tcg_gen_shli_i32(tmp_29, tmp_26, ((int32_t) 0x2));
}
TCGv_i32 tmp_30 = tcg_temp_new_i32();
if (((int32_t) 0x2) >= 32) {
tcg_gen_movi_i32(tmp_30, 0);
} else {
tcg_gen_shli_i32(tmp_30, field, ((int32_t) 0x2));
}
TCGv_i32 tmp_31 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_31, tmp_30, tmp_29);
tcg_gen_not_i32(tmp_29, tmp_29);
TCGv_i32 tmp_32 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_32, RxV, tmp_29);
TCGv_i32 tmp_33 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_33, tmp_32, tmp_31);
TCGv_i32 tmp_34 = tcg_constant_i32(0);
tcg_gen_movcond_i32(TCG_COND_NE, RxV, width, tmp_34, tmp_33, RxV);
}

void emit_S2_tableidxd(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV, int uiV, int SiV)
/* { int width=uiV; int offset=SiV+3; int field = (fZXTN(width, 32, ((((offset)) < 0) ? ((fCAST4_8u((RsV)) << ((-((offset))) - 1)) << 1) : (fCAST4_8u((RsV)) >> ((offset)))))); fINSERT_BITS(RxV,width,3,field); } */
{
TCGv_i32 width = tcg_temp_new_i32();
TCGv_i32 offset = tcg_temp_new_i32();
TCGv_i32 field = tcg_temp_new_i32();
tcg_gen_movi_i32(width, uiV);
int32_t qemu_tmp_0 = SiV + ((int32_t) 0x3);
tcg_gen_movi_i32(offset, qemu_tmp_0);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LT, tmp_0, offset, ((int32_t) 0x0));
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_1, RsV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_2, offset);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_3, tmp_2, ((int32_t) 0x1));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_5, tmp_1, tmp_4);
TCGv_i64 tmp_6 = tcg_constant_i64(0);
TCGv_i64 tmp_7 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_5, tmp_4, tmp_7, tmp_6, tmp_5);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_8, 0);
} else {
tcg_gen_shli_i64(tmp_8, tmp_5, qemu_tmp_1);
}
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_9, RsV);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_10, offset);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_11, tmp_9, tmp_10);
TCGv_i64 tmp_12 = tcg_constant_i64(0);
TCGv_i64 tmp_13 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_11, tmp_10, tmp_13, tmp_12, tmp_11);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_16, tmp_0);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_15, tmp_16, tmp_14, tmp_8, tmp_11);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_17, width);
TCGv_i64 tmp_18 = tcg_constant_i64(0);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_subfi_i64(tmp_19, 64, tmp_17);
TCGv_i64 tmp_21 = tcg_constant_i64(-1);
tcg_gen_shr_i64(tmp_20, tmp_21, tmp_19);
tcg_gen_and_i64(tmp_20, tmp_20, tmp_15);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_20, tmp_17, tmp_18, tmp_18, tmp_20);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_22, tmp_20);
tcg_gen_mov_i32(field, tmp_22);
TCGv_i32 tmp_23 = tcg_constant_i32(0xffffffffUL);
TCGv_i32 tmp_24 = tcg_constant_i32(32);
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_sub_i32(tmp_25, tmp_24, width);
TCGv_i32 tmp_26 = tcg_temp_new_i32();
tcg_gen_shr_i32(tmp_26, tmp_23, tmp_25);
TCGv_i32 tmp_27 = tcg_constant_i32(0);
TCGv_i32 tmp_28 = tcg_constant_i32((int32_t) (((uint32_t) 0x20)));
tcg_gen_movcond_i32(TCG_COND_GEU, tmp_26, tmp_25, tmp_28, tmp_27, tmp_26);
TCGv_i32 tmp_29 = tcg_temp_new_i32();
if (((int32_t) 0x3) >= 32) {
tcg_gen_movi_i32(tmp_29, 0);
} else {
tcg_gen_shli_i32(tmp_29, tmp_26, ((int32_t) 0x3));
}
TCGv_i32 tmp_30 = tcg_temp_new_i32();
if (((int32_t) 0x3) >= 32) {
tcg_gen_movi_i32(tmp_30, 0);
} else {
tcg_gen_shli_i32(tmp_30, field, ((int32_t) 0x3));
}
TCGv_i32 tmp_31 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_31, tmp_30, tmp_29);
tcg_gen_not_i32(tmp_29, tmp_29);
TCGv_i32 tmp_32 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_32, RxV, tmp_29);
TCGv_i32 tmp_33 = tcg_temp_new_i32();
tcg_gen_or_i32(tmp_33, tmp_32, tmp_31);
TCGv_i32 tmp_34 = tcg_constant_i32(0);
tcg_gen_movcond_i32(TCG_COND_NE, RxV, width, tmp_34, tmp_33, RxV);
}

void emit_A4_bitspliti(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, int uiV)
/* { fSETWORD(1,RddV,(fCAST4_4u(RsV)>>uiV)); fSETWORD(0,RddV,fZXTN(uiV,32,RsV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
if (uiV >= 32) {
tcg_gen_movi_i32(tmp_0, 0);
} else {
tcg_gen_shri_i32(tmp_0, RsV, uiV);
}
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, tmp_0);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_2, RsV);
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_3 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_3, tmp_2, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_3, 0);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_3, ((int32_t) 0x0) * 32, 32);
}

void emit_A4_bitsplit(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { size4u_t shamt = fZXTN(5,32,RtV); fSETWORD(1,RddV,(fCAST4_4u(RsV)>>shamt)); fSETWORD(0,RddV,fZXTN(shamt,32,RsV)); } */
{
TCGv_i32 shamt = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x5);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(shamt, tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_shr_i32(tmp_3, RsV, shamt);
TCGv_i32 tmp_4 = tcg_constant_i32(0);
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((uint32_t) 0x20)));
tcg_gen_movcond_i32(TCG_COND_GEU, tmp_3, shamt, tmp_5, tmp_4, tmp_3);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_6, tmp_3);
tcg_gen_deposit_i64(RddV, RddV, tmp_6, ((int32_t) 0x1) * 32, 32);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_7, RsV);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_8, shamt);
TCGv_i64 tmp_9 = tcg_constant_i64(0);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_subfi_i64(tmp_10, 64, tmp_8);
TCGv_i64 tmp_12 = tcg_constant_i64(-1);
tcg_gen_shr_i64(tmp_11, tmp_12, tmp_10);
tcg_gen_and_i64(tmp_11, tmp_11, tmp_7);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_11, tmp_8, tmp_9, tmp_9, tmp_11);
tcg_gen_deposit_i64(RddV, RddV, tmp_11, ((int32_t) 0x0) * 32, 32);
}

void emit_S4_extract(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV, int UiV)
/* { int width=uiV; int offset=UiV; RdV = fSXTN(width,32,(fCAST4_4u(RsV) >> offset)); } */
{
TCGv_i32 width = tcg_temp_new_i32();
TCGv_i32 offset = tcg_temp_new_i32();
tcg_gen_movi_i32(width, uiV);
tcg_gen_movi_i32(offset, UiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_shr_i32(tmp_0, RsV, offset);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (((uint32_t) 0x20)));
tcg_gen_movcond_i32(TCG_COND_GEU, tmp_0, offset, tmp_2, tmp_1, tmp_0);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_0);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, width);
TCGv_i64 tmp_5 = tcg_constant_i64(0);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_subfi_i64(tmp_6, 64, tmp_4);
tcg_gen_shl_i64(tmp_7, tmp_3, tmp_6);
tcg_gen_sar_i64(tmp_7, tmp_7, tmp_6);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_7, tmp_4, tmp_5, tmp_5, tmp_7);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_7);
tcg_gen_mov_i32(RdV, tmp_8);
}

void emit_S2_extractu(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV, int UiV)
/* { int width=uiV; int offset=UiV; RdV = fZXTN(width,32,(fCAST4_4u(RsV) >> offset)); } */
{
TCGv_i32 width = tcg_temp_new_i32();
TCGv_i32 offset = tcg_temp_new_i32();
tcg_gen_movi_i32(width, uiV);
tcg_gen_movi_i32(offset, UiV);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_shr_i32(tmp_0, RsV, offset);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_constant_i32((int32_t) (((uint32_t) 0x20)));
tcg_gen_movcond_i32(TCG_COND_GEU, tmp_0, offset, tmp_2, tmp_1, tmp_0);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_0);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, width);
TCGv_i64 tmp_5 = tcg_constant_i64(0);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_subfi_i64(tmp_6, 64, tmp_4);
TCGv_i64 tmp_8 = tcg_constant_i64(-1);
tcg_gen_shr_i64(tmp_7, tmp_8, tmp_6);
tcg_gen_and_i64(tmp_7, tmp_7, tmp_3);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_7, tmp_4, tmp_5, tmp_5, tmp_7);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_9, tmp_7);
tcg_gen_mov_i32(RdV, tmp_9);
}

void emit_S2_insertp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, int uiV, int UiV)
/* { int width=uiV; int offset=UiV; RxxV &= ~(((fCONSTLL(1)<<width)-1)<<offset); RxxV |= ((RssV & ((fCONSTLL(1)<<width)-1)) << offset); } */
{
TCGv_i32 width = tcg_temp_new_i32();
TCGv_i32 offset = tcg_temp_new_i32();
tcg_gen_movi_i32(width, uiV);
tcg_gen_movi_i32(offset, UiV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, width);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
TCGv_i64 tmp_2 = tcg_constant_i64((int64_t) (qemu_tmp_0));
tcg_gen_shl_i64(tmp_1, tmp_2, tmp_0);
TCGv_i64 tmp_3 = tcg_constant_i64(0);
TCGv_i64 tmp_4 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_1, tmp_0, tmp_4, tmp_3, tmp_1);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_subi_i64(tmp_5, tmp_1, qemu_tmp_1);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, offset);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_7, tmp_5, tmp_6);
TCGv_i64 tmp_8 = tcg_constant_i64(0);
TCGv_i64 tmp_9 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_7, tmp_6, tmp_9, tmp_8, tmp_7);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_not_i64(tmp_10, tmp_7);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_11, RxxV, tmp_10);
tcg_gen_mov_i64(RxxV, tmp_11);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, width);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
TCGv_i64 tmp_14 = tcg_constant_i64((int64_t) (qemu_tmp_2));
tcg_gen_shl_i64(tmp_13, tmp_14, tmp_12);
TCGv_i64 tmp_15 = tcg_constant_i64(0);
TCGv_i64 tmp_16 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_13, tmp_12, tmp_16, tmp_15, tmp_13);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_subi_i64(tmp_17, tmp_13, qemu_tmp_3);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_18, RssV, tmp_17);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_19, offset);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_20, tmp_18, tmp_19);
TCGv_i64 tmp_21 = tcg_constant_i64(0);
TCGv_i64 tmp_22 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_20, tmp_19, tmp_22, tmp_21, tmp_20);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_23, RxxV, tmp_20);
tcg_gen_mov_i64(RxxV, tmp_23);
}

void emit_S4_extractp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, int uiV, int UiV)
/* { int width=uiV; int offset=UiV; RddV = fSXTN(width,64,(fCAST8_8u(RssV) >> offset)); } */
{
TCGv_i32 width = tcg_temp_new_i32();
TCGv_i32 offset = tcg_temp_new_i32();
tcg_gen_movi_i32(width, uiV);
tcg_gen_movi_i32(offset, UiV);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, offset);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_1, RssV, tmp_0);
TCGv_i64 tmp_2 = tcg_constant_i64(0);
TCGv_i64 tmp_3 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_1, tmp_0, tmp_3, tmp_2, tmp_1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, width);
TCGv_i64 tmp_5 = tcg_constant_i64(0);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_subfi_i64(tmp_6, 64, tmp_4);
tcg_gen_shl_i64(tmp_7, tmp_1, tmp_6);
tcg_gen_sar_i64(tmp_7, tmp_7, tmp_6);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_7, tmp_4, tmp_5, tmp_5, tmp_7);
tcg_gen_mov_i64(RddV, tmp_7);
}

void emit_S2_extractup(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, int uiV, int UiV)
/* { int width=uiV; int offset=UiV; RddV = fZXTN(width,64,(fCAST8_8u(RssV) >> offset)); } */
{
TCGv_i32 width = tcg_temp_new_i32();
TCGv_i32 offset = tcg_temp_new_i32();
tcg_gen_movi_i32(width, uiV);
tcg_gen_movi_i32(offset, UiV);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, offset);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_1, RssV, tmp_0);
TCGv_i64 tmp_2 = tcg_constant_i64(0);
TCGv_i64 tmp_3 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_1, tmp_0, tmp_3, tmp_2, tmp_1);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, width);
TCGv_i64 tmp_5 = tcg_constant_i64(0);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_subfi_i64(tmp_6, 64, tmp_4);
TCGv_i64 tmp_8 = tcg_constant_i64(-1);
tcg_gen_shr_i64(tmp_7, tmp_8, tmp_6);
tcg_gen_and_i64(tmp_7, tmp_7, tmp_1);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_7, tmp_4, tmp_5, tmp_5, tmp_7);
tcg_gen_mov_i64(RddV, tmp_7);
}

void emit_S2_mask(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, int uiV, int UiV)
/* { RdV = ((1<<uiV)-1) << UiV; } */
{
int32_t qemu_tmp_0 = ((int32_t) 0x1) << uiV;
int32_t qemu_tmp_1 = qemu_tmp_0 - ((int32_t) 0x1);
int32_t qemu_tmp_2 = qemu_tmp_1 << UiV;
tcg_gen_movi_i32(RdV, qemu_tmp_2);
}

void emit_S4_extract_rp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i64 RttV)
/* { int width=fZXTN(6,32,(fGETWORD(1,RttV))); int offset=fSXTN(7,32,(fGETWORD(0,RttV))); RdV = fSXTN(width,64,(((offset) < 0) ? ((fCAST4_8u(fCAST4_8u(RsV)) << ((-(offset)) - 1)) << 1) : (fCAST4_8u(fCAST4_8u(RsV)) >> (offset)))); } */
{
TCGv_i32 width = tcg_temp_new_i32();
TCGv_i32 offset = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, ((int32_t) 0x1) * 32, 32);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x6);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(width, tmp_2);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RttV, ((int32_t) 0x0) * 32, 32);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_mov_i32(offset, tmp_5);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LT, tmp_6, offset, ((int32_t) 0x0));
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_7, RsV);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_7);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_9, tmp_8);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_10, offset);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_11, tmp_10, ((int32_t) 0x1));
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_13, tmp_9, tmp_12);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_13, tmp_12, tmp_15, tmp_14, tmp_13);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_16, 0);
} else {
tcg_gen_shli_i64(tmp_16, tmp_13, qemu_tmp_2);
}
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_17, RsV);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_18, tmp_17);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_19, tmp_18);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_20, offset);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_21, tmp_19, tmp_20);
TCGv_i64 tmp_22 = tcg_constant_i64(0);
TCGv_i64 tmp_23 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_21, tmp_20, tmp_23, tmp_22, tmp_21);
TCGv_i64 tmp_24 = tcg_constant_i64(0);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
TCGv_i64 tmp_26 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_26, tmp_6);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_25, tmp_26, tmp_24, tmp_16, tmp_21);
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_27, width);
TCGv_i64 tmp_28 = tcg_constant_i64(0);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_subfi_i64(tmp_29, 64, tmp_27);
tcg_gen_shl_i64(tmp_30, tmp_25, tmp_29);
tcg_gen_sar_i64(tmp_30, tmp_30, tmp_29);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_30, tmp_27, tmp_28, tmp_28, tmp_30);
TCGv_i32 tmp_31 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_31, tmp_30);
tcg_gen_mov_i32(RdV, tmp_31);
}

void emit_S2_extractu_rp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i64 RttV)
/* { int width=fZXTN(6,32,(fGETWORD(1,RttV))); int offset=fSXTN(7,32,(fGETWORD(0,RttV))); RdV = fZXTN(width,64,(((offset) < 0) ? ((fCAST4_8u(fCAST4_8u(RsV)) << ((-(offset)) - 1)) << 1) : (fCAST4_8u(fCAST4_8u(RsV)) >> (offset)))); } */
{
TCGv_i32 width = tcg_temp_new_i32();
TCGv_i32 offset = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, ((int32_t) 0x1) * 32, 32);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x6);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(width, tmp_2);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RttV, ((int32_t) 0x0) * 32, 32);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_mov_i32(offset, tmp_5);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LT, tmp_6, offset, ((int32_t) 0x0));
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_7, RsV);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_8, tmp_7);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_9, tmp_8);
TCGv_i32 tmp_10 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_10, offset);
TCGv_i32 tmp_11 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_11, tmp_10, ((int32_t) 0x1));
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_13, tmp_9, tmp_12);
TCGv_i64 tmp_14 = tcg_constant_i64(0);
TCGv_i64 tmp_15 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_13, tmp_12, tmp_15, tmp_14, tmp_13);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_16, 0);
} else {
tcg_gen_shli_i64(tmp_16, tmp_13, qemu_tmp_2);
}
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_17, RsV);
TCGv_i32 tmp_18 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_18, tmp_17);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_19, tmp_18);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_20, offset);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_21, tmp_19, tmp_20);
TCGv_i64 tmp_22 = tcg_constant_i64(0);
TCGv_i64 tmp_23 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_21, tmp_20, tmp_23, tmp_22, tmp_21);
TCGv_i64 tmp_24 = tcg_constant_i64(0);
TCGv_i64 tmp_25 = tcg_temp_new_i64();
TCGv_i64 tmp_26 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_26, tmp_6);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_25, tmp_26, tmp_24, tmp_16, tmp_21);
TCGv_i64 tmp_27 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_27, width);
TCGv_i64 tmp_28 = tcg_constant_i64(0);
TCGv_i64 tmp_29 = tcg_temp_new_i64();
TCGv_i64 tmp_30 = tcg_temp_new_i64();
tcg_gen_subfi_i64(tmp_29, 64, tmp_27);
TCGv_i64 tmp_31 = tcg_constant_i64(-1);
tcg_gen_shr_i64(tmp_30, tmp_31, tmp_29);
tcg_gen_and_i64(tmp_30, tmp_30, tmp_25);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_30, tmp_27, tmp_28, tmp_28, tmp_30);
TCGv_i32 tmp_32 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_32, tmp_30);
tcg_gen_mov_i32(RdV, tmp_32);
}

void emit_S2_insertp_rp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RxxV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int width=fZXTN(6,32,(fGETWORD(1,RttV))); int offset=fSXTN(7,32,(fGETWORD(0,RttV))); size8u_t mask = ((fCONSTLL(1)<<width)-1); if (offset < 0) { RxxV = 0; } else { RxxV &= ~(mask<<offset); RxxV |= ((RssV & mask) << offset); } } */
{
TCGv_i32 width = tcg_temp_new_i32();
TCGv_i32 offset = tcg_temp_new_i32();
TCGv_i64 mask = tcg_temp_new_i64();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, ((int32_t) 0x1) * 32, 32);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x6);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(width, tmp_2);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RttV, ((int32_t) 0x0) * 32, 32);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_mov_i32(offset, tmp_5);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, width);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i64 tmp_8 = tcg_constant_i64((int64_t) (qemu_tmp_2));
tcg_gen_shl_i64(tmp_7, tmp_8, tmp_6);
TCGv_i64 tmp_9 = tcg_constant_i64(0);
TCGv_i64 tmp_10 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_7, tmp_6, tmp_10, tmp_9, tmp_7);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_subi_i64(tmp_11, tmp_7, qemu_tmp_3);
tcg_gen_mov_i64(mask, tmp_11);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LT, tmp_12, offset, ((int32_t) 0x0));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_12, 0, if_label_0);
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x0);
tcg_gen_movi_i64(RxxV, qemu_tmp_4);
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, offset);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_14, mask, tmp_13);
TCGv_i64 tmp_15 = tcg_constant_i64(0);
TCGv_i64 tmp_16 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_14, tmp_13, tmp_16, tmp_15, tmp_14);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_not_i64(tmp_17, tmp_14);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_18, RxxV, tmp_17);
tcg_gen_mov_i64(RxxV, tmp_18);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_19, RssV, mask);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_20, offset);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_21, tmp_19, tmp_20);
TCGv_i64 tmp_22 = tcg_constant_i64(0);
TCGv_i64 tmp_23 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_21, tmp_20, tmp_23, tmp_22, tmp_21);
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_24, RxxV, tmp_21);
tcg_gen_mov_i64(RxxV, tmp_24);
gen_set_label(if_label_1);
}

void emit_S4_extractp_rp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int width=fZXTN(6,32,(fGETWORD(1,RttV))); int offset=fSXTN(7,32,(fGETWORD(0,RttV))); RddV = fSXTN(width,64,(((offset) < 0) ? ((fCAST8_8u(fCAST8_8u(RssV)) << ((-(offset)) - 1)) << 1) : (fCAST8_8u(fCAST8_8u(RssV)) >> (offset)))); } */
{
TCGv_i32 width = tcg_temp_new_i32();
TCGv_i32 offset = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, ((int32_t) 0x1) * 32, 32);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x6);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(width, tmp_2);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RttV, ((int32_t) 0x0) * 32, 32);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_mov_i32(offset, tmp_5);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LT, tmp_6, offset, ((int32_t) 0x0));
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_7, offset);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_8, tmp_7, ((int32_t) 0x1));
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_10, RssV, tmp_9);
TCGv_i64 tmp_11 = tcg_constant_i64(0);
TCGv_i64 tmp_12 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_10, tmp_9, tmp_12, tmp_11, tmp_10);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_13, 0);
} else {
tcg_gen_shli_i64(tmp_13, tmp_10, qemu_tmp_2);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_14, offset);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_15, RssV, tmp_14);
TCGv_i64 tmp_16 = tcg_constant_i64(0);
TCGv_i64 tmp_17 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_15, tmp_14, tmp_17, tmp_16, tmp_15);
TCGv_i64 tmp_18 = tcg_constant_i64(0);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_20, tmp_6);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_19, tmp_20, tmp_18, tmp_13, tmp_15);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_21, width);
TCGv_i64 tmp_22 = tcg_constant_i64(0);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_subfi_i64(tmp_23, 64, tmp_21);
tcg_gen_shl_i64(tmp_24, tmp_19, tmp_23);
tcg_gen_sar_i64(tmp_24, tmp_24, tmp_23);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_24, tmp_21, tmp_22, tmp_22, tmp_24);
tcg_gen_mov_i64(RddV, tmp_24);
}

void emit_S2_extractup_rp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int width=fZXTN(6,32,(fGETWORD(1,RttV))); int offset=fSXTN(7,32,(fGETWORD(0,RttV))); RddV = fZXTN(width,64,(((offset) < 0) ? ((fCAST8_8u(fCAST8_8u(RssV)) << ((-(offset)) - 1)) << 1) : (fCAST8_8u(fCAST8_8u(RssV)) >> (offset)))); } */
{
TCGv_i32 width = tcg_temp_new_i32();
TCGv_i32 offset = tcg_temp_new_i32();
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, ((int32_t) 0x1) * 32, 32);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x6);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(width, tmp_2);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RttV, ((int32_t) 0x0) * 32, 32);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_1 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_1);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_mov_i32(offset, tmp_5);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_LT, tmp_6, offset, ((int32_t) 0x0));
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_neg_i32(tmp_7, offset);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_8, tmp_7, ((int32_t) 0x1));
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_9, tmp_8);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_10, RssV, tmp_9);
TCGv_i64 tmp_11 = tcg_constant_i64(0);
TCGv_i64 tmp_12 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_10, tmp_9, tmp_12, tmp_11, tmp_10);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_13, 0);
} else {
tcg_gen_shli_i64(tmp_13, tmp_10, qemu_tmp_2);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_14, offset);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_15, RssV, tmp_14);
TCGv_i64 tmp_16 = tcg_constant_i64(0);
TCGv_i64 tmp_17 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_15, tmp_14, tmp_17, tmp_16, tmp_15);
TCGv_i64 tmp_18 = tcg_constant_i64(0);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_20, tmp_6);
tcg_gen_movcond_i64(TCG_COND_NE, tmp_19, tmp_20, tmp_18, tmp_13, tmp_15);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_21, width);
TCGv_i64 tmp_22 = tcg_constant_i64(0);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
TCGv_i64 tmp_24 = tcg_temp_new_i64();
tcg_gen_subfi_i64(tmp_23, 64, tmp_21);
TCGv_i64 tmp_25 = tcg_constant_i64(-1);
tcg_gen_shr_i64(tmp_24, tmp_25, tmp_23);
tcg_gen_and_i64(tmp_24, tmp_24, tmp_19);
tcg_gen_movcond_i64(TCG_COND_EQ, tmp_24, tmp_21, tmp_22, tmp_22, tmp_24);
tcg_gen_mov_i64(RddV, tmp_24);
}

void emit_S2_tstbit_i(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, int uiV)
/* { PdV = (((RsV & (1<<uiV)) != 0) ? 0xff : 0x00); } */
{
int32_t qemu_tmp_0 = ((int32_t) 0x1) << uiV;
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, RsV, qemu_tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_NE, tmp_1, tmp_0, ((int32_t) 0x0));
TCGv_i32 tmp_2 = tcg_constant_i32(0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_3, tmp_1, tmp_2, tmp_4, tmp_5);
tcg_gen_andi_i32(PdV, tmp_3, 0xff);
}

void emit_S4_ntstbit_i(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, int uiV)
/* { PdV = (((RsV & (1<<uiV)) == 0) ? 0xff : 0x00); } */
{
int32_t qemu_tmp_0 = ((int32_t) 0x1) << uiV;
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, RsV, qemu_tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_EQ, tmp_1, tmp_0, ((int32_t) 0x0));
TCGv_i32 tmp_2 = tcg_constant_i32(0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_5 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_3, tmp_1, tmp_2, tmp_4, tmp_5);
tcg_gen_andi_i32(PdV, tmp_3, 0xff);
}

void emit_S2_setbit_i(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* { RdV = (RsV | (1<<uiV)); } */
{
int32_t qemu_tmp_0 = ((int32_t) 0x1) << uiV;
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_ori_i32(tmp_0, RsV, qemu_tmp_0);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_S2_togglebit_i(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* { RdV = (RsV ^ (1<<uiV)); } */
{
int32_t qemu_tmp_0 = ((int32_t) 0x1) << uiV;
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_xori_i32(tmp_0, RsV, qemu_tmp_0);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_S2_clrbit_i(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* { RdV = (RsV & (~(1<<uiV))); } */
{
int32_t qemu_tmp_0 = ((int32_t) 0x1) << uiV;
int32_t qemu_tmp_1 = ~(qemu_tmp_0);
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, RsV, qemu_tmp_1);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_S2_tstbit_r(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { PdV = (((fCAST4_8u(RsV) & ((fSXTN(7,32,RtV) > 0) ? (fCAST4_8u(1) << fSXTN(7,32,RtV)) : (fCAST4_8u(1) >>> -fSXTN(7,32,RtV)))) != 0) ? 0xff : 0x00); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_0, RsV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_2, tmp_1, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_2, 0);
}
TCGv_i64 tmp_3 = tcg_temp_new_i64();
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
tcg_gen_setcondi_i64(TCG_COND_GT, tmp_3, tmp_2, qemu_tmp_1);
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((uint32_t) 0x1)));
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_5, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RtV);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_7, tmp_6, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_7, 0);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_8, tmp_5, tmp_7);
TCGv_i64 tmp_9 = tcg_constant_i64(0);
TCGv_i64 tmp_10 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_8, tmp_7, tmp_10, tmp_9, tmp_8);
TCGv_i32 tmp_11 = tcg_constant_i32((int32_t) (((uint32_t) 0x1)));
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_12, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, RtV);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_14, tmp_13, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_14, 0);
}
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_15, tmp_14);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_16, tmp_12, tmp_15);
TCGv_i64 tmp_17 = tcg_constant_i64(0);
TCGv_i64 tmp_18 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_16, tmp_15, tmp_18, tmp_17, tmp_16);
TCGv_i64 tmp_19 = tcg_constant_i64(0);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_movcond_i64(TCG_COND_NE, tmp_20, tmp_3, tmp_19, tmp_8, tmp_16);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_21, tmp_0, tmp_20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x0);
tcg_gen_setcondi_i64(TCG_COND_NE, tmp_22, tmp_21, qemu_tmp_4);
TCGv_i32 tmp_23 = tcg_constant_i32(0);
TCGv_i32 tmp_24 = tcg_temp_new_i32();
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_25, tmp_22);
TCGv_i32 tmp_26 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_27 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_24, tmp_25, tmp_23, tmp_26, tmp_27);
tcg_gen_andi_i32(PdV, tmp_24, 0xff);
}

void emit_S4_ntstbit_r(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv PdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { PdV = (((fCAST4_8u(RsV) & ((fSXTN(7,32,RtV) > 0) ? (fCAST4_8u(1) << fSXTN(7,32,RtV)) : (fCAST4_8u(1) >>> -fSXTN(7,32,RtV)))) == 0) ? 0xff : 0x00); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_0, RsV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_2, tmp_1, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_2, 0);
}
TCGv_i64 tmp_3 = tcg_temp_new_i64();
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
tcg_gen_setcondi_i64(TCG_COND_GT, tmp_3, tmp_2, qemu_tmp_1);
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((uint32_t) 0x1)));
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_5, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RtV);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_7, tmp_6, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_7, 0);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_8, tmp_5, tmp_7);
TCGv_i64 tmp_9 = tcg_constant_i64(0);
TCGv_i64 tmp_10 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_8, tmp_7, tmp_10, tmp_9, tmp_8);
TCGv_i32 tmp_11 = tcg_constant_i32((int32_t) (((uint32_t) 0x1)));
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_12, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, RtV);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_14, tmp_13, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_14, 0);
}
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_15, tmp_14);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_16, tmp_12, tmp_15);
TCGv_i64 tmp_17 = tcg_constant_i64(0);
TCGv_i64 tmp_18 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_16, tmp_15, tmp_18, tmp_17, tmp_16);
TCGv_i64 tmp_19 = tcg_constant_i64(0);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_movcond_i64(TCG_COND_NE, tmp_20, tmp_3, tmp_19, tmp_8, tmp_16);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_21, tmp_0, tmp_20);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x0);
tcg_gen_setcondi_i64(TCG_COND_EQ, tmp_22, tmp_21, qemu_tmp_4);
TCGv_i32 tmp_23 = tcg_constant_i32(0);
TCGv_i32 tmp_24 = tcg_temp_new_i32();
TCGv_i32 tmp_25 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_25, tmp_22);
TCGv_i32 tmp_26 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_27 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_24, tmp_25, tmp_23, tmp_26, tmp_27);
tcg_gen_andi_i32(PdV, tmp_24, 0xff);
}

void emit_S2_setbit_r(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RdV = (RsV | ((fSXTN(7,32,RtV) > 0) ? (fCAST4_8u(1) << fSXTN(7,32,RtV)) : (fCAST4_8u(1) >>> -fSXTN(7,32,RtV)))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
tcg_gen_setcondi_i64(TCG_COND_GT, tmp_2, tmp_1, qemu_tmp_1);
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((uint32_t) 0x1)));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_4, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RtV);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_7, tmp_4, tmp_6);
TCGv_i64 tmp_8 = tcg_constant_i64(0);
TCGv_i64 tmp_9 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_7, tmp_6, tmp_9, tmp_8, tmp_7);
TCGv_i32 tmp_10 = tcg_constant_i32((int32_t) (((uint32_t) 0x1)));
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_11, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, RtV);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_13, tmp_12, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_13, 0);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_14, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_15, tmp_11, tmp_14);
TCGv_i64 tmp_16 = tcg_constant_i64(0);
TCGv_i64 tmp_17 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_15, tmp_14, tmp_17, tmp_16, tmp_15);
TCGv_i64 tmp_18 = tcg_constant_i64(0);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_movcond_i64(TCG_COND_NE, tmp_19, tmp_2, tmp_18, tmp_7, tmp_15);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_20, RsV);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_21, tmp_20, tmp_19);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_22, tmp_21);
tcg_gen_mov_i32(RdV, tmp_22);
}

void emit_S2_togglebit_r(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RdV = (RsV ^ ((fSXTN(7,32,RtV) > 0) ? (fCAST4_8u(1) << fSXTN(7,32,RtV)) : (fCAST4_8u(1) >>> -fSXTN(7,32,RtV)))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
tcg_gen_setcondi_i64(TCG_COND_GT, tmp_2, tmp_1, qemu_tmp_1);
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((uint32_t) 0x1)));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_4, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RtV);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_7, tmp_4, tmp_6);
TCGv_i64 tmp_8 = tcg_constant_i64(0);
TCGv_i64 tmp_9 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_7, tmp_6, tmp_9, tmp_8, tmp_7);
TCGv_i32 tmp_10 = tcg_constant_i32((int32_t) (((uint32_t) 0x1)));
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_11, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, RtV);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_13, tmp_12, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_13, 0);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_14, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_15, tmp_11, tmp_14);
TCGv_i64 tmp_16 = tcg_constant_i64(0);
TCGv_i64 tmp_17 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_15, tmp_14, tmp_17, tmp_16, tmp_15);
TCGv_i64 tmp_18 = tcg_constant_i64(0);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_movcond_i64(TCG_COND_NE, tmp_19, tmp_2, tmp_18, tmp_7, tmp_15);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_20, RsV);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_xor_i64(tmp_21, tmp_20, tmp_19);
TCGv_i32 tmp_22 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_22, tmp_21);
tcg_gen_mov_i32(RdV, tmp_22);
}

void emit_S2_clrbit_r(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RdV = (RsV & (~(((fSXTN(7,32,RtV) > 0) ? (fCAST4_8u(1) << fSXTN(7,32,RtV)) : (fCAST4_8u(1) >>> -fSXTN(7,32,RtV)))))); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
tcg_gen_setcondi_i64(TCG_COND_GT, tmp_2, tmp_1, qemu_tmp_1);
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((uint32_t) 0x1)));
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_4, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RtV);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_7, tmp_4, tmp_6);
TCGv_i64 tmp_8 = tcg_constant_i64(0);
TCGv_i64 tmp_9 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_7, tmp_6, tmp_9, tmp_8, tmp_7);
TCGv_i32 tmp_10 = tcg_constant_i32((int32_t) (((uint32_t) 0x1)));
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_11, tmp_10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, RtV);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_13, tmp_12, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_13, 0);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_14, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_15, tmp_11, tmp_14);
TCGv_i64 tmp_16 = tcg_constant_i64(0);
TCGv_i64 tmp_17 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_15, tmp_14, tmp_17, tmp_16, tmp_15);
TCGv_i64 tmp_18 = tcg_constant_i64(0);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_movcond_i64(TCG_COND_NE, tmp_19, tmp_2, tmp_18, tmp_7, tmp_15);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_not_i64(tmp_20, tmp_19);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_21, RsV);
TCGv_i64 tmp_22 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_22, tmp_21, tmp_20);
TCGv_i32 tmp_23 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_23, tmp_22);
tcg_gen_mov_i32(RdV, tmp_23);
}

void emit_S2_asr_i_vh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, int uiV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV, (fGETHALF(i,RssV)>>uiV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 16, 16);
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_1 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_1, tmp_0, shift);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_1, i * 16, 16);
}
}

void emit_S2_lsr_i_vh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, int uiV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV, (fGETUHALF(i,RssV)>>uiV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, i * 16, 16);
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_1, 0);
} else {
tcg_gen_shri_i64(tmp_1, tmp_0, qemu_tmp_0);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_1, i * 16, 16);
}
}

void emit_S2_asl_i_vh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, int uiV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV, (fGETHALF(i,RssV)<<uiV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 16, 16);
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_1, 0);
} else {
tcg_gen_shli_i64(tmp_1, tmp_0, qemu_tmp_0);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_1, i * 16, 16);
}
}

void emit_S2_asr_r_vh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV, ((fSXTN(7,32,RtV) > 0) ? (fSXTN(16, 64, fGETHALF(i,RssV)) >> fSXTN(7,32,RtV)) : (fSXTN(16, 64, fGETHALF(i,RssV)) << -fSXTN(7,32,RtV)))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
tcg_gen_setcondi_i64(TCG_COND_GT, tmp_2, tmp_1, qemu_tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RssV, i * 16, 16);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RtV);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_7, tmp_4, tmp_6);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
TCGv_i64 tmp_9 = tcg_constant_i64(0);
TCGv_i64 tmp_10 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_8, tmp_4, 63, 1);
tcg_gen_sub_i64(tmp_8, tmp_9, tmp_8);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_7, tmp_6, tmp_10, tmp_8, tmp_7);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_11, RssV, i * 16, 16);
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_12, tmp_11, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_12, 0);
}
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_13, RtV);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_5 != 0) {
tcg_gen_sextract_i64(tmp_14, tmp_13, 0, qemu_tmp_5);
} else {
tcg_gen_movi_i64(tmp_14, 0);
}
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_15, tmp_14);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_16, tmp_12, tmp_15);
TCGv_i64 tmp_17 = tcg_constant_i64(0);
TCGv_i64 tmp_18 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_16, tmp_15, tmp_18, tmp_17, tmp_16);
TCGv_i64 tmp_19 = tcg_constant_i64(0);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_movcond_i64(TCG_COND_NE, tmp_20, tmp_2, tmp_19, tmp_7, tmp_16);
tcg_gen_deposit_i64(RddV, RddV, tmp_20, i * 16, 16);
}
}

void emit_S5_asrhub_rnd_sat(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV, int uiV)
/* { int i; for (i=0;i<4;i++) { fSETBYTE(i,RdV, fSATUN(8, ((fGETHALF(i,RssV) >> uiV )+1)>>1)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 16, 16);
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_1 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_1, tmp_0, shift);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_2, tmp_1, qemu_tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_3, tmp_2, shift);
}
TCGv_i64 tmp_4 = tcg_temp_new_i64();
TCGv_i32 tmp_5 = tcg_temp_new_i32();
gen_satu_i64_ovfl(tmp_5, tmp_4, tmp_3, 8);
gen_set_usr_field_if(ctx, USR_OVF,tmp_5);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_6, tmp_4);
tcg_gen_deposit_i32(RdV, RdV, tmp_6, i * 8, 8);
}
}

void emit_S5_asrhub_sat(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV, int uiV)
/* { int i; for (i=0;i<4;i++) { fSETBYTE(i,RdV, fSATUN(8, fGETHALF(i,RssV) >> uiV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 16, 16);
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_1 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_1, tmp_0, shift);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
TCGv_i32 tmp_3 = tcg_temp_new_i32();
gen_satu_i64_ovfl(tmp_3, tmp_2, tmp_1, 8);
gen_set_usr_field_if(ctx, USR_OVF,tmp_3);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_2);
tcg_gen_deposit_i32(RdV, RdV, tmp_4, i * 8, 8);
}
}

void emit_S5_vasrhrnd(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, int uiV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV, ( ((fGETHALF(i,RssV) >> uiV)+1)>>1 )); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 16, 16);
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_1 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_1, tmp_0, shift);
}
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_2, tmp_1, qemu_tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_2;
if (qemu_tmp_2 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_3, tmp_2, shift);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_3, i * 16, 16);
}
}

void emit_S2_asl_r_vh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV, ((fSXTN(7,32,RtV) > 0) ? (fSXTN(16, 64, fGETHALF(i,RssV)) << fSXTN(7,32,RtV)) : (fSXTN(16, 64, fGETHALF(i,RssV)) >> -fSXTN(7,32,RtV)))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
tcg_gen_setcondi_i64(TCG_COND_GT, tmp_2, tmp_1, qemu_tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RssV, i * 16, 16);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_4, tmp_3, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RtV);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_7, tmp_4, tmp_6);
TCGv_i64 tmp_8 = tcg_constant_i64(0);
TCGv_i64 tmp_9 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_7, tmp_6, tmp_9, tmp_8, tmp_7);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RssV, i * 16, 16);
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_sextract_i64(tmp_11, tmp_10, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_11, 0);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, RtV);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_5 != 0) {
tcg_gen_sextract_i64(tmp_13, tmp_12, 0, qemu_tmp_5);
} else {
tcg_gen_movi_i64(tmp_13, 0);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_14, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_15, tmp_11, tmp_14);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
TCGv_i64 tmp_17 = tcg_constant_i64(0);
TCGv_i64 tmp_18 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_16, tmp_11, 63, 1);
tcg_gen_sub_i64(tmp_16, tmp_17, tmp_16);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_15, tmp_14, tmp_18, tmp_16, tmp_15);
TCGv_i64 tmp_19 = tcg_constant_i64(0);
TCGv_i64 tmp_20 = tcg_temp_new_i64();
tcg_gen_movcond_i64(TCG_COND_NE, tmp_20, tmp_2, tmp_19, tmp_7, tmp_15);
tcg_gen_deposit_i64(RddV, RddV, tmp_20, i * 16, 16);
}
}

void emit_S2_lsr_r_vh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV, (((fSXTN(7,32,RtV)) < 0) ? ((fZXTN(16, 64, fGETUHALF(i,RssV)) << ((-(fSXTN(7,32,RtV))) - 1)) << 1) : (fZXTN(16, 64, fGETUHALF(i,RssV)) >> (fSXTN(7,32,RtV))))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
tcg_gen_setcondi_i64(TCG_COND_LT, tmp_2, tmp_1, qemu_tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_3, RssV, i * 16, 16);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RtV);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_7, tmp_6);
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_subi_i64(tmp_8, tmp_7, qemu_tmp_4);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_9, tmp_4, tmp_8);
TCGv_i64 tmp_10 = tcg_constant_i64(0);
TCGv_i64 tmp_11 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_9, tmp_8, tmp_11, tmp_10, tmp_9);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
if (qemu_tmp_5 >= 64) {
tcg_gen_movi_i64(tmp_12, 0);
} else {
tcg_gen_shli_i64(tmp_12, tmp_9, qemu_tmp_5);
}
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_13, RssV, i * 16, 16);
int64_t qemu_tmp_6 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
if (qemu_tmp_6 != 0) {
tcg_gen_extract_i64(tmp_14, tmp_13, 0, qemu_tmp_6);
} else {
tcg_gen_movi_i64(tmp_14, 0);
}
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_15, RtV);
int64_t qemu_tmp_7 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
if (qemu_tmp_7 != 0) {
tcg_gen_sextract_i64(tmp_16, tmp_15, 0, qemu_tmp_7);
} else {
tcg_gen_movi_i64(tmp_16, 0);
}
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_17, tmp_14, tmp_16);
TCGv_i64 tmp_18 = tcg_constant_i64(0);
TCGv_i64 tmp_19 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_17, tmp_16, tmp_19, tmp_18, tmp_17);
TCGv_i64 tmp_20 = tcg_constant_i64(0);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_movcond_i64(TCG_COND_NE, tmp_21, tmp_2, tmp_20, tmp_12, tmp_17);
tcg_gen_deposit_i64(RddV, RddV, tmp_21, i * 16, 16);
}
}

void emit_S2_lsl_r_vh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV, ((fSXTN(7,32,RtV) > 0) ? (fZXTN(16, 64, fGETUHALF(i,RssV)) << fSXTN(7,32,RtV)) : (fZXTN(16, 64, fGETUHALF(i,RssV)) >>> -fSXTN(7,32,RtV)))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
tcg_gen_setcondi_i64(TCG_COND_GT, tmp_2, tmp_1, qemu_tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_3, RssV, i * 16, 16);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_extract_i64(tmp_4, tmp_3, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_4, 0);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, RtV);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_6, tmp_5, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_6, 0);
}
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_7, tmp_4, tmp_6);
TCGv_i64 tmp_8 = tcg_constant_i64(0);
TCGv_i64 tmp_9 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_7, tmp_6, tmp_9, tmp_8, tmp_7);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_10, RssV, i * 16, 16);
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_4 != 0) {
tcg_gen_extract_i64(tmp_11, tmp_10, 0, qemu_tmp_4);
} else {
tcg_gen_movi_i64(tmp_11, 0);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_12, RtV);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_5 != 0) {
tcg_gen_sextract_i64(tmp_13, tmp_12, 0, qemu_tmp_5);
} else {
tcg_gen_movi_i64(tmp_13, 0);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_14, tmp_13);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_15, tmp_11, tmp_14);
TCGv_i64 tmp_16 = tcg_constant_i64(0);
TCGv_i64 tmp_17 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_15, tmp_14, tmp_17, tmp_16, tmp_15);
TCGv_i64 tmp_18 = tcg_constant_i64(0);
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_movcond_i64(TCG_COND_NE, tmp_19, tmp_2, tmp_18, tmp_7, tmp_15);
tcg_gen_deposit_i64(RddV, RddV, tmp_19, i * 16, 16);
}
}

void emit_S2_asr_i_vw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, int uiV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV,(fGETWORD(i,RssV)>>uiV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 32, 32);
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_1 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_1, tmp_0, shift);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_1, i * 32, 32);
}
}

void emit_S2_asr_i_svw_trun(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV, int uiV)
/* { int i; for (i=0;i<2;i++) { fSETHALF(i,RdV,fGETHALF(0,(fGETWORD(i,RssV)>>uiV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 32, 32);
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_1 = tcg_temp_new_i64();
{
int64_t shift = qemu_tmp_0;
if (qemu_tmp_0 >= 64) {
    shift = 64 - 1;
}
tcg_gen_sari_i64(tmp_1, tmp_0, shift);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, tmp_1, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_2);
tcg_gen_deposit_i32(RdV, RdV, tmp_3, i * 16, 16);
}
}

void emit_S2_lsr_i_vw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, int uiV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV,(fGETUWORD(i,RssV)>>uiV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_0, RssV, i * 32, 32);
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_1, 0);
} else {
tcg_gen_shri_i64(tmp_1, tmp_0, qemu_tmp_0);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_1, i * 32, 32);
}
}

void emit_S2_asl_i_vw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, int uiV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV,(fGETWORD(i,RssV)<<uiV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 32, 32);
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_1, 0);
} else {
tcg_gen_shli_i64(tmp_1, tmp_0, qemu_tmp_0);
}
tcg_gen_deposit_i64(RddV, RddV, tmp_1, i * 32, 32);
}
}

void emit_S2_asr_r_vw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV, ((fSXTN(7,32,RtV) > 0) ? (fCAST4_8s(fGETWORD(i,RssV)) >> fSXTN(7,32,RtV)) : (fCAST4_8s(fGETWORD(i,RssV)) << -fSXTN(7,32,RtV)))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
tcg_gen_setcondi_i64(TCG_COND_GT, tmp_2, tmp_1, qemu_tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RssV, i * 32, 32);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, RtV);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_5, tmp_4, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_5, 0);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_6, tmp_3, tmp_5);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
TCGv_i64 tmp_8 = tcg_constant_i64(0);
TCGv_i64 tmp_9 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_7, tmp_3, 63, 1);
tcg_gen_sub_i64(tmp_7, tmp_8, tmp_7);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_6, tmp_5, tmp_9, tmp_7, tmp_6);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_10, RssV, i * 32, 32);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_11, RtV);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_12 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_12, tmp_11, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_12, 0);
}
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_13, tmp_12);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_14, tmp_10, tmp_13);
TCGv_i64 tmp_15 = tcg_constant_i64(0);
TCGv_i64 tmp_16 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_14, tmp_13, tmp_16, tmp_15, tmp_14);
TCGv_i64 tmp_17 = tcg_constant_i64(0);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_movcond_i64(TCG_COND_NE, tmp_18, tmp_2, tmp_17, tmp_6, tmp_14);
tcg_gen_deposit_i64(RddV, RddV, tmp_18, i * 32, 32);
}
}

void emit_S2_asl_r_vw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV, ((fSXTN(7,32,RtV) > 0) ? (fCAST4_8s(fGETWORD(i,RssV)) << fSXTN(7,32,RtV)) : (fCAST4_8s(fGETWORD(i,RssV)) >> -fSXTN(7,32,RtV)))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
tcg_gen_setcondi_i64(TCG_COND_GT, tmp_2, tmp_1, qemu_tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RssV, i * 32, 32);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_4, RtV);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_5, tmp_4, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_5, 0);
}
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_6, tmp_3, tmp_5);
TCGv_i64 tmp_7 = tcg_constant_i64(0);
TCGv_i64 tmp_8 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_6, tmp_5, tmp_8, tmp_7, tmp_6);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_9, RssV, i * 32, 32);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_10, RtV);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_11, tmp_10, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_11, 0);
}
TCGv_i64 tmp_12 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_12, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_sar_i64(tmp_13, tmp_9, tmp_12);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
TCGv_i64 tmp_15 = tcg_constant_i64(0);
TCGv_i64 tmp_16 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_extract_i64(tmp_14, tmp_9, 63, 1);
tcg_gen_sub_i64(tmp_14, tmp_15, tmp_14);
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_13, tmp_12, tmp_16, tmp_14, tmp_13);
TCGv_i64 tmp_17 = tcg_constant_i64(0);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
tcg_gen_movcond_i64(TCG_COND_NE, tmp_18, tmp_2, tmp_17, tmp_6, tmp_13);
tcg_gen_deposit_i64(RddV, RddV, tmp_18, i * 32, 32);
}
}

void emit_S2_lsr_r_vw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV, (((fSXTN(7,32,RtV)) < 0) ? ((fCAST4_8u(fGETUWORD(i,RssV)) << ((-(fSXTN(7,32,RtV))) - 1)) << 1) : (fCAST4_8u(fGETUWORD(i,RssV)) >> (fSXTN(7,32,RtV))))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
tcg_gen_setcondi_i64(TCG_COND_LT, tmp_2, tmp_1, qemu_tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_3, RssV, i * 32, 32);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_5, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RtV);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_7, tmp_6, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_7, 0);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_8, tmp_7);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_9 = tcg_temp_new_i64();
tcg_gen_subi_i64(tmp_9, tmp_8, qemu_tmp_3);
TCGv_i64 tmp_10 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_10, tmp_5, tmp_9);
TCGv_i64 tmp_11 = tcg_constant_i64(0);
TCGv_i64 tmp_12 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_10, tmp_9, tmp_12, tmp_11, tmp_10);
int64_t qemu_tmp_4 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
if (qemu_tmp_4 >= 64) {
tcg_gen_movi_i64(tmp_13, 0);
} else {
tcg_gen_shli_i64(tmp_13, tmp_10, qemu_tmp_4);
}
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_14, RssV, i * 32, 32);
TCGv_i32 tmp_15 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_15, tmp_14);
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_16, tmp_15);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_17, RtV);
int64_t qemu_tmp_5 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_18 = tcg_temp_new_i64();
if (qemu_tmp_5 != 0) {
tcg_gen_sextract_i64(tmp_18, tmp_17, 0, qemu_tmp_5);
} else {
tcg_gen_movi_i64(tmp_18, 0);
}
TCGv_i64 tmp_19 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_19, tmp_16, tmp_18);
TCGv_i64 tmp_20 = tcg_constant_i64(0);
TCGv_i64 tmp_21 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_19, tmp_18, tmp_21, tmp_20, tmp_19);
TCGv_i64 tmp_22 = tcg_constant_i64(0);
TCGv_i64 tmp_23 = tcg_temp_new_i64();
tcg_gen_movcond_i64(TCG_COND_NE, tmp_23, tmp_2, tmp_22, tmp_13, tmp_19);
tcg_gen_deposit_i64(RddV, RddV, tmp_23, i * 32, 32);
}
}

void emit_S2_lsl_r_vw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i32 RtV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV, ((fSXTN(7,32,RtV) > 0) ? (fCAST4_8u(fGETUWORD(i,RssV)) << fSXTN(7,32,RtV)) : (fCAST4_8u(fGETUWORD(i,RssV)) >>> -fSXTN(7,32,RtV)))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RtV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i64 tmp_2 = tcg_temp_new_i64();
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
tcg_gen_setcondi_i64(TCG_COND_GT, tmp_2, tmp_1, qemu_tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_3, RssV, i * 32, 32);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_5, tmp_4);
TCGv_i64 tmp_6 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_6, RtV);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
if (qemu_tmp_2 != 0) {
tcg_gen_sextract_i64(tmp_7, tmp_6, 0, qemu_tmp_2);
} else {
tcg_gen_movi_i64(tmp_7, 0);
}
TCGv_i64 tmp_8 = tcg_temp_new_i64();
tcg_gen_shl_i64(tmp_8, tmp_5, tmp_7);
TCGv_i64 tmp_9 = tcg_constant_i64(0);
TCGv_i64 tmp_10 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_8, tmp_7, tmp_10, tmp_9, tmp_8);
TCGv_i64 tmp_11 = tcg_temp_new_i64();
tcg_gen_extract_i64(tmp_11, RssV, i * 32, 32);
TCGv_i32 tmp_12 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_12, tmp_11);
TCGv_i64 tmp_13 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_13, tmp_12);
TCGv_i64 tmp_14 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_14, RtV);
int64_t qemu_tmp_3 = (int64_t)((int32_t) 0x7);
TCGv_i64 tmp_15 = tcg_temp_new_i64();
if (qemu_tmp_3 != 0) {
tcg_gen_sextract_i64(tmp_15, tmp_14, 0, qemu_tmp_3);
} else {
tcg_gen_movi_i64(tmp_15, 0);
}
TCGv_i64 tmp_16 = tcg_temp_new_i64();
tcg_gen_neg_i64(tmp_16, tmp_15);
TCGv_i64 tmp_17 = tcg_temp_new_i64();
tcg_gen_shr_i64(tmp_17, tmp_13, tmp_16);
TCGv_i64 tmp_18 = tcg_constant_i64(0);
TCGv_i64 tmp_19 = tcg_constant_i64((int64_t) (((uint64_t) 0x40ULL)));
tcg_gen_movcond_i64(TCG_COND_GEU, tmp_17, tmp_16, tmp_19, tmp_18, tmp_17);
TCGv_i64 tmp_20 = tcg_constant_i64(0);
TCGv_i64 tmp_21 = tcg_temp_new_i64();
tcg_gen_movcond_i64(TCG_COND_NE, tmp_21, tmp_2, tmp_20, tmp_8, tmp_17);
tcg_gen_deposit_i64(RddV, RddV, tmp_21, i * 32, 32);
}
}

void emit_S2_vrndpackwh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV)
/* { int i; for (i=0;i<2;i++) { fSETHALF(i,RdV,fGETHALF(1,(fGETWORD(i,RssV)+0x08000))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 32, 32);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_1, tmp_0, qemu_tmp_0);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, tmp_1, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_2);
tcg_gen_deposit_i32(RdV, RdV, tmp_3, i * 16, 16);
}
}

void emit_S2_vrndpackwhs(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV)
/* { int i; for (i=0;i<2;i++) { fSETHALF(i,RdV,fGETHALF(1,fSATN(32, fGETWORD(i,RssV)+0x08000))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 32, 32);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x8000);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_1, tmp_0, qemu_tmp_0);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
TCGv_i32 tmp_3 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_3, tmp_2, tmp_1, 32);
gen_set_usr_field_if(ctx, USR_OVF,tmp_3);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_4, tmp_2, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_deposit_i32(RdV, RdV, tmp_5, i * 16, 16);
}
}

void emit_S2_vsxtbh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV,fGETBYTE(i,RsV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, tmp_0);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, i * 16, 16);
}
}

void emit_S2_vzxtbh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV,fGETUBYTE(i,RsV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, i * 8, 8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_1, tmp_0);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, i * 16, 16);
}
}

void emit_S2_vsathub(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV)
/* { int i; for (i=0;i<4;i++) { fSETBYTE(i,RdV,fSATUN(8,fGETHALF(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
TCGv_i32 tmp_2 = tcg_temp_new_i32();
gen_satu_i64_ovfl(tmp_2, tmp_1, tmp_0, 8);
gen_set_usr_field_if(ctx, USR_OVF,tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
tcg_gen_deposit_i32(RdV, RdV, tmp_3, i * 8, 8);
}
}

void emit_S2_svsathub(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* { fSETBYTE(0,RdV,fSATUN(8,fGETHALF(0,RsV))); fSETBYTE(1,RdV,fSATUN(8,fGETHALF(1,RsV))); fSETBYTE(2,RdV,0); fSETBYTE(3,RdV,0); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
TCGv_i32 tmp_2 = tcg_temp_new_i32();
gen_satu_i32_ovfl(tmp_2, tmp_1, tmp_0, 8);
gen_set_usr_field_if(ctx, USR_OVF,tmp_2);
tcg_gen_deposit_i32(RdV, RdV, tmp_1, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
TCGv_i32 tmp_5 = tcg_temp_new_i32();
gen_satu_i32_ovfl(tmp_5, tmp_4, tmp_3, 8);
gen_set_usr_field_if(ctx, USR_OVF,tmp_5);
tcg_gen_deposit_i32(RdV, RdV, tmp_4, ((int32_t) 0x1) * 8, 8);
TCGv_i32 tmp_6 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_deposit_i32(RdV, RdV, tmp_6, ((int32_t) 0x2) * 8, 8);
TCGv_i32 tmp_7 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_deposit_i32(RdV, RdV, tmp_7, ((int32_t) 0x3) * 8, 8);
}

void emit_S2_svsathb(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* { fSETBYTE(0,RdV,fSATN(8,fGETHALF(0,RsV))); fSETBYTE(1,RdV,fSATN(8,fGETHALF(1,RsV))); fSETBYTE(2,RdV,0); fSETBYTE(3,RdV,0); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
TCGv_i32 tmp_2 = tcg_temp_new_i32();
gen_sat_i32_ovfl(tmp_2, tmp_1, tmp_0, 8);
gen_set_usr_field_if(ctx, USR_OVF,tmp_2);
tcg_gen_deposit_i32(RdV, RdV, tmp_1, ((int32_t) 0x0) * 8, 8);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_3, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
TCGv_i32 tmp_5 = tcg_temp_new_i32();
gen_sat_i32_ovfl(tmp_5, tmp_4, tmp_3, 8);
gen_set_usr_field_if(ctx, USR_OVF,tmp_5);
tcg_gen_deposit_i32(RdV, RdV, tmp_4, ((int32_t) 0x1) * 8, 8);
TCGv_i32 tmp_6 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_deposit_i32(RdV, RdV, tmp_6, ((int32_t) 0x2) * 8, 8);
TCGv_i32 tmp_7 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_deposit_i32(RdV, RdV, tmp_7, ((int32_t) 0x3) * 8, 8);
}

void emit_S2_vsathb(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV)
/* { int i; for (i=0;i<4;i++) { fSETBYTE(i,RdV,fSATN(8,fGETHALF(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
TCGv_i32 tmp_2 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_2, tmp_1, tmp_0, 8);
gen_set_usr_field_if(ctx, USR_OVF,tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
tcg_gen_deposit_i32(RdV, RdV, tmp_3, i * 8, 8);
}
}

void emit_S2_vtrunohb(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV)
/* { int i; for (i=0;i<4;i++) { fSETBYTE(i,RdV,fGETBYTE(i*2+1,RssV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
int32_t qemu_tmp_0 = i * ((int32_t) 0x2);
int32_t qemu_tmp_1 = qemu_tmp_0 + ((int32_t) 0x1);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, qemu_tmp_1 * 8, 8);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_1, tmp_0);
tcg_gen_deposit_i32(RdV, RdV, tmp_1, i * 8, 8);
}
}

void emit_S2_vtrunewh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETHALF(0,RddV,fGETHALF(0,RttV)); fSETHALF(1,RddV,fGETHALF(2,RttV)); fSETHALF(2,RddV,fGETHALF(0,RssV)); fSETHALF(3,RddV,fGETHALF(2,RssV)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, ((int32_t) 0x0) * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_0, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x2) * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RssV, ((int32_t) 0x0) * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RssV, ((int32_t) 0x2) * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, ((int32_t) 0x3) * 16, 16);
}

void emit_S2_vtrunowh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { fSETHALF(0,RddV,fGETHALF(1,RttV)); fSETHALF(1,RddV,fGETHALF(3,RttV)); fSETHALF(2,RddV,fGETHALF(1,RssV)); fSETHALF(3,RddV,fGETHALF(3,RssV)); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, ((int32_t) 0x1) * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_0, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, ((int32_t) 0x3) * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_2, RssV, ((int32_t) 0x1) * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_2, ((int32_t) 0x2) * 16, 16);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, RssV, ((int32_t) 0x3) * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, ((int32_t) 0x3) * 16, 16);
}

void emit_S2_vtrunehb(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV)
/* { int i; for (i=0;i<4;i++) { fSETBYTE(i,RdV,fGETBYTE(i*2,RssV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
int32_t qemu_tmp_0 = i * ((int32_t) 0x2);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, qemu_tmp_0 * 8, 8);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_1, tmp_0);
tcg_gen_deposit_i32(RdV, RdV, tmp_1, i * 8, 8);
}
}

void emit_S6_vtrunehb_ppp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i=0;i<4;i++) { fSETBYTE(i,RddV,fGETBYTE(i*2,RttV)); fSETBYTE(i+4,RddV,fGETBYTE(i*2,RssV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
int32_t qemu_tmp_0 = i * ((int32_t) 0x2);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, qemu_tmp_0 * 8, 8);
tcg_gen_deposit_i64(RddV, RddV, tmp_0, i * 8, 8);
int32_t qemu_tmp_1 = i + ((int32_t) 0x4);
int32_t qemu_tmp_2 = i * ((int32_t) 0x2);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, qemu_tmp_2 * 8, 8);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, qemu_tmp_1 * 8, 8);
}
}

void emit_S6_vtrunohb_ppp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i=0;i<4;i++) { fSETBYTE(i,RddV,fGETBYTE(i*2+1,RttV)); fSETBYTE(i+4,RddV,fGETBYTE(i*2+1,RssV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
int32_t qemu_tmp_0 = i * ((int32_t) 0x2);
int32_t qemu_tmp_1 = qemu_tmp_0 + ((int32_t) 0x1);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, qemu_tmp_1 * 8, 8);
tcg_gen_deposit_i64(RddV, RddV, tmp_0, i * 8, 8);
int32_t qemu_tmp_2 = i + ((int32_t) 0x4);
int32_t qemu_tmp_3 = i * ((int32_t) 0x2);
int32_t qemu_tmp_4 = qemu_tmp_3 + ((int32_t) 0x1);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, qemu_tmp_4 * 8, 8);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, qemu_tmp_2 * 8, 8);
}
}

void emit_S2_vsxthw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV,fGETHALF(i,RsV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RsV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, tmp_0);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, i * 32, 32);
}
}

void emit_S2_vzxthw(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV,fGETUHALF(i,RsV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_0, RsV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_1, tmp_0);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, i * 32, 32);
}
}

void emit_S2_vsatwh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV)
/* { int i; for (i=0;i<2;i++) { fSETHALF(i,RdV,fSATN(16,fGETWORD(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
TCGv_i32 tmp_2 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_2, tmp_1, tmp_0, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
tcg_gen_deposit_i32(RdV, RdV, tmp_3, i * 16, 16);
}
}

void emit_S2_vsatwuh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV)
/* { int i; for (i=0;i<2;i++) { fSETHALF(i,RdV,fSATUN(16,fGETWORD(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
TCGv_i32 tmp_2 = tcg_temp_new_i32();
gen_satu_i64_ovfl(tmp_2, tmp_1, tmp_0, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_2);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_1);
tcg_gen_deposit_i32(RdV, RdV, tmp_3, i * 16, 16);
}
}

void emit_S2_packhl(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { fSETHALF(0,RddV,fGETHALF(0,RtV)); fSETHALF(1,RddV,fGETHALF(0,RsV)); fSETHALF(2,RddV,fGETHALF(1,RtV)); fSETHALF(3,RddV,fGETHALF(1,RsV)); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_0, RtV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, tmp_0);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, ((int32_t) 0x0) * 16, 16);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_2, RsV, ((int32_t) 0x0) * 16, 16);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_3, tmp_2);
tcg_gen_deposit_i64(RddV, RddV, tmp_3, ((int32_t) 0x1) * 16, 16);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_4, RtV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_5, tmp_4);
tcg_gen_deposit_i64(RddV, RddV, tmp_5, ((int32_t) 0x2) * 16, 16);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_6, RsV, ((int32_t) 0x1) * 16, 16);
TCGv_i64 tmp_7 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_7, tmp_6);
tcg_gen_deposit_i64(RddV, RddV, tmp_7, ((int32_t) 0x3) * 16, 16);
}

void emit_S2_vsathub_nopack(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV,fSATUN(8,fGETHALF(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
TCGv_i32 tmp_2 = tcg_temp_new_i32();
gen_satu_i64_ovfl(tmp_2, tmp_1, tmp_0, 8);
gen_set_usr_field_if(ctx, USR_OVF,tmp_2);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, i * 16, 16);
}
}

void emit_S2_vsathb_nopack(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV)
/* { int i; for (i=0;i<4;i++) { fSETHALF(i,RddV,fSATN(8,fGETHALF(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 16, 16);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
TCGv_i32 tmp_2 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_2, tmp_1, tmp_0, 8);
gen_set_usr_field_if(ctx, USR_OVF,tmp_2);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, i * 16, 16);
}
}

void emit_S2_vsatwh_nopack(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV,fSATN(16,fGETWORD(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
TCGv_i32 tmp_2 = tcg_temp_new_i32();
gen_sat_i64_ovfl(tmp_2, tmp_1, tmp_0, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_2);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, i * 32, 32);
}
}

void emit_S2_vsatwuh_nopack(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV)
/* { int i; for (i=0;i<2;i++) { fSETWORD(i,RddV,fSATUN(16,fGETWORD(i,RssV))); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, i * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
TCGv_i32 tmp_2 = tcg_temp_new_i32();
gen_satu_i64_ovfl(tmp_2, tmp_1, tmp_0, 16);
gen_set_usr_field_if(ctx, USR_OVF,tmp_2);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, i * 32, 32);
}
}

void emit_S2_shuffob(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i=0;i<4;i++) { fSETBYTE(i*2 ,RddV,fGETBYTE(i*2+1,RssV)); fSETBYTE(i*2+1,RddV,fGETBYTE(i*2+1,RttV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
int32_t qemu_tmp_0 = i * ((int32_t) 0x2);
int32_t qemu_tmp_1 = i * ((int32_t) 0x2);
int32_t qemu_tmp_2 = qemu_tmp_1 + ((int32_t) 0x1);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, qemu_tmp_2 * 8, 8);
tcg_gen_deposit_i64(RddV, RddV, tmp_0, qemu_tmp_0 * 8, 8);
int32_t qemu_tmp_3 = i * ((int32_t) 0x2);
int32_t qemu_tmp_4 = qemu_tmp_3 + ((int32_t) 0x1);
int32_t qemu_tmp_5 = i * ((int32_t) 0x2);
int32_t qemu_tmp_6 = qemu_tmp_5 + ((int32_t) 0x1);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, qemu_tmp_6 * 8, 8);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, qemu_tmp_4 * 8, 8);
}
}

void emit_S2_shuffeb(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i=0;i<4;i++) { fSETBYTE(i*2 ,RddV,fGETBYTE(i*2,RttV)); fSETBYTE(i*2+1,RddV,fGETBYTE(i*2,RssV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x4); i++) {
int32_t qemu_tmp_0 = i * ((int32_t) 0x2);
int32_t qemu_tmp_1 = i * ((int32_t) 0x2);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, qemu_tmp_1 * 8, 8);
tcg_gen_deposit_i64(RddV, RddV, tmp_0, qemu_tmp_0 * 8, 8);
int32_t qemu_tmp_2 = i * ((int32_t) 0x2);
int32_t qemu_tmp_3 = qemu_tmp_2 + ((int32_t) 0x1);
int32_t qemu_tmp_4 = i * ((int32_t) 0x2);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, qemu_tmp_4 * 8, 8);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, qemu_tmp_3 * 8, 8);
}
}

void emit_S2_shuffoh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RttV, TCGv_i64 RssV)
/* { int i; for (i=0;i<2;i++) { fSETHALF(i*2 ,RddV,fGETHALF(i*2+1,RssV)); fSETHALF(i*2+1,RddV,fGETHALF(i*2+1,RttV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
int32_t qemu_tmp_0 = i * ((int32_t) 0x2);
int32_t qemu_tmp_1 = i * ((int32_t) 0x2);
int32_t qemu_tmp_2 = qemu_tmp_1 + ((int32_t) 0x1);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RssV, qemu_tmp_2 * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_0, qemu_tmp_0 * 16, 16);
int32_t qemu_tmp_3 = i * ((int32_t) 0x2);
int32_t qemu_tmp_4 = qemu_tmp_3 + ((int32_t) 0x1);
int32_t qemu_tmp_5 = i * ((int32_t) 0x2);
int32_t qemu_tmp_6 = qemu_tmp_5 + ((int32_t) 0x1);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RttV, qemu_tmp_6 * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, qemu_tmp_4 * 16, 16);
}
}

void emit_S2_shuffeh(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { int i; for (i=0;i<2;i++) { fSETHALF(i*2 ,RddV,fGETHALF(i*2,RttV)); fSETHALF(i*2+1,RddV,fGETHALF(i*2,RssV)); } } */
{
for (int i = ((int32_t) 0x0); i < ((int32_t) 0x2); i++) {
int32_t qemu_tmp_0 = i * ((int32_t) 0x2);
int32_t qemu_tmp_1 = i * ((int32_t) 0x2);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_0, RttV, qemu_tmp_1 * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_0, qemu_tmp_0 * 16, 16);
int32_t qemu_tmp_2 = i * ((int32_t) 0x2);
int32_t qemu_tmp_3 = qemu_tmp_2 + ((int32_t) 0x1);
int32_t qemu_tmp_4 = i * ((int32_t) 0x2);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_1, RssV, qemu_tmp_4 * 16, 16);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, qemu_tmp_3 * 16, 16);
}
}

void emit_S5_popcountp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV)
/* { RdV = fCOUNTONES_8(RssV); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ctpop_i64(tmp_0, RssV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_1, tmp_0);
tcg_gen_mov_i32(RdV, tmp_1);
}

void emit_S4_parity(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, TCGv_i32 RtV)
/* { RdV = 1&fCOUNTONES_4(RsV & RtV); } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_and_i32(tmp_0, RsV, RtV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_ctpop_i32(tmp_1, tmp_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, tmp_1, ((int32_t) 0x1));
tcg_gen_mov_i32(RdV, tmp_2);
}

void emit_S2_parityp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RdV = 1&fCOUNTONES_8(RssV & RttV); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_0, RssV, RttV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ctpop_i64(tmp_1, tmp_0);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_andi_i64(tmp_2, tmp_1, qemu_tmp_0);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_3, tmp_2);
tcg_gen_mov_i32(RdV, tmp_3);
}

void emit_S2_lfsp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i64 RssV, TCGv_i64 RttV)
/* { RddV = (fCAST8u(RssV) >> 1) | (fCAST8u((1&fCOUNTONES_8(RssV & RttV)))<<63) ; } */
{
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
if (qemu_tmp_0 >= 64) {
tcg_gen_movi_i64(tmp_0, 0);
} else {
tcg_gen_shri_i64(tmp_0, RssV, qemu_tmp_0);
}
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_and_i64(tmp_1, RssV, RttV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_ctpop_i64(tmp_2, tmp_1);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_andi_i64(tmp_3, tmp_2, qemu_tmp_1);
int64_t qemu_tmp_2 = (int64_t)((int32_t) 0x3f);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
if (qemu_tmp_2 >= 64) {
tcg_gen_movi_i64(tmp_4, 0);
} else {
tcg_gen_shli_i64(tmp_4, tmp_3, qemu_tmp_2);
}
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_5, tmp_0, tmp_4);
tcg_gen_mov_i64(RddV, tmp_5);
}

void emit_S2_clbnorm(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* { if (RsV == 0) { RdV = 0; } else { RdV = (fMAX(fCL1_4(RsV),fCL1_4(~RsV)))-1;} } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_EQ, tmp_0, RsV, ((int32_t) 0x0));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_0, 0, if_label_0);
tcg_gen_movi_i32(RdV, ((int32_t) 0x0));
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, RsV);
tcg_gen_clzi_i32(tmp_1, tmp_1, 32);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, RsV);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_3, tmp_2);
tcg_gen_clzi_i32(tmp_3, tmp_3, 32);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_smax_i32(tmp_4, tmp_1, tmp_3);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_5, tmp_4, ((int32_t) 0x1));
tcg_gen_mov_i32(RdV, tmp_5);
gen_set_label(if_label_1);
}

void emit_S4_clbaddi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int siV)
/* { RdV = (fMAX(fCL1_4(RsV),fCL1_4(~RsV)))+siV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, RsV);
tcg_gen_clzi_i32(tmp_0, tmp_0, 32);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, RsV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, tmp_1);
tcg_gen_clzi_i32(tmp_2, tmp_2, 32);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_smax_i32(tmp_3, tmp_0, tmp_2);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_4, tmp_3, siV);
tcg_gen_mov_i32(RdV, tmp_4);
}

void emit_S4_clbpnorm(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV)
/* { if (RssV == 0) { RdV = 0; } else { RdV = (fMAX(fCL1_8(RssV),fCL1_8(~RssV)))-1;}} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
tcg_gen_setcondi_i64(TCG_COND_EQ, tmp_0, RssV, qemu_tmp_0);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i64(TCG_COND_EQ, tmp_0, 0, if_label_0);
tcg_gen_movi_i32(RdV, ((int32_t) 0x0));
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_not_i64(tmp_1, RssV);
tcg_gen_clzi_i64(tmp_1, tmp_1, 64);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_not_i64(tmp_2, RssV);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_not_i64(tmp_3, tmp_2);
tcg_gen_clzi_i64(tmp_3, tmp_3, 64);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_smax_i64(tmp_4, tmp_1, tmp_3);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_subi_i64(tmp_5, tmp_4, qemu_tmp_1);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_6, tmp_5);
tcg_gen_mov_i32(RdV, tmp_6);
gen_set_label(if_label_1);
}

void emit_S4_clbpaddi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV, int siV)
/* { RdV = (fMAX(fCL1_8(RssV),fCL1_8(~RssV)))+siV;} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_not_i64(tmp_0, RssV);
tcg_gen_clzi_i64(tmp_0, tmp_0, 64);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_not_i64(tmp_1, RssV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_not_i64(tmp_2, tmp_1);
tcg_gen_clzi_i64(tmp_2, tmp_2, 64);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_smax_i64(tmp_3, tmp_0, tmp_2);
int64_t qemu_tmp_0 = (int64_t)siV;
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_addi_i64(tmp_4, tmp_3, qemu_tmp_0);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_5, tmp_4);
tcg_gen_mov_i32(RdV, tmp_5);
}

void emit_S2_clb(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* {RdV = fMAX(fCL1_4(RsV),fCL1_4(~RsV));} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, RsV);
tcg_gen_clzi_i32(tmp_0, tmp_0, 32);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, RsV);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_2, tmp_1);
tcg_gen_clzi_i32(tmp_2, tmp_2, 32);
TCGv_i32 tmp_3 = tcg_temp_new_i32();
tcg_gen_smax_i32(tmp_3, tmp_0, tmp_2);
tcg_gen_mov_i32(RdV, tmp_3);
}

void emit_S2_cl0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* {RdV = fCL1_4(~RsV);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, RsV);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, tmp_0);
tcg_gen_clzi_i32(tmp_1, tmp_1, 32);
tcg_gen_mov_i32(RdV, tmp_1);
}

void emit_S2_cl1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* {RdV = fCL1_4(RsV);} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_0, RsV);
tcg_gen_clzi_i32(tmp_0, tmp_0, 32);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_S2_clbp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV)
/* {RdV = fMAX(fCL1_8(RssV),fCL1_8(~RssV));} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_not_i64(tmp_0, RssV);
tcg_gen_clzi_i64(tmp_0, tmp_0, 64);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_not_i64(tmp_1, RssV);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
tcg_gen_not_i64(tmp_2, tmp_1);
tcg_gen_clzi_i64(tmp_2, tmp_2, 64);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_smax_i64(tmp_3, tmp_0, tmp_2);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_3);
tcg_gen_mov_i32(RdV, tmp_4);
}

void emit_S2_cl0p(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV)
/* {RdV = fCL1_8(~RssV);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_not_i64(tmp_0, RssV);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_not_i64(tmp_1, tmp_0);
tcg_gen_clzi_i64(tmp_1, tmp_1, 64);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(RdV, tmp_2);
}

void emit_S2_cl1p(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i64 RssV)
/* {RdV = fCL1_8(RssV);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_not_i64(tmp_0, RssV);
tcg_gen_clzi_i64(tmp_0, tmp_0, 64);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_1, tmp_0);
tcg_gen_mov_i32(RdV, tmp_1);
}

void emit_SA1_addi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, int siV)
/* { fIMMEXT(siV); RxV=RxV+siV;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RxV, siV);
tcg_gen_mov_i32(RxV, tmp_0);
}

void emit_SA1_tfr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* { RdV=RsV;} */
{
tcg_gen_mov_i32(RdV, RsV);
}

void emit_SA1_seti(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, int uiV)
/* { fIMMEXT(uiV); RdV=uiV;} */
{
tcg_gen_movi_i32(RdV, uiV);
}

void emit_SA1_setin1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV)
/* { RdV=-1;} */
{
int32_t qemu_tmp_0 = -(((int32_t) 0x1));
tcg_gen_movi_i32(RdV, qemu_tmp_0);
}

void emit_SA1_clrtnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV)
/* { if (fLSBNEW(P0N)) {RdV=0;} else {CANCEL;} } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_mov_i32(tmp_0, ctx->new_pred_value[0]);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_1, tmp_0, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
tcg_gen_movi_i32(RdV, ((int32_t) 0x0));
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_SA1_clrfnew(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV)
/* { if (fLSBNEW(~P0N)) {RdV=0;} else {CANCEL;} } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_mov_i32(tmp_0, ctx->new_pred_value[0]);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, tmp_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_2, tmp_1, ((uint32_t) 0x1));
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
tcg_gen_movi_i32(RdV, ((int32_t) 0x0));
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_SA1_clrt(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV)
/* { if ((fGETBIT(0, fREAD_P0()))) {RdV=0;} else {CANCEL;} } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_read_preg(tmp_0, 0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_1, tmp_0, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_1, 0, if_label_0);
tcg_gen_movi_i32(RdV, ((int32_t) 0x0));
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_SA1_clrf(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV)
/* { if (fGETBIT(0, ~fREAD_P0())) {RdV=0;} else {CANCEL;} } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
gen_read_preg(tmp_0, 0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_not_i32(tmp_1, tmp_0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_extract_i32(tmp_2, tmp_1, ((int32_t) 0x0) * 1, 1);
TCGLabel *if_label_0 = gen_new_label();
tcg_gen_brcondi_i32(TCG_COND_EQ, tmp_2, 0, if_label_0);
tcg_gen_movi_i32(RdV, ((int32_t) 0x0));
TCGLabel *if_label_1 = gen_new_label();
tcg_gen_br(if_label_1);
gen_set_label(if_label_0);
gen_set_label(if_label_1);
}

void emit_SA1_addsp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, int uiV)
/* { RdV=fREAD_SP()+uiV; } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, hex_gpr[29], uiV);
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_SA1_inc(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* { RdV=RsV+1;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, ((int32_t) 0x1));
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_SA1_dec(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* { RdV=RsV-1;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_0, RsV, ((int32_t) 0x1));
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_SA1_addrx(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RxV, TCGv_i32 RsV)
/* { RxV=RxV+RsV; } */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_add_i32(tmp_0, RxV, RsV);
tcg_gen_mov_i32(RxV, tmp_0);
}

void emit_SA1_zxtb(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* { RdV= fZXTN(8,32,RsV);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(RdV, tmp_2);
}

void emit_SA1_and1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* { RdV= RsV&1;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_0, RsV, ((int32_t) 0x1));
tcg_gen_mov_i32(RdV, tmp_0);
}

void emit_SA1_sxtb(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* { RdV= fSXTN(8,32,RsV);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x8);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(RdV, tmp_2);
}

void emit_SA1_zxth(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* { RdV= fZXTN(16,32,RsV);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_extract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(RdV, tmp_2);
}

void emit_SA1_sxth(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV)
/* { RdV= fSXTN(16,32,RsV);} */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x10);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
if (qemu_tmp_0 != 0) {
tcg_gen_sextract_i64(tmp_1, tmp_0, 0, qemu_tmp_0);
} else {
tcg_gen_movi_i64(tmp_1, 0);
}
TCGv_i32 tmp_2 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_2, tmp_1);
tcg_gen_mov_i32(RdV, tmp_2);
}

void emit_SA1_combinezr(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV)
/* { fSETWORD(0,RddV,RsV); fSETWORD(1,RddV,0); } */
{
TCGv_i64 tmp_0 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_0, RsV);
tcg_gen_deposit_i64(RddV, RddV, tmp_0, ((int32_t) 0x0) * 32, 32);
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_1 = tcg_constant_i64((int64_t) (qemu_tmp_0));
tcg_gen_deposit_i64(RddV, RddV, tmp_1, ((int32_t) 0x1) * 32, 32);
}

void emit_SA1_combinerz(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, TCGv_i32 RsV)
/* { fSETWORD(0,RddV,0); fSETWORD(1,RddV,RsV); } */
{
int64_t qemu_tmp_0 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_0 = tcg_constant_i64((int64_t) (qemu_tmp_0));
tcg_gen_deposit_i64(RddV, RddV, tmp_0, ((int32_t) 0x0) * 32, 32);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_ext_i32_i64(tmp_1, RsV);
tcg_gen_deposit_i64(RddV, RddV, tmp_1, ((int32_t) 0x1) * 32, 32);
}

void emit_SA1_combine0i(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, int uiV)
/* { fSETWORD(0,RddV,uiV); fSETWORD(1,RddV,0); } */
{
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_0 = tcg_constant_i64((int64_t) (qemu_tmp_0));
tcg_gen_deposit_i64(RddV, RddV, tmp_0, ((int32_t) 0x0) * 32, 32);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x0);
TCGv_i64 tmp_1 = tcg_constant_i64((int64_t) (qemu_tmp_1));
tcg_gen_deposit_i64(RddV, RddV, tmp_1, ((int32_t) 0x1) * 32, 32);
}

void emit_SA1_combine1i(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, int uiV)
/* { fSETWORD(0,RddV,uiV); fSETWORD(1,RddV,1); } */
{
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_0 = tcg_constant_i64((int64_t) (qemu_tmp_0));
tcg_gen_deposit_i64(RddV, RddV, tmp_0, ((int32_t) 0x0) * 32, 32);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x1);
TCGv_i64 tmp_1 = tcg_constant_i64((int64_t) (qemu_tmp_1));
tcg_gen_deposit_i64(RddV, RddV, tmp_1, ((int32_t) 0x1) * 32, 32);
}

void emit_SA1_combine2i(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, int uiV)
/* { fSETWORD(0,RddV,uiV); fSETWORD(1,RddV,2); } */
{
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_0 = tcg_constant_i64((int64_t) (qemu_tmp_0));
tcg_gen_deposit_i64(RddV, RddV, tmp_0, ((int32_t) 0x0) * 32, 32);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x2);
TCGv_i64 tmp_1 = tcg_constant_i64((int64_t) (qemu_tmp_1));
tcg_gen_deposit_i64(RddV, RddV, tmp_1, ((int32_t) 0x1) * 32, 32);
}

void emit_SA1_combine3i(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, int uiV)
/* { fSETWORD(0,RddV,uiV); fSETWORD(1,RddV,3); } */
{
int64_t qemu_tmp_0 = (int64_t)uiV;
TCGv_i64 tmp_0 = tcg_constant_i64((int64_t) (qemu_tmp_0));
tcg_gen_deposit_i64(RddV, RddV, tmp_0, ((int32_t) 0x0) * 32, 32);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x3);
TCGv_i64 tmp_1 = tcg_constant_i64((int64_t) (qemu_tmp_1));
tcg_gen_deposit_i64(RddV, RddV, tmp_1, ((int32_t) 0x1) * 32, 32);
}

void emit_SA1_cmpeqi(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int uiV)
/* {P0 = ((RsV==uiV) ? 0xff : 0x00);;} */
{
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_setcondi_i32(TCG_COND_EQ, tmp_0, RsV, uiV);
TCGv_i32 tmp_1 = tcg_constant_i32(0);
TCGv_i32 tmp_2 = tcg_temp_new_i32();
TCGv_i32 tmp_3 = tcg_constant_i32((int32_t) (((int32_t) 0xff)));
TCGv_i32 tmp_4 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
tcg_gen_movcond_i32(TCG_COND_NE, tmp_2, tmp_0, tmp_1, tmp_3, tmp_4);
TCGv_i32 tmp_5 = tcg_temp_new_i32();
tcg_gen_andi_i32(tmp_5, tmp_2, 0xff);
gen_log_pred_write(ctx, 0, tmp_5);
}

void emit_SL1_loadri_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {(EA = RsV + uiV); fLOAD(1,4,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
}

void emit_SL1_loadrub_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {(EA = RsV + uiV); fLOAD(1,1,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_TE);
}

void emit_SL2_loadrh_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {(EA = RsV + uiV); fLOAD(1,2,s,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_SIGN | MO_TE);
}

void emit_SL2_loadruh_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {(EA = RsV + uiV); fLOAD(1,2,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x2), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_16 | MO_TE);
}

void emit_SL2_loadrb_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {(EA = RsV + uiV); fLOAD(1,1,s,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x1), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_8 | MO_SIGN | MO_TE);
}

void emit_SL2_loadri_sp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RdV, int uiV)
/* size4u_t EA; {(EA = fREAD_SP() + uiV); fLOAD(1,4,u,EA,RdV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, hex_gpr[29], uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x4), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i32(RdV, EA, ctx->mem_idx, MO_32 | MO_TE);
}

void emit_SL2_loadrd_sp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RddV, int uiV)
/* size4u_t EA; {(EA = fREAD_SP() + uiV); fLOAD(1,8,u,EA,RddV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, hex_gpr[29], uiV);
tcg_gen_mov_i32(EA, tmp_0);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(RddV, EA, ctx->mem_idx, MO_64 | MO_TE);
}

void emit_SL2_deallocframe(DisasContext *ctx, Insn *insn, Packet *pkt)
/* size4u_t EA; { size8u_t tmp; (EA = fREAD_FP()); fLOAD(1,8,u,EA,tmp); tmp = fFRAME_UNSCRAMBLE(tmp); (LR = fGETWORD(1,tmp)); (FP = fGETWORD(0,tmp)); (SP = EA+8); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i64 tmp = tcg_temp_new_i64();
tcg_gen_mov_i32(EA, hex_gpr[30]);
if (insn->slot == 0 && pkt->pkt_has_store_s1) {
probe_noshuf_load(EA, ((int32_t) 0x8), ctx->mem_idx);
process_store(ctx, 1);
}
tcg_gen_qemu_ld_i64(tmp, EA, ctx->mem_idx, MO_64 | MO_TE);
TCGv_i64 tmp_0 = tcg_temp_new_i64();
TCGv_i64 tmp_1 = tcg_temp_new_i64();
TCGv_i32 tmp_2 = tcg_temp_new_i32();
gen_read_reg(tmp_2, HEX_REG_FRAMEKEY);
tcg_gen_concat_i32_i64(tmp_0, tmp_2, tmp_2);
tcg_gen_xor_i64(tmp_1, tmp, tmp_0);
tcg_gen_mov_i64(tmp, tmp_1);
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_3, tmp, ((int32_t) 0x1) * 32, 32);
TCGv_i32 tmp_4 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_4, tmp_3);
gen_log_reg_write(ctx, 31, tmp_4);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
tcg_gen_sextract_i64(tmp_5, tmp, ((int32_t) 0x0) * 32, 32);
TCGv_i32 tmp_6 = tcg_temp_new_i32();
tcg_gen_trunc_i64_tl(tmp_6, tmp_5);
gen_log_reg_write(ctx, 30, tmp_6);
TCGv_i32 tmp_7 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_7, EA, ((int32_t) 0x8));
gen_log_reg_write(ctx, 29, tmp_7);
}

void emit_SS1_storew_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + uiV); fSTORE(1,4,EA,RtV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
gen_store4(tcg_env, EA, RtV, insn->slot);
}

void emit_SS1_storeb_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + uiV); fSTORE(1,1,EA,fGETBYTE(0,RtV));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 8, 8);
gen_store1(tcg_env, EA, tmp_1, insn->slot);
}

void emit_SS2_storeh_io(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = RsV + uiV); fSTORE(1,2,EA,fGETHALF(0,RtV));} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_temp_new_i32();
tcg_gen_sextract_i32(tmp_1, RtV, ((int32_t) 0x0) * 16, 16);
gen_store2(tcg_env, EA, tmp_1, insn->slot);
}

void emit_SS2_stored_sp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i64 RttV, int siV)
/* size4u_t EA; {(EA = fREAD_SP() + siV); fSTORE(1,8,EA,RttV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, hex_gpr[29], siV);
tcg_gen_mov_i32(EA, tmp_0);
gen_store8(tcg_env, EA, RttV, insn->slot);
}

void emit_SS2_storew_sp(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RtV, int uiV)
/* size4u_t EA; {(EA = fREAD_SP() + uiV); fSTORE(1,4,EA,RtV);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, hex_gpr[29], uiV);
tcg_gen_mov_i32(EA, tmp_0);
gen_store4(tcg_env, EA, RtV, insn->slot);
}

void emit_SS2_storewi0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {(EA = RsV + uiV); fSTORE(1,4,EA,0);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
gen_store4(tcg_env, EA, tmp_1, insn->slot);
}

void emit_SS2_storebi0(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {(EA = RsV + uiV); fSTORE(1,1,EA,0);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (((int32_t) 0x0)));
gen_store1(tcg_env, EA, tmp_1, insn->slot);
}

void emit_SS2_storewi1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {(EA = RsV + uiV); fSTORE(1,4,EA,1);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (((int32_t) 0x1)));
gen_store4(tcg_env, EA, tmp_1, insn->slot);
}

void emit_SS2_storebi1(DisasContext *ctx, Insn *insn, Packet *pkt, TCGv_i32 RsV, int uiV)
/* size4u_t EA; {(EA = RsV + uiV); fSTORE(1,1,EA,1);} */
{
TCGv_i32 EA = tcg_temp_new_i32();
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, RsV, uiV);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i32 tmp_1 = tcg_constant_i32((int32_t) (((int32_t) 0x1)));
gen_store1(tcg_env, EA, tmp_1, insn->slot);
}

void emit_SS2_allocframe(DisasContext *ctx, Insn *insn, Packet *pkt, int uiV)
/* size4u_t EA; { (EA = fREAD_SP() + -8); fSTORE(1,8,EA,fFRAME_SCRAMBLE((fCAST8_8u(fREAD_LR()) << 32) | fCAST4_4u(fREAD_FP()))); (FP = EA); fFRAMECHECK(EA-uiV,EA); (SP = EA-uiV); } */
{
TCGv_i32 EA = tcg_temp_new_i32();
int32_t qemu_tmp_0 = -(((int32_t) 0x8));
TCGv_i32 tmp_0 = tcg_temp_new_i32();
tcg_gen_addi_i32(tmp_0, hex_gpr[29], qemu_tmp_0);
tcg_gen_mov_i32(EA, tmp_0);
TCGv_i64 tmp_1 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_1, hex_gpr[31]);
int64_t qemu_tmp_1 = (int64_t)((int32_t) 0x20);
TCGv_i64 tmp_2 = tcg_temp_new_i64();
if (qemu_tmp_1 >= 64) {
tcg_gen_movi_i64(tmp_2, 0);
} else {
tcg_gen_shli_i64(tmp_2, tmp_1, qemu_tmp_1);
}
TCGv_i64 tmp_3 = tcg_temp_new_i64();
tcg_gen_extu_i32_i64(tmp_3, hex_gpr[30]);
TCGv_i64 tmp_4 = tcg_temp_new_i64();
tcg_gen_or_i64(tmp_4, tmp_2, tmp_3);
TCGv_i64 tmp_5 = tcg_temp_new_i64();
TCGv_i64 tmp_6 = tcg_temp_new_i64();
TCGv_i32 tmp_7 = tcg_temp_new_i32();
gen_read_reg(tmp_7, HEX_REG_FRAMEKEY);
tcg_gen_concat_i32_i64(tmp_5, tmp_7, tmp_7);
tcg_gen_xor_i64(tmp_6, tmp_4, tmp_5);
gen_store8(tcg_env, EA, tmp_6, insn->slot);
gen_log_reg_write(ctx, 30, EA);
TCGv_i32 tmp_8 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_8, EA, uiV);
TCGv_i32 tmp_9 = tcg_temp_new_i32();
tcg_gen_subi_i32(tmp_9, EA, uiV);
gen_log_reg_write(ctx, 29, tmp_9);
}

